/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/path","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/network","vs/base/common/errors","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/platform/log/common/log","vs/base/common/async","vs/base/common/strings","vs/base/common/arrays","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","os","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/map","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/errorMessage","vs/server/node/serverEnvironmentService","vs/base/common/codicons","child_process","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/iterator","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/performance","vs/editor/common/core/range","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/processes","vs/platform/environment/node/argv","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/base/parts/ipc/node/ipc.net","vs/base/common/functional","vs/base/common/json","vs/base/common/mime","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","net","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","crypto","url","vs/platform/shell/node/shellEnv","vs/server/node/remoteLanguagePacks","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/base/common/decorators","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/console","vs/base/common/htmlContent","vs/base/common/labels","path","vs/base/node/id","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/languagePacks/node/languagePacks","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/api/common/extHostTypes","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/hash","vs/base/common/filters","vs/base/common/iconLabels","vs/base/node/decoder","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteAgentEnvironmentImpl","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/platform/credentials/node/credentialsMainService","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTestItem","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/common/remoteConsoleUtil","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","string_decoder","util","minimist","assert","graceful-fs","https","yauzl","yazl","vs/server/node/server.main"],ye=function(ie){for(var e=[],I=0,t=ie.length;I<t;I++)e[I]=we[ie[I]];return e};define(we[128],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class I{static get(){const y=new Map,P=new Map,k=new Map,S=new Map;function v(w,m){w.has(m.detail)||w.set(m.detail,-m.timestamp)}function D(w,m){let E=w.get(m.detail);!E||E>=0||w.set(m.detail,E+m.timestamp)}const T=ie.getStats().slice(0).sort((w,m)=>w.timestamp-m.timestamp);for(const w of T)switch(w.type){case 10:v(y,w);break;case 11:case 12:D(y,w);break;case 21:v(P,w);break;case 22:D(P,w);break;case 33:v(k,w);break;case 34:D(k,w);break;case 31:v(S,w);break;case 32:D(S,w);break}let R=0;k.forEach(w=>R+=w);function C(w){let m=[];return w.forEach((E,f)=>m.push([f,E])),m}return{amdLoad:C(y),amdInvoke:C(P),nodeRequire:C(k),nodeEval:C(S),nodeRequireTotal:R}}static toMarkdownTable(y,P){let k="",S=[];return y.forEach((v,D)=>{S[D]=v.length}),P.forEach(v=>{v.forEach((D,T)=>{typeof D=="undefined"&&(D=v[T]="-");const R=D.toString().length;S[T]=Math.max(R,S[T])})}),y.forEach((v,D)=>{k+=`| ${v+" ".repeat(S[D]-v.toString().length)} `}),k+=`|
`,y.forEach((v,D)=>{k+=`| ${"-".repeat(S[D])} `}),k+=`|
`,P.forEach(v=>{v.forEach((D,T)=>{typeof D!="undefined"&&(k+=`| ${D+" ".repeat(S[T]-D.toString().length)} `)}),k+=`|
`}),k}}e.LoaderStats=I}),define(we[129],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function I(t,y){if(!t)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=I}),define(we[38],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function I(k){return k?k.replace(/\$\((.*?)\)/g,(S,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=I;class t{constructor(S,v,D){this.id=S,this.definition=v,this.description=D,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function y(k,S){const v=["codicon","codicon-"+k];return S&&v.push("codicon-modifier-"+S),v}e.getClassNamesArray=y;var P;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function v(R){if(R instanceof t)return["codicon","codicon-"+R.id];const C=S.exec(R.id);if(!C)return v(t.error);let[,w,m]=C;const E=["codicon","codicon-"+w];return m&&E.push("codicon-modifier-"+m.substr(1)),E}k.asClassNameArray=v;function D(R){return v(R).join(" ")}k.asClassName=D;function T(R){return"."+v(R).join(".")}k.asCSSSelector=T})(P=e.CSSIcon||(e.CSSIcon={}))}),define(we[81],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function I(k){return(S,v,D)=>{let T=null,R=null;if(typeof D.value=="function"?(T="value",R=D.value):typeof D.get=="function"&&(T="get",R=D.get),!R)throw new Error("not supported");D[T]=k(R,v)}}e.createDecorator=I;function t(k,S,v){let D=null,T=null;if(typeof v.value=="function"?(D="value",T=v.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(D="get",T=v.get),!T)throw new Error("not supported");const R=`$memoize$${S}`;v[D]=function(...C){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,C)}),this[R]}}e.memoize=t;function y(k,S,v){return I((D,T)=>{const R=`$debounce$${T}`,C=`$debounce$result$${T}`;return function(...w){this[C]||(this[C]=v?v():void 0),clearTimeout(this[R]),S&&(this[C]=S(this[C],...w),w=[this[C]]),this[R]=setTimeout(()=>{D.apply(this,w),this[C]=v?v():void 0},k)}})}e.debounce=y;function P(k,S,v){return I((D,T)=>{const R=`$throttle$timer$${T}`,C=`$throttle$result$${T}`,w=`$throttle$lastRun$${T}`,m=`$throttle$pending$${T}`;return function(...E){if(this[C]||(this[C]=v?v():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),S&&(this[C]=S(this[C],...E)),this[m])return;const f=this[w]+k;f<=Date.now()?(this[w]=Date.now(),D.apply(this,[this[C]]),this[C]=v?v():void 0):(this[m]=!0,this[R]=setTimeout(()=>{this[m]=!1,this[w]=Date.now(),D.apply(this,[this[C]]),this[C]=v?v():void 0},f-Date.now()))}})}e.throttle=P}),define(we[9],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(o=>{o(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=I,e.errorHandler=new I;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function y(c){v(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=y;function P(c){v(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=P;function k(c){if(c instanceof Error){let{name:n,message:o}=c;const i=c.stacktrace||c.stack;return{$isError:!0,name:n,message:o,stack:i}}return c}e.transformErrorForSerialization=k;const S="Canceled";function v(c){return c instanceof D?!0:c instanceof Error&&c.name===S&&c.message===S}e.isCancellationError=v;class D extends Error{constructor(){super(S);this.name=this.message}}e.CancellationError=D;function T(){const c=new Error(S);return c.name=c.message,c}e.canceled=T;function R(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=R;function C(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=C;function w(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function m(c){const n=new Error(`${c} has been disposed`);return n.name="DISPOSED",n}e.disposed=m;function E(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=E;class f extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=f;class p extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=p;class g extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=g;class d extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(n){if(n&&n instanceof d)return n;if(n&&n instanceof Error){const o=new d;return o.name=n.name,o.message=n.message,o.stack=n.stack,o}return new d(n)}}e.ErrorNoTelemetry=d;class l extends Error{constructor(n){super(n||"An unexpected bug occurred.");Object.setPrototypeOf(this,l.prototype);debugger}}e.BugIndicatingError=l}),define(we[16],ye([0,1,9]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(z,te=0){return z[z.length-(1+te)]}e.tail=t;function y(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=y;function P(z,te,ce=(Z,se)=>Z===se){if(z===te)return!0;if(!z||!te||z.length!==te.length)return!1;for(let Z=0,se=z.length;Z<se;Z++)if(!ce(z[Z],te[Z]))return!1;return!0}e.equals=P;function k(z,te,ce){return S(z.length,Z=>ce(z[Z],te))}e.binarySearch=k;function S(z,te){let ce=0,Z=z-1;for(;ce<=Z;){const se=(ce+Z)/2|0,ge=te(se);if(ge<0)ce=se+1;else if(ge>0)Z=se-1;else return se}return-(ce+1)}e.binarySearch2=S;function v(z,te){let ce=0,Z=z.length;if(Z===0)return 0;for(;ce<Z;){const se=Math.floor((ce+Z)/2);te(z[se])?Z=se:ce=se+1}return ce}e.findFirstInSorted=v;function D(z,te,ce){if(z=z|0,z>=te.length)throw new TypeError("invalid index");let Z=te[Math.floor(te.length*Math.random())],se=[],ge=[],Y=[];for(let re of te){const H=ce(re,Z);H<0?se.push(re):H>0?ge.push(re):Y.push(re)}return z<se.length?D(z,se,ce):z<se.length+Y.length?Y[0]:D(z-(se.length+Y.length),ge,ce)}e.quickSelect=D;function T(z,te){const ce=[];let Z;for(const se of z.slice(0).sort(te))!Z||te(Z[0],se)!==0?(Z=[se],ce.push(Z)):Z.push(se);return ce}e.groupBy=T;function R(z,te,ce){const Z=[];function se(re,H,K){if(H===0&&K.length===0)return;const ue=Z[Z.length-1];ue&&ue.start+ue.deleteCount===re?(ue.deleteCount+=H,ue.toInsert.push(...K)):Z.push({start:re,deleteCount:H,toInsert:K})}let ge=0,Y=0;for(;;){if(ge===z.length){se(ge,0,te.slice(Y));break}if(Y===te.length){se(ge,z.length-ge,[]);break}const re=z[ge],H=te[Y],K=ce(re,H);K===0?(ge+=1,Y+=1):K<0?(se(ge,1,[]),ge+=1):K>0&&(se(ge,0,[H]),Y+=1)}return Z}e.sortedDiff=R;function C(z,te,ce){const Z=R(z,te,ce),se=[],ge=[];for(const Y of Z)se.push(...z.slice(Y.start,Y.start+Y.deleteCount)),ge.push(...Y.toInsert);return{removed:se,added:ge}}e.delta=C;function w(z,te,ce){if(ce===0)return[];const Z=z.slice(0,ce).sort(te);return E(z,te,Z,ce,z.length),Z}e.top=w;function m(z,te,ce,Z,se){return ce===0?Promise.resolve([]):new Promise((ge,Y)=>{(async()=>{const re=z.length,H=z.slice(0,ce).sort(te);for(let K=ce,ue=Math.min(ce+Z,re);K<re;K=ue,ue=Math.min(ue+Z,re)){if(K>ce&&await new Promise(pe=>setTimeout(pe)),se&&se.isCancellationRequested)throw new I.CancellationError;E(z,te,H,K,ue)}return H})().then(ge,Y)})}e.topAsync=m;function E(z,te,ce,Z,se){for(const ge=ce.length;Z<se;Z++){const Y=z[Z];if(te(Y,ce[ge-1])<0){ce.pop();const re=v(ce,H=>te(Y,H)<0);ce.splice(re,0,Y)}}}function f(z){return z.filter(te=>!!te)}e.coalesce=f;function p(z){let te=0;for(let ce=0;ce<z.length;ce++)z[ce]&&(z[te]=z[ce],te+=1);z.length=te}e.coalesceInPlace=p;function g(z,te,ce){z.splice(ce,0,z.splice(te,1)[0])}e.move=g;function d(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=d;function l(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=l;function c(z,te=ce=>ce){const ce=new Set;return z.filter(Z=>{const se=te(Z);return ce.has(se)?!1:(ce.add(se),!0)})}e.distinct=c;function n(z){const te=new Set;return ce=>{const Z=z(ce);return te.has(Z)?!1:(te.add(Z),!0)}}e.uniqueFilter=n;function o(z,te){const ce=i(z,te);if(ce!==-1)return z[ce]}e.findLast=o;function i(z,te){for(let ce=z.length-1;ce>=0;ce--){const Z=z[ce];if(te(Z))return ce}return-1}e.lastIndex=i;function a(z,te){return z.length>0?z[0]:te}e.firstOrDefault=a;function r(z,te){return z.length>0?z[z.length-1]:te}e.lastOrDefault=r;function s(z,te,ce=(Z,se)=>Z===se){let Z=0;for(let se=0,ge=Math.min(z.length,te.length);se<ge&&ce(z[se],te[se]);se++)Z++;return Z}e.commonPrefixLength=s;function u(z){return[].concat(...z)}e.flatten=u;function h(z,te){let ce=typeof te=="number"?z:0;typeof te=="number"?ce=z:(ce=0,te=z);const Z=[];if(ce<=te)for(let se=ce;se<te;se++)Z.push(se);else for(let se=ce;se>te;se--)Z.push(se);return Z}e.range=h;function b(z,te,ce){return z.reduce((Z,se)=>(Z[te(se)]=ce?ce(se):se,Z),Object.create(null))}e.index=b;function A(z,te){return z.push(te),()=>B(z,te)}e.insert=A;function B(z,te){const ce=z.indexOf(te);if(ce>-1)return z.splice(ce,1),te}e.remove=B;function G(z,te,ce){const Z=z.slice(0,te),se=z.slice(te);return Z.concat(ce,se)}e.arrayInsert=G;function Q(z,te){let ce;if(typeof te=="number"){let Z=te;ce=()=>{const se=Math.sin(Z++)*179426549;return se-Math.floor(se)}}else ce=Math.random;for(let Z=z.length-1;Z>0;Z-=1){const se=Math.floor(ce()*(Z+1)),ge=z[Z];z[Z]=z[se],z[se]=ge}}e.shuffle=Q;function _(z,te){const ce=z.indexOf(te);ce>-1&&(z.splice(ce,1),z.unshift(te))}e.pushToStart=_;function X(z,te){const ce=z.indexOf(te);ce>-1&&(z.splice(ce,1),z.push(te))}e.pushToEnd=X;function F(z,te){for(const ce of te)z.push(ce)}e.pushMany=F;function U(z,te){return Array.isArray(z)?z.map(te):te(z)}e.mapArrayOrNot=U;function le(z){return Array.isArray(z)?z:[z]}e.asArray=le;function j(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=j;function $(z,te){for(const ce of z){const Z=te(ce);if(Z!==void 0)return Z}}e.mapFind=$;function O(z,te,ce){const Z=W(z,te),se=z.length,ge=ce.length;z.length=se+ge;for(let Y=se-1;Y>=Z;Y--)z[Y+ge]=z[Y];for(let Y=0;Y<ge;Y++)z[Y+Z]=ce[Y]}e.insertInto=O;function M(z,te,ce,Z){const se=W(z,te),ge=z.splice(se,ce);return O(z,se,Z),ge}e.splice=M;function W(z,te){return te<0?Math.max(te+z.length,0):Math.min(te,z.length)}var J;(function(z){function te(se){return se<0}z.isLessThan=te;function ce(se){return se>0}z.isGreaterThan=ce;function Z(se){return se===0}z.isNeitherLessOrGreaterThan=Z,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(J=e.CompareResult||(e.CompareResult={}));function ae(z,te){return(ce,Z)=>te(z(ce),z(Z))}e.compareBy=ae;const me=(z,te)=>z-te;e.numberComparator=me;function fe(z,te){if(z.length===0)return;let ce=z[0];for(let Z=1;Z<z.length;Z++){const se=z[Z];te(se,ce)>0&&(ce=se)}return ce}e.findMaxBy=fe;function V(z,te){if(z.length===0)return;let ce=z[0];for(let Z=1;Z<z.length;Z++){const se=z[Z];te(se,ce)>=0&&(ce=se)}return ce}e.findLastMaxBy=V;function ee(z,te){return fe(z,(ce,Z)=>-te(ce,Z))}e.findMinBy=ee;class x{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ce=this.firstIdx;for(;ce<this.items.length&&te(this.items[ce]);)ce++;const Z=ce===this.firstIdx?null:this.items.slice(this.firstIdx,ce);return this.firstIdx=ce,Z}takeFromEndWhile(te){let ce=this.lastIdx;for(;ce>=0&&te(this.items[ce]);)ce--;const Z=ce===this.lastIdx?null:this.items.slice(ce+1,this.lastIdx+1);return this.lastIdx=ce,Z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const ce=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,ce}}e.ArrayQueue=x}),define(we[62],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(t){const y=this;let P=!1,k;return function(){return P||(P=!0,k=t.apply(y,arguments)),k}}e.once=I}),define(we[43],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(t){function y(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=y;const P=Object.freeze([]);function k(){return P}t.empty=k;function*S(o){yield o}t.single=S;function v(o){return o||P}t.from=v;function D(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=D;function T(o){return o[Symbol.iterator]().next().value}t.first=T;function R(o,i){for(const a of o)if(i(a))return!0;return!1}t.some=R;function C(o,i){for(const a of o)if(i(a))return a}t.find=C;function*w(o,i){for(const a of o)i(a)&&(yield a)}t.filter=w;function*m(o,i){let a=0;for(const r of o)yield i(r,a++)}t.map=m;function*E(...o){for(const i of o)for(const a of i)yield a}t.concat=E;function*f(o){for(const i of o)for(const a of i)yield a}t.concatNested=f;function p(o,i,a){let r=a;for(const s of o)r=i(r,s);return r}t.reduce=p;function g(o,i){let a=0;for(const r of o)i(r,a++)}t.forEach=g;function*d(o,i,a=o.length){for(i<0&&(i+=o.length),a<0?a+=o.length:a>o.length&&(a=o.length);i<a;i++)yield o[i]}t.slice=d;function l(o,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,o];const r=o[Symbol.iterator]();for(let s=0;s<i;s++){const u=r.next();if(u.done)return[a,t.empty()];a.push(u.value)}return[a,{[Symbol.iterator](){return r}}]}t.consume=l;function c(o){return l(o)[0]}t.collect=c;function n(o,i,a=(r,s)=>r===s){const r=o[Symbol.iterator](),s=i[Symbol.iterator]();for(;;){const u=r.next(),h=s.next();if(u.done!==h.done)return!1;if(u.done)return!0;if(!a(u.value,h.value))return!1}}t.equals=n})(I=e.Iterable||(e.Iterable={}))}),define(we[63],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(n){n.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function k(n,o=!1){let i=0,a=n.length,r="",s=0,u=16,h=0;function b(F){let U=0,le=0;for(;U<F;){const j=n.charCodeAt(i);if(j>=48&&j<=57)le=le*16+j-48;else if(j>=65&&j<=70)le=le*16+j-65+10;else if(j>=97&&j<=102)le=le*16+j-97+10;else break;i++,U++}return U<F&&(le=-1),le}function A(F){i=F,r="",s=0,u=16,h=0}function B(){const F=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&D(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&D(n.charCodeAt(i)))for(i++;i<n.length&&D(n.charCodeAt(i));)i++;else return h=3,n.substring(F,i);let U=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&D(n.charCodeAt(i))){for(i++;i<n.length&&D(n.charCodeAt(i));)i++;U=i}else h=3;return n.substring(F,U)}function G(){let F="",U=i;for(;;){if(i>=a){F+=n.substring(U,i),h=2;break}const le=n.charCodeAt(i);if(le===34){F+=n.substring(U,i),i++;break}if(le===92){if(F+=n.substring(U,i),i++,i>=a){h=2;break}switch(n.charCodeAt(i++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const $=b(4);$>=0?F+=String.fromCharCode($):h=4;break}default:h=5}U=i;continue}if(le>=0&&le<=31)if(v(le)){F+=n.substring(U,i),h=2;break}else h=6;i++}return F}function Q(){if(r="",h=0,s=i,i>=a)return s=a,u=17;let F=n.charCodeAt(i);if(S(F)){do i++,r+=String.fromCharCode(F),F=n.charCodeAt(i);while(S(F));return u=15}if(v(F))return i++,r+=String.fromCharCode(F),F===13&&n.charCodeAt(i)===10&&(i++,r+=`
`),u=14;switch(F){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,r=G(),u=10;case 47:{const U=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<a&&!v(n.charCodeAt(i));)i++;return r=n.substring(U,i),u=12}if(n.charCodeAt(i+1)===42){i+=2;const le=a-1;let j=!1;for(;i<le;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,j=!0;break}i++}return j||(i++,h=1),r=n.substring(U,i),u=13}return r+=String.fromCharCode(F),i++,u=16}case 45:if(r+=String.fromCharCode(F),i++,i===a||!D(n.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=B(),u=11;default:for(;i<a&&_(F);)i++,F=n.charCodeAt(i);if(s!==i){switch(r=n.substring(s,i),r){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return r+=String.fromCharCode(F),i++,u=16}}function _(F){if(S(F)||v(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function X(){let F;do F=Q();while(F>=12&&F<=15);return F}return{setPosition:A,getPosition:()=>i,scan:o?X:Q,getToken:()=>u,getTokenValue:()=>r,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>h}}e.createScanner=k;function S(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function v(n){return n===10||n===13||n===8232||n===8233}function D(n){return n>=48&&n<=57}var T;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(T||(T={}));function R(n,o){const i=[],a=new Object;let r;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function h(b,A,B,G){s.value=b,s.offset=A,s.length=B,s.type=G,s.colonOffset=void 0,r=s}try{d(n,{onObjectBegin:(b,A)=>{if(o<=b)throw a;r=void 0,u=o>b,i.push("")},onObjectProperty:(b,A,B)=>{if(o<A||(h(b,A,B,"property"),i[i.length-1]=b,o<=A+B))throw a},onObjectEnd:(b,A)=>{if(o<=b)throw a;r=void 0,i.pop()},onArrayBegin:(b,A)=>{if(o<=b)throw a;r=void 0,i.push(0)},onArrayEnd:(b,A)=>{if(o<=b)throw a;r=void 0,i.pop()},onLiteralValue:(b,A,B)=>{if(o<A||(h(b,A,B,c(b)),o<=A+B))throw a},onSeparator:(b,A,B)=>{if(o<=A)throw a;if(b===":"&&r&&r.type==="property")r.colonOffset=A,u=!1,r=void 0;else if(b===","){const G=i[i.length-1];typeof G=="number"?i[i.length-1]=G+1:(u=!0,i[i.length-1]=""),r=void 0}}})}catch(b){if(b!==a)throw b}return{path:i,previousNode:r,isAtPropertyKey:u,matches:b=>{let A=0;for(let B=0;A<b.length&&B<i.length;B++)if(b[A]===i[B]||b[A]==="*")A++;else if(b[A]!=="**")return!1;return A===b.length}}}e.getLocation=R;function C(n,o=[],i=P.DEFAULT){let a=null,r=[];const s=[];function u(b){Array.isArray(r)?r.push(b):a!==null&&(r[a]=b)}return d(n,{onObjectBegin:()=>{const b={};u(b),s.push(r),r=b,a=null},onObjectProperty:b=>{a=b},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const b=[];u(b),s.push(r),r=b,a=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:u,onError:(b,A,B)=>{o.push({error:b,offset:A,length:B})}},i),r[0]}e.parse=C;function w(n,o=[],i=P.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(b){a.type==="property"&&(a.length=b-a.offset,a=a.parent)}function s(b){return a.children.push(b),b}d(n,{onObjectBegin:b=>{a=s({type:"object",offset:b,length:-1,parent:a,children:[]})},onObjectProperty:(b,A,B)=>{a=s({type:"property",offset:A,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:b,offset:A,length:B,parent:a})},onObjectEnd:(b,A)=>{a.length=b+A-a.offset,a=a.parent,r(b+A)},onArrayBegin:(b,A)=>{a=s({type:"array",offset:b,length:-1,parent:a,children:[]})},onArrayEnd:(b,A)=>{a.length=b+A-a.offset,a=a.parent,r(b+A)},onLiteralValue:(b,A,B)=>{s({type:c(b),offset:A,length:B,parent:a,value:b}),r(A+B)},onSeparator:(b,A,B)=>{a.type==="property"&&(b===":"?a.colonOffset=A:b===","&&r(A))},onError:(b,A,B)=>{o.push({error:b,offset:A,length:B})}},i);const h=a.children[0];return h&&delete h.parent,h}e.parseTree=w;function m(n,o){if(!n)return;let i=n;for(let a of o)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===a){i=s.children[1],r=!0;break}if(!r)return}else{const r=a;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=m;function E(n){if(!n.parent||!n.parent.children)return[];const o=E(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;o.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&o.push(i)}return o}e.getNodePath=E;function f(n){switch(n.type){case"array":return n.children.map(f);case"object":{const o=Object.create(null);for(let i of n.children){const a=i.children[1];a&&(o[i.children[0].value]=f(a))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=f;function p(n,o,i=!1){return o>=n.offset&&o<n.offset+n.length||i&&o===n.offset+n.length}e.contains=p;function g(n,o,i=!1){if(p(n,o,i)){const a=n.children;if(Array.isArray(a))for(let r=0;r<a.length&&a[r].offset<=o;r++){const s=g(a[r],o,i);if(s)return s}return n}}e.findNodeAtOffset=g;function d(n,o,i=P.DEFAULT){const a=k(n,!1);function r(me){return me?()=>me(a.getTokenOffset(),a.getTokenLength()):()=>!0}function s(me){return me?fe=>me(fe,a.getTokenOffset(),a.getTokenLength()):()=>!0}const u=r(o.onObjectBegin),h=s(o.onObjectProperty),b=r(o.onObjectEnd),A=r(o.onArrayBegin),B=r(o.onArrayEnd),G=s(o.onLiteralValue),Q=s(o.onSeparator),_=r(o.onComment),X=s(o.onError),F=i&&i.disallowComments,U=i&&i.allowTrailingComma;function le(){for(;;){const me=a.scan();switch(a.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:F||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(me){case 12:case 13:F?j(10):_();break;case 16:j(1);break;case 15:case 14:break;default:return me}}}function j(me,fe=[],V=[]){if(X(me),fe.length+V.length>0){let ee=a.getToken();for(;ee!==17;){if(fe.indexOf(ee)!==-1){le();break}else if(V.indexOf(ee)!==-1)break;ee=le()}}}function $(me){const fe=a.getTokenValue();return me?G(fe):h(fe),le(),!0}function O(){switch(a.getToken()){case 11:{let me=0;try{me=JSON.parse(a.getTokenValue()),typeof me!="number"&&(j(2),me=0)}catch{j(2)}G(me);break}case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return le(),!0}function M(){return a.getToken()!==10?(j(3,[],[2,5]),!1):($(!1),a.getToken()===6?(Q(":"),le(),ae()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function W(){u(),le();let me=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(me||j(4,[],[]),Q(","),le(),a.getToken()===2&&U)break}else me&&j(6,[],[]);M()||j(4,[],[2,5]),me=!0}return b(),a.getToken()!==2?j(7,[2],[]):le(),!0}function J(){A(),le();let me=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(me||j(4,[],[]),Q(","),le(),a.getToken()===4&&U)break}else me&&j(6,[],[]);ae()||j(4,[],[4,5]),me=!0}return B(),a.getToken()!==4?j(8,[4],[]):le(),!0}function ae(){switch(a.getToken()){case 3:return J();case 1:return W();case 10:return $(!0);default:return O()}}return le(),a.getToken()===17?i.allowEmptyContent?!0:(j(4,[],[]),!1):ae()?(a.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=d;function l(n,o){let i=k(n),a=[],r,s=0,u;do switch(u=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:s!==u&&a.push(n.substring(s,u)),o!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,o)),s=i.getPosition();break}while(r!==17);return a.join("")}e.stripComments=l;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(we[130],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(y){this.executor=y,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(y){return new I(()=>y(this.getValue()))}}e.Lazy=I}),define(we[2],ye([0,1,62,43]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const y=!1;let P=null;function k(r){P=r}if(e.setDisposableTracker=k,y){const r="__is_disposable_tracked__";k(new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[r]||console.log(u)},3e3)}setParent(s,u){if(s&&s!==g.None)try{s[r]=!0}catch{}}markAsDisposed(s){if(s&&s!==g.None)try{s[r]=!0}catch{}}markAsSingleton(s){}})}function S(r){return P?.trackDisposable(r),r}function v(r){P?.markAsDisposed(r)}function D(r,s){P?.setParent(r,s)}function T(r,s){if(!!P)for(const u of r)P.setParent(u,s)}function R(r){return P?.markAsSingleton(r),r}e.markAsSingleton=R;class C extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=C;function w(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=w;function m(r){if(t.Iterable.is(r)){let s=[];for(const u of r)if(u)try{u.dispose()}catch(h){s.push(h)}if(s.length===1)throw s[0];if(s.length>1)throw new C(s);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=m;function E(...r){const s=f(()=>m(r));return T(r,s),s}e.combinedDisposable=E;function f(r){const s=S({dispose:(0,I.once)(()=>{v(s),r()})});return s}e.toDisposable=f;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{m(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return D(s,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new p,S(this),D(this._store,this)}dispose(){v(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&D(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&D(s,null),s}}e.MutableDisposable=d;class l{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(s){let u=s;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,v(this))},this}}e.SafeDisposable=c;class n{constructor(){this.references=new Map}acquire(s,...u){let h=this.references.get(s);h||(h={counter:0,object:this.createReferencedObject(s,...u)},this.references.set(s,h));const{object:b}=h,A=(0,I.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(s,h.object),this.references.delete(s))});return h.counter++,{object:b,dispose:A}}}e.ReferenceCollection=n;class o{constructor(s){this.referenceCollection=s}async acquire(s,...u){const h=this.referenceCollection.acquire(s,...u);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(b){throw h.dispose(),b}}}e.AsyncReferenceCollection=o;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function a(r){const s=new p;try{r(s)}finally{s.dispose()}}e.disposeOnReturn=a}),define(we[131],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(P){this.element=P,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class t{constructor(){this._first=I.Undefined,this._last=I.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===I.Undefined}clear(){let P=this._first;for(;P!==I.Undefined;){const k=P.next;P.prev=I.Undefined,P.next=I.Undefined,P=k}this._first=I.Undefined,this._last=I.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,k){const S=new I(P);if(this._first===I.Undefined)this._first=S,this._last=S;else if(k){const D=this._last;this._last=S,S.prev=D,D.next=S}else{const D=this._first;this._first=S,S.next=D,D.prev=S}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(S))}}shift(){if(this._first!==I.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==I.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==I.Undefined&&P.next!==I.Undefined){const k=P.prev;k.next=P.next,P.next.prev=k}else P.prev===I.Undefined&&P.next===I.Undefined?(this._first=I.Undefined,this._last=I.Undefined):P.next===I.Undefined?(this._last=this._last.prev,this._last.next=I.Undefined):P.prev===I.Undefined&&(this._first=this._first.next,this._first.prev=I.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==I.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(ie,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(we[132],ye([1]),e):(ie=typeof globalThis!="undefined"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(Z,se){for(var ge=0;ge<se.length;ge++){var Y=se[ge];Y.enumerable=Y.enumerable||!1,Y.configurable=!0,"value"in Y&&(Y.writable=!0),Object.defineProperty(Z,Y.key,Y)}}function I(Z,se,ge){return se&&e(Z.prototype,se),ge&&e(Z,ge),Object.defineProperty(Z,"prototype",{writable:!1}),Z}function t(Z,se){if(!!Z){if(typeof Z=="string")return y(Z,se);var ge=Object.prototype.toString.call(Z).slice(8,-1);if(ge==="Object"&&Z.constructor&&(ge=Z.constructor.name),ge==="Map"||ge==="Set")return Array.from(Z);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return y(Z,se)}}function y(Z,se){(se==null||se>Z.length)&&(se=Z.length);for(var ge=0,Y=new Array(se);ge<se;ge++)Y[ge]=Z[ge];return Y}function P(Z,se){var ge=typeof Symbol!="undefined"&&Z[Symbol.iterator]||Z["@@iterator"];if(ge)return(ge=ge.call(Z)).next.bind(ge);if(Array.isArray(Z)||(ge=t(Z))||se&&Z&&typeof Z.length=="number"){ge&&(Z=ge);var Y=0;return function(){return Y>=Z.length?{done:!0}:{done:!1,value:Z[Y++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=k();function S(Z){ie.defaults=Z}var v=/[&<>"']/,D=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(se){return C[se]};function m(Z,se){if(se){if(v.test(Z))return Z.replace(D,w)}else if(T.test(Z))return Z.replace(R,w);return Z}var E=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(Z){return Z.replace(E,function(se,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var p=/(^|[^\[])\^/g;function g(Z,se){Z=typeof Z=="string"?Z:Z.source,se=se||"";var ge={replace:function(re,H){return H=H.source||H,H=H.replace(p,"$1"),Z=Z.replace(re,H),ge},getRegex:function(){return new RegExp(Z,se)}};return ge}var d=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(Z,se,ge){if(Z){var Y;try{Y=decodeURIComponent(f(ge)).replace(d,"").toLowerCase()}catch{return null}if(Y.indexOf("javascript:")===0||Y.indexOf("vbscript:")===0||Y.indexOf("data:")===0)return null}se&&!l.test(ge)&&(ge=r(se,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var n={},o=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Z,se){n[" "+Z]||(o.test(Z)?n[" "+Z]=Z+"/":n[" "+Z]=b(Z,"/",!0)),Z=n[" "+Z];var ge=Z.indexOf(":")===-1;return se.substring(0,2)==="//"?ge?se:Z.replace(i,"$1")+se:se.charAt(0)==="/"?ge?se:Z.replace(a,"$1")+se:Z+se}var s={exec:function(){}};function u(Z){for(var se=1,ge,Y;se<arguments.length;se++){ge=arguments[se];for(Y in ge)Object.prototype.hasOwnProperty.call(ge,Y)&&(Z[Y]=ge[Y])}return Z}function h(Z,se){var ge=Z.replace(/\|/g,function(H,K,ue){for(var pe=!1,De=K;--De>=0&&ue[De]==="\\";)pe=!pe;return pe?"|":" |"}),Y=ge.split(/ \|/),re=0;if(Y[0].trim()||Y.shift(),Y.length>0&&!Y[Y.length-1].trim()&&Y.pop(),Y.length>se)Y.splice(se);else for(;Y.length<se;)Y.push("");for(;re<Y.length;re++)Y[re]=Y[re].trim().replace(/\\\|/g,"|");return Y}function b(Z,se,ge){var Y=Z.length;if(Y===0)return"";for(var re=0;re<Y;){var H=Z.charAt(Y-re-1);if(H===se&&!ge)re++;else if(H!==se&&ge)re++;else break}return Z.slice(0,Y-re)}function A(Z,se){if(Z.indexOf(se[1])===-1)return-1;for(var ge=Z.length,Y=0,re=0;re<ge;re++)if(Z[re]==="\\")re++;else if(Z[re]===se[0])Y++;else if(Z[re]===se[1]&&(Y--,Y<0))return re;return-1}function B(Z){Z&&Z.sanitize&&!Z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function G(Z,se){if(se<1)return"";for(var ge="";se>1;)se&1&&(ge+=Z),se>>=1,Z+=Z;return ge+Z}function Q(Z,se,ge,Y){var re=se.href,H=se.title?m(se.title):null,K=Z[1].replace(/\\([\[\]])/g,"$1");if(Z[0].charAt(0)!=="!"){Y.state.inLink=!0;var ue={type:"link",raw:ge,href:re,title:H,text:K,tokens:Y.inlineTokens(K,[])};return Y.state.inLink=!1,ue}return{type:"image",raw:ge,href:re,title:H,text:m(K)}}function _(Z,se){var ge=Z.match(/^(\s+)(?:```)/);if(ge===null)return se;var Y=ge[1];return se.split(`
`).map(function(re){var H=re.match(/^\s+/);if(H===null)return re;var K=H[0];return K.length>=Y.length?re.slice(Y.length):re}).join(`
`)}var X=function(){function Z(ge){this.options=ge||ie.defaults}var se=Z.prototype;return se.space=function(Y){var re=this.rules.block.newline.exec(Y);if(re&&re[0].length>0)return{type:"space",raw:re[0]}},se.code=function(Y){var re=this.rules.block.code.exec(Y);if(re){var H=re[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:re[0],codeBlockStyle:"indented",text:this.options.pedantic?H:b(H,`
`)}}},se.fences=function(Y){var re=this.rules.block.fences.exec(Y);if(re){var H=re[0],K=_(H,re[3]||"");return{type:"code",raw:H,lang:re[2]?re[2].trim():re[2],text:K}}},se.heading=function(Y){var re=this.rules.block.heading.exec(Y);if(re){var H=re[2].trim();if(/#$/.test(H)){var K=b(H,"#");(this.options.pedantic||!K||/ $/.test(K))&&(H=K.trim())}var ue={type:"heading",raw:re[0],depth:re[1].length,text:H,tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},se.hr=function(Y){var re=this.rules.block.hr.exec(Y);if(re)return{type:"hr",raw:re[0]}},se.blockquote=function(Y){var re=this.rules.block.blockquote.exec(Y);if(re){var H=re[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:re[0],tokens:this.lexer.blockTokens(H,[]),text:H}}},se.list=function(Y){var re=this.rules.block.list.exec(Y);if(re){var H,K,ue,pe,De,Te,Me,Ue,de,Se,ve,Le,Ne=re[1].trim(),Ze=Ne.length>1,$e={type:"list",raw:"",ordered:Ze,start:Ze?+Ne.slice(0,-1):"",loose:!1,items:[]};Ne=Ze?"\\d{1,9}\\"+Ne.slice(-1):"\\"+Ne,this.options.pedantic&&(Ne=Ze?Ne:"[*+-]");for(var He=new RegExp("^( {0,3}"+Ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");Y&&(Le=!1,!(!(re=He.exec(Y))||this.rules.block.hr.test(Y)));){if(H=re[0],Y=Y.substring(H.length),Ue=re[2].split(`
`,1)[0],de=Y.split(`
`,1)[0],this.options.pedantic?(pe=2,ve=Ue.trimLeft()):(pe=re[2].search(/[^ ]/),pe=pe>4?1:pe,ve=Ue.slice(pe),pe+=re[1].length),Te=!1,!Ue&&/^ *$/.test(de)&&(H+=de+`
`,Y=Y.substring(de.length+1),Le=!0),!Le)for(var je=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ye=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");Y&&(Se=Y.split(`
`,1)[0],Ue=Se,this.options.pedantic&&(Ue=Ue.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(je.test(Ue)||Ye.test(Y)));){if(Ue.search(/[^ ]/)>=pe||!Ue.trim())ve+=`
`+Ue.slice(pe);else if(!Te)ve+=`
`+Ue;else break;!Te&&!Ue.trim()&&(Te=!0),H+=Se+`
`,Y=Y.substring(Se.length+1)}$e.loose||(Me?$e.loose=!0:/\n *\n *$/.test(H)&&(Me=!0)),this.options.gfm&&(K=/^\[[ xX]\] /.exec(ve),K&&(ue=K[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),$e.items.push({type:"list_item",raw:H,task:!!K,checked:ue,loose:!1,text:ve}),$e.raw+=H}$e.items[$e.items.length-1].raw=H.trimRight(),$e.items[$e.items.length-1].text=ve.trimRight(),$e.raw=$e.raw.trimRight();var oe=$e.items.length;for(De=0;De<oe;De++){this.lexer.state.top=!1,$e.items[De].tokens=this.lexer.blockTokens($e.items[De].text,[]);var be=$e.items[De].tokens.filter(function(_e){return _e.type==="space"}),ke=be.every(function(_e){for(var Be=_e.raw.split(""),Fe=0,qe=P(Be),Ge;!(Ge=qe()).done;){var Ke=Ge.value;if(Ke===`
`&&(Fe+=1),Fe>1)return!0}return!1});!$e.loose&&be.length&&ke&&($e.loose=!0,$e.items[De].loose=!0)}return $e}},se.html=function(Y){var re=this.rules.block.html.exec(Y);if(re){var H={type:"html",raw:re[0],pre:!this.options.sanitizer&&(re[1]==="pre"||re[1]==="script"||re[1]==="style"),text:re[0]};return this.options.sanitize&&(H.type="paragraph",H.text=this.options.sanitizer?this.options.sanitizer(re[0]):m(re[0]),H.tokens=[],this.lexer.inline(H.text,H.tokens)),H}},se.def=function(Y){var re=this.rules.block.def.exec(Y);if(re){re[3]&&(re[3]=re[3].substring(1,re[3].length-1));var H=re[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:H,raw:re[0],href:re[2],title:re[3]}}},se.table=function(Y){var re=this.rules.block.table.exec(Y);if(re){var H={type:"table",header:h(re[1]).map(function(Me){return{text:Me}}),align:re[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:re[3]&&re[3].trim()?re[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=re[0];var K=H.align.length,ue,pe,De,Te;for(ue=0;ue<K;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(K=H.rows.length,ue=0;ue<K;ue++)H.rows[ue]=h(H.rows[ue],H.header.length).map(function(Me){return{text:Me}});for(K=H.header.length,pe=0;pe<K;pe++)H.header[pe].tokens=[],this.lexer.inline(H.header[pe].text,H.header[pe].tokens);for(K=H.rows.length,pe=0;pe<K;pe++)for(Te=H.rows[pe],De=0;De<Te.length;De++)Te[De].tokens=[],this.lexer.inline(Te[De].text,Te[De].tokens);return H}}},se.lheading=function(Y){var re=this.rules.block.lheading.exec(Y);if(re){var H={type:"heading",raw:re[0],depth:re[2].charAt(0)==="="?1:2,text:re[1],tokens:[]};return this.lexer.inline(H.text,H.tokens),H}},se.paragraph=function(Y){var re=this.rules.block.paragraph.exec(Y);if(re){var H={type:"paragraph",raw:re[0],text:re[1].charAt(re[1].length-1)===`
`?re[1].slice(0,-1):re[1],tokens:[]};return this.lexer.inline(H.text,H.tokens),H}},se.text=function(Y){var re=this.rules.block.text.exec(Y);if(re){var H={type:"text",raw:re[0],text:re[0],tokens:[]};return this.lexer.inline(H.text,H.tokens),H}},se.escape=function(Y){var re=this.rules.inline.escape.exec(Y);if(re)return{type:"escape",raw:re[0],text:m(re[1])}},se.tag=function(Y){var re=this.rules.inline.tag.exec(Y);if(re)return!this.lexer.state.inLink&&/^<a /i.test(re[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(re[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(re[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(re[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:re[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):m(re[0]):re[0]}},se.link=function(Y){var re=this.rules.inline.link.exec(Y);if(re){var H=re[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var K=b(H.slice(0,-1),"\\");if((H.length-K.length)%2==0)return}else{var ue=A(re[2],"()");if(ue>-1){var pe=re[0].indexOf("!")===0?5:4,De=pe+re[1].length+ue;re[2]=re[2].substring(0,ue),re[0]=re[0].substring(0,De).trim(),re[3]=""}}var Te=re[2],Me="";if(this.options.pedantic){var Ue=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);Ue&&(Te=Ue[1],Me=Ue[3])}else Me=re[3]?re[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(H)?Te=Te.slice(1):Te=Te.slice(1,-1)),Q(re,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},re[0],this.lexer)}},se.reflink=function(Y,re){var H;if((H=this.rules.inline.reflink.exec(Y))||(H=this.rules.inline.nolink.exec(Y))){var K=(H[2]||H[1]).replace(/\s+/g," ");if(K=re[K.toLowerCase()],!K||!K.href){var ue=H[0].charAt(0);return{type:"text",raw:ue,text:ue}}return Q(H,K,H[0],this.lexer)}},se.emStrong=function(Y,re,H){H===void 0&&(H="");var K=this.rules.inline.emStrong.lDelim.exec(Y);if(!!K&&!(K[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=K[1]||K[2]||"";if(!ue||ue&&(H===""||this.rules.inline.punctuation.exec(H))){var pe=K[0].length-1,De,Te,Me=pe,Ue=0,de=K[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,re=re.slice(-1*Y.length+pe);(K=de.exec(re))!=null;)if(De=K[1]||K[2]||K[3]||K[4]||K[5]||K[6],!!De){if(Te=De.length,K[3]||K[4]){Me+=Te;continue}else if((K[5]||K[6])&&pe%3&&!((pe+Te)%3)){Ue+=Te;continue}if(Me-=Te,!(Me>0)){if(Te=Math.min(Te,Te+Me+Ue),Math.min(pe,Te)%2){var Se=Y.slice(1,pe+K.index+Te);return{type:"em",raw:Y.slice(0,pe+K.index+Te+1),text:Se,tokens:this.lexer.inlineTokens(Se,[])}}var ve=Y.slice(2,pe+K.index+Te-1);return{type:"strong",raw:Y.slice(0,pe+K.index+Te+1),text:ve,tokens:this.lexer.inlineTokens(ve,[])}}}}}},se.codespan=function(Y){var re=this.rules.inline.code.exec(Y);if(re){var H=re[2].replace(/\n/g," "),K=/[^ ]/.test(H),ue=/^ /.test(H)&&/ $/.test(H);return K&&ue&&(H=H.substring(1,H.length-1)),H=m(H,!0),{type:"codespan",raw:re[0],text:H}}},se.br=function(Y){var re=this.rules.inline.br.exec(Y);if(re)return{type:"br",raw:re[0]}},se.del=function(Y){var re=this.rules.inline.del.exec(Y);if(re)return{type:"del",raw:re[0],text:re[2],tokens:this.lexer.inlineTokens(re[2],[])}},se.autolink=function(Y,re){var H=this.rules.inline.autolink.exec(Y);if(H){var K,ue;return H[2]==="@"?(K=m(this.options.mangle?re(H[1]):H[1]),ue="mailto:"+K):(K=m(H[1]),ue=K),{type:"link",raw:H[0],text:K,href:ue,tokens:[{type:"text",raw:K,text:K}]}}},se.url=function(Y,re){var H;if(H=this.rules.inline.url.exec(Y)){var K,ue;if(H[2]==="@")K=m(this.options.mangle?re(H[0]):H[0]),ue="mailto:"+K;else{var pe;do pe=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(pe!==H[0]);K=m(H[0]),H[1]==="www."?ue="http://"+K:ue=K}return{type:"link",raw:H[0],text:K,href:ue,tokens:[{type:"text",raw:K,text:K}]}}},se.inlineText=function(Y,re){var H=this.rules.inline.text.exec(Y);if(H){var K;return this.lexer.state.inRawBlock?K=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):m(H[0]):H[0]:K=m(this.options.smartypants?re(H[0]):H[0]),{type:"text",raw:H[0],text:K}}},Z}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:s,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=g(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=g(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=g(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=g(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=g(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=g(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=u({},F),F.gfm=u({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=g(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=g(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=u({},F.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:s,paragraph:g(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:s,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:s,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=g(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=g(F._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=g(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=g(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=g(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=g(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=g(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=g(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=g(U.reflink).replace("label",U._label).replace("ref",F._label).getRegex(),U.nolink=g(U.nolink).replace("ref",F._label).getRegex(),U.reflinkSearch=g(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=u({},U),U.pedantic=u({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=u({},U.normal,{escape:g(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=g(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=u({},U.gfm,{br:g(U.br).replace("{2,}","*").getRegex(),text:g(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function le(Z){return Z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(Z){var se="",ge,Y,re=Z.length;for(ge=0;ge<re;ge++)Y=Z.charCodeAt(ge),Math.random()>.5&&(Y="x"+Y.toString(16)),se+="&#"+Y+";";return se}var $=function(){function Z(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||ie.defaults,this.options.tokenizer=this.options.tokenizer||new X,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Y={block:F.normal,inline:U.normal};this.options.pedantic?(Y.block=F.pedantic,Y.inline=U.pedantic):this.options.gfm&&(Y.block=F.gfm,this.options.breaks?Y.inline=U.breaks:Y.inline=U.gfm),this.tokenizer.rules=Y}Z.lex=function(Y,re){var H=new Z(re);return H.lex(Y)},Z.lexInline=function(Y,re){var H=new Z(re);return H.inlineTokens(Y)};var se=Z.prototype;return se.lex=function(Y){Y=Y.replace(/\r\n|\r/g,`
`),this.blockTokens(Y,this.tokens);for(var re;re=this.inlineQueue.shift();)this.inlineTokens(re.src,re.tokens);return this.tokens},se.blockTokens=function(Y,re){var H=this;re===void 0&&(re=[]),this.options.pedantic?Y=Y.replace(/\t/g,"    ").replace(/^ +$/gm,""):Y=Y.replace(/^( *)(\t+)/gm,function(Me,Ue,de){return Ue+"    ".repeat(de.length)});for(var K,ue,pe,De;Y;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return(K=Me.call({lexer:H},Y,re))?(Y=Y.substring(K.raw.length),re.push(K),!0):!1}))){if(K=this.tokenizer.space(Y)){Y=Y.substring(K.raw.length),K.raw.length===1&&re.length>0?re[re.length-1].raw+=`
`:re.push(K);continue}if(K=this.tokenizer.code(Y)){Y=Y.substring(K.raw.length),ue=re[re.length-1],ue&&(ue.type==="paragraph"||ue.type==="text")?(ue.raw+=`
`+K.raw,ue.text+=`
`+K.text,this.inlineQueue[this.inlineQueue.length-1].src=ue.text):re.push(K);continue}if(K=this.tokenizer.fences(Y)){Y=Y.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.heading(Y)){Y=Y.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.hr(Y)){Y=Y.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.blockquote(Y)){Y=Y.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.list(Y)){Y=Y.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.html(Y)){Y=Y.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.def(Y)){Y=Y.substring(K.raw.length),ue=re[re.length-1],ue&&(ue.type==="paragraph"||ue.type==="text")?(ue.raw+=`
`+K.raw,ue.text+=`
`+K.raw,this.inlineQueue[this.inlineQueue.length-1].src=ue.text):this.tokens.links[K.tag]||(this.tokens.links[K.tag]={href:K.href,title:K.title});continue}if(K=this.tokenizer.table(Y)){Y=Y.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.lheading(Y)){Y=Y.substring(K.raw.length),re.push(K);continue}if(pe=Y,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,Ue=Y.slice(1),de=void 0;H.options.extensions.startBlock.forEach(function(Se){de=Se.call({lexer:this},Ue),typeof de=="number"&&de>=0&&(Me=Math.min(Me,de))}),Me<1/0&&Me>=0&&(pe=Y.substring(0,Me+1))}(),this.state.top&&(K=this.tokenizer.paragraph(pe))){ue=re[re.length-1],De&&ue.type==="paragraph"?(ue.raw+=`
`+K.raw,ue.text+=`
`+K.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ue.text):re.push(K),De=pe.length!==Y.length,Y=Y.substring(K.raw.length);continue}if(K=this.tokenizer.text(Y)){Y=Y.substring(K.raw.length),ue=re[re.length-1],ue&&ue.type==="text"?(ue.raw+=`
`+K.raw,ue.text+=`
`+K.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ue.text):re.push(K);continue}if(Y){var Te="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return this.state.top=!0,re},se.inline=function(Y,re){this.inlineQueue.push({src:Y,tokens:re})},se.inlineTokens=function(Y,re){var H=this;re===void 0&&(re=[]);var K,ue,pe,De=Y,Te,Me,Ue;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)de.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,Te.index)+"["+G("a",Te[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,Te.index)+"["+G("a",Te[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,Te.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Y;)if(Me||(Ue=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(K=ve.call({lexer:H},Y,re))?(Y=Y.substring(K.raw.length),re.push(K),!0):!1}))){if(K=this.tokenizer.escape(Y)){Y=Y.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.tag(Y)){Y=Y.substring(K.raw.length),ue=re[re.length-1],ue&&K.type==="text"&&ue.type==="text"?(ue.raw+=K.raw,ue.text+=K.text):re.push(K);continue}if(K=this.tokenizer.link(Y)){Y=Y.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.reflink(Y,this.tokens.links)){Y=Y.substring(K.raw.length),ue=re[re.length-1],ue&&K.type==="text"&&ue.type==="text"?(ue.raw+=K.raw,ue.text+=K.text):re.push(K);continue}if(K=this.tokenizer.emStrong(Y,De,Ue)){Y=Y.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.codespan(Y)){Y=Y.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.br(Y)){Y=Y.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.del(Y)){Y=Y.substring(K.raw.length),re.push(K);continue}if(K=this.tokenizer.autolink(Y,j)){Y=Y.substring(K.raw.length),re.push(K);continue}if(!this.state.inLink&&(K=this.tokenizer.url(Y,j))){Y=Y.substring(K.raw.length),re.push(K);continue}if(pe=Y,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Le=Y.slice(1),Ne=void 0;H.options.extensions.startInline.forEach(function(Ze){Ne=Ze.call({lexer:this},Le),typeof Ne=="number"&&Ne>=0&&(ve=Math.min(ve,Ne))}),ve<1/0&&ve>=0&&(pe=Y.substring(0,ve+1))}(),K=this.tokenizer.inlineText(pe,le)){Y=Y.substring(K.raw.length),K.raw.slice(-1)!=="_"&&(Ue=K.raw.slice(-1)),Me=!0,ue=re[re.length-1],ue&&ue.type==="text"?(ue.raw+=K.raw,ue.text+=K.text):re.push(K);continue}if(Y){var Se="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return re},I(Z,null,[{key:"rules",get:function(){return{block:F,inline:U}}}]),Z}(),O=function(){function Z(ge){this.options=ge||ie.defaults}var se=Z.prototype;return se.code=function(Y,re,H){var K=(re||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(Y,K);ue!=null&&ue!==Y&&(H=!0,Y=ue)}return Y=Y.replace(/\n$/,"")+`
`,K?'<pre><code class="'+this.options.langPrefix+m(K,!0)+'">'+(H?Y:m(Y,!0))+`</code></pre>
`:"<pre><code>"+(H?Y:m(Y,!0))+`</code></pre>
`},se.blockquote=function(Y){return`<blockquote>
`+Y+`</blockquote>
`},se.html=function(Y){return Y},se.heading=function(Y,re,H,K){if(this.options.headerIds){var ue=this.options.headerPrefix+K.slug(H);return"<h"+re+' id="'+ue+'">'+Y+"</h"+re+`>
`}return"<h"+re+">"+Y+"</h"+re+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(Y,re,H){var K=re?"ol":"ul",ue=re&&H!==1?' start="'+H+'"':"";return"<"+K+ue+`>
`+Y+"</"+K+`>
`},se.listitem=function(Y){return"<li>"+Y+`</li>
`},se.checkbox=function(Y){return"<input "+(Y?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(Y){return"<p>"+Y+`</p>
`},se.table=function(Y,re){return re&&(re="<tbody>"+re+"</tbody>"),`<table>
<thead>
`+Y+`</thead>
`+re+`</table>
`},se.tablerow=function(Y){return`<tr>
`+Y+`</tr>
`},se.tablecell=function(Y,re){var H=re.header?"th":"td",K=re.align?"<"+H+' align="'+re.align+'">':"<"+H+">";return K+Y+("</"+H+`>
`)},se.strong=function(Y){return"<strong>"+Y+"</strong>"},se.em=function(Y){return"<em>"+Y+"</em>"},se.codespan=function(Y){return"<code>"+Y+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(Y){return"<del>"+Y+"</del>"},se.link=function(Y,re,H){if(Y=c(this.options.sanitize,this.options.baseUrl,Y),Y===null)return H;var K='<a href="'+m(Y)+'"';return re&&(K+=' title="'+re+'"'),K+=">"+H+"</a>",K},se.image=function(Y,re,H){if(Y=c(this.options.sanitize,this.options.baseUrl,Y),Y===null)return H;var K='<img src="'+Y+'" alt="'+H+'"';return re&&(K+=' title="'+re+'"'),K+=this.options.xhtml?"/>":">",K},se.text=function(Y){return Y},Z}(),M=function(){function Z(){}var se=Z.prototype;return se.strong=function(Y){return Y},se.em=function(Y){return Y},se.codespan=function(Y){return Y},se.del=function(Y){return Y},se.html=function(Y){return Y},se.text=function(Y){return Y},se.link=function(Y,re,H){return""+H},se.image=function(Y,re,H){return""+H},se.br=function(){return""},Z}(),W=function(){function Z(){this.seen={}}var se=Z.prototype;return se.serialize=function(Y){return Y.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(Y,re){var H=Y,K=0;if(this.seen.hasOwnProperty(H)){K=this.seen[Y];do K++,H=Y+"-"+K;while(this.seen.hasOwnProperty(H))}return re||(this.seen[Y]=K,this.seen[H]=0),H},se.slug=function(Y,re){re===void 0&&(re={});var H=this.serialize(Y);return this.getNextSafeSlug(H,re.dryrun)},Z}(),J=function(){function Z(ge){this.options=ge||ie.defaults,this.options.renderer=this.options.renderer||new O,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new M,this.slugger=new W}Z.parse=function(Y,re){var H=new Z(re);return H.parse(Y)},Z.parseInline=function(Y,re){var H=new Z(re);return H.parseInline(Y)};var se=Z.prototype;return se.parse=function(Y,re){re===void 0&&(re=!0);var H="",K,ue,pe,De,Te,Me,Ue,de,Se,ve,Le,Ne,Ze,$e,He,je,Ye,oe,be,ke=Y.length;for(K=0;K<ke;K++){if(ve=Y[K],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(be=this.options.extensions.renderers[ve.type].call({parser:this},ve),be!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){H+=be||"";continue}switch(ve.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,f(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(de="",Ue="",De=ve.header.length,ue=0;ue<De;ue++)Ue+=this.renderer.tablecell(this.parseInline(ve.header[ue].tokens),{header:!0,align:ve.align[ue]});for(de+=this.renderer.tablerow(Ue),Se="",De=ve.rows.length,ue=0;ue<De;ue++){for(Me=ve.rows[ue],Ue="",Te=Me.length,pe=0;pe<Te;pe++)Ue+=this.renderer.tablecell(this.parseInline(Me[pe].tokens),{header:!1,align:ve.align[pe]});Se+=this.renderer.tablerow(Ue)}H+=this.renderer.table(de,Se);continue}case"blockquote":{Se=this.parse(ve.tokens),H+=this.renderer.blockquote(Se);continue}case"list":{for(Le=ve.ordered,Ne=ve.start,Ze=ve.loose,De=ve.items.length,Se="",ue=0;ue<De;ue++)He=ve.items[ue],je=He.checked,Ye=He.task,$e="",He.task&&(oe=this.renderer.checkbox(je),Ze?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=oe+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=oe+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:oe}):$e+=oe),$e+=this.parse(He.tokens,Ze),Se+=this.renderer.listitem($e,Ye,je);H+=this.renderer.list(Se,Le,Ne);continue}case"html":{H+=this.renderer.html(ve.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Se=ve.tokens?this.parseInline(ve.tokens):ve.text;K+1<ke&&Y[K+1].type==="text";)ve=Y[++K],Se+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);H+=re?this.renderer.paragraph(Se):Se;continue}default:{var _e='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(_e);return}else throw new Error(_e)}}}return H},se.parseInline=function(Y,re){re=re||this.renderer;var H="",K,ue,pe,De=Y.length;for(K=0;K<De;K++){if(ue=Y[K],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(pe=this.options.extensions.renderers[ue.type].call({parser:this},ue),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ue.type))){H+=pe||"";continue}switch(ue.type){case"escape":{H+=re.text(ue.text);break}case"html":{H+=re.html(ue.text);break}case"link":{H+=re.link(ue.href,ue.title,this.parseInline(ue.tokens,re));break}case"image":{H+=re.image(ue.href,ue.title,ue.text);break}case"strong":{H+=re.strong(this.parseInline(ue.tokens,re));break}case"em":{H+=re.em(this.parseInline(ue.tokens,re));break}case"codespan":{H+=re.codespan(ue.text);break}case"br":{H+=re.br();break}case"del":{H+=re.del(this.parseInline(ue.tokens,re));break}case"text":{H+=re.text(ue.text);break}default:{var Te='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return H},Z}();function ae(Z,se,ge){if(typeof Z=="undefined"||Z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");if(typeof se=="function"&&(ge=se,se=null),se=u({},ae.defaults,se||{}),B(se),ge){var Y=se.highlight,re;try{re=$.lex(Z,se)}catch(pe){return ge(pe)}var H=function(De){var Te;if(!De)try{se.walkTokens&&ae.walkTokens(re,se.walkTokens),Te=J.parse(re,se)}catch(Me){De=Me}return se.highlight=Y,De?ge(De):ge(null,Te)};if(!Y||Y.length<3||(delete se.highlight,!re.length))return H();var K=0;ae.walkTokens(re,function(pe){pe.type==="code"&&(K++,setTimeout(function(){Y(pe.text,pe.lang,function(De,Te){if(De)return H(De);Te!=null&&Te!==pe.text&&(pe.text=Te,pe.escaped=!0),K--,K===0&&H()})},0))}),K===0&&H();return}try{var ue=$.lex(Z,se);return se.walkTokens&&ae.walkTokens(ue,se.walkTokens),J.parse(ue,se)}catch(pe){if(pe.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+m(pe.message+"",!0)+"</pre>";throw pe}}ae.options=ae.setOptions=function(Z){return u(ae.defaults,Z),S(ae.defaults),ae},ae.getDefaults=k,ae.defaults=ie.defaults,ae.use=function(){for(var Z=arguments.length,se=new Array(Z),ge=0;ge<Z;ge++)se[ge]=arguments[ge];var Y=u.apply(void 0,[{}].concat(se)),re=ae.defaults.extensions||{renderers:{},childTokens:{}},H;se.forEach(function(K){if(K.extensions&&(H=!0,K.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var De=re.renderers?re.renderers[pe.name]:null;De?re.renderers[pe.name]=function(){for(var Te=arguments.length,Me=new Array(Te),Ue=0;Ue<Te;Ue++)Me[Ue]=arguments[Ue];var de=pe.renderer.apply(this,Me);return de===!1&&(de=De.apply(this,Me)),de}:re.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");re[pe.level]?re[pe.level].unshift(pe.tokenizer):re[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?re.startBlock?re.startBlock.push(pe.start):re.startBlock=[pe.start]:pe.level==="inline"&&(re.startInline?re.startInline.push(pe.start):re.startInline=[pe.start]))}pe.childTokens&&(re.childTokens[pe.name]=pe.childTokens)})),K.renderer&&function(){var pe=ae.defaults.renderer||new O,De=function(Ue){var de=pe[Ue];pe[Ue]=function(){for(var Se=arguments.length,ve=new Array(Se),Le=0;Le<Se;Le++)ve[Le]=arguments[Le];var Ne=K.renderer[Ue].apply(pe,ve);return Ne===!1&&(Ne=de.apply(pe,ve)),Ne}};for(var Te in K.renderer)De(Te);Y.renderer=pe}(),K.tokenizer&&function(){var pe=ae.defaults.tokenizer||new X,De=function(Ue){var de=pe[Ue];pe[Ue]=function(){for(var Se=arguments.length,ve=new Array(Se),Le=0;Le<Se;Le++)ve[Le]=arguments[Le];var Ne=K.tokenizer[Ue].apply(pe,ve);return Ne===!1&&(Ne=de.apply(pe,ve)),Ne}};for(var Te in K.tokenizer)De(Te);Y.tokenizer=pe}(),K.walkTokens){var ue=ae.defaults.walkTokens;Y.walkTokens=function(pe){K.walkTokens.call(this,pe),ue&&ue.call(this,pe)}}H&&(Y.extensions=re),ae.setOptions(Y)})},ae.walkTokens=function(Z,se){for(var ge=function(){var K=re.value;switch(se.call(ae,K),K.type){case"table":{for(var ue=P(K.header),pe;!(pe=ue()).done;){var De=pe.value;ae.walkTokens(De.tokens,se)}for(var Te=P(K.rows),Me;!(Me=Te()).done;)for(var Ue=Me.value,de=P(Ue),Se;!(Se=de()).done;){var ve=Se.value;ae.walkTokens(ve.tokens,se)}break}case"list":{ae.walkTokens(K.items,se);break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[K.type]?ae.defaults.extensions.childTokens[K.type].forEach(function(Le){ae.walkTokens(K[Le],se)}):K.tokens&&ae.walkTokens(K.tokens,se)}},Y=P(Z),re;!(re=Y()).done;)ge()},ae.parseInline=function(Z,se){if(typeof Z=="undefined"||Z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");se=u({},ae.defaults,se||{}),B(se);try{var ge=$.lexInline(Z,se);return se.walkTokens&&ae.walkTokens(ge,se.walkTokens),J.parseInline(ge,se)}catch(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+m(Y.message+"",!0)+"</pre>";throw Y}},ae.Parser=J,ae.parser=J.parse,ae.Renderer=O,ae.TextRenderer=M,ae.Lexer=$,ae.lexer=$.lex,ae.Tokenizer=X,ae.Slugger=W,ae.parse=ae;var me=ae.options,fe=ae.setOptions,V=ae.use,ee=ae.walkTokens,x=ae.parseInline,z=ae,te=J.parse,ce=$.lex;ie.Lexer=$,ie.Parser=J,ie.Renderer=O,ie.Slugger=W,ie.TextRenderer=M,ie.Tokenizer=X,ie.getDefaults=k,ie.lexer=ce,ie.marked=ae,ie.options=me,ie.parse=z,ie.parseInline=x,ie.parser=te,ie.setOptions=fe,ie.use=V,ie.walkTokens=ee,Object.defineProperty(ie,"__esModule",{value:!0})}),function(){function ie(y){const P=[];typeof y=="number"&&P.push("code/timeOrigin",y);function k(v){P.push(v,Date.now())}function S(){const v=[];for(let D=0;D<P.length;D+=2)v.push({name:P[D],startTime:P[D+1]});return v}return{mark:k,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const k of performance.getEntriesByType("mark"))P.push({name:k.name,startTime:Math.round(y+k.startTime)});return P}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function I(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=I(t))}(),define(we[3],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const I="en";let t=!1,y=!1,P=!1,k=!1,S=!1,v=!1,D=!1,T=!1,R=!1,C,w=I,m,E;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const p=typeof f?.versions?.electron=="string",g=p&&f?.type==="renderer";if(typeof navigator=="object"&&!g){E=navigator.userAgent,t=E.indexOf("Windows")>=0,y=E.indexOf("Macintosh")>=0,T=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=E.indexOf("Linux")>=0,v=!0,C=I,w=C;const s=typeof document!="undefined"&&document.getElementById("vscode-remote-nls-configuration"),u=s&&s.getAttribute("data-settings");if(u)try{const h=JSON.parse(u);C=h.locale,m=h._translationsConfigFile,w=h.availableLanguages["*"]||I}catch{}}else if(typeof f=="object"){t=f.platform==="win32",y=f.platform==="darwin",P=f.platform==="linux",k=P&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,D=p,R=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=I,w=I;const s=f.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),h=u.availableLanguages["*"];C=u.locale,w=h||I,m=u._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var d;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function l(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let c=0;y?c=1:t?c=3:P&&(c=2),e.isWindows=t,e.isMacintosh=y,e.isLinux=P,e.isLinuxSnap=k,e.isNative=S,e.isElectron=D,e.isWeb=v,e.isWebWorker=v&&typeof e.globals.importScripts=="function",e.isIOS=T,e.isCI=R,e.platform=c,e.userAgent=E,e.language=w;var n;(function(s){function u(){return e.language}s.value=u;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=h;function b(){return e.language==="en"}s.isDefault=b})(n=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){let s=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let b=0,A=s.length;b<A;b++){const B=s[b];if(B.id===h.data.vscodeScheduleAsyncWork){s.splice(b,1),B.callback();return}}});let u=0;return h=>{const b=++u;s.push({id:b,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:b},"*")}}return s=>setTimeout(s)})();var o;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||T?2:t?1:3;let i=!0,a=!1;function r(){if(!a){a=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,i=new Uint16Array(s.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(we[27],ye([0,1,3]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof I.globals.vscode!="undefined"&&typeof I.globals.vscode.process!="undefined"){const y=I.globals.vscode.process;t={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(we[5],ye([0,1,27]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,y=97,P=90,k=122,S=46,v=47,D=92,T=58,R=63;class C extends Error{constructor(l,c,n){let o;typeof c=="string"&&c.indexOf("not ")===0?(o="must not be",c=c.replace(/^not /,"")):o="must be";const i=l.indexOf(".")!==-1?"property":"argument";let a=`The "${l}" ${i} ${o} of type ${c}`;a+=`. Received type ${typeof n}`;super(a);this.code="ERR_INVALID_ARG_TYPE"}}function w(d,l){if(typeof d!="string")throw new C(l,"string",d)}function m(d){return d===v||d===D}function E(d){return d===v}function f(d){return d>=t&&d<=P||d>=y&&d<=k}function p(d,l,c,n){let o="",i=0,a=-1,r=0,s=0;for(let u=0;u<=d.length;++u){if(u<d.length)s=d.charCodeAt(u);else{if(n(s))break;s=v}if(n(s)){if(!(a===u-1||r===1))if(r===2){if(o.length<2||i!==2||o.charCodeAt(o.length-1)!==S||o.charCodeAt(o.length-2)!==S){if(o.length>2){const h=o.lastIndexOf(c);h===-1?(o="",i=0):(o=o.slice(0,h),i=o.length-1-o.lastIndexOf(c)),a=u,r=0;continue}else if(o.length!==0){o="",i=0,a=u,r=0;continue}}l&&(o+=o.length>0?`${c}..`:"..",i=2)}else o.length>0?o+=`${c}${d.slice(a+1,u)}`:o=d.slice(a+1,u),i=u-a-1;a=u,r=0}else s===S&&r!==-1?++r:r=-1}return o}function g(d,l){if(l===null||typeof l!="object")throw new C("pathObject","Object",l);const c=l.dir||l.root,n=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${n}`:`${c}${d}${n}`:n}e.win32={resolve(...d){let l="",c="",n=!1;for(let o=d.length-1;o>=-1;o--){let i;if(o>=0){if(i=d[o],w(i,"path"),i.length===0)continue}else l.length===0?i=I.cwd():(i=I.env[`=${l}`]||I.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==l.toLowerCase()&&i.charCodeAt(2)===D)&&(i=`${l}\\`));const a=i.length;let r=0,s="",u=!1;const h=i.charCodeAt(0);if(a===1)m(h)&&(r=1,u=!0);else if(m(h))if(u=!0,m(i.charCodeAt(1))){let b=2,A=b;for(;b<a&&!m(i.charCodeAt(b));)b++;if(b<a&&b!==A){const B=i.slice(A,b);for(A=b;b<a&&m(i.charCodeAt(b));)b++;if(b<a&&b!==A){for(A=b;b<a&&!m(i.charCodeAt(b));)b++;(b===a||b!==A)&&(s=`\\\\${B}\\${i.slice(A,b)}`,r=b)}}}else r=1;else f(h)&&i.charCodeAt(1)===T&&(s=i.slice(0,2),r=2,a>2&&m(i.charCodeAt(2))&&(u=!0,r=3));if(s.length>0)if(l.length>0){if(s.toLowerCase()!==l.toLowerCase())continue}else l=s;if(n){if(l.length>0)break}else if(c=`${i.slice(r)}\\${c}`,n=u,u&&l.length>0)break}return c=p(c,!n,"\\",m),n?`${l}\\${c}`:`${l}${c}`||"."},normalize(d){w(d,"path");const l=d.length;if(l===0)return".";let c=0,n,o=!1;const i=d.charCodeAt(0);if(l===1)return E(i)?"\\":d;if(m(i))if(o=!0,m(d.charCodeAt(1))){let r=2,s=r;for(;r<l&&!m(d.charCodeAt(r));)r++;if(r<l&&r!==s){const u=d.slice(s,r);for(s=r;r<l&&m(d.charCodeAt(r));)r++;if(r<l&&r!==s){for(s=r;r<l&&!m(d.charCodeAt(r));)r++;if(r===l)return`\\\\${u}\\${d.slice(s)}\\`;r!==s&&(n=`\\\\${u}\\${d.slice(s,r)}`,c=r)}}}else c=1;else f(i)&&d.charCodeAt(1)===T&&(n=d.slice(0,2),c=2,l>2&&m(d.charCodeAt(2))&&(o=!0,c=3));let a=c<l?p(d.slice(c),!o,"\\",m):"";return a.length===0&&!o&&(a="."),a.length>0&&m(d.charCodeAt(l-1))&&(a+="\\"),n===void 0?o?`\\${a}`:a:o?`${n}\\${a}`:`${n}${a}`},isAbsolute(d){w(d,"path");const l=d.length;if(l===0)return!1;const c=d.charCodeAt(0);return m(c)||l>2&&f(c)&&d.charCodeAt(1)===T&&m(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let l,c;for(let i=0;i<d.length;++i){const a=d[i];w(a,"path"),a.length>0&&(l===void 0?l=c=a:l+=`\\${a}`)}if(l===void 0)return".";let n=!0,o=0;if(typeof c=="string"&&m(c.charCodeAt(0))){++o;const i=c.length;i>1&&m(c.charCodeAt(1))&&(++o,i>2&&(m(c.charCodeAt(2))?++o:n=!1))}if(n){for(;o<l.length&&m(l.charCodeAt(o));)o++;o>=2&&(l=`\\${l.slice(o)}`)}return e.win32.normalize(l)},relative(d,l){if(w(d,"from"),w(l,"to"),d===l)return"";const c=e.win32.resolve(d),n=e.win32.resolve(l);if(c===n||(d=c.toLowerCase(),l=n.toLowerCase(),d===l))return"";let o=0;for(;o<d.length&&d.charCodeAt(o)===D;)o++;let i=d.length;for(;i-1>o&&d.charCodeAt(i-1)===D;)i--;const a=i-o;let r=0;for(;r<l.length&&l.charCodeAt(r)===D;)r++;let s=l.length;for(;s-1>r&&l.charCodeAt(s-1)===D;)s--;const u=s-r,h=a<u?a:u;let b=-1,A=0;for(;A<h;A++){const G=d.charCodeAt(o+A);if(G!==l.charCodeAt(r+A))break;G===D&&(b=A)}if(A!==h){if(b===-1)return n}else{if(u>h){if(l.charCodeAt(r+A)===D)return n.slice(r+A+1);if(A===2)return n.slice(r+A)}a>h&&(d.charCodeAt(o+A)===D?b=A:A===2&&(b=3)),b===-1&&(b=0)}let B="";for(A=o+b+1;A<=i;++A)(A===i||d.charCodeAt(A)===D)&&(B+=B.length===0?"..":"\\..");return r+=b,B.length>0?`${B}${n.slice(r,s)}`:(n.charCodeAt(r)===D&&++r,n.slice(r,s))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const l=e.win32.resolve(d);if(l.length<=2)return d;if(l.charCodeAt(0)===D){if(l.charCodeAt(1)===D){const c=l.charCodeAt(2);if(c!==R&&c!==S)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(f(l.charCodeAt(0))&&l.charCodeAt(1)===T&&l.charCodeAt(2)===D)return`\\\\?\\${l}`;return d},dirname(d){w(d,"path");const l=d.length;if(l===0)return".";let c=-1,n=0;const o=d.charCodeAt(0);if(l===1)return m(o)?d:".";if(m(o)){if(c=n=1,m(d.charCodeAt(1))){let r=2,s=r;for(;r<l&&!m(d.charCodeAt(r));)r++;if(r<l&&r!==s){for(s=r;r<l&&m(d.charCodeAt(r));)r++;if(r<l&&r!==s){for(s=r;r<l&&!m(d.charCodeAt(r));)r++;if(r===l)return d;r!==s&&(c=n=r+1)}}}}else f(o)&&d.charCodeAt(1)===T&&(c=l>2&&m(d.charCodeAt(2))?3:2,n=c);let i=-1,a=!0;for(let r=l-1;r>=n;--r)if(m(d.charCodeAt(r))){if(!a){i=r;break}}else a=!1;if(i===-1){if(c===-1)return".";i=c}return d.slice(0,i)},basename(d,l){l!==void 0&&w(l,"ext"),w(d,"path");let c=0,n=-1,o=!0,i;if(d.length>=2&&f(d.charCodeAt(0))&&d.charCodeAt(1)===T&&(c=2),l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let a=l.length-1,r=-1;for(i=d.length-1;i>=c;--i){const s=d.charCodeAt(i);if(m(s)){if(!o){c=i+1;break}}else r===-1&&(o=!1,r=i+1),a>=0&&(s===l.charCodeAt(a)?--a==-1&&(n=i):(a=-1,n=r))}return c===n?n=r:n===-1&&(n=d.length),d.slice(c,n)}for(i=d.length-1;i>=c;--i)if(m(d.charCodeAt(i))){if(!o){c=i+1;break}}else n===-1&&(o=!1,n=i+1);return n===-1?"":d.slice(c,n)},extname(d){w(d,"path");let l=0,c=-1,n=0,o=-1,i=!0,a=0;d.length>=2&&d.charCodeAt(1)===T&&f(d.charCodeAt(0))&&(l=n=2);for(let r=d.length-1;r>=l;--r){const s=d.charCodeAt(r);if(m(s)){if(!i){n=r+1;break}continue}o===-1&&(i=!1,o=r+1),s===S?c===-1?c=r:a!==1&&(a=1):c!==-1&&(a=-1)}return c===-1||o===-1||a===0||a===1&&c===o-1&&c===n+1?"":d.slice(c,o)},format:g.bind(null,"\\"),parse(d){w(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const c=d.length;let n=0,o=d.charCodeAt(0);if(c===1)return m(o)?(l.root=l.dir=d,l):(l.base=l.name=d,l);if(m(o)){if(n=1,m(d.charCodeAt(1))){let b=2,A=b;for(;b<c&&!m(d.charCodeAt(b));)b++;if(b<c&&b!==A){for(A=b;b<c&&m(d.charCodeAt(b));)b++;if(b<c&&b!==A){for(A=b;b<c&&!m(d.charCodeAt(b));)b++;b===c?n=b:b!==A&&(n=b+1)}}}}else if(f(o)&&d.charCodeAt(1)===T){if(c<=2)return l.root=l.dir=d,l;if(n=2,m(d.charCodeAt(2))){if(c===3)return l.root=l.dir=d,l;n=3}}n>0&&(l.root=d.slice(0,n));let i=-1,a=n,r=-1,s=!0,u=d.length-1,h=0;for(;u>=n;--u){if(o=d.charCodeAt(u),m(o)){if(!s){a=u+1;break}continue}r===-1&&(s=!1,r=u+1),o===S?i===-1?i=u:h!==1&&(h=1):i!==-1&&(h=-1)}return r!==-1&&(i===-1||h===0||h===1&&i===r-1&&i===a+1?l.base=l.name=d.slice(a,r):(l.name=d.slice(a,i),l.base=d.slice(a,r),l.ext=d.slice(i,r))),a>0&&a!==n?l.dir=d.slice(0,a-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let l="",c=!1;for(let n=d.length-1;n>=-1&&!c;n--){const o=n>=0?d[n]:I.cwd();w(o,"path"),o.length!==0&&(l=`${o}/${l}`,c=o.charCodeAt(0)===v)}return l=p(l,!c,"/",E),c?`/${l}`:l.length>0?l:"."},normalize(d){if(w(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===v,c=d.charCodeAt(d.length-1)===v;return d=p(d,!l,"/",E),d.length===0?l?"/":c?"./":".":(c&&(d+="/"),l?`/${d}`:d)},isAbsolute(d){return w(d,"path"),d.length>0&&d.charCodeAt(0)===v},join(...d){if(d.length===0)return".";let l;for(let c=0;c<d.length;++c){const n=d[c];w(n,"path"),n.length>0&&(l===void 0?l=n:l+=`/${n}`)}return l===void 0?".":e.posix.normalize(l)},relative(d,l){if(w(d,"from"),w(l,"to"),d===l||(d=e.posix.resolve(d),l=e.posix.resolve(l),d===l))return"";const c=1,n=d.length,o=n-c,i=1,a=l.length-i,r=o<a?o:a;let s=-1,u=0;for(;u<r;u++){const b=d.charCodeAt(c+u);if(b!==l.charCodeAt(i+u))break;b===v&&(s=u)}if(u===r)if(a>r){if(l.charCodeAt(i+u)===v)return l.slice(i+u+1);if(u===0)return l.slice(i+u)}else o>r&&(d.charCodeAt(c+u)===v?s=u:u===0&&(s=0));let h="";for(u=c+s+1;u<=n;++u)(u===n||d.charCodeAt(u)===v)&&(h+=h.length===0?"..":"/..");return`${h}${l.slice(i+s)}`},toNamespacedPath(d){return d},dirname(d){if(w(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===v;let c=-1,n=!0;for(let o=d.length-1;o>=1;--o)if(d.charCodeAt(o)===v){if(!n){c=o;break}}else n=!1;return c===-1?l?"/":".":l&&c===1?"//":d.slice(0,c)},basename(d,l){l!==void 0&&w(l,"ext"),w(d,"path");let c=0,n=-1,o=!0,i;if(l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let a=l.length-1,r=-1;for(i=d.length-1;i>=0;--i){const s=d.charCodeAt(i);if(s===v){if(!o){c=i+1;break}}else r===-1&&(o=!1,r=i+1),a>=0&&(s===l.charCodeAt(a)?--a==-1&&(n=i):(a=-1,n=r))}return c===n?n=r:n===-1&&(n=d.length),d.slice(c,n)}for(i=d.length-1;i>=0;--i)if(d.charCodeAt(i)===v){if(!o){c=i+1;break}}else n===-1&&(o=!1,n=i+1);return n===-1?"":d.slice(c,n)},extname(d){w(d,"path");let l=-1,c=0,n=-1,o=!0,i=0;for(let a=d.length-1;a>=0;--a){const r=d.charCodeAt(a);if(r===v){if(!o){c=a+1;break}continue}n===-1&&(o=!1,n=a+1),r===S?l===-1?l=a:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||n===-1||i===0||i===1&&l===n-1&&l===c+1?"":d.slice(l,n)},format:g.bind(null,"/"),parse(d){w(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const c=d.charCodeAt(0)===v;let n;c?(l.root="/",n=1):n=0;let o=-1,i=0,a=-1,r=!0,s=d.length-1,u=0;for(;s>=n;--s){const h=d.charCodeAt(s);if(h===v){if(!r){i=s+1;break}continue}a===-1&&(r=!1,a=s+1),h===S?o===-1?o=s:u!==1&&(u=1):o!==-1&&(u=-1)}if(a!==-1){const h=i===0&&c?1:i;o===-1||u===0||u===1&&o===a-1&&o===i+1?l.base=l.name=d.slice(h,a):(l.name=d.slice(h,o),l.base=d.slice(h,a),l.ext=d.slice(o,a))}return i>0?l.dir=d.slice(0,i-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=I.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=I.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=I.platform==="win32"?e.win32.join:e.posix.join,e.resolve=I.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=I.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=I.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=I.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=I.platform==="win32"?e.win32.extname:e.posix.extname,e.format=I.platform==="win32"?e.win32.format:e.posix.format,e.parse=I.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=I.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=I.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=I.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[64],ye([0,1,5]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(R){R.text="text/plain",R.binary="application/octet-stream",R.unknown="application/unknown",R.markdown="text/markdown",R.latex="text/latex",R.uriList="text/uri-list"})(t=e.Mimes||(e.Mimes={}));const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(R){const C=(0,I.extname)(R),w=y[C.toLowerCase()];return w!==void 0?w:S(R)}e.getMediaOrTextMime=k;function S(R){const C=(0,I.extname)(R);return P[C.toLowerCase()]}e.getMediaMime=S;function v(R){for(const C in P)if(P[C]===R)return C}e.getExtensionForMimeType=v;const D=/^(.+)\/(.+?)(;.+)?$/;function T(R,C){const w=D.exec(R);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:C?void 0:R}e.normalizeMimeType=T}),define(we[53],ye([0,1,3]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var y;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(y=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(S,...v){const D=v.reduce((C,w)=>(C[w]=!0,C),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(S).filter(C=>!D[C]).forEach(C=>{for(let w=0;w<T.length;w++)if(C.search(T[w])!==-1){delete S[C];break}})}e.sanitizeProcessEnvironment=P;function k(S){!S||(delete S.DEBUG,I.isMacintosh&&delete S.DYLD_LIBRARY_PATH,I.isLinux&&delete S.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var t in I)(typeof exports=="object"?exports:ie)[t]=I[t]}}(typeof self!="undefined"?self:this,function(){return function(ie){var e={};function I(t){if(e[t])return e[t].exports;var y=e[t]={i:t,l:!1,exports:{}};return ie[t].call(y.exports,y,y.exports,I),y.l=!0,y.exports}return I.m=ie,I.c=e,I.d=function(t,y,P){I.o(t,y)||Object.defineProperty(t,y,{enumerable:!0,get:P})},I.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},I.t=function(t,y){if(1&y&&(t=I(t)),8&y||4&y&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(I.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&y&&typeof t!="string")for(var k in t)I.d(P,k,function(S){return t[S]}.bind(null,k));return P},I.n=function(t){var y=t&&t.__esModule?function(){return t.default}:function(){return t};return I.d(y,"a",y),y},I.o=function(t,y){return Object.prototype.hasOwnProperty.call(t,y)},I.p="",I(I.s=0)}([function(ie,e,I){(function(t){var y;e=ie.exports=V,y=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var de=Array.prototype.slice.call(arguments,0);de.unshift("SEMVER"),console.log.apply(console,de)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],v=e.src=[],D=0,T=D++;v[T]="0|[1-9]\\d*";var R=D++;v[R]="[0-9]+";var C=D++;v[C]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=D++;v[w]="("+v[T]+")\\.("+v[T]+")\\.("+v[T]+")";var m=D++;v[m]="("+v[R]+")\\.("+v[R]+")\\.("+v[R]+")";var E=D++;v[E]="(?:"+v[T]+"|"+v[C]+")";var f=D++;v[f]="(?:"+v[R]+"|"+v[C]+")";var p=D++;v[p]="(?:-("+v[E]+"(?:\\."+v[E]+")*))";var g=D++;v[g]="(?:-?("+v[f]+"(?:\\."+v[f]+")*))";var d=D++;v[d]="[0-9A-Za-z-]+";var l=D++;v[l]="(?:\\+("+v[d]+"(?:\\."+v[d]+")*))";var c=D++,n="v?"+v[w]+v[p]+"?"+v[l]+"?";v[c]="^"+n+"$";var o="[v=\\s]*"+v[m]+v[g]+"?"+v[l]+"?",i=D++;v[i]="^"+o+"$";var a=D++;v[a]="((?:<|>)?=?)";var r=D++;v[r]=v[R]+"|x|X|\\*";var s=D++;v[s]=v[T]+"|x|X|\\*";var u=D++;v[u]="[v=\\s]*("+v[s]+")(?:\\.("+v[s]+")(?:\\.("+v[s]+")(?:"+v[p]+")?"+v[l]+"?)?)?";var h=D++;v[h]="[v=\\s]*("+v[r]+")(?:\\.("+v[r]+")(?:\\.("+v[r]+")(?:"+v[g]+")?"+v[l]+"?)?)?";var b=D++;v[b]="^"+v[a]+"\\s*"+v[u]+"$";var A=D++;v[A]="^"+v[a]+"\\s*"+v[h]+"$";var B=D++;v[B]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=D++;v[G]="(?:~>?)";var Q=D++;v[Q]="(\\s*)"+v[G]+"\\s+",S[Q]=new RegExp(v[Q],"g");var _=D++;v[_]="^"+v[G]+v[u]+"$";var X=D++;v[X]="^"+v[G]+v[h]+"$";var F=D++;v[F]="(?:\\^)";var U=D++;v[U]="(\\s*)"+v[F]+"\\s+",S[U]=new RegExp(v[U],"g");var le=D++;v[le]="^"+v[F]+v[u]+"$";var j=D++;v[j]="^"+v[F]+v[h]+"$";var $=D++;v[$]="^"+v[a]+"\\s*("+o+")$|^$";var O=D++;v[O]="^"+v[a]+"\\s*("+n+")$|^$";var M=D++;v[M]="(\\s*)"+v[a]+"\\s*("+o+"|"+v[u]+")",S[M]=new RegExp(v[M],"g");var W=D++;v[W]="^\\s*("+v[u]+")\\s+-\\s+("+v[u]+")\\s*$";var J=D++;v[J]="^\\s*("+v[h]+")\\s+-\\s+("+v[h]+")\\s*$";var ae=D++;v[ae]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)y(me,v[me]),S[me]||(S[me]=new RegExp(v[me]));function fe(de,Se){if(de instanceof V)return de;if(typeof de!="string"||de.length>P||!(Se?S[i]:S[c]).test(de))return null;try{return new V(de,Se)}catch{return null}}function V(de,Se){if(de instanceof V){if(de.loose===Se)return de;de=de.version}else if(typeof de!="string")throw new TypeError("Invalid Version: "+de);if(de.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof V))return new V(de,Se);y("SemVer",de,Se),this.loose=Se;var ve=de.trim().match(Se?S[i]:S[c]);if(!ve)throw new TypeError("Invalid Version: "+de);if(this.raw=de,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var Ne=+Le;if(Ne>=0&&Ne<k)return Ne}return Le}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=fe,e.valid=function(de,Se){var ve=fe(de,Se);return ve?ve.version:null},e.clean=function(de,Se){var ve=fe(de.trim().replace(/^[=v]+/,""),Se);return ve?ve.version:null},e.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(de){return y("SemVer.compare",this.version,this.loose,de),de instanceof V||(de=new V(de,this.loose)),this.compareMain(de)||this.comparePre(de)},V.prototype.compareMain=function(de){return de instanceof V||(de=new V(de,this.loose)),x(this.major,de.major)||x(this.minor,de.minor)||x(this.patch,de.patch)},V.prototype.comparePre=function(de){if(de instanceof V||(de=new V(de,this.loose)),this.prerelease.length&&!de.prerelease.length)return-1;if(!this.prerelease.length&&de.prerelease.length)return 1;if(!this.prerelease.length&&!de.prerelease.length)return 0;var Se=0;do{var ve=this.prerelease[Se],Le=de.prerelease[Se];if(y("prerelease compare",Se,ve,Le),ve===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(ve===void 0)return-1;if(ve!==Le)return x(ve,Le)}while(++Se)},V.prototype.inc=function(de,Se){switch(de){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+de)}return this.format(),this.raw=this.version,this},e.inc=function(de,Se,ve,Le){typeof ve=="string"&&(Le=ve,ve=void 0);try{return new V(de,ve).inc(Se,Le).version}catch{return null}},e.diff=function(de,Se){if(Z(de,Se))return null;var ve=fe(de),Le=fe(Se);if(ve.prerelease.length||Le.prerelease.length){for(var Ne in ve)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&ve[Ne]!==Le[Ne])return"pre"+Ne;return"prerelease"}for(var Ne in ve)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&ve[Ne]!==Le[Ne])return Ne},e.compareIdentifiers=x;var ee=/^[0-9]+$/;function x(de,Se){var ve=ee.test(de),Le=ee.test(Se);return ve&&Le&&(de=+de,Se=+Se),ve&&!Le?-1:Le&&!ve?1:de<Se?-1:de>Se?1:0}function z(de,Se,ve){return new V(de,ve).compare(new V(Se,ve))}function te(de,Se,ve){return z(de,Se,ve)>0}function ce(de,Se,ve){return z(de,Se,ve)<0}function Z(de,Se,ve){return z(de,Se,ve)===0}function se(de,Se,ve){return z(de,Se,ve)!==0}function ge(de,Se,ve){return z(de,Se,ve)>=0}function Y(de,Se,ve){return z(de,Se,ve)<=0}function re(de,Se,ve,Le){var Ne;switch(Se){case"===":typeof de=="object"&&(de=de.version),typeof ve=="object"&&(ve=ve.version),Ne=de===ve;break;case"!==":typeof de=="object"&&(de=de.version),typeof ve=="object"&&(ve=ve.version),Ne=de!==ve;break;case"":case"=":case"==":Ne=Z(de,ve,Le);break;case"!=":Ne=se(de,ve,Le);break;case">":Ne=te(de,ve,Le);break;case">=":Ne=ge(de,ve,Le);break;case"<":Ne=ce(de,ve,Le);break;case"<=":Ne=Y(de,ve,Le);break;default:throw new TypeError("Invalid operator: "+Se)}return Ne}function H(de,Se){if(de instanceof H){if(de.loose===Se)return de;de=de.value}if(!(this instanceof H))return new H(de,Se);y("comparator",de,Se),this.loose=Se,this.parse(de),this.semver===K?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(de,Se){return x(Se,de)},e.major=function(de,Se){return new V(de,Se).major},e.minor=function(de,Se){return new V(de,Se).minor},e.patch=function(de,Se){return new V(de,Se).patch},e.compare=z,e.compareLoose=function(de,Se){return z(de,Se,!0)},e.rcompare=function(de,Se,ve){return z(Se,de,ve)},e.sort=function(de,Se){return de.sort(function(ve,Le){return e.compare(ve,Le,Se)})},e.rsort=function(de,Se){return de.sort(function(ve,Le){return e.rcompare(ve,Le,Se)})},e.gt=te,e.lt=ce,e.eq=Z,e.neq=se,e.gte=ge,e.lte=Y,e.cmp=re,e.Comparator=H;var K={};function ue(de,Se){if(de instanceof ue)return de.loose===Se?de:new ue(de.raw,Se);if(de instanceof H)return new ue(de.value,Se);if(!(this instanceof ue))return new ue(de,Se);if(this.loose=Se,this.raw=de,this.set=de.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+de);this.format()}function pe(de){return!de||de.toLowerCase()==="x"||de==="*"}function De(de,Se,ve,Le,Ne,Ze,$e,He,je,Ye,oe,be,ke){return((Se=pe(ve)?"":pe(Le)?">="+ve+".0.0":pe(Ne)?">="+ve+"."+Le+".0":">="+Se)+" "+(He=pe(je)?"":pe(Ye)?"<"+(+je+1)+".0.0":pe(oe)?"<"+je+"."+(+Ye+1)+".0":be?"<="+je+"."+Ye+"."+oe+"-"+be:"<="+He)).trim()}function Te(de,Se){for(var ve=0;ve<de.length;ve++)if(!de[ve].test(Se))return!1;if(Se.prerelease.length){for(ve=0;ve<de.length;ve++)if(y(de[ve].semver),de[ve].semver!==K&&de[ve].semver.prerelease.length>0){var Le=de[ve].semver;if(Le.major===Se.major&&Le.minor===Se.minor&&Le.patch===Se.patch)return!0}return!1}return!0}function Me(de,Se,ve){try{Se=new ue(Se,ve)}catch{return!1}return Se.test(de)}function Ue(de,Se,ve,Le){var Ne,Ze,$e,He,je;switch(de=new V(de,Le),Se=new ue(Se,Le),ve){case">":Ne=te,Ze=Y,$e=ce,He=">",je=">=";break;case"<":Ne=ce,Ze=ge,$e=te,He="<",je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(de,Se,Le))return!1;for(var Ye=0;Ye<Se.set.length;++Ye){var oe=Se.set[Ye],be=null,ke=null;if(oe.forEach(function(_e){_e.semver===K&&(_e=new H(">=0.0.0")),be=be||_e,ke=ke||_e,Ne(_e.semver,be.semver,Le)?be=_e:$e(_e.semver,ke.semver,Le)&&(ke=_e)}),be.operator===He||be.operator===je||(!ke.operator||ke.operator===He)&&Ze(de,ke.semver)||ke.operator===je&&$e(de,ke.semver))return!1}return!0}H.prototype.parse=function(de){var Se=this.loose?S[$]:S[O],ve=de.match(Se);if(!ve)throw new TypeError("Invalid comparator: "+de);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new V(ve[2],this.loose):this.semver=K},H.prototype.toString=function(){return this.value},H.prototype.test=function(de){return y("Comparator.test",de,this.loose),this.semver===K||(typeof de=="string"&&(de=new V(de,this.loose)),re(de,this.operator,this.semver,this.loose))},H.prototype.intersects=function(de,Se){if(!(de instanceof H))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new ue(de.value,Se),Me(this.value,ve,Se);if(de.operator==="")return ve=new ue(this.value,Se),Me(de.semver,ve,Se);var Le=!(this.operator!==">="&&this.operator!==">"||de.operator!==">="&&de.operator!==">"),Ne=!(this.operator!=="<="&&this.operator!=="<"||de.operator!=="<="&&de.operator!=="<"),Ze=this.semver.version===de.semver.version,$e=!(this.operator!==">="&&this.operator!=="<="||de.operator!==">="&&de.operator!=="<="),He=re(this.semver,"<",de.semver,Se)&&(this.operator===">="||this.operator===">")&&(de.operator==="<="||de.operator==="<"),je=re(this.semver,">",de.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(de.operator===">="||de.operator===">");return Le||Ne||Ze&&$e||He||je},e.Range=ue,ue.prototype.format=function(){return this.range=this.set.map(function(de){return de.join(" ").trim()}).join("||").trim(),this.range},ue.prototype.toString=function(){return this.range},ue.prototype.parseRange=function(de){var Se=this.loose;de=de.trim(),y("range",de,Se);var ve=Se?S[J]:S[W];de=de.replace(ve,De),y("hyphen replace",de),de=de.replace(S[M],"$1$2$3"),y("comparator trim",de,S[M]),de=(de=(de=de.replace(S[Q],"$1~")).replace(S[U],"$1^")).split(/\s+/).join(" ");var Le=Se?S[$]:S[O],Ne=de.split(" ").map(function(Ze){return function($e,He){return y("comp",$e),$e=function(je,Ye){return je.trim().split(/\s+/).map(function(oe){return function(be,ke){y("caret",be,ke);var _e=ke?S[j]:S[le];return be.replace(_e,function(Be,Fe,qe,Ge,Ke){var xe;return y("caret",be,Be,Fe,qe,Ge,Ke),pe(Fe)?xe="":pe(qe)?xe=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":pe(Ge)?xe=Fe==="0"?">="+Fe+"."+qe+".0 <"+Fe+"."+(+qe+1)+".0":">="+Fe+"."+qe+".0 <"+(+Fe+1)+".0.0":Ke?(y("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),xe=Fe==="0"?qe==="0"?">="+Fe+"."+qe+"."+Ge+Ke+" <"+Fe+"."+qe+"."+(+Ge+1):">="+Fe+"."+qe+"."+Ge+Ke+" <"+Fe+"."+(+qe+1)+".0":">="+Fe+"."+qe+"."+Ge+Ke+" <"+(+Fe+1)+".0.0"):(y("no pr"),xe=Fe==="0"?qe==="0"?">="+Fe+"."+qe+"."+Ge+" <"+Fe+"."+qe+"."+(+Ge+1):">="+Fe+"."+qe+"."+Ge+" <"+Fe+"."+(+qe+1)+".0":">="+Fe+"."+qe+"."+Ge+" <"+(+Fe+1)+".0.0"),y("caret return",xe),xe})}(oe,Ye)}).join(" ")}($e,He),y("caret",$e),$e=function(je,Ye){return je.trim().split(/\s+/).map(function(oe){return function(be,ke){var _e=ke?S[X]:S[_];return be.replace(_e,function(Be,Fe,qe,Ge,Ke){var xe;return y("tilde",be,Be,Fe,qe,Ge,Ke),pe(Fe)?xe="":pe(qe)?xe=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":pe(Ge)?xe=">="+Fe+"."+qe+".0 <"+Fe+"."+(+qe+1)+".0":Ke?(y("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),xe=">="+Fe+"."+qe+"."+Ge+Ke+" <"+Fe+"."+(+qe+1)+".0"):xe=">="+Fe+"."+qe+"."+Ge+" <"+Fe+"."+(+qe+1)+".0",y("tilde return",xe),xe})}(oe,Ye)}).join(" ")}($e,He),y("tildes",$e),$e=function(je,Ye){return y("replaceXRanges",je,Ye),je.split(/\s+/).map(function(oe){return function(be,ke){be=be.trim();var _e=ke?S[A]:S[b];return be.replace(_e,function(Be,Fe,qe,Ge,Ke,xe){y("xRange",be,Be,Fe,qe,Ge,Ke,xe);var tt=pe(qe),nt=tt||pe(Ge),at=nt||pe(Ke);return Fe==="="&&at&&(Fe=""),tt?Be=Fe===">"||Fe==="<"?"<0.0.0":"*":Fe&&at?(nt&&(Ge=0),at&&(Ke=0),Fe===">"?(Fe=">=",nt?(qe=+qe+1,Ge=0,Ke=0):at&&(Ge=+Ge+1,Ke=0)):Fe==="<="&&(Fe="<",nt?qe=+qe+1:Ge=+Ge+1),Be=Fe+qe+"."+Ge+"."+Ke):nt?Be=">="+qe+".0.0 <"+(+qe+1)+".0.0":at&&(Be=">="+qe+"."+Ge+".0 <"+qe+"."+(+Ge+1)+".0"),y("xRange return",Be),Be})}(oe,Ye)}).join(" ")}($e,He),y("xrange",$e),$e=function(je,Ye){return y("replaceStars",je,Ye),je.trim().replace(S[ae],"")}($e,He),y("stars",$e),$e}(Ze,Se)}).join(" ").split(/\s+/);return this.loose&&(Ne=Ne.filter(function(Ze){return!!Ze.match(Le)})),Ne=Ne.map(function(Ze){return new H(Ze,Se)})},ue.prototype.intersects=function(de,Se){if(!(de instanceof ue))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Le){return de.set.some(function(Ne){return Ne.every(function(Ze){return Le.intersects(Ze,Se)})})})})},e.toComparators=function(de,Se){return new ue(de,Se).set.map(function(ve){return ve.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},ue.prototype.test=function(de){if(!de)return!1;typeof de=="string"&&(de=new V(de,this.loose));for(var Se=0;Se<this.set.length;Se++)if(Te(this.set[Se],de))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(de,Se,ve){var Le=null,Ne=null;try{var Ze=new ue(Se,ve)}catch{return null}return de.forEach(function($e){Ze.test($e)&&(Le&&Ne.compare($e)!==-1||(Ne=new V(Le=$e,ve)))}),Le},e.minSatisfying=function(de,Se,ve){var Le=null,Ne=null;try{var Ze=new ue(Se,ve)}catch{return null}return de.forEach(function($e){Ze.test($e)&&(Le&&Ne.compare($e)!==1||(Ne=new V(Le=$e,ve)))}),Le},e.validRange=function(de,Se){try{return new ue(de,Se).range||"*"}catch{return null}},e.ltr=function(de,Se,ve){return Ue(de,Se,"<",ve)},e.gtr=function(de,Se,ve){return Ue(de,Se,">",ve)},e.outside=Ue,e.prerelease=function(de,Se){var ve=fe(de,Se);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(de,Se,ve){return de=new ue(de,ve),Se=new ue(Se,ve),de.intersects(Se)},e.coerce=function(de){if(de instanceof V)return de;if(typeof de!="string")return null;var Se=de.match(S[B]);return Se==null?null:fe((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,I(1))},function(ie,e){var I,t,y=ie.exports={};function P(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function S(f){if(I===setTimeout)return setTimeout(f,0);if((I===P||!I)&&setTimeout)return I=setTimeout,setTimeout(f,0);try{return I(f,0)}catch{try{return I.call(null,f,0)}catch{return I.call(this,f,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:P}catch{I=P}try{t=typeof clearTimeout=="function"?clearTimeout:k}catch{t=k}})();var v,D=[],T=!1,R=-1;function C(){T&&v&&(T=!1,v.length?D=v.concat(D):R=-1,D.length&&w())}function w(){if(!T){var f=S(C);T=!0;for(var p=D.length;p;){for(v=D,D=[];++R<p;)v&&v[R].run();R=-1,p=D.length}v=null,T=!1,function(g){if(t===clearTimeout)return clearTimeout(g);if((t===k||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(g);try{t(g)}catch{try{return t.call(null,g)}catch{return t.call(this,g)}}}(f)}}function m(f,p){this.fun=f,this.array=p}function E(){}y.nextTick=function(f){var p=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)p[g-1]=arguments[g];D.push(new m(f,p)),D.length!==1||T||S(w)},m.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=E,y.addListener=E,y.once=E,y.off=E,y.removeListener=E,y.removeAllListeners=E,y.emit=E,y.prependListener=E,y.prependOnceListener=E,y.listeners=function(f){return[]},y.binding=function(f){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(f){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(we[133],ye([0,1]),function(ie,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(S,v,D){this.level=S,this.key=v,this.value=D,this.forward=[]}}const y=void 0;class P{constructor(S,v=2**16){this.comparator=S,this[I]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(v)|0),this._header=new t(this._maxLevel,y,y)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,y,y)}has(S){return Boolean(P._search(this,S,this.comparator))}get(S){return P._search(this,S,this.comparator)?.value}set(S,v){return P._insert(this,S,v,this.comparator)&&(this._size+=1),this}delete(S){const v=P._delete(this,S,this.comparator);return v&&(this._size-=1),v}forEach(S,v){let D=this._header.forward[0];for(;D;)S.call(v,D.value,D.key,this),D=D.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this._header.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this._header.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this._header.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",v=this._header.forward[0];for(;v;)S+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return S}static _search(S,v,D){let T=S._header;for(let R=S._level-1;R>=0;R--)for(;T.forward[R]&&D(T.forward[R].key,v)<0;)T=T.forward[R];if(T=T.forward[0],T&&D(T.key,v)===0)return T}static _insert(S,v,D,T){let R=[],C=S._header;for(let w=S._level-1;w>=0;w--){for(;C.forward[w]&&T(C.forward[w].key,v)<0;)C=C.forward[w];R[w]=C}if(C=C.forward[0],C&&T(C.key,v)===0)return C.value=D,!1;{let w=P._randomLevel(S);if(w>S._level){for(let m=S._level;m<w;m++)R[m]=S._header;S._level=w}C=new t(w,v,D);for(let m=0;m<w;m++)C.forward[m]=R[m].forward[m],R[m].forward[m]=C;return!0}}static _randomLevel(S,v=.5){let D=1;for(;Math.random()<v&&D<S._maxLevel;)D+=1;return D}static _delete(S,v,D){let T=[],R=S._header;for(let C=S._level-1;C>=0;C--){for(;R.forward[C]&&D(R.forward[C].key,v)<0;)R=R.forward[C];T[C]=R}if(R=R.forward[0],!R||D(R.key,v)!==0)return!1;for(let C=0;C<S._level&&T[C].forward[C]===R;C++)T[C].forward[C]=R.forward[C];for(;S._level>0&&S._header.forward[S._level-1]===y;)S._level-=1;return!0}}e.SkipList=P}),define(we[134],ye([0,1,3]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=I.globals.performance&&typeof I.globals.performance.now=="function";class y{constructor(k){this._highResolution=t&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new y(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?I.globals.performance.now():Date.now()}}e.StopWatch=y}),define(we[6],ye([0,1,9,62,2,131,134]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let S=!1,v=!1;var D;(function(s){s.None=()=>y.Disposable.None;function u(fe){if(v){const{onListenerDidAdd:V}=fe,ee=m.create();let x=0;fe.onListenerDidAdd=()=>{++x==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),V?.()}}}function h(fe){return(V,ee=null,x)=>{let z=!1,te;return te=fe(ce=>{if(!z)return te?te.dispose():z=!0,V.call(ee,ce)},null,x),z&&te.dispose(),te}}s.once=h;function b(fe,V,ee){return X((x,z=null,te)=>fe(ce=>x.call(z,V(ce)),null,te),ee)}s.map=b;function A(fe,V,ee){return X((x,z=null,te)=>fe(ce=>{V(ce),x.call(z,ce)},null,te),ee)}s.forEach=A;function B(fe,V,ee){return X((x,z=null,te)=>fe(ce=>V(ce)&&x.call(z,ce),null,te),ee)}s.filter=B;function G(fe){return fe}s.signal=G;function Q(...fe){return(V,ee=null,x)=>(0,y.combinedDisposable)(...fe.map(z=>z(te=>V.call(ee,te),null,x)))}s.any=Q;function _(fe,V,ee,x){let z=ee;return b(fe,te=>(z=V(z,te),z),x)}s.reduce=_;function X(fe,V){let ee;const x={onFirstListenerAdd(){ee=fe(z.fire,z)},onLastListenerRemove(){ee.dispose()}};V||u(x);const z=new f(x);return V&&V.add(z),z.event}function F(fe,V,ee=100,x=!1,z,te){let ce,Z,se,ge=0;const Y={leakWarningThreshold:z,onFirstListenerAdd(){ce=fe(H=>{ge++,Z=V(Z,H),x&&!se&&(re.fire(Z),Z=void 0),clearTimeout(se),se=setTimeout(()=>{const K=Z;Z=void 0,se=void 0,(!x||ge>1)&&re.fire(K),ge=0},ee)})},onLastListenerRemove(){ce.dispose()}};te||u(Y);const re=new f(Y);return te&&te.add(re),re.event}s.debounce=F;function U(fe,V=(x,z)=>x===z,ee){let x=!0,z;return B(fe,te=>{const ce=x||!V(te,z);return x=!1,z=te,ce},ee)}s.latch=U;function le(fe,V,ee){return[s.filter(fe,V,ee),s.filter(fe,x=>!V(x),ee)]}s.split=le;function j(fe,V=!1,ee=[]){let x=ee.slice(),z=fe(Z=>{x?x.push(Z):ce.fire(Z)});const te=()=>{x&&x.forEach(Z=>ce.fire(Z)),x=null},ce=new f({onFirstListenerAdd(){z||(z=fe(Z=>ce.fire(Z)))},onFirstListenerDidAdd(){x&&(V?setTimeout(te):te())},onLastListenerRemove(){z&&z.dispose(),z=null}});return ce.event}s.buffer=j;class ${constructor(V){this.event=V}map(V){return new $(b(this.event,V))}forEach(V){return new $(A(this.event,V))}filter(V){return new $(B(this.event,V))}reduce(V,ee){return new $(_(this.event,V,ee))}latch(){return new $(U(this.event))}debounce(V,ee=100,x=!1,z){return new $(F(this.event,V,ee,x,z))}on(V,ee,x){return this.event(V,ee,x)}once(V,ee,x){return h(this.event)(V,ee,x)}}function O(fe){return new $(fe)}s.chain=O;function M(fe,V,ee=x=>x){const x=(...Z)=>ce.fire(ee(...Z)),z=()=>fe.on(V,x),te=()=>fe.removeListener(V,x),ce=new f({onFirstListenerAdd:z,onLastListenerRemove:te});return ce.event}s.fromNodeEventEmitter=M;function W(fe,V,ee=x=>x){const x=(...Z)=>ce.fire(ee(...Z)),z=()=>fe.addEventListener(V,x),te=()=>fe.removeEventListener(V,x),ce=new f({onFirstListenerAdd:z,onLastListenerRemove:te});return ce.event}s.fromDOMEventEmitter=W;function J(fe){return new Promise(V=>h(fe)(V))}s.toPromise=J;function ae(fe,V){return V(void 0),fe(ee=>V(ee))}s.runAndSubscribe=ae;function me(fe,V){let ee=null;function x(te){ee?.dispose(),ee=new y.DisposableStore,V(te,ee)}x(void 0);const z=fe(te=>x(te));return(0,y.toDisposable)(()=>{z.dispose(),ee?.dispose()})}s.runAndSubscribeWithStore=me})(D=e.Event||(e.Event={}));class T{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${T._idPool++}`}start(u){this._stopWatch=new k.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}T._idPool=0;let R=-1;function C(s){const u=R;return R=s,{dispose(){R=u}}}e.setGlobalLeakWarningThreshold=C;class w{constructor(u,h=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u,h){let b=R;if(typeof this.customThreshold=="number"&&(b=this.customThreshold),b<=0||h<b)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=b*.5;let B,G=0;for(const[Q,_]of this._stacks)(!B||G<_)&&(B=Q,G=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${G}):`),console.warn(B)}return()=>{const B=this._stacks.get(u.value)||0;this._stacks.set(u.value,B-1)}}}class m{constructor(u){this.value=u}static create(){return new m(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(u,h,b){this.callback=u,this.callbackThis=h,this.stack=b,this.subscription=new y.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class f{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=R>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new T(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(S){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const h of u)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,h,b)=>{this._listeners||(this._listeners=new P.LinkedList);const A=this._listeners.isEmpty();A&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let B,G;this._leakageMon&&this._listeners.size>=30&&(G=m.create(),B=this._leakageMon.check(G,this._listeners.size+1)),S&&(G=G??m.create());const Q=new E(u,h,G),_=this._listeners.push(Q);A&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,h);const X=Q.subscription.set(()=>{B&&B(),this._disposed||(_(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return b instanceof y.DisposableStore?b.add(X):Array.isArray(b)&&b.push(X),X}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(let h of this._listeners)this._deliveryQueue.push(this,h,u);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=f;class p{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(u,h,b){this._queue.push(new d(u,h,b))}clear(u){const h=new P.LinkedList;for(const b of this._queue)b.emitter!==u&&h.push(b);this._queue=h}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(h){(0,I.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=p;class g extends p{clear(u){this._queue.clear()}}class d{constructor(u,h,b){this.emitter=u,this.listener=h,this.event=b}}class l extends f{async fireAsync(u,h,b){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,u]);for(;this._asyncDeliveryQueue.size>0&&!h.isCancellationRequested;){const[A,B]=this._asyncDeliveryQueue.shift(),G=[],Q={...B,token:h,waitUntil:_=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");b&&(_=b(_,A.callback)),G.push(_)}};try{A.invoke(Q)}catch(_){(0,I.onUnexpectedError)(_);continue}Object.freeze(G),await Promise.allSettled(G).then(_=>{for(const X of _)X.status==="rejected"&&(0,I.onUnexpectedError)(X.reason)})}}}}e.AsyncEmitter=l;class c extends f{constructor(u){super(u);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=c;class n extends c{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=n;class o extends f{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(h=>super.fire(h)),this._queuedEvents=[]})}}e.MicrotaskEmitter=o;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const h={event:u,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const b=()=>{this.hasListeners&&this.unhook(h);const A=this.events.indexOf(h);this.events.splice(A,1)};return(0,y.toDisposable)((0,t.once)(b))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(h=>this.emitter.fire(h))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class a{constructor(){this.buffers=[]}wrapEvent(u){return(h,b,A)=>u(B=>{const G=this.buffers[this.buffers.length-1];G?G.push(()=>h.call(b,B)):h.call(b,B)},void 0,A)}bufferEvents(u){const h=[];this.buffers.push(h);const b=u();return this.buffers.pop(),h.forEach(A=>A()),b}}e.EventBufferer=a;class r{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=y.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(we[20],ye([0,1,6]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(S,v){const D=setTimeout(S.bind(v),0);return{dispose(){clearTimeout(D)}}});var y;(function(S){function v(D){return D===S.None||D===S.Cancelled||D instanceof P?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}S.isCancellationToken=v,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(y=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new I.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(v){this._token=void 0,this._parentListener=void 0,this._parentListener=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=y.Cancelled}dispose(v=!1){v&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=k}),define(we[135],ye([0,1,20]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(S){this.task=S,this.result=null}get(){if(this.result)return this.result;const S=new I.CancellationTokenSource,v=this.task(S.token);return this.result={promise:v,dispose:()=>{this.result=null,S.cancel(),S.dispose()}},this.result}}e.Cache=t;class y{constructor(S){this.fn=S,this.lastCache=void 0,this.lastArgKey=void 0}get(S){const v=JSON.stringify(S);return this.lastArgKey!==v&&(this.lastArgKey=v,this.lastCache=this.fn(S)),this.lastCache}}e.LRUCachedFunction=y;class P{constructor(S){this.fn=S,this._map=new Map}get cachedValues(){return this._map}get(S){if(this._map.has(S))return this._map.get(S);const v=this.fn(S);return this._map.set(S,v),v}}e.CachedFunction=P}),define(we[82],ye([0,1,6,2]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const y=k=>({onDidChange:I.Event.None,value:k});e.staticObservableValue=y;class P extends t.Disposable{constructor(S){super();this._value=S,this.changeEmitter=this._register(new I.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(S){S!==this._value&&(this._value=S,this.changeEmitter.fire(S))}}e.MutableObservableValue=P}),define(we[44],ye([0,1,9,2]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(l){const c=l;return c?typeof c.read=="function":!1}e.isReadable=y;function P(l){const c=l;return c?[c.on,c.pause,c.resume,c.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=P;function k(l){const c=l;return c?P(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=k;function S(l,c){return new v(l,c)}e.newWriteableStream=S;class v{constructor(c,n){this.reducer=c,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(n=>n(c))}emitError(c){this.listeners.error.length===0?(0,I.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(n=>n(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,n){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(c,n){if(this.state.destroyed)return;let o;switch(c){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const i=o.indexOf(n);i>=0&&o.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(l,c){const n=[];let o;for(;(o=l.read())!==null;)n.push(o);return c(n)}e.consumeReadable=D;function T(l,c,n){const o=[];let i;for(;(i=l.read())!==null&&o.length<n;)o.push(i);return i===null&&o.length>0?c(o):{read:()=>{if(o.length>0)return o.shift();if(typeof i!="undefined"){const a=i;return i=void 0,a}return l.read()}}}e.peekReadable=T;function R(l,c){return new Promise((n,o)=>{const i=[];C(l,{onData:a=>{c&&i.push(a)},onError:a=>{c?o(a):n(void 0)},onEnd:()=>{n(c?c(i):void 0)}})})}e.consumeStream=R;function C(l,c){let n=!1;return l.on("error",o=>{n||c.onError(o)}),l.on("end",()=>{n||c.onEnd()}),l.on("data",o=>{n||c.onData(o)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=C;function w(l,c){return new Promise((n,o)=>{const i=new t.DisposableStore,a=[],r=h=>{if(a.push(h),a.length>c)return i.dispose(),l.pause(),n({stream:l,buffer:a,ended:!1})},s=h=>o(h),u=()=>n({stream:l,buffer:a,ended:!0});i.add((0,t.toDisposable)(()=>l.removeListener("error",s))),l.on("error",s),i.add((0,t.toDisposable)(()=>l.removeListener("end",u))),l.on("end",u),i.add((0,t.toDisposable)(()=>l.removeListener("data",r))),l.on("data",r)})}e.peekStream=w;function m(l,c){const n=S(c);return n.end(l),n}e.toStream=m;function E(){const l=S(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=E;function f(l){let c=!1;return{read:()=>c?null:(c=!0,l)}}e.toReadable=f;function p(l,c,n){const o=S(n);return C(l,{onData:i=>o.write(c.data(i)),onError:i=>o.error(c.error?c.error(i):i),onEnd:()=>o.end()}),o}e.transform=p;function g(l,c,n){let o=!1;return{read:()=>{const i=c.read();return o?i:(o=!0,i!==null?n([l,i]):l)}}}e.prefixedReadable=g;function d(l,c,n){let o=!1;const i=S(n);return C(c,{onData:a=>o?i.write(a):(o=!0,i.write(n([l,a]))),onError:a=>i.error(a),onEnd:()=>{o||(o=!0,i.write(l)),i.end()}}),i}e.prefixedStream=d}),define(we[17],ye([0,1,44]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let y,P;class k{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return t?new k(Buffer.allocUnsafe(h)):new k(new Uint8Array(h))}static wrap(h){return t&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new k(h)}static fromString(h,b){return!(b?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(h)):(y||(y=new TextEncoder),new k(y.encode(h)))}static fromByteArray(h){const b=k.alloc(h.length);for(let A=0,B=h.length;A<B;A++)b.buffer[A]=h[A];return b}static concat(h,b){if(typeof b=="undefined"){b=0;for(let G=0,Q=h.length;G<Q;G++)b+=h[G].byteLength}const A=k.alloc(b);let B=0;for(let G=0,Q=h.length;G<Q;G++){const _=h[G];A.set(_,B),B+=_.byteLength}return A}clone(){const h=k.alloc(this.byteLength);return h.set(this),h}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(h,b){return new k(this.buffer.subarray(h,b))}set(h,b){if(h instanceof k)this.buffer.set(h.buffer,b);else if(h instanceof Uint8Array)this.buffer.set(h,b);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),b);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return D(this.buffer,h)}writeUInt32BE(h,b){T(this.buffer,h,b)}readUInt32LE(h){return R(this.buffer,h)}writeUInt32LE(h,b){C(this.buffer,h,b)}readUInt8(h){return w(this.buffer,h)}writeUInt8(h,b){m(this.buffer,h,b)}}e.VSBuffer=k;function S(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0}e.readUInt16LE=S;function v(u,h,b){u[b+0]=h&255,h=h>>>8,u[b+1]=h&255}e.writeUInt16LE=v;function D(u,h){return u[h]*2**24+u[h+1]*2**16+u[h+2]*2**8+u[h+3]}e.readUInt32BE=D;function T(u,h,b){u[b+3]=h,h=h>>>8,u[b+2]=h,h=h>>>8,u[b+1]=h,h=h>>>8,u[b]=h}e.writeUInt32BE=T;function R(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0|u[h+2]<<16>>>0|u[h+3]<<24>>>0}e.readUInt32LE=R;function C(u,h,b){u[b+0]=h&255,h=h>>>8,u[b+1]=h&255,h=h>>>8,u[b+2]=h&255,h=h>>>8,u[b+3]=h&255}e.writeUInt32LE=C;function w(u,h){return u[h]}e.readUInt8=w;function m(u,h,b){u[b]=h}e.writeUInt8=m;function E(u){return I.consumeReadable(u,h=>k.concat(h))}e.readableToBuffer=E;function f(u){return I.toReadable(u)}e.bufferToReadable=f;function p(u){return I.consumeStream(u,h=>k.concat(h))}e.streamToBuffer=p;async function g(u){return u.ended?k.concat(u.buffer):k.concat([...u.buffer,await p(u.stream)])}e.bufferedStreamToBuffer=g;function d(u){return I.toStream(u,h=>k.concat(h))}e.bufferToStream=d;function l(u){return I.transform(u,{data:h=>typeof h=="string"?k.fromString(h):k.wrap(h)},h=>k.concat(h))}e.streamToBufferReadableStream=l;function c(u){return I.newWriteableStream(h=>k.concat(h),u)}e.newWriteableBufferStream=c;function n(u,h){return I.prefixedReadable(u,h,b=>k.concat(b))}e.prefixedBufferReadable=n;function o(u,h){return I.prefixedStream(u,h,b=>k.concat(b))}e.prefixedBufferStream=o;function i(u){let h=0,b=0,A=0;const B=new Uint8Array(Math.floor(u.length/4*3)),G=_=>{switch(b){case 3:B[A++]=h|_,b=0;break;case 2:B[A++]=h|_>>>2,h=_<<6,b=3;break;case 1:B[A++]=h|_>>>4,h=_<<4,b=2;break;default:h=_<<2,b=1}};for(let _=0;_<u.length;_++){const X=u.charCodeAt(_);if(X>=65&&X<=90)G(X-65);else if(X>=97&&X<=122)G(X-97+26);else if(X>=48&&X<=57)G(X-48+52);else if(X===43||X===45)G(62);else if(X===47||X===95)G(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${u[_]}`)}}const Q=A;for(;b>0;)G(0);return k.wrap(B).slice(0,Q)}e.decodeBase64=i;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:u},h=!0,b=!1){const A=b?r:a;let B="";const G=u.byteLength%3;let Q=0;for(;Q<u.byteLength-G;Q+=3){const _=u[Q+0],X=u[Q+1],F=u[Q+2];B+=A[_>>>2],B+=A[(_<<4|X>>>4)&63],B+=A[(X<<2|F>>>6)&63],B+=A[F&63]}if(G===1){const _=u[Q+0];B+=A[_>>>2],B+=A[_<<4&63],h&&(B+="==")}else if(G===2){const _=u[Q+0],X=u[Q+1];B+=A[_>>>2],B+=A[(_<<4|X>>>4)&63],B+=A[X<<2&63],h&&(B+="=")}return B}e.encodeBase64=s}),define(we[15],ye([0,1,135,130]),function(ie,e,I,t){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}e.isFalsyOrWhitespace=P;const k=/{(\d+)}/g;function S(oe,...be){return be.length===0?oe:oe.replace(k,function(ke,_e){const Be=parseInt(_e,10);return isNaN(Be)||Be<0||Be>=be.length?ke:be[Be]})}e.format=S;const v=/{([^}]+)}/g;function D(oe,be){return oe.replace(v,(ke,_e)=>be[_e]??ke)}e.format2=D;function T(oe){return oe.replace(/[<>&]/g,function(be){switch(be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return be}})}e.escape=T;function R(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=R;function C(oe,be){let ke=0;const _e=be.charCodeAt(0);for(let Be=oe.length-1;Be>=0;Be--)oe.charCodeAt(Be)===_e&&ke++;return ke}e.count=C;function w(oe,be,ke="\u2026"){return oe.length<=be?oe:`${oe.substr(0,be)}${ke}`}e.truncate=w;function m(oe,be=" "){const ke=E(oe,be);return f(ke,be)}e.trim=m;function E(oe,be){if(!oe||!be)return oe;const ke=be.length;if(ke===0||oe.length===0)return oe;let _e=0;for(;oe.indexOf(be,_e)===_e;)_e=_e+ke;return oe.substring(_e)}e.ltrim=E;function f(oe,be){if(!oe||!be)return oe;const ke=be.length,_e=oe.length;if(ke===0||_e===0)return oe;let Be=_e,Fe=-1;for(;Fe=oe.lastIndexOf(be,Be-1),!(Fe===-1||Fe+ke!==Be);){if(Fe===0)return"";Be=Fe}return oe.substring(0,Be)}e.rtrim=f;function p(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function g(oe){return oe.replace(/\*/g,"")}e.stripWildcards=g;function d(oe,be,ke={}){if(!oe)throw new Error("Cannot create regex from empty string");be||(oe=R(oe)),ke.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let _e="";return ke.global&&(_e+="g"),ke.matchCase||(_e+="i"),ke.multiline&&(_e+="m"),ke.unicode&&(_e+="u"),new RegExp(oe,_e)}e.createRegExp=d;function l(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function c(oe){return!!oe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function n(oe){return(oe.global?"g":"")+(oe.ignoreCase?"i":"")+(oe.multiline?"m":"")+(oe.unicode?"u":"")}e.regExpFlags=n;function o(oe){return oe.split(/\r\n|\r|\n/)}e.splitLines=o;function i(oe){for(let be=0,ke=oe.length;be<ke;be++){const _e=oe.charCodeAt(be);if(_e!==32&&_e!==9)return be}return-1}e.firstNonWhitespaceIndex=i;function a(oe,be=0,ke=oe.length){for(let _e=be;_e<ke;_e++){const Be=oe.charCodeAt(_e);if(Be!==32&&Be!==9)return oe.substring(be,_e)}return oe.substring(be,ke)}e.getLeadingWhitespace=a;function r(oe,be=oe.length-1){for(let ke=be;ke>=0;ke--){const _e=oe.charCodeAt(ke);if(_e!==32&&_e!==9)return ke}return-1}e.lastNonWhitespaceIndex=r;function s(oe,be,ke){let _e=[],Be=0;for(const Fe of oe.matchAll(be)){if(_e.push(oe.slice(Be,Fe.index)),Fe.index===void 0)throw new Error("match.index should be defined");Be=Fe.index+Fe[0].length,_e.push(ke(Fe[0],...Fe.slice(1),Fe.index,oe,Fe.groups))}return _e.push(oe.slice(Be)),Promise.all(_e).then(Fe=>Fe.join(""))}e.replaceAsync=s;function u(oe,be){return oe<be?-1:oe>be?1:0}e.compare=u;function h(oe,be,ke=0,_e=oe.length,Be=0,Fe=be.length){for(;ke<_e&&Be<Fe;ke++,Be++){let Ke=oe.charCodeAt(ke),xe=be.charCodeAt(Be);if(Ke<xe)return-1;if(Ke>xe)return 1}const qe=_e-ke,Ge=Fe-Be;return qe<Ge?-1:qe>Ge?1:0}e.compareSubstring=h;function b(oe,be){return A(oe,be,0,oe.length,0,be.length)}e.compareIgnoreCase=b;function A(oe,be,ke=0,_e=oe.length,Be=0,Fe=be.length){for(;ke<_e&&Be<Fe;ke++,Be++){let Ke=oe.charCodeAt(ke),xe=be.charCodeAt(Be);if(Ke===xe)continue;if(Ke>=128||xe>=128)return h(oe.toLowerCase(),be.toLowerCase(),ke,_e,Be,Fe);B(Ke)&&(Ke-=32),B(xe)&&(xe-=32);const tt=Ke-xe;if(tt!==0)return tt}const qe=_e-ke,Ge=Fe-Be;return qe<Ge?-1:qe>Ge?1:0}e.compareSubstringIgnoreCase=A;function B(oe){return oe>=97&&oe<=122}e.isLowerAsciiLetter=B;function G(oe){return oe>=65&&oe<=90}e.isUpperAsciiLetter=G;function Q(oe,be){return oe.length===be.length&&A(oe,be)===0}e.equalsIgnoreCase=Q;function _(oe,be){const ke=be.length;return be.length>oe.length?!1:A(oe,be,0,ke)===0}e.startsWithIgnoreCase=_;function X(oe,be){let ke,_e=Math.min(oe.length,be.length);for(ke=0;ke<_e;ke++)if(oe.charCodeAt(ke)!==be.charCodeAt(ke))return ke;return _e}e.commonPrefixLength=X;function F(oe,be){let ke,_e=Math.min(oe.length,be.length);const Be=oe.length-1,Fe=be.length-1;for(ke=0;ke<_e;ke++)if(oe.charCodeAt(Be-ke)!==be.charCodeAt(Fe-ke))return ke;return _e}e.commonSuffixLength=F;function U(oe){return 55296<=oe&&oe<=56319}e.isHighSurrogate=U;function le(oe){return 56320<=oe&&oe<=57343}e.isLowSurrogate=le;function j(oe,be){return(oe-55296<<10)+(be-56320)+65536}e.computeCodePoint=j;function $(oe,be,ke){const _e=oe.charCodeAt(ke);if(U(_e)&&ke+1<be){const Be=oe.charCodeAt(ke+1);if(le(Be))return j(_e,Be)}return _e}e.getNextCodePoint=$;function O(oe,be){const ke=oe.charCodeAt(be-1);if(le(ke)&&be>1){const _e=oe.charCodeAt(be-2);if(U(_e))return j(_e,ke)}return ke}class M{constructor(be,ke=0){this._str=be,this._len=be.length,this._offset=ke}get offset(){return this._offset}setOffset(be){this._offset=be}prevCodePoint(){const be=O(this._str,this._offset);return this._offset-=be>=65536?2:1,be}nextCodePoint(){const be=$(this._str,this._len,this._offset);return this._offset+=be>=65536?2:1,be}eol(){return this._offset>=this._len}}e.CodePointIterator=M;class W{constructor(be,ke=0){this._iterator=new M(be,ke)}get offset(){return this._iterator.offset}nextGraphemeLength(){const be=ve.getInstance(),ke=this._iterator,_e=ke.offset;let Be=be.getGraphemeBreakType(ke.nextCodePoint());for(;!ke.eol();){const Fe=ke.offset,qe=be.getGraphemeBreakType(ke.nextCodePoint());if(de(Be,qe)){ke.setOffset(Fe);break}Be=qe}return ke.offset-_e}prevGraphemeLength(){const be=ve.getInstance(),ke=this._iterator,_e=ke.offset;let Be=be.getGraphemeBreakType(ke.prevCodePoint());for(;ke.offset>0;){const Fe=ke.offset,qe=be.getGraphemeBreakType(ke.prevCodePoint());if(de(qe,Be)){ke.setOffset(Fe);break}Be=qe}return _e-ke.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=W;function J(oe,be){return new W(oe,be).nextGraphemeLength()}e.nextCharLength=J;function ae(oe,be){return new W(oe,be).prevGraphemeLength()}e.prevCharLength=ae;function me(oe,be){be>0&&le(oe.charCodeAt(be))&&be--;const ke=be+J(oe,be);return[ke-ae(oe,ke),ke]}e.getCharContainingOffset=me;const fe=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function V(oe){return fe.test(oe)}e.containsRTL=V;const ee=/^[\t\n\r\x20-\x7E]*$/;function x(oe){return ee.test(oe)}e.isBasicASCII=x,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(oe){return e.UNUSUAL_LINE_TERMINATORS.test(oe)}e.containsUnusualLineTerminators=z;function te(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}e.isFullWidthCharacter=te;function ce(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}e.isEmojiImprecise=ce;function Z(oe,be){if(oe.length<be)return oe;const ke=/\b/g;let _e=0;for(;ke.test(oe)&&!(oe.length-ke.lastIndex<be);)_e=ke.lastIndex,ke.lastIndex+=1;return oe.substring(_e).replace(/^\s/,"")}e.lcut=Z;const se=/\x1B\x5B[12]?K/g,ge=/\x1b\[\d+m/g,Y=/\x1b\[0?m/g;function re(oe){return oe&&(oe=oe.replace(se,""),oe=oe.replace(ge,""),oe=oe.replace(Y,"")),oe}e.removeAnsiEscapeCodes=re,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function H(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=H;function K(oe){return H(oe)?oe.substr(1):oe}e.stripUTF8BOM=K;function ue(oe,be){if(!oe||!be||oe.length<be.length)return!1;const ke=be.length,_e=oe.toLowerCase();let Be=0,Fe=-1;for(;Be<ke;){const qe=_e.indexOf(be[Be],Fe+1);if(qe<0)return!1;Fe=qe,Be++}return!0}e.fuzzyContains=ue;function pe(oe,be=!1){return oe?(be&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}e.containsUppercaseCharacter=pe;function De(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}e.uppercaseFirstLetter=De;function Te(oe,be=1){if(be===0)return"";let ke=-1;do ke=oe.indexOf(`
`,ke+1),be--;while(be>0&&ke>=0);return ke===-1?oe:(oe[ke-1]==="\r"&&ke--,oe.substr(0,ke))}e.getNLines=Te;function Me(oe){const be=90-65+1;return oe=oe%(2*be),oe<be?String.fromCharCode(97+oe):String.fromCharCode(65+oe-be)}e.singleLetterHash=Me;function Ue(oe){return ve.getInstance().getGraphemeBreakType(oe)}e.getGraphemeBreakType=Ue;function de(oe,be){return oe===0?be!==5&&be!==7:oe===2&&be===3?!1:oe===4||oe===2||oe===3||be===4||be===2||be===3?!0:!(oe===8&&(be===8||be===9||be===11||be===12)||(oe===11||oe===9)&&(be===9||be===10)||(oe===12||oe===10)&&be===10||be===5||be===13||be===7||oe===1||oe===13&&be===14||oe===6&&be===6)}var Se;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(Se=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ve{constructor(){this._data=Le()}static getInstance(){return ve._INSTANCE||(ve._INSTANCE=new ve),ve._INSTANCE}getGraphemeBreakType(be){if(be<32)return be===10?3:be===13?2:4;if(be<127)return 0;const ke=this._data,_e=ke.length/3;let Be=1;for(;Be<=_e;)if(be<ke[3*Be])Be=2*Be;else if(be>ke[3*Be+1])Be=2*Be+1;else return ke[3*Be+2];return 0}}ve._INSTANCE=null;function Le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(oe,be){if(oe===0)return 0;const ke=Ze(oe,be);if(ke!==void 0)return ke;const _e=new M(be,oe);return _e.prevCodePoint(),_e.offset}e.getLeftDeleteOffset=Ne;function Ze(oe,be){const ke=new M(be,oe);let _e=ke.prevCodePoint();for(;$e(_e)||_e===65039||_e===8419;){if(ke.offset===0)return;_e=ke.prevCodePoint()}if(!ce(_e))return;let Be=ke.offset;return Be>0&&ke.prevCodePoint()===8205&&(Be=ke.offset),Be}function $e(oe){return 127995<=oe&&oe<=127999}var He;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),e.noBreakWhitespace="\xA0";class je{constructor(be){this.confusableDictionary=be}static getInstance(be){return je.cache.get(Array.from(be))}static getLocales(){return je._locales.getValue()}isAmbiguous(be){return this.confusableDictionary.has(be)}getPrimaryConfusable(be){return this.confusableDictionary.get(be)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=je,y=je,je.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new I.LRUCachedFunction(oe=>{function be(xe){const tt=new Map;for(let nt=0;nt<xe.length;nt+=2)tt.set(xe[nt],xe[nt+1]);return tt}function ke(xe,tt){const nt=new Map(xe);for(const[at,ht]of tt)nt.set(at,ht);return nt}function _e(xe,tt){if(!xe)return tt;const nt=new Map;for(const[at,ht]of xe)tt.has(at)&&nt.set(at,ht);return nt}const Be=y.ambiguousCharacterData.getValue();let Fe=oe.filter(xe=>!xe.startsWith("_")&&xe in Be);Fe.length===0&&(Fe=["_default"]);let qe;for(const xe of Fe){const tt=be(Be[xe]);qe=_e(qe,tt)}const Ge=be(Be._common),Ke=ke(Ge,qe);return new je(Ke)}),je._locales=new t.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(oe=>!oe.startsWith("_")));class Ye{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ye.getRawData())),this._data}static isInvisibleCharacter(be){return Ye.getData().has(be)}static get codePoints(){return Ye.getData()}}e.InvisibleCharacters=Ye,Ye._data=void 0}),define(we[136],ye([0,1,15]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(p){return y(p,0)}e.hash=t;function y(p,g){switch(typeof p){case"object":return p===null?P(349,g):Array.isArray(p)?v(p,g):D(p,g);case"string":return S(p,g);case"boolean":return k(p,g);case"number":return P(p,g);case"undefined":return P(937,g);default:return P(617,g)}}e.doHash=y;function P(p,g){return(g<<5)-g+p|0}e.numberHash=P;function k(p,g){return P(p?433:863,g)}function S(p,g){g=P(149417,g);for(let d=0,l=p.length;d<l;d++)g=P(p.charCodeAt(d),g);return g}e.stringHash=S;function v(p,g){return g=P(104579,g),p.reduce((d,l)=>y(l,d),g)}function D(p,g){return g=P(181387,g),Object.keys(p).sort().reduce((d,l)=>(d=S(l,d),y(p[l],d)),g)}class T{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=y(g,this._value),this._value}}e.Hasher=T;var R;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function C(p,g,d=32){const l=d-g,c=~((1<<l)-1);return(p<<g|(c&p)>>>l)>>>0}function w(p,g=0,d=p.byteLength,l=0){for(let c=0;c<d;c++)p[g+c]=l}function m(p,g,d="0"){for(;p.length<g;)p=d+p;return p}function E(p,g=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(d=>d.toString(16).padStart(2,"0")).join(""):m((p>>>0).toString(16),g/4)}e.toHexString=E;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const d=g.length;if(d===0)return;const l=this._buff;let c=this._buffLen,n=this._leftoverHighSurrogate,o,i;for(n!==0?(o=n,i=-1,n=0):(o=g.charCodeAt(0),i=0);;){let a=o;if(I.isHighSurrogate(o))if(i+1<d){const r=g.charCodeAt(i+1);I.isLowSurrogate(r)?(i++,a=I.computeCodePoint(o,r)):a=65533}else{n=o;break}else I.isLowSurrogate(o)&&(a=65533);if(c=this._push(l,c,a),i++,i<d)o=g.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=n}_push(g,d,l){return l<128?g[d++]=l:l<2048?(g[d++]=192|(l&1984)>>>6,g[d++]=128|(l&63)>>>0):l<65536?(g[d++]=224|(l&61440)>>>12,g[d++]=128|(l&4032)>>>6,g[d++]=128|(l&63)>>>0):(g[d++]=240|(l&1835008)>>>18,g[d++]=128|(l&258048)>>>12,g[d++]=128|(l&4032)>>>6,g[d++]=128|(l&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=f._bigBlock32,d=this._buffDV;for(let u=0;u<64;u+=4)g.setUint32(u,d.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)g.setUint32(u,C(g.getUint32(u-12,!1)^g.getUint32(u-32,!1)^g.getUint32(u-56,!1)^g.getUint32(u-64,!1),1),!1);let l=this._h0,c=this._h1,n=this._h2,o=this._h3,i=this._h4,a,r,s;for(let u=0;u<80;u++)u<20?(a=c&n|~c&o,r=1518500249):u<40?(a=c^n^o,r=1859775393):u<60?(a=c&n|c&o|n&o,r=2400959708):(a=c^n^o,r=3395469782),s=C(l,5)+a+i+r+g.getUint32(u*4,!1)&4294967295,i=o,o=n,n=C(c,30),c=l,l=s;this._h0=this._h0+l&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))});var St=this&&this.__classPrivateFieldSet||function(ie,e,I,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(ie,I):y?y.value=I:e.set(ie,I),I},et=this&&this.__classPrivateFieldGet||function(ie,e,I,t){if(I==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!t:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return I==="m"?t:I==="a"?t.call(ie):t?t.value:e.get(ie)};define(we[29],ye([0,1,16,15]),function(ie,e,I,t){"use strict";var y,P,k,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function v(r,s,u){let h=r.get(s);return h===void 0&&(h=u,r.set(s,h)),h}e.getOrSet=v;function D(r){const s=[];return r.forEach((u,h)=>{s.push(`${h} => ${u}`)}),`Map(${r.size}) {${s.join(", ")}}`}e.mapToString=D;function T(r){const s=[];return r.forEach(u=>{s.push(u)}),`Set(${r.size}) {${s.join(", ")}}`}e.setToString=T;class R{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const u=s.charCodeAt(0),h=this._value.charCodeAt(this._pos);return u-h}value(){return this._value[this._pos]}}e.StringIterator=R;class C{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,t.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class w{constructor(s=!0,u=!0){this._splitOnBackslash=s,this._caseSensitive=u}reset(s){this._from=0,this._to=0,this._value=s,this._valueLen=s.length;for(let u=s.length-1;u>=0;u--,this._valueLen--){const h=this._value.charCodeAt(u);if(!(h===47||this._splitOnBackslash&&h===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let s=!0;for(;this._to<this._valueLen;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,t.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=w;var m;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(m||(m={}));class E{constructor(s,u){this._ignorePathCasing=s,this._ignoreQueryAndFragment=u,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(s)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,t.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=E;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const s=this.right;return this.right=s.left,s.left=this,this.updateHeight(),s.updateHeight(),s}rotateRight(){const s=this.left;return this.left=s.right,s.right=this,this.updateHeight(),s.updateHeight(),s}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(p||(p={}));class g{constructor(s){this._iter=s}static forUris(s=()=>!1,u=()=>!1){return new g(new E(s,u))}static forPaths(s=!1){return new g(new w(void 0,!s))}static forStrings(){return new g(new R)}static forConfigKeys(){return new g(new C)}clear(){this._root=void 0}fill(s,u){if(u){const h=u.slice(0);(0,I.shuffle)(h);for(let b of h)this.set(b,s)}else{const h=s.slice(0);(0,I.shuffle)(h);for(let b of h)this.set(b[0],b[1])}}set(s,u){const h=this._iter.reset(s);let b;this._root||(this._root=new f,this._root.segment=h.value());const A=[];for(b=this._root;;){const G=h.cmp(b.segment);if(G>0)b.left||(b.left=new f,b.left.segment=h.value()),A.push([-1,b]),b=b.left;else if(G<0)b.right||(b.right=new f,b.right.segment=h.value()),A.push([1,b]),b=b.right;else if(h.hasNext())h.next(),b.mid||(b.mid=new f,b.mid.segment=h.value()),A.push([0,b]),b=b.mid;else break}const B=b.value;b.value=u,b.key=s;for(let G=A.length-1;G>=0;G--){const Q=A[G][1];Q.updateHeight();const _=Q.balanceFactor();if(_<-1||_>1){const X=A[G][0],F=A[G+1][0];if(X===1&&F===1)A[G][1]=Q.rotateLeft();else if(X===-1&&F===-1)A[G][1]=Q.rotateRight();else if(X===1&&F===-1)Q.right=A[G+1][1]=A[G+1][1].rotateRight(),A[G][1]=Q.rotateLeft();else if(X===-1&&F===1)Q.left=A[G+1][1]=A[G+1][1].rotateLeft(),A[G][1]=Q.rotateRight();else throw new Error;if(G>0)switch(A[G-1][0]){case-1:A[G-1][1].left=A[G][1];break;case 1:A[G-1][1].right=A[G][1];break;case 0:A[G-1][1].mid=A[G][1];break}else this._root=A[0][1]}}return B}get(s){return this._getNode(s)?.value}_getNode(s){const u=this._iter.reset(s);let h=this._root;for(;h;){const b=u.cmp(h.segment);if(b>0)h=h.left;else if(b<0)h=h.right;else if(u.hasNext())u.next(),h=h.mid;else break}return h}has(s){const u=this._getNode(s);return!(u?.value===void 0&&u?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,u){const h=this._iter.reset(s),b=[];let A=this._root;for(;A;){const B=h.cmp(A.segment);if(B>0)b.push([-1,A]),A=A.left;else if(B<0)b.push([1,A]),A=A.right;else if(h.hasNext())h.next(),b.push([0,A]),A=A.mid;else break}if(!!A){if(u?(A.left=void 0,A.mid=void 0,A.right=void 0,A.height=1):(A.key=void 0,A.value=void 0),!A.mid&&!A.value)if(A.left&&A.right){const B=this._min(A.right),{key:G,value:Q,segment:_}=B;this._delete(B.key,!1),A.key=G,A.value=Q,A.segment=_}else{const B=A.left??A.right;if(b.length>0){const[G,Q]=b[b.length-1];switch(G){case-1:Q.left=B;break;case 0:Q.mid=B;break;case 1:Q.right=B;break}}else this._root=B}for(let B=b.length-1;B>=0;B--){const G=b[B][1];G.updateHeight();const Q=G.balanceFactor();if(Q>1?(G.right.balanceFactor()>=0||(G.right=G.right.rotateRight()),b[B][1]=G.rotateLeft()):Q<-1&&(G.left.balanceFactor()<=0||(G.left=G.left.rotateLeft()),b[B][1]=G.rotateRight()),B>0)switch(b[B-1][0]){case-1:b[B-1][1].left=b[B][1];break;case 1:b[B-1][1].right=b[B][1];break;case 0:b[B-1][1].mid=b[B][1];break}else this._root=b[0][1]}}}_min(s){for(;s.left;)s=s.left;return s}findSubstr(s){const u=this._iter.reset(s);let h=this._root,b;for(;h;){const A=u.cmp(h.segment);if(A>0)h=h.left;else if(A<0)h=h.right;else if(u.hasNext())u.next(),b=h.value||b,h=h.mid;else break}return h&&h.value||b}findSuperstr(s){const u=this._iter.reset(s);let h=this._root;for(;h;){const b=u.cmp(h.segment);if(b>0)h=h.left;else if(b<0)h=h.right;else if(u.hasNext())u.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(s){for(const[u,h]of this)s(h,u)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){!s||(s.left&&(yield*this._entries(s.left)),s.value&&(yield[s.key,s.value]),s.mid&&(yield*this._entries(s.mid)),s.right&&(yield*this._entries(s.right)))}_isBalanced(){const s=u=>{if(!u)return!0;const h=u.balanceFactor();return h<-1||h>1?!1:s(u.left)&&s(u.right)};return s(this._root)}}e.TernarySearchTree=g;class d{constructor(s,u){this.uri=s,this.value=u}}class l{constructor(s,u){this[y]="ResourceMap",s instanceof l?(this.map=new Map(s.map),this.toKey=u??l.defaultToKey):(this.map=new Map,this.toKey=s??l.defaultToKey)}set(s,u){return this.map.set(this.toKey(s),new d(s,u)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,u){typeof u!="undefined"&&(s=s.bind(u));for(let[h,b]of this.map)s(b.value,b.uri,this)}*values(){for(let s of this.map.values())yield s.value}*keys(){for(let s of this.map.values())yield s.uri}*entries(){for(let s of this.map.values())yield[s.uri,s.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let[,s]of this.map)yield[s.uri,s.value]}}e.ResourceMap=l,l.defaultToKey=r=>r.toString();class c{constructor(s,u){this[P]="ResourceSet",!s||typeof s=="function"?this._map=new l(s):(this._map=new l(u),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,u){this._map.forEach((h,b)=>s.call(u,b,b,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var n;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(n=e.Touch||(e.Touch={}));class o{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,u=0){const h=this._map.get(s);if(!!h)return u!==0&&this.touch(h,u),h.value}set(s,u,h=0){let b=this._map.get(s);if(b)b.value=u,h!==0&&this.touch(b,h);else{switch(b={key:s,value:u,next:void 0,previous:void 0},h){case 0:this.addItemLast(b);break;case 1:this.addItemFirst(b);break;case 2:this.addItemLast(b);break;default:this.addItemLast(b);break}this._map.set(s,b),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const u=this._map.get(s);if(!!u)return this._map.delete(s),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,u){const h=this._state;let b=this._head;for(;b;){if(u?s.bind(u)(b.value,b.key,this):s(b.value,b.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const s=this,u=this._state;let h=this._head;const b={[Symbol.iterator](){return b},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const A={value:h.key,done:!1};return h=h.next,A}else return{value:void 0,done:!0}}};return b}values(){const s=this,u=this._state;let h=this._head;const b={[Symbol.iterator](){return b},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const A={value:h.value,done:!1};return h=h.next,A}else return{value:void 0,done:!0}}};return b}entries(){const s=this,u=this._state;let h=this._head;const b={[Symbol.iterator](){return b},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const A={value:[h.key,h.value],done:!1};return h=h.next,A}else return{value:void 0,done:!0}}};return b}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let u=this._head,h=this.size;for(;u&&h>s;)this._map.delete(u.key),u=u.next,h--;this._head=u,this._size=h,u&&(u.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const u=s.next,h=s.previous;if(!u||!h)throw new Error("Invalid list");u.previous=h,h.next=u}s.next=void 0,s.previous=void 0,this._state++}touch(s,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(s===this._head)return;const h=s.next,b=s.previous;s===this._tail?(b.next=void 0,this._tail=b):(h.previous=b,b.next=h),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(u===2){if(s===this._tail)return;const h=s.next,b=s.previous;s===this._head?(h.previous=void 0,this._head=h):(h.previous=b,b.next=h),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((u,h)=>{s.push([h,u])}),s}fromJSON(s){this.clear();for(const[u,h]of s)this.set(u,h)}}e.LinkedMap=o;class i extends o{constructor(s,u=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,u=2){return super.get(s,u)}peek(s){return super.get(s,0)}set(s,u){return super.set(s,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class a{constructor(s){S.set(this,void 0),St(this,S,s,"f")}get size(){return et(this,S,"f").size}forEach(s,u){et(this,S,"f").forEach(s,u)}get(s){return et(this,S,"f").get(s)}has(s){return et(this,S,"f").has(s)}entries(){return et(this,S,"f").entries()}keys(){return et(this,S,"f").keys()}values(){return et(this,S,"f").values()}[(S=new WeakMap,Symbol.iterator)](){return et(this,S,"f").entries()}}e.ReadonlyMapView=a}),define(we[137],ye([0,1,29,15]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...H){return function(K,ue){for(let pe=0,De=H.length;pe<De;pe++){const Te=H[pe](K,ue);if(Te)return Te}return null}}e.or=y,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(H,K,ue){if(!ue||ue.length<K.length)return null;let pe;return H?pe=t.startsWithIgnoreCase(ue,K):pe=ue.indexOf(K)===0,pe?K.length>0?[{start:0,end:K.length}]:[]:null}function k(H,K){const ue=K.toLowerCase().indexOf(H.toLowerCase());return ue===-1?null:[{start:ue,end:ue+H.length}]}e.matchesContiguousSubString=k;function S(H,K){return v(H.toLowerCase(),K.toLowerCase(),0,0)}e.matchesSubString=S;function v(H,K,ue,pe){if(ue===H.length)return[];if(pe===K.length)return null;if(H[ue]===K[pe]){let De=null;return(De=v(H,K,ue+1,pe+1))?p({start:pe,end:pe+1},De):null}return v(H,K,ue,pe+1)}function D(H){return 97<=H&&H<=122}function T(H){return 65<=H&&H<=90}e.isUpper=T;function R(H){return 48<=H&&H<=57}function C(H){return H===32||H===9||H===10||H===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(H=>w.add(H.charCodeAt(0)));function m(H){return C(H)||w.has(H)}function E(H,K){return H===K||m(H)&&m(K)}function f(H){return D(H)||T(H)||R(H)}function p(H,K){return K.length===0?K=[H]:H.end===K[0].start?K[0].start=H.start:K.unshift(H),K}function g(H,K){for(let ue=K;ue<H.length;ue++){const pe=H.charCodeAt(ue);if(T(pe)||R(pe)||ue>0&&!f(H.charCodeAt(ue-1)))return ue}return H.length}function d(H,K,ue,pe){if(ue===H.length)return[];if(pe===K.length)return null;if(H[ue]!==K[pe].toLowerCase())return null;{let De=null,Te=pe+1;for(De=d(H,K,ue+1,pe+1);!De&&(Te=g(K,Te))<K.length;)De=d(H,K,ue+1,Te),Te++;return De===null?null:p({start:pe,end:pe+1},De)}}function l(H){let K=0,ue=0,pe=0,De=0,Te=0;for(let ve=0;ve<H.length;ve++)Te=H.charCodeAt(ve),T(Te)&&K++,D(Te)&&ue++,f(Te)&&pe++,R(Te)&&De++;const Me=K/H.length,Ue=ue/H.length,de=pe/H.length,Se=De/H.length;return{upperPercent:Me,lowerPercent:Ue,alphaPercent:de,numericPercent:Se}}function c(H){const{upperPercent:K,lowerPercent:ue}=H;return ue===0&&K>.6}function n(H){const{upperPercent:K,lowerPercent:ue,alphaPercent:pe,numericPercent:De}=H;return ue>.2&&K<.8&&pe>.6&&De<.2}function o(H){let K=0,ue=0,pe=0,De=0;for(let Te=0;Te<H.length;Te++)pe=H.charCodeAt(Te),T(pe)&&K++,D(pe)&&ue++,C(pe)&&De++;return(K===0||ue===0)&&De===0?H.length<=30:K<=5}function i(H,K){if(!K||(K=K.trim(),K.length===0)||!o(H)||K.length>60)return null;const ue=l(K);if(!n(ue)){if(!c(ue))return null;K=K.toLowerCase()}let pe=null,De=0;for(H=H.toLowerCase();De<K.length&&(pe=d(H,K,0,De))===null;)De=g(K,De+1);return pe}e.matchesCamelCase=i;function a(H,K,ue=!1){if(!K||K.length===0)return null;let pe=null,De=0;for(H=H.toLowerCase(),K=K.toLowerCase();De<K.length&&(pe=r(H,K,0,De,ue))===null;)De=s(K,De+1);return pe}e.matchesWords=a;function r(H,K,ue,pe,De){if(ue===H.length)return[];if(pe===K.length)return null;if(E(H.charCodeAt(ue),K.charCodeAt(pe))){let Te=null,Me=pe+1;if(Te=r(H,K,ue+1,pe+1,De),!De)for(;!Te&&(Me=s(K,Me))<K.length;)Te=r(H,K,ue+1,Me,De),Me++;return Te===null?null:p({start:pe,end:pe+1},Te)}else return null}function s(H,K){for(let ue=K;ue<H.length;ue++)if(m(H.charCodeAt(ue))||ue>0&&m(H.charCodeAt(ue-1)))return ue;return H.length}const u=y(e.matchesPrefix,i,k),h=y(e.matchesPrefix,i,S),b=new I.LRUCache(1e4);function A(H,K,ue=!1){if(typeof H!="string"||typeof K!="string")return null;let pe=b.get(H);pe||(pe=new RegExp(t.convertSimple2RegExpPattern(H),"i"),b.set(H,pe));const De=pe.exec(K);return De?[{start:De.index,end:De.index+De[0].length}]:ue?h(H,K):u(H,K)}e.matchesFuzzy=A;function B(H,K){const ue=te(H,H.toLowerCase(),0,K,K.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ue?Q(ue):null}e.matchesFuzzy2=B;function G(H,K,ue,pe,De,Te){const Me=Math.min(13,H.length);for(;ue<Me;ue++){const Ue=te(H,K,ue,pe,De,Te,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Ue)return Ue}return[0,Te]}e.anyScore=G;function Q(H){if(typeof H=="undefined")return[];const K=[],ue=H[1];for(let pe=H.length-1;pe>1;pe--){const De=H[pe]+ue,Te=K[K.length-1];Te&&Te.end===De?Te.end=De+1:K.push({start:De,end:De+1})}return K}e.createMatches=Q;const _=128;function X(){const H=[],K=[];for(let ue=0;ue<=_;ue++)K[ue]=0;for(let ue=0;ue<=_;ue++)H.push(K.slice(0));return H}function F(H){const K=[];for(let ue=0;ue<=H;ue++)K[ue]=0;return K}const U=F(2*_),le=F(2*_),j=X(),$=X(),O=X(),M=!1;function W(H,K,ue,pe,De){function Te(Ue,de,Se=" "){for(;Ue.length<de;)Ue=Se+Ue;return Ue}let Me=` |   |${pe.split("").map(Ue=>Te(Ue,3)).join("|")}
`;for(let Ue=0;Ue<=ue;Ue++)Ue===0?Me+=" |":Me+=`${K[Ue-1]}|`,Me+=H[Ue].slice(0,De+1).map(de=>Te(de.toString(),3)).join("|")+`
`;return Me}function J(H,K,ue,pe){H=H.substr(K),ue=ue.substr(pe),console.log(W($,H,H.length,ue,ue.length)),console.log(W(O,H,H.length,ue,ue.length)),console.log(W(j,H,H.length,ue,ue.length))}function ae(H,K){if(K<0||K>=H.length)return!1;const ue=H.codePointAt(K);switch(ue){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(ue)}}function me(H,K){if(K<0||K>=H.length)return!1;switch(H.charCodeAt(K)){case 32:case 9:return!0;default:return!1}}function fe(H,K,ue){return K[H]!==ue[H]}function V(H,K,ue,pe,De,Te,Me=!1){for(;K<ue&&De<Te;)H[K]===pe[De]&&(Me&&(U[K]=De),K+=1),De+=1;return K===ue}e.isPatternInWord=V;var ee;(function(H){H[H.Diag=1]="Diag",H[H.Left=2]="Left",H[H.LeftLeft=3]="LeftLeft"})(ee||(ee={}));var x;(function(H){H.Default=[-100,0];function K(ue){return!ue||ue.length===2&&ue[0]===-100&&ue[1]===0}H.isDefault=K})(x=e.FuzzyScore||(e.FuzzyScore={}));class z{constructor(K,ue){this.firstMatchCanBeWeak=K,this.boostFullMatch=ue}}e.FuzzyScoreOptions=z,z.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function te(H,K,ue,pe,De,Te,Me=z.default){const Ue=H.length>_?_:H.length,de=pe.length>_?_:pe.length;if(ue>=Ue||Te>=de||Ue-ue>de-Te||!V(K,ue,Ue,De,Te,de,!0))return;ce(Ue,de,ue,Te,K,De);let Se=1,ve=1,Le=ue,Ne=Te;const Ze=[!1];for(Se=1,Le=ue;Le<Ue;Se++,Le++){const oe=U[Le],be=le[Le],ke=Le+1<Ue?le[Le+1]:de;for(ve=oe-Te+1,Ne=oe;Ne<ke;ve++,Ne++){let _e=Number.MIN_SAFE_INTEGER,Be=!1;Ne<=be&&(_e=Z(H,K,Le,ue,pe,De,Ne,de,Te,j[Se-1][ve-1]===0,Ze));let Fe=0;_e!==Number.MAX_SAFE_INTEGER&&(Be=!0,Fe=_e+$[Se-1][ve-1]);const qe=Ne>oe,Ge=qe?$[Se][ve-1]+(j[Se][ve-1]>0?-5:0):0,Ke=Ne>oe+1&&j[Se][ve-1]>0,xe=Ke?$[Se][ve-2]+(j[Se][ve-2]>0?-5:0):0;if(Ke&&(!qe||xe>=Ge)&&(!Be||xe>=Fe))$[Se][ve]=xe,O[Se][ve]=3,j[Se][ve]=0;else if(qe&&(!Be||Ge>=Fe))$[Se][ve]=Ge,O[Se][ve]=2,j[Se][ve]=0;else if(Be)$[Se][ve]=Fe,O[Se][ve]=1,j[Se][ve]=j[Se-1][ve-1]+1;else throw new Error("not possible")}}if(M&&J(H,ue,pe,Te),!Ze[0]&&!Me.firstMatchCanBeWeak)return;Se--,ve--;const $e=[$[Se][ve],Te];let He=0,je=0;for(;Se>=1;){let oe=ve;do{const be=O[Se][oe];if(be===3)oe=oe-2;else if(be===2)oe=oe-1;else break}while(oe>=1);He>1&&K[ue+Se-1]===De[Te+ve-1]&&!fe(oe+Te-1,pe,De)&&He+1>j[Se][oe]&&(oe=ve),oe===ve?He++:He=1,je||(je=oe),Se--,ve=oe-1,$e.push(ve)}de===Ue&&Me.boostFullMatch&&($e[0]+=2);const Ye=je-Ue;return $e[0]-=Ye,$e}e.fuzzyScore=te;function ce(H,K,ue,pe,De,Te){let Me=H-1,Ue=K-1;for(;Me>=ue&&Ue>=pe;)De[Me]===Te[Ue]&&(le[Me]=Ue,Me--),Ue--}function Z(H,K,ue,pe,De,Te,Me,Ue,de,Se,ve){if(K[ue]!==Te[Me])return Number.MIN_SAFE_INTEGER;let Le=1,Ne=!1;return Me===ue-pe?Le=H[ue]===De[Me]?7:5:fe(Me,De,Te)&&(Me===0||!fe(Me-1,De,Te))?(Le=H[ue]===De[Me]?7:5,Ne=!0):ae(Te,Me)&&(Me===0||!ae(Te,Me-1))?Le=5:(ae(Te,Me-1)||me(Te,Me-1))&&(Le=5,Ne=!0),Le>1&&ue===pe&&(ve[0]=!0),Ne||(Ne=fe(Me,De,Te)||ae(Te,Me-1)||me(Te,Me-1)),ue===pe?Me>de&&(Le-=Ne?3:5):Se?Le+=Ne?2:0:Le+=Ne?0:1,Me+1===Ue&&(Le-=Ne?3:5),Le}function se(H,K,ue,pe,De,Te,Me){return Y(H,K,ue,pe,De,Te,!0,Me)}e.fuzzyScoreGracefulAggressive=se;function ge(H,K,ue,pe,De,Te,Me){return Y(H,K,ue,pe,De,Te,!1,Me)}e.fuzzyScoreGraceful=ge;function Y(H,K,ue,pe,De,Te,Me,Ue){let de=te(H,K,ue,pe,De,Te,Ue);if(de&&!Me)return de;if(H.length>=3){const Se=Math.min(7,H.length-1);for(let ve=ue+1;ve<Se;ve++){const Le=re(H,ve);if(Le){const Ne=te(Le,Le.toLowerCase(),ue,pe,De,Te,Ue);Ne&&(Ne[0]-=3,(!de||Ne[0]>de[0])&&(de=Ne))}}}return de}function re(H,K){if(K+1>=H.length)return;const ue=H[K],pe=H[K+1];if(ue!==pe)return H.slice(0,K)+pe+ue+H.slice(K+2)}}),define(we[138],ye([0,1,38,137,15]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(I.CSSIcon.iconNameCharacter),S=new RegExp(`(\\\\)?${P.source}`,"g");function v(f){return f.replace(S,(p,g)=>g?p:`\\${p}`)}e.escapeIcons=v;const D=new RegExp(`\\\\${P.source}`,"g");function T(f){return f.replace(D,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=T;const R=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function C(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(R,(p,g,d,l)=>d?p:g||l||"")}e.stripIcons=C;function w(f){const p=f.indexOf(e.iconStartMarker);return p===-1?{text:f}:m(f,p)}e.parseLabelWithIcons=w;function m(f,p){const g=[];let d="";function l(u){if(u){d+=u;for(const h of u)g.push(o)}}let c=-1,n="",o=0,i,a,r=p;const s=f.length;for(l(f.substr(0,p));r<s;)i=f[r],a=f[r+1],i===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(c=r,l(n),n=e.iconStartMarker,r++):i===")"&&c!==-1?(o+=r-c+1,c=-1,n=""):c!==-1?k.test(i)?n+=i:(l(n),c=-1,n=""):l(i),r++;return l(n),{text:d,iconOffsets:g}}function E(f,p,g=!1){const{text:d,iconOffsets:l}=p;if(!l||l.length===0)return(0,t.matchesFuzzy)(f,d,g);const c=(0,y.ltrim)(d," "),n=d.length-c.length,o=(0,t.matchesFuzzy)(f,c,g);if(o)for(const i of o){const a=l[i.start+n]+n;i.start+=a,i.end+=a}return o}e.matchesFuzzyIconAware=E}),define(we[83],ye([0,1,29]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new I.LRUCache(1e4);function y(D){return v(D,"NFC",t)}e.normalizeNFC=y;const P=new I.LRUCache(1e4);function k(D){return v(D,"NFD",P)}e.normalizeNFD=k;const S=/[^\u0000-\u0080]/;function v(D,T,R){if(!D)return D;const C=R.get(D);if(C)return C;let w;return S.test(D)?w=D.normalize(T):w=D,R.set(D,w),w}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(T){return k(T).replace(D,"")}}()}),define(we[65],ye([0,1,15]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(t||(t={})),function(y){const P="error",k="warning",S="warn",v="info",D="ignore";function T(C){return C?I.equalsIgnoreCase(P,C)?y.Error:I.equalsIgnoreCase(k,C)||I.equalsIgnoreCase(S,C)?y.Warning:I.equalsIgnoreCase(v,C)?y.Info:y.Ignore:y.Ignore}y.fromValue=T;function R(C){switch(C){case y.Error:return P;case y.Warning:return k;case y.Info:return v;default:return D}}y.toString=R}(t||(t={})),e.default=t}),define(we[12],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function I(u){return Array.isArray(u)}e.isArray=I;function t(u){return typeof u=="string"}e.isString=t;function y(u){return Array.isArray(u)&&u.every(h=>t(h))}e.isStringArray=y;function P(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=P;function k(u){return typeof u=="object"&&(u instanceof Uint8Array||u instanceof Uint16Array||u instanceof Uint32Array||u instanceof Float32Array||u instanceof Float64Array||u instanceof Int8Array||u instanceof Int16Array||u instanceof Int32Array||u instanceof BigInt64Array||u instanceof BigUint64Array||u instanceof Uint8ClampedArray)}e.isTypedArray=k;function S(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=S;function v(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=v;function D(u){return u===!0||u===!1}e.isBoolean=D;function T(u){return typeof u=="undefined"}e.isUndefined=T;function R(u){return!C(u)}e.isDefined=R;function C(u){return T(u)||u===null}e.isUndefinedOrNull=C;function w(u,h){if(!u)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}e.assertType=w;function m(u){if(C(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=m;function E(...u){const h=[];for(let b=0;b<u.length;b++){const A=u[b];if(C(A))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);h.push(A)}return h}e.assertAllDefined=E;const f=Object.prototype.hasOwnProperty;function p(u){if(!P(u))return!1;for(let h in u)if(f.call(u,h))return!1;return!0}e.isEmptyObject=p;function g(u){return typeof u=="function"}e.isFunction=g;function d(...u){return u.length>0&&u.every(g)}e.areFunctions=d;function l(u,h){const b=Math.min(u.length,h.length);for(let A=0;A<b;A++)c(u[A],h[A])}e.validateConstraints=l;function c(u,h){if(t(h)){if(typeof u!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(g(h)){try{if(u instanceof h)return}catch{}if(!C(u)&&u.constructor===h||h.length===1&&h.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function n(u){let h=[],b=Object.getPrototypeOf(u);for(;Object.prototype!==b;)h=h.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return h}e.getAllPropertyNames=n;function o(u){const h=[];for(const b of n(u))typeof u[b]=="function"&&h.push(b);return h}e.getAllMethodNames=o;function i(u,h){const b=B=>function(){const G=Array.prototype.slice.call(arguments,0);return h(B,G)};let A={};for(const B of u)A[B]=b(B);return A}e.createProxyObject=i;function a(u){return u===null?void 0:u}e.withNullAsUndefined=a;function r(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=r;function s(u,h="Unreachable"){throw new Error(h)}e.assertNever=s}),define(we[33],ye([0,1,5,3,15,12]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function S(r){return r.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=S;function v(r){return r.indexOf("/")===-1&&(r=S(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=v;function D(r,s=I.posix.sep){if(!r)return"";const u=r.length,h=r.charCodeAt(0);if(k(h)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let A=3;const B=A;for(;A<u&&!k(r.charCodeAt(A));A++);if(B!==A&&!k(r.charCodeAt(A+1))){for(A+=1;A<u;A++)if(k(r.charCodeAt(A)))return r.slice(0,A+1).replace(/[\\/]/g,s)}}return s}else if(p(h)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let b=r.indexOf("://");if(b!==-1){for(b+=3;b<u;b++)if(k(r.charCodeAt(b)))return r.slice(0,b+1)}return""}e.getRoot=D;function T(r){if(!t.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let u=2;const h=u;for(;u<r.length&&(s=r.charCodeAt(u),s!==92);u++);return!(h===u||(s=r.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=T;const R=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(r,s=t.isWindows){const u=s?R:C;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||s&&w.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=m;function E(r,s,u){const h=r===s;return!u||h?h:!r||!s?!1:(0,y.equalsIgnoreCase)(r,s)}e.isEqual=E;function f(r,s,u,h=I.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(u){if(!(0,y.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let A=s.length;return s.charAt(s.length-1)===h&&A--,r.charAt(A)===h}return s.charAt(s.length-1)!==h&&(s+=h),r.indexOf(s)===0}e.isEqualOrParent=f;function p(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=p;function g(r,s){return t.isWindows&&r.endsWith(":")&&(r+=I.sep),(0,I.isAbsolute)(r)||(r=(0,I.join)(s,r)),r=(0,I.normalize)(r),t.isWindows?(r=(0,y.rtrim)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,y.rtrim)(r,I.sep),r||(r=I.sep)),r}e.sanitizeFilePath=g;function d(r){const s=(0,I.normalize)(r);return t.isWindows?r.length>3?!1:l(s)&&(r.length===2||s.charCodeAt(2)===92):s===I.posix.sep}e.isRootOrDriveLetter=d;function l(r,s=t.isWindows){return s?p(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function c(r){return l(r)?r[0]:void 0}e.getDriveLetter=c;function n(r,s,u){return s.length>r.length?-1:r===s?0:(u&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=n;function o(r){const s=r.split(":");let u,h,b;for(const A of s){const B=Number(A);(0,P.isNumber)(B)?h===void 0?h=B:b===void 0&&(b=B):u=u?[u,A].join(":"):A}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:h!==void 0?h:void 0,column:b!==void 0?b:h!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(r,s,u=8){let h="";for(let A=0;A<u;A++)h+=i.charAt(Math.floor(Math.random()*i.length));let b;return s?b=`${s}-${h}`:b=h,r?(0,I.join)(r,b):b}e.randomPath=a}),define(we[21],ye([0,1,12]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const f=Array.isArray(E)?[]:{};return Object.keys(E).forEach(p=>{E[p]&&typeof E[p]=="object"?f[p]=t(E[p]):f[p]=E[p]}),f}e.deepClone=t;function y(E){if(!E||typeof E!="object")return E;const f=[E];for(;f.length>0;){const p=f.shift();Object.freeze(p);for(const g in p)if(P.call(p,g)){const d=p[g];typeof d=="object"&&!Object.isFrozen(d)&&!(0,I.isTypedArray)(d)&&f.push(d)}}return E}e.deepFreeze=y;const P=Object.prototype.hasOwnProperty;function k(E,f){return S(E,f,new Set)}e.cloneAndChange=k;function S(E,f,p){if((0,I.isUndefinedOrNull)(E))return E;const g=f(E);if(typeof g!="undefined")return g;if((0,I.isArray)(E)){const d=[];for(const l of E)d.push(S(l,f,p));return d}if((0,I.isObject)(E)){if(p.has(E))throw new Error("Cannot clone recursive data-structure");p.add(E);const d={};for(let l in E)P.call(E,l)&&(d[l]=S(E[l],f,p));return p.delete(E),d}return E}function v(E,f,p=!0){return(0,I.isObject)(E)?((0,I.isObject)(f)&&Object.keys(f).forEach(g=>{g in E?p&&((0,I.isObject)(E[g])&&(0,I.isObject)(f[g])?v(E[g],f[g],p):E[g]=f[g]):E[g]=f[g]}),E):f}e.mixin=v;function D(E,f){if(E===f)return!0;if(E==null||f===null||f===void 0||typeof E!=typeof f||typeof E!="object"||Array.isArray(E)!==Array.isArray(f))return!1;let p,g;if(Array.isArray(E)){if(E.length!==f.length)return!1;for(p=0;p<E.length;p++)if(!D(E[p],f[p]))return!1}else{const d=[];for(g in E)d.push(g);d.sort();const l=[];for(g in f)l.push(g);if(l.sort(),!D(d,l))return!1;for(p=0;p<d.length;p++)if(!D(E[d[p]],f[d[p]]))return!1}return!0}e.equals=D;function T(E){const f=new Set;return JSON.stringify(E,(p,g)=>{if((0,I.isObject)(g)||Array.isArray(g)){if(f.has(g))return"[Circular]";f.add(g)}return g})}e.safeStringify=T;function R(E,f,p){const g=f(E);return typeof g=="undefined"?p:g}e.getOrDefault=R;function C(E,f){const p=Object.create(null);return!E||!f||Object.keys(f).forEach(d=>{const l=E[d],c=f[d];D(l,c)||(p[d]=c)}),p}e.distinct=C;function w(E,f){const p=f.toLowerCase(),g=Object.keys(E).find(d=>d.toLowerCase()===p);return g?E[g]:E[f]}e.getCaseInsensitive=w;function m(E,f){const p=Object.create(null);for(const[g,d]of Object.entries(E))f(g,d)&&(p[g]=d);return p}e.filter=m}),define(we[4],ye([0,1,5,3]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const y=/^\w[\w\d+.-]*$/,P=/^\//,k=/^\/\//;function S(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!y.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!P.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(i,a){return!i&&!a?"file":i}function D(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==R&&(a=R+a):a=R;break}return a}const T="",R="/",C=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(a,r,s,u,h,b=!1){typeof a=="object"?(this.scheme=a.scheme||T,this.authority=a.authority||T,this.path=a.path||T,this.query=a.query||T,this.fragment=a.fragment||T):(this.scheme=v(a,b),this.authority=r||T,this.path=D(this.scheme,s||T),this.query=u||T,this.fragment=h||T,S(this,b))}static isUri(a){return a instanceof w?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return d(this,!1)}with(a){if(!a)return this;let{scheme:r,authority:s,path:u,query:h,fragment:b}=a;return r===void 0?r=this.scheme:r===null&&(r=T),s===void 0?s=this.authority:s===null&&(s=T),u===void 0?u=this.path:u===null&&(u=T),h===void 0?h=this.query:h===null&&(h=T),b===void 0?b=this.fragment:b===null&&(b=T),r===this.scheme&&s===this.authority&&u===this.path&&h===this.query&&b===this.fragment?this:new E(r,s,u,h,b)}static parse(a,r=!1){const s=C.exec(a);return s?new E(s[2]||T,o(s[4]||T),o(s[5]||T),o(s[7]||T),o(s[9]||T),r):new E(T,T,T,T,T)}static file(a){let r=T;if(t.isWindows&&(a=a.replace(/\\/g,R)),a[0]===R&&a[1]===R){const s=a.indexOf(R,2);s===-1?(r=a.substring(2),a=R):(r=a.substring(2,s),a=a.substring(s)||R)}return new E("file",r,a,T,T)}static from(a){const r=new E(a.scheme,a.authority,a.path,a.query,a.fragment);return S(r,!0),r}static joinPath(a,...r){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return t.isWindows&&a.scheme==="file"?s=w.file(I.win32.join(d(a,!0),...r)).path:s=I.posix.join(a.path,...r),a.with({path:s})}toString(a=!1){return l(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof w)return a;{const r=new E(a);return r._formatted=a.external,r._fsPath=a._sep===m?a.fsPath:null,r}}else return a}}e.URI=w;const m=t.isWindows?1:void 0;class E extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(a=!1){return a?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=m),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(i,a){let r,s=-1;for(let u=0;u<i.length;u++){const h=i.charCodeAt(u);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||a&&h===47)s!==-1&&(r+=encodeURIComponent(i.substring(s,u)),s=-1),r!==void 0&&(r+=i.charAt(u));else{r===void 0&&(r=i.substr(0,u));const b=f[h];b!==void 0?(s!==-1&&(r+=encodeURIComponent(i.substring(s,u)),s=-1),r+=b):s===-1&&(s=u)}}return s!==-1&&(r+=encodeURIComponent(i.substring(s))),r!==void 0?r:i}function g(i){let a;for(let r=0;r<i.length;r++){const s=i.charCodeAt(r);s===35||s===63?(a===void 0&&(a=i.substr(0,r)),a+=f[s]):a!==void 0&&(a+=i[r])}return a!==void 0?a:i}function d(i,a){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=d;function l(i,a){const r=a?g:p;let s="",{scheme:u,authority:h,path:b,query:A,fragment:B}=i;if(u&&(s+=u,s+=":"),(h||u==="file")&&(s+=R,s+=R),h){let G=h.indexOf("@");if(G!==-1){const Q=h.substr(0,G);h=h.substr(G+1),G=Q.indexOf(":"),G===-1?s+=r(Q,!1):(s+=r(Q.substr(0,G),!1),s+=":",s+=r(Q.substr(G+1),!1)),s+="@"}h=h.toLowerCase(),G=h.indexOf(":"),G===-1?s+=r(h,!1):(s+=r(h.substr(0,G),!1),s+=h.substr(G))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const G=b.charCodeAt(1);G>=65&&G<=90&&(b=`/${String.fromCharCode(G+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const G=b.charCodeAt(0);G>=65&&G<=90&&(b=`${String.fromCharCode(G+32)}:${b.substr(2)}`)}s+=r(b,!0)}return A&&(s+="?",s+=r(A,!1)),B&&(s+="#",s+=a?B:p(B,!1)),s}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(i){return i.match(n)?i.replace(n,a=>c(a)):i}}),define(we[84],ye([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(D){const T=D;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=t;function y(D){const T=[];let R;try{const C=JSON.parse(D.arguments),w=C[C.length-1];w&&w.__$stack&&(C.pop(),R=w.__$stack),T.push(...C)}catch{T.push("Unable to log remote console arguments",D.arguments)}return{args:T,stack:R}}e.parse=y;function P(D){if(typeof D!="string")return P(y(D).stack);const T=D;if(T){const R=k(T),C=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(C&&C.length===4)return{uri:I.URI.file(C[1]),line:Number(C[2]),column:Number(C[3])}}}e.getFirstFrame=P;function k(D){if(!D)return D;const T=D.indexOf(`
`);return T===-1?D:D.substring(0,T)}function S(D,T){const{args:R,stack:C}=y(D),w=typeof R[0]=="string"&&R.length===1;let m=k(C);m&&(m=`(${m.trim()})`);let E=[];if(typeof R[0]=="string"?m&&w?E=[`%c[${T}] %c${R[0]} %c${m}`,v("blue"),v(""),v("grey")]:E=[`%c[${T}] %c${R[0]}`,v("blue"),v(""),...R.slice(1)]:E=[`%c[${T}]%`,v("blue"),...R],m&&!w&&E.push(m),typeof console[D.severity]!="function")throw new Error("Unknown console method");console[D.severity].apply(console,E)}e.log=S;function v(D){return`color: ${D}`}}),define(we[45],ye([0,1,17,15,4]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(D){return JSON.stringify(D,S)}e.stringify=P;function k(D){let T=JSON.parse(D);return T=v(T),T}e.parse=k;function S(D,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,t.regExpFlags)(T)}:T}function v(D,T=0){if(!D||T>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return y.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 14:return new Date(D.source)}if(D instanceof I.VSBuffer||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let R=0;R<D.length;++R)D[R]=v(D[R],T+1);else for(const R in D)Object.hasOwnProperty.call(D,R)&&(D[R]=v(D[R],T+1))}return D}e.revive=v}),define(we[8],ye([0,1,3,4]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls"})(y=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}setServerRootPath(v){this._remoteResourcesPath=`${v}/${y.vscodeRemoteResource}`}set(v,D,T){this._hosts[v]=D,this._ports[v]=T}setConnectionToken(v,D){this._connectionTokens[v]=D}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(v){if(this._delegate)return this._delegate(v);const D=v.authority;let T=this._hosts[D];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const R=this._ports[D],C=this._connectionTokens[D];let w=`path=${encodeURIComponent(v.path)}`;return typeof C=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),t.URI.from({scheme:I.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${T}:${R}`,path:I.isWeb?(window.location.pathname+"/"+this._remoteResourcesPath).replace(/\/\/+/g,"/"):this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new P;class k{asBrowserUri(v,D){const T=this.toUri(v,D);return T.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===y.file&&(I.isNative||I.isWebWorker&&I.globals.origin===`${y.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?T.with({scheme:y.vscodeFileResource,authority:T.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):T}asFileUri(v,D){const T=this.toUri(v,D);return T.scheme===y.vscodeFileResource?T.with({scheme:y.file,authority:T.authority!==k.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(v,D){return t.URI.isUri(v)?v:t.URI.parse(D.toUrl(v))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(we[19],ye([0,1,33,8,5,3,15,4]),function(ie,e,I,t,y,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(w){return(0,S.uriToFsPath)(w,!0)}e.originalFSPath=v;class D{constructor(m){this._ignorePathCasing=m}compare(m,E,f=!1){return m===E?0:(0,k.compare)(this.getComparisonKey(m,f),this.getComparisonKey(E,f))}isEqual(m,E,f=!1){return m===E?!0:!m||!E?!1:this.getComparisonKey(m,f)===this.getComparisonKey(E,f)}getComparisonKey(m,E=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,E,f=!1){if(m.scheme===E.scheme){if(m.scheme===t.Schemas.file)return I.isEqualOrParent(v(m),v(E),this._ignorePathCasing(m))&&m.query===E.query&&(f||m.fragment===E.fragment);if((0,e.isEqualAuthority)(m.authority,E.authority))return I.isEqualOrParent(m.path,E.path,this._ignorePathCasing(m),"/")&&m.query===E.query&&(f||m.fragment===E.fragment)}return!1}joinPath(m,...E){return S.URI.joinPath(m,...E)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return y.posix.basename(m.path)}extname(m){return y.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let E;return m.scheme===t.Schemas.file?E=S.URI.file(y.dirname(v(m))).path:(E=y.posix.dirname(m.path),m.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),E="/")),m.with({path:E})}normalizePath(m){if(!m.path.length)return m;let E;return m.scheme===t.Schemas.file?E=S.URI.file(y.normalize(v(m))).path:E=y.posix.normalize(m.path),m.with({path:E})}relativePath(m,E){if(m.scheme!==E.scheme||!(0,e.isEqualAuthority)(m.authority,E.authority))return;if(m.scheme===t.Schemas.file){const g=y.relative(v(m),v(E));return P.isWindows?I.toSlashes(g):g}let f=m.path||"/",p=E.path||"/";if(this._ignorePathCasing(m)){let g=0;for(const d=Math.min(f.length,p.length);g<d&&!(f.charCodeAt(g)!==p.charCodeAt(g)&&f.charAt(g).toLowerCase()!==p.charAt(g).toLowerCase());g++);f=p.substr(0,g)+f.substr(g)}return y.posix.relative(f,p)}resolvePath(m,E){if(m.scheme===t.Schemas.file){const f=S.URI.file(y.resolve(v(m),E));return m.with({authority:f.authority,path:f.path})}return E=I.toPosixPath(E),m.with({path:y.posix.resolve(m.path,E)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,E){return m===E||m!==void 0&&E!==void 0&&(0,k.equalsIgnoreCase)(m,E)}hasTrailingPathSeparator(m,E=y.sep){if(m.scheme===t.Schemas.file){const f=v(m);return f.length>I.getRoot(f).length&&f[f.length-1]===E}else{const f=m.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,E=y.sep){return(0,e.hasTrailingPathSeparator)(m,E)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,E=y.sep){let f=!1;if(m.scheme===t.Schemas.file){const p=v(m);f=p!==void 0&&p.length===I.getRoot(p).length&&p[p.length-1]===E}else{E="/";const p=m.path;f=p.length===1&&p.charCodeAt(p.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(m,E)?m.with({path:m.path+"/"}):m}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(w=>w.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new D(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(w,m){const E=[];for(let f=0;f<w.length;f++){const p=m(w[f]);w.some((g,d)=>d===f?!1:(0,e.isEqualOrParent)(p,m(g)))||E.push(w[f])}return E}e.distinctParents=T;var R;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function m(E){const f=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(d=>{const[l,c]=d.split(":");l&&c&&f.set(l,c)});const g=E.path.substring(0,E.path.indexOf(";"));return g&&f.set(w.META_DATA_MIME,g),f}w.parseMetaData=m})(R=e.DataUri||(e.DataUri={}));function C(w,m,E){if(m){let f=w.path;return f&&f[0]!==y.posix.sep&&(f=y.posix.sep+f),w.with({scheme:E,authority:m,path:f})}return w.with({scheme:E})}e.toLocalResource=C}),define(we[14],ye([0,1,20,9,6,2,19,3]),function(ie,e,I,t,y,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=v;function D(fe){const V=new I.CancellationTokenSource,ee=fe(V.token),x=new Promise((z,te)=>{const ce=V.token.onCancellationRequested(()=>{ce.dispose(),V.dispose(),te(new t.CancellationError)});Promise.resolve(ee).then(Z=>{ce.dispose(),V.dispose(),z(Z)},Z=>{ce.dispose(),V.dispose(),te(Z)})});return new class{cancel(){V.cancel()}then(z,te){return x.then(z,te)}catch(z){return this.then(void 0,z)}finally(z){return x.finally(z)}}}e.createCancelablePromise=D;function T(fe,V,ee){return new Promise((x,z)=>{const te=V.onCancellationRequested(()=>{te.dispose(),x(ee)});fe.then(x,z).finally(()=>te.dispose())})}e.raceCancellation=T;function R(fe,V){return new Promise((ee,x)=>{const z=V.onCancellationRequested(()=>{z.dispose(),x(new t.CancellationError)});fe.then(ee,x).finally(()=>z.dispose())})}e.raceCancellationError=R;async function C(fe){let V=-1;const ee=fe.map((z,te)=>z.then(ce=>(V=te,ce))),x=await Promise.race(ee);return fe.forEach((z,te)=>{te!==V&&z.cancel()}),x}e.raceCancellablePromises=C;function w(fe,V,ee){let x;const z=setTimeout(()=>{x?.(void 0),ee?.()},V);return Promise.race([fe.finally(()=>clearTimeout(z)),new Promise(te=>x=te)])}e.raceTimeout=w;function m(fe){return new Promise((V,ee)=>{const x=fe();v(x)?x.then(V,ee):V(x)})}e.asPromise=m;class E{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(V){if(this.activePromise){if(this.queuedPromiseFactory=V,!this.queuedPromise){const ee=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(ee,ee).then(x)})}return new Promise((ee,x)=>{this.queuedPromise.then(ee,x)})}return this.activePromise=V(),new Promise((ee,x)=>{this.activePromise.then(z=>{this.activePromise=null,ee(z)},z=>{this.activePromise=null,x(z)})})}}e.Throttler=E;class f{constructor(){this.current=Promise.resolve(null)}queue(V){return this.current=this.current.then(()=>V(),()=>V())}}e.Sequencer=f;class p{constructor(){this.promiseMap=new Map}queue(V,ee){const z=(this.promiseMap.get(V)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.promiseMap.get(V)===z&&this.promiseMap.delete(V)});return this.promiseMap.set(V,z),z}}e.SequencerByKey=p;const g=(fe,V)=>{let ee=!0;const x=setTimeout(()=>{ee=!1,V()},fe);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(x),ee=!1}}},d=fe=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,fe())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(V){this.defaultDelay=V,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(V,ee=this.defaultDelay){this.task=V,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,te)=>{this.doResolve=z,this.doReject=te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}}));const x=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ee===e.MicrotaskDelay?d(x):g(ee,x),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class c{constructor(V){this.delayer=new l(V),this.throttler=new E}trigger(V,ee){return this.delayer.trigger(()=>this.throttler.queue(V),ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class n{constructor(){this._isOpen=!1,this._promise=new Promise((V,ee)=>{this._completePromise=V})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class o extends n{constructor(V){super();this._timeout=setTimeout(()=>this.open(),V)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function i(fe,V){return V?new Promise((ee,x)=>{const z=setTimeout(()=>{te.dispose(),ee()},fe),te=V.onCancellationRequested(()=>{clearTimeout(z),te.dispose(),x(new t.CancellationError)})}):D(ee=>i(fe,ee))}e.timeout=i;function a(fe,V=0){const ee=setTimeout(fe,V);return(0,P.toDisposable)(()=>clearTimeout(ee))}e.disposableTimeout=a;function r(fe){const V=[];let ee=0;const x=fe.length;function z(){return ee<x?fe[ee++]():null}function te(ce){ce!=null&&V.push(ce);const Z=z();return Z?Z.then(te):Promise.resolve(V)}return Promise.resolve(null).then(te)}e.sequence=r;function s(fe,V=x=>!!x,ee=null){let x=0;const z=fe.length,te=()=>{if(x>=z)return Promise.resolve(ee);const ce=fe[x++];return Promise.resolve(ce()).then(se=>V(se)?Promise.resolve(se):te())};return te()}e.first=s;function u(fe,V=x=>!!x,ee=null){if(fe.length===0)return Promise.resolve(ee);let x=fe.length;const z=()=>{x=-1;for(const te of fe)te.cancel?.()};return new Promise((te,ce)=>{for(const Z of fe)Z.then(se=>{--x>=0&&V(se)?(z(),te(se)):x===0&&te(ee)}).catch(se=>{--x>=0&&(z(),ce(se))})})}e.firstParallel=u;class h{constructor(V){this._size=0,this.maxDegreeOfParalellism=V,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new y.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(V){return this._size++,new Promise((ee,x)=>{this.outstandingPromises.push({factory:V,c:ee,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const V=this.outstandingPromises.shift();this.runningPromises++;const ee=V.factory();ee.then(V.c,V.e),ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class b extends h{constructor(){super(1)}}e.Queue=b;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const V=new O;return this.drainers.add(V),V.p}isDrained(){for(const[,V]of this.queues)if(V.size>0)return!1;return!0}queueFor(V,ee=k.extUri){const x=ee.getComparisonKey(V);let z=this.queues.get(x);return z||(z=new b,y.Event.once(z.onDrained)(()=>{z?.dispose(),this.queues.delete(x),this.onDidQueueDrain()}),this.queues.set(x,z)),z}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const V of this.drainers)V.complete();this.drainers.clear()}dispose(){for(const[,V]of this.queues)V.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class B{constructor(V,ee){this._token=-1,typeof V=="function"&&typeof ee=="number"&&this.setIfNotSet(V,ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(V,ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,V()},ee)}setIfNotSet(V,ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,V()},ee))}}e.TimeoutTimer=B;class G{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(V,ee){this.cancel(),this._token=setInterval(()=>{V()},ee)}}e.IntervalTimer=G;class Q{constructor(V,ee){this.timeoutToken=-1,this.runner=V,this.timeout=ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(V=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,V)}get delay(){return this.timeout}set delay(V){this.timeout=V}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=Q;class _{constructor(V,ee){ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.runner=V,this.timeout=ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(V=this.timeout){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(V/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=_;class X extends Q{constructor(V,ee){super(V,ee);this.units=[]}work(V){this.units.push(V),this.isScheduled()||this.schedule()}doRun(){const V=this.units;this.units=[],this.runner&&this.runner(V)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X;class F extends P.Disposable{constructor(V,ee){super();this.options=V,this.handler=ee,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(V){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+V.length>this.options.maxBufferedWork)return!1}else if(this.pending+V.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...V),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,S.setTimeout0)(()=>{if(V)return;const ee=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.runWhenIdle=(fe,V)=>{const ee=requestIdleCallback(fe,typeof V=="number"?{timeout:V}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(ee))}}}}();class U{constructor(V){this._didRun=!1,this._executor=()=>{try{this._value=V()}catch(ee){this._error=ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=U;async function le(fe,V,ee){let x;for(let z=0;z<ee;z++)try{return await fe()}catch(te){x=te,await i(V)}throw x}e.retry=le;class j{hasPending(V){return this._pending?typeof V=="number"?this._pending.taskId===V:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(V,ee,x){return this._pending={taskId:V,cancel:()=>x?.(),promise:ee},ee.then(()=>this.donePending(V),()=>this.donePending(V)),ee}donePending(V){this._pending&&V===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const V=this._next;this._next=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}setNext(V){if(this._next)this._next.run=V;else{let ee,x;const z=new Promise((te,ce)=>{ee=te,x=ce});this._next={run:V,promise:z,promiseResolve:ee,promiseReject:x}}return this._next.promise}}e.TaskSequentializer=j;class ${constructor(V,ee=()=>Date.now()){this.interval=V,this.nowFn=ee,this.lastIncrementTime=0,this.value=0}increment(){const V=this.nowFn();return V-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=V,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class O{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((V,ee)=>{this.completeCallback=V,this.errorCallback=ee})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(V){return new Promise(ee=>{this.completeCallback(V),this.resolved=!0,ee()})}error(V){return new Promise(ee=>{this.errorCallback(V),this.rejected=!0,ee()})}cancel(){new Promise(V=>{this.errorCallback(new t.CancellationError),this.rejected=!0,V()})}}e.DeferredPromise=O;var M;(function(fe){async function V(x){let z;const te=await Promise.all(x.map(ce=>ce.then(Z=>Z,Z=>{z||(z=Z)})));if(typeof z!="undefined")throw z;return te}fe.settled=V;function ee(x){return new Promise(async(z,te)=>{try{await x(z,te)}catch(ce){te(ce)}})}fe.withAsyncBody=ee})(M=e.Promises||(e.Promises={}));var W;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(W||(W={}));class J{constructor(V){this._state=0,this._results=[],this._error=null,this._onStateChanged=new y.Emitter,queueMicrotask(async()=>{const ee={emitOne:x=>this.emitOne(x),emitMany:x=>this.emitMany(x),reject:x=>this.reject(x)};try{await Promise.resolve(V(ee)),this.resolve()}catch(x){this.reject(x)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}static fromArray(V){return new J(ee=>{ee.emitMany(V)})}static fromPromise(V){return new J(async ee=>{ee.emitMany(await V)})}static fromPromises(V){return new J(async ee=>{await Promise.all(V.map(async x=>ee.emitOne(await x)))})}static merge(V){return new J(async ee=>{await Promise.all(V.map(async x=>{for await(const z of x)ee.emitOne(z)}))})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(V<this._results.length)return{done:!1,value:this._results[V++]};if(this._state===1)return{done:!0,value:void 0};await y.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(V,ee){return new J(async x=>{for await(const z of V)x.emitOne(ee(z))})}map(V){return J.map(this,V)}static filter(V,ee){return new J(async x=>{for await(const z of V)ee(z)&&x.emitOne(z)})}filter(V){return J.filter(this,V)}static coalesce(V){return J.filter(V,ee=>!!ee)}coalesce(){return J.coalesce(this)}static async toPromise(V){const ee=[];for await(const x of V)ee.push(x);return ee}toPromise(){return J.toPromise(this)}emitOne(V){this._state===0&&(this._results.push(V),this._onStateChanged.fire())}emitMany(V){this._state===0&&(this._results=this._results.concat(V),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(V){this._state===0&&(this._state=2,this._error=V,this._onStateChanged.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class ae extends J{constructor(V,ee){super(ee);this._source=V}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ae;function me(fe){const V=new I.CancellationTokenSource,ee=fe(V.token);return new ae(V,async x=>{const z=V.token.onCancellationRequested(()=>{z.dispose(),V.dispose(),x.reject(new t.CancellationError)});try{for await(const te of ee){if(V.token.isCancellationRequested)return;x.emitOne(te)}z.dispose(),V.dispose()}catch(te){z.dispose(),V.dispose(),x.reject(te)}})}e.createCancelableAsyncIterable=me}),define(we[66],ye([0,1,16,14,33,29,5,3,15]),function(ie,e,I,t,y,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",R="[^/\\\\]",C=/\//g;function w(O,M){switch(O){case 0:return"";case 1:return`${R}*?`;default:return`(?:${T}|${R}+${T}${M?`|${T}${R}+`:""})*?`}}function m(O,M){if(!O)return[];const W=[];let J=!1,ae=!1,me="";for(const fe of O){switch(fe){case M:if(!J&&!ae){W.push(me),me="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}me+=fe}return me&&W.push(me),W}e.splitGlobAware=m;function E(O){if(!O)return"";let M="";const W=m(O,e.GLOB_SPLIT);if(W.every(J=>J===e.GLOBSTAR))M=".*";else{let J=!1;W.forEach((ae,me)=>{if(ae===e.GLOBSTAR){if(J)return;M+=w(2,me===W.length-1)}else{let fe=!1,V="",ee=!1,x="";for(const z of ae){if(z!=="}"&&fe){V+=z;continue}if(ee&&(z!=="]"||!x)){let te;z==="-"?te=z:(z==="^"||z==="!")&&!x?te="^":z===e.GLOB_SPLIT?te="":te=(0,v.escapeRegExpCharacters)(z),x+=te;continue}switch(z){case"{":fe=!0;continue;case"[":ee=!0;continue;case"}":{M+=`(?:${m(V,",").map(Z=>E(Z)).join("|")})`,fe=!1,V="";break}case"]":{M+="["+x+"]",ee=!1,x="";break}case"?":M+=R;continue;case"*":M+=w(1);continue;default:M+=(0,v.escapeRegExpCharacters)(z)}}me<W.length-1&&(W[me+1]!==e.GLOBSTAR||me+2<W.length)&&(M+=T)}J=ae===e.GLOBSTAR})}return M}const f=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new P.LRUCache(1e4),o=function(){return!1},i=function(){return null};function a(O,M){if(!O)return i;let W;typeof O!="string"?W=O.pattern:W=O,W=W.trim();const J=`${W}_${!!M.trimForExclusions}`;let ae=n.get(J);if(ae)return r(ae,O);let me;return f.test(W)?ae=u(W.substr(4),W):(me=p.exec(s(W,M)))?ae=h(me[1],W):(M.trimForExclusions?d:g).test(W)?ae=b(W,M):(me=l.exec(s(W,M)))?ae=A(me[1].substr(1),W,!0):(me=c.exec(s(W,M)))?ae=A(me[1],W,!1):ae=B(W),n.set(J,ae),r(ae,O)}function r(O,M){if(typeof M=="string")return O;const W=function(J,ae){return(0,y.isEqualOrParent)(J,M.base,!S.isLinux)?O(J.substr(M.base.length+1),ae):null};return W.allBasenames=O.allBasenames,W.allPaths=O.allPaths,W.basenames=O.basenames,W.patterns=O.patterns,W}function s(O,M){return M.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function u(O,M){return function(W,J){return typeof W=="string"&&W.endsWith(O)?M:null}}function h(O,M){const W=`/${O}`,J=`\\${O}`,ae=function(fe,V){return typeof fe!="string"?null:V?V===O?M:null:fe===O||fe.endsWith(W)||fe.endsWith(J)?M:null},me=[O];return ae.basenames=me,ae.patterns=[M],ae.allBasenames=me,ae}function b(O,M){const W=j(O.slice(1,-1).split(",").map(V=>a(V,M)).filter(V=>V!==i),O),J=W.length;if(!J)return i;if(J===1)return W[0];const ae=function(V,ee){for(let x=0,z=W.length;x<z;x++)if(W[x](V,ee))return O;return null},me=W.find(V=>!!V.allBasenames);me&&(ae.allBasenames=me.allBasenames);const fe=W.reduce((V,ee)=>ee.allPaths?V.concat(ee.allPaths):V,[]);return fe.length&&(ae.allPaths=fe),ae}function A(O,M,W){const J=k.sep===k.posix.sep,ae=J?O:O.replace(C,k.sep),me=k.sep+ae,fe=k.posix.sep+O;let V;return W?V=function(ee,x){return typeof ee=="string"&&(ee===ae||ee.endsWith(me)||!J&&(ee===O||ee.endsWith(fe)))?M:null}:V=function(ee,x){return typeof ee=="string"&&(ee===ae||!J&&ee===O)?M:null},V.allPaths=[(W?"*/":"./")+O],V}function B(O){try{const M=new RegExp(`^${E(O)}$`);return function(W){return M.lastIndex=0,typeof W=="string"&&M.test(W)?O:null}}catch{return i}}function G(O,M,W){return!O||typeof M!="string"?!1:Q(O)(M,void 0,W)}e.match=G;function Q(O,M={}){if(!O)return o;if(typeof O=="string"||_(O)){const W=a(O,M);if(W===i)return o;const J=function(ae,me){return!!W(ae,me)};return W.allBasenames&&(J.allBasenames=W.allBasenames),W.allPaths&&(J.allPaths=W.allPaths),J}return U(O,M)}e.parse=Q;function _(O){const M=O;return M?typeof M.base=="string"&&typeof M.pattern=="string":!1}e.isRelativePattern=_;function X(O){return O.allBasenames||[]}e.getBasenameTerms=X;function F(O){return O.allPaths||[]}e.getPathTerms=F;function U(O,M){const W=j(Object.getOwnPropertyNames(O).map(V=>le(V,O[V],M)).filter(V=>V!==i)),J=W.length;if(!J)return i;if(!W.some(V=>!!V.requiresSiblings)){if(J===1)return W[0];const V=function(z,te){let ce;for(let Z=0,se=W.length;Z<se;Z++){const ge=W[Z](z,te);if(typeof ge=="string")return ge;(0,t.isThenable)(ge)&&(ce||(ce=[]),ce.push(ge))}return ce?(async()=>{for(const Z of ce){const se=await Z;if(typeof se=="string")return se}return null})():null},ee=W.find(z=>!!z.allBasenames);ee&&(V.allBasenames=ee.allBasenames);const x=W.reduce((z,te)=>te.allPaths?z.concat(te.allPaths):z,[]);return x.length&&(V.allPaths=x),V}const ae=function(V,ee,x){let z,te;for(let ce=0,Z=W.length;ce<Z;ce++){const se=W[ce];se.requiresSiblings&&x&&(ee||(ee=(0,k.basename)(V)),z||(z=ee.substr(0,ee.length-(0,k.extname)(V).length)));const ge=se(V,ee,z,x);if(typeof ge=="string")return ge;(0,t.isThenable)(ge)&&(te||(te=[]),te.push(ge))}return te?(async()=>{for(const ce of te){const Z=await ce;if(typeof Z=="string")return Z}return null})():null},me=W.find(V=>!!V.allBasenames);me&&(ae.allBasenames=me.allBasenames);const fe=W.reduce((V,ee)=>ee.allPaths?V.concat(ee.allPaths):V,[]);return fe.length&&(ae.allPaths=fe),ae}function le(O,M,W){if(M===!1)return i;const J=a(O,W);if(J===i)return i;if(typeof M=="boolean")return J;if(M){const ae=M.when;if(typeof ae=="string"){const me=(fe,V,ee,x)=>{if(!x||!J(fe,V))return null;const z=ae.replace("$(basename)",ee),te=x(z);return(0,t.isThenable)(te)?te.then(ce=>ce?O:null):te?O:null};return me.requiresSiblings=!0,me}}return J}function j(O,M){const W=O.filter(V=>!!V.basenames);if(W.length<2)return O;const J=W.reduce((V,ee)=>{const x=ee.basenames;return x?V.concat(x):V},[]);let ae;if(M){ae=[];for(let V=0,ee=J.length;V<ee;V++)ae.push(M)}else ae=W.reduce((V,ee)=>{const x=ee.patterns;return x?V.concat(x):V},[]);const me=function(V,ee){if(typeof V!="string")return null;if(!ee){let z;for(z=V.length;z>0;z--){const te=V.charCodeAt(z-1);if(te===47||te===92)break}ee=V.substr(z)}const x=J.indexOf(ee);return x!==-1?ae[x]:null};me.basenames=J,me.patterns=ae,me.allBasenames=J;const fe=O.filter(V=>!V.basenames);return fe.push(me),fe}function $(O,M){return(0,I.equals)(O,M,(W,J)=>typeof W=="string"&&typeof J=="string"?W===J:typeof W!="string"&&typeof J!="string"?W.base===J.base&&W.pattern===J.pattern:!1)}e.patternsEquals=$}),define(we[85],ye([0,1,9,138,19,15,4]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(E){E[E.Paragraph=0]="Paragraph",E[E.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class v{constructor(f="",p=!1){if(this.value=f,typeof this.value!="string")throw(0,I.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(f,p=0){return this.value+=C(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(g,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,p){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(f,p,g){return this.value+="[",this.value+=this._escape(p,"]"),this.value+="](",this.value+=this._escape(String(f),")"),g&&(this.value+=` "${this._escape(this._escape(g,'"'),")")}"`),this.value+=")",this}_escape(f,p){const g=new RegExp((0,P.escapeRegExpCharacters)(p),"g");return f.replace(g,(d,l)=>f.charAt(l-1)!=="\\"?`\\${d}`:d)}}e.MarkdownString=v;function D(E){return T(E)?!E.value:Array.isArray(E)?E.every(D):!0}e.isEmptyMarkdownString=D;function T(E){return E instanceof v?!0:E&&typeof E=="object"?typeof E.value=="string"&&(typeof E.isTrusted=="boolean"||E.isTrusted===void 0)&&(typeof E.supportThemeIcons=="boolean"||E.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function R(E,f){return E===f?!0:!E||!f?!1:E.value===f.value&&E.isTrusted===f.isTrusted&&E.supportThemeIcons===f.supportThemeIcons&&E.supportHtml===f.supportHtml&&(E.baseUri===f.baseUri||!!E.baseUri&&!!f.baseUri&&(0,y.isEqual)(k.URI.from(E.baseUri),k.URI.from(f.baseUri)))}e.markdownStringEqual=R;function C(E){return E.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function w(E){return E&&E.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function m(E){const f=[],p=E.split("|").map(d=>d.trim());E=p[0];const g=p[1];if(g){const d=/height=(\d+)/.exec(g),l=/width=(\d+)/.exec(g),c=d?d[1]:"",n=l?l[1]:"",o=isFinite(parseInt(n)),i=isFinite(parseInt(c));o&&f.push(`width="${n}"`),i&&f.push(`height="${c}"`)}return{href:E,dimensions:f}}e.parseHrefAndDimensions=m}),define(we[86],ye([0,1,16,33,8,5,3,19,15,4]),function(ie,e,I,t,y,P,k,S,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(s,u){const{os:h,tildify:b,relative:A}=u;if(A){const Q=R(s,A,h);if(typeof Q=="string")return Q}let B=s.fsPath;if(h===1&&!k.isWindows?B=B.replace(/\//g,"\\"):h!==1&&k.isWindows&&(B=B.replace(/\\/g,"/")),h!==1&&b?.userHome){let Q=b.userHome.fsPath,_;s.scheme!==b.userHome.scheme&&s.path.startsWith(P.posix.sep)?_=b.userHome.with({path:s.path}).fsPath:_=s.fsPath,B=E(_,Q,h)}return(h===1?P.win32:P.posix).normalize(w(B,h===1))}e.getPathLabel=T;function R(s,u,h){const b=h===1?P.win32:P.posix,A=h===3?S.extUri:S.extUriIgnorePathCase,B=u.getWorkspace(),G=(0,I.firstOrDefault)(B.folders);if(!G)return;s.scheme!==G.uri.scheme&&s.path.startsWith(P.posix.sep)&&(s=G.uri.with({path:s.path}));const Q=u.getWorkspaceFolder(s);if(!Q)return;let _;if(A.isEqual(Q.uri,s)?_="":_=A.relativePath(Q.uri,s)??"",_&&(_=b.normalize(_)),B.folders.length>1&&!u.noPrefix){const X=Q.name?Q.name:A.basenameOrAuthority(Q.uri);_=_?`${X} \u2022 ${_}`:X}return _}function C(s){if(!s)return;typeof s=="string"&&(s=D.URI.file(s));const u=(0,S.basename)(s)||(s.scheme===y.Schemas.file?s.fsPath:s.path);return k.isWindows&&(0,t.isRootOrDriveLetter)(u)?w(u):u}e.getBaseLabel=C;function w(s,u=k.isWindows){return(0,t.hasDriveLetter)(s,u)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=w;let m=Object.create(null);function E(s,u,h=k.OS){if(h===1||!s||!u)return s;let b=m.original===u?m.normalized:void 0;b||(b=u,k.isWindows&&(b=(0,t.toSlashes)(b)),b=`${(0,v.rtrim)(b,P.posix.sep)}${P.posix.sep}`,m={original:u,normalized:b});let A=s;return k.isWindows&&(A=(0,t.toSlashes)(A)),(h===3?A.startsWith(b):(0,v.startsWithIgnoreCase)(A,b))?`~/${A.substr(b.length)}`:s}e.tildify=E;function f(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=f;const p="\u2026",g="\\\\",d="~";function l(s,u=P.sep){const h=new Array(s.length);let b=!1;for(let A=0;A<s.length;A++){let B=s[A];if(B===""){h[A]=`.${u}`;continue}if(!B){h[A]=B;continue}b=!0;let G="",Q=B;Q.indexOf(g)===0?(G=Q.substr(0,Q.indexOf(g)+g.length),Q=Q.substr(Q.indexOf(g)+g.length)):Q.indexOf(u)===0?(G=Q.substr(0,Q.indexOf(u)+u.length),Q=Q.substr(Q.indexOf(u)+u.length)):Q.indexOf(d)===0&&(G=Q.substr(0,Q.indexOf(d)+d.length),Q=Q.substr(Q.indexOf(d)+d.length));const _=Q.split(u);for(let X=1;b&&X<=_.length;X++)for(let F=_.length-X;b&&F>=0;F--){b=!1;let U=_.slice(F,F+X).join(u);for(let le=0;!b&&le<s.length;le++)if(le!==A&&s[le]&&s[le].indexOf(U)>-1){const j=F+X===_.length,$=F>0&&s[le].indexOf(u)>-1?u+U:U,O=s[le].endsWith($);b=!j||O}if(!b){let le="";(_[0].endsWith(":")||G!=="")&&(F===1&&(F=0,X++,U=_[0]+u+U),F>0&&(le=_[0]+u),le=G+le),F>0&&(le=le+p+u),le=le+U,F+X<_.length&&(le=le+u+p),h[A]=le}}b&&(h[A]=B)}return h}e.shorten=l;var c;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function n(s,u=Object.create(null)){const h=[];let b=!1,A="";for(const B of s)if(B==="$"||b&&B==="{")A&&h.push({value:A,type:c.TEXT}),A="",b=!0;else if(B==="}"&&b){const G=u[A];if(typeof G=="string")G.length&&h.push({value:G,type:c.VARIABLE});else if(G){const Q=h[h.length-1];(!Q||Q.type!==c.SEPARATOR)&&h.push({value:G.label,type:c.SEPARATOR})}A="",b=!1}else A+=B;return A&&!b&&h.push({value:A,type:c.TEXT}),h.filter((B,G)=>{if(B.type===c.SEPARATOR){const Q=h[G-1],_=h[G+1];return[Q,_].every(X=>X&&(X.type===c.VARIABLE||X.type===c.TEXT)&&X.value.length>0)}return!0}).map(B=>B.value).join("")}e.template=n;function o(s,u){return k.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):s.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=o;function i(s,u){return k.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,""):k.isWindows?s.replace(/&&|&/g,h=>h==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function a(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=a;function r(s){const u=s.indexOf("/")!==-1?P.posix:P.win32,h=u.basename(s),b=u.dirname(s);return h.length?{name:h,parentPath:b}:{name:b,parentPath:""}}e.splitName=r}),define(we[67],ye([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(T){return T.toJSON()}class y{constructor(R){this._uriTransformer=R}transformIncoming(R){const C=this._uriTransformer.transformIncoming(R);return C===R?R:t(I.URI.from(C))}transformOutgoing(R){const C=this._uriTransformer.transformOutgoing(R);return C===R?R:t(I.URI.from(C))}transformOutgoingURI(R){const C=this._uriTransformer.transformOutgoing(R);return C===R?R:I.URI.from(C)}transformOutgoingScheme(R){return this._uriTransformer.transformOutgoingScheme(R)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function P(T,R,C){if(!T||C>200)return null;if(typeof T=="object"){if(T instanceof I.URI)return R.transformOutgoing(T);for(let w in T)if(Object.hasOwnProperty.call(T,w)){const m=P(T[w],R,C+1);m!==null&&(T[w]=m)}}return null}function k(T,R){const C=P(T,R,0);return C===null?T:C}e.transformOutgoingURIs=k;function S(T,R,C,w){if(!T||w>200)return null;if(typeof T=="object"){if(T.$mid===1)return C?I.URI.revive(R.transformIncoming(T)):R.transformIncoming(T);for(let m in T)if(Object.hasOwnProperty.call(T,m)){const E=S(T[m],R,C,w+1);E!==null&&(T[m]=E)}}return null}function v(T,R){const C=S(T,R,!1,0);return C===null?T:C}e.transformIncomingURIs=v;function D(T,R){const C=S(T,R,!0,0);return C===null?T:C}e.transformAndReviveIncomingURIs=D}),define(we[23],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(y){return I.test(y)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(S){for(let v=0;v<S.length;v++)S[v]=Math.floor(Math.random()*256);return S};const P=new Uint8Array(16),k=[];for(let S=0;S<256;S++)k.push(S.toString(16).padStart(2,"0"));return function(){y(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let v=0,D="";return D+=k[P[v++]],D+=k[P[v++]],D+=k[P[v++]],D+=k[P[v++]],D+="-",D+=k[P[v++]],D+=k[P[v++]],D+="-",D+=k[P[v++]],D+=k[P[v++]],D+="-",D+=k[P[v++]],D+=k[P[v++]],D+="-",D+=k[P[v++]],D+=k[P[v++]],D+=k[P[v++]],D+=k[P[v++]],D+=k[P[v++]],D+=k[P[v++]],D}}()}),define(we[139],ye([0,1,262]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(P="utf8"){this.stringDecoder=new I.StringDecoder(P),this.remaining=null}write(P){const k=[],S=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(S.length<1)return k;let v=0,D,T=v;for(;T<S.length;)if(D=S.charCodeAt(T),D===13||D===10){if(k.push(S.substring(v,T)),T++,T<S.length){const R=D;D=S.charCodeAt(T),(R===13&&D===10||R===10&&D===13)&&T++}v=T}else T++;return this.remaining=v<S.length?S.substr(v):null,k}end(){return this.remaining}}e.LineDecoder=t}),function(){"use strict";function ie(e,I,t,y){function P(m){return new Promise(E=>t.exists(m,E))}function k(m){return new Promise((E,f)=>{const p=new Date;t.utimes(m,p,p,g=>g?f(g):E())})}function S(m){return new Promise((E,f)=>t.mkdir(m,{recursive:!0},p=>p&&p.code!=="EEXIST"?f(p):E(m)))}function v(m){return new Promise((E,f)=>t.rm(m,{recursive:!0,force:!0,maxRetries:3},p=>p?f(p):E()))}function D(m){return new Promise((E,f)=>t.readFile(m,"utf8",(p,g)=>p?f(p):E(g)))}function T(m,E){return new Promise((f,p)=>t.writeFile(m,E,"utf8",g=>g?p(g):f()))}function R(m){const E=I.join(m,"languagepacks.json");try{return e(E)}catch{}}function C(m,E){try{for(;E;){if(m[E])return E;{const f=E.lastIndexOf("-");if(f>0)E=E.substring(0,f);else return}}}catch(f){console.error("Resolving language pack configuration failed.",f)}}function w(m,E,f,p){if(p==="pseudo")return Promise.resolve({locale:p,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:p,availableLanguages:{}});if(p&&(p==="en"||p==="en-us"))return Promise.resolve({locale:p,availableLanguages:{}});const g=p;y.mark("code/willGenerateNls");const d=function(l){return y.mark("code/didGenerateNls"),Promise.resolve({locale:l,availableLanguages:{}})};try{if(!m)return d(g);const l=R(E);if(!l||(p=C(l,p),!p))return d(g);const c=l[p];let n;return!c||typeof c.hash!="string"||!c.translations||typeof(n=c.translations.vscode)!="string"?d(g):P(n).then(o=>{if(!o)return d(g);const i=c.hash+"."+p,a=I.join(E,"clp",i),r=I.join(a,m),s=I.join(a,"tcf.json"),u=I.join(a,"corrupted.info"),h={locale:g,availableLanguages:{"*":p},_languagePackId:i,_translationsConfigFile:s,_cacheRoot:a,_resolvedLanguagePackCoreLocation:r,_corruptedFile:u};return P(u).then(b=>{let A;return b?A=v(a):A=Promise.resolve(void 0),A.then(()=>P(r).then(B=>B?(k(r).catch(()=>{}),y.mark("code/didGenerateNls"),h):S(r).then(()=>Promise.all([D(f),D(n)])).then(G=>{const Q=JSON.parse(G[0]),_=JSON.parse(G[1]).contents,X=Object.keys(Q.bundles),F=[];for(const U of X){const le=Q.bundles[U],j=Object.create(null);for(const $ of le){const O=Q.keys[$],M=Q.messages[$],W=_[$];let J;if(W){J=[];for(let ae=0;ae<O.length;ae++){const me=O[ae],fe=typeof me=="string"?me:me.key;let V=W[fe];V===void 0&&(V=M[ae]),J.push(V)}}else J=M;j[$]=J}F.push(T(I.join(r,U.replace(/\//g,"!")+".nls.json"),JSON.stringify(j)))}return F.push(T(s,JSON.stringify(c.translations))),Promise.all(F)}).then(()=>(y.mark("code/didGenerateNls"),h)).catch(G=>(console.error("Generating translation files failed.",G),d(p)))))})})}catch(l){return console.error("Generating translation files failed.",l),d(p)}}return{getNLSConfiguration:w}}if(typeof define=="function")define(we[140],ye([0,87,30,46]),function(e,I,t,y){return ie(e.__$__nodeRequire,I,t,y)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("fs"),t=require("../common/performance");module.exports=ie(require,e,I,t)}else throw new Error("Unknown context")}(),define(we[141],ye([0,1,24]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function y(k){const S=k.replace(/\-/g,":").toLowerCase();return!t.has(S)}function P(){const k=(0,I.networkInterfaces)();for(let S in k){const v=k[S];if(v){for(const{mac:D}of v)if(y(D))return D}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=P}),define(we[88],ye([0,1,24,9,29,23,141]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(T){return this._virtualMachineOUIs||(this._virtualMachineOUIs=y.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(T)}value(){if(this._value===void 0){let T=0,R=0;const C=(0,I.networkInterfaces)();for(let w in C){const m=C[w];if(m)for(const{mac:E,internal:f}of m)f||(R+=1,this._isVirtualMachineMacAddress(E.toUpperCase())&&(T+=1))}this._value=R>0?T/R:0}return this._value}};let S;async function v(){return S||(S=(async()=>await D()||P.generateUuid())()),S}e.getMachineId=v;async function D(){try{const T=await new Promise((C,w)=>{ie(["crypto"],C,w)}),R=(0,k.getMac)();return T.createHash("sha256").update(R,"utf8").digest("hex")}catch(T){t.onUnexpectedError(T);return}}}),define(we[22],ye([0,1,30,24,263,14,33,83,5,3,19,4]),function(ie,e,I,t,y,P,k,S,v,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var C;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(C=e.RimRafMode||(e.RimRafMode={}));async function w(F,U=C.UNLINK){if((0,k.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return U===C.UNLINK?E(F):m(F)}async function m(F){try{const U=(0,k.randomPath)((0,t.tmpdir)());try{await I.promises.rename(F,U)}catch{return E(F)}E(U).catch(le=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function E(F){return(0,y.promisify)(I.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function f(F){if((0,k.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function p(F,U){return l(await(U?g(F):(0,y.promisify)(I.readdir)(F)))}async function g(F){try{return await(0,y.promisify)(I.readdir)(F,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const U=[],le=await p(F);for(const j of le){let $=!1,O=!1,M=!1;try{const W=await e.Promises.lstat((0,v.join)(F,j));$=W.isFile(),O=W.isDirectory(),M=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}U.push({name:j,isFile:()=>$,isDirectory:()=>O,isSymbolicLink:()=>M})}return U}function d(F){return l(I.readdirSync(F))}e.readdirSync=d;function l(F){return F.map(U=>typeof U=="string"?D.isMacintosh?(0,S.normalizeNFC)(U):U:(U.name=D.isMacintosh?(0,S.normalizeNFC)(U.name):U.name,U))}async function c(F){const U=await p(F),le=[];for(const j of U)await o.existsDirectory((0,v.join)(F,j))&&le.push(j);return le}function n(F,U=1e3){return new Promise(le=>{let j=!1;const $=setInterval(()=>{j||(j=!0,I.access(F,O=>{j=!1,O&&(clearInterval($),le(void 0))}))},U)})}e.whenDeleted=n;var o;(function(F){async function U($){let O;try{if(O=await e.Promises.lstat($),!O.isSymbolicLink())return{stat:O}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(M){if(M.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(D.isWindows&&M.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw W}throw M}}F.stat=U;async function le($){try{const{stat:O,symbolicLink:M}=await F.stat($);return O.isFile()&&M?.dangling!==!0}catch{}return!1}F.existsFile=le;async function j($){try{const{stat:O,symbolicLink:M}=await F.stat($);return O.isDirectory()&&M?.dangling!==!0}catch{}return!1}F.existsDirectory=j})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new P.ResourceQueue;function a(F,U,le){return i.queueFor(R.URI.file(F),T.extUriBiasedIgnorePathCase).queue(()=>{const j=h(le);return new Promise(($,O)=>s(F,U,j,M=>M?O(M):$()))})}let r=!0;function s(F,U,le,j){if(!r)return I.writeFile(F,U,{mode:le.mode,flag:le.flag},j);I.open(F,le.flag,le.mode,($,O)=>{if($)return j($);I.writeFile(O,U,M=>{if(M)return I.close(O,()=>j(M));I.fdatasync(O,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),r=!1),I.close(O,J=>j(J))))})})}function u(F,U,le){const j=h(le);if(!r)return I.writeFileSync(F,U,{mode:j.mode,flag:j.flag});const $=I.openSync(F,j.flag,j.mode);try{I.writeFileSync($,U);try{I.fdatasyncSync($)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),r=!1}}finally{I.closeSync($)}}e.writeFileSync=u;function h(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function b(F,U){if(F!==U)try{await e.Promises.rename(F,U)}catch(le){if(F.toLowerCase()!==U.toLowerCase()&&le.code==="EXDEV"||F.endsWith("."))await A(F,U,{preserveSymlinks:!1}),await w(F,C.MOVE);else throw le}}async function A(F,U,le){return G(F,U,{root:{source:F,target:U},options:le,handledSourcePaths:new Set})}const B=511;async function G(F,U,le){if(le.handledSourcePaths.has(F))return;le.handledSourcePaths.add(F);const{stat:j,symbolicLink:$}=await o.stat(F);if($){if(le.options.preserveSymlinks)try{return await X(F,U,le)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if($.dangling)return}return j.isDirectory()?Q(F,U,j.mode&B,le):_(F,U,j.mode&B)}async function Q(F,U,le,j){await e.Promises.mkdir(U,{recursive:!0,mode:le});const $=await p(F);for(const O of $)await G((0,v.join)(F,O),(0,v.join)(U,O),j)}async function _(F,U,le){await e.Promises.copyFile(F,U),await e.Promises.chmod(U,le)}async function X(F,U,le){let j=await e.Promises.readlink(F);(0,k.isEqualOrParent)(j,le.root.source,!D.isLinux)&&(j=(0,v.join)(le.root.target,j.substr(le.root.source.length+1))),await e.Promises.symlink(j,U)}e.Promises=new class{get access(){return(0,y.promisify)(I.access)}get stat(){return(0,y.promisify)(I.stat)}get lstat(){return(0,y.promisify)(I.lstat)}get utimes(){return(0,y.promisify)(I.utimes)}get read(){return(F,U,le,j,$)=>new Promise((O,M)=>{I.read(F,U,le,j,$,(W,J,ae)=>W?M(W):O({bytesRead:J,buffer:ae}))})}get readFile(){return(0,y.promisify)(I.readFile)}get write(){return(F,U,le,j,$)=>new Promise((O,M)=>{I.write(F,U,le,j,$,(W,J,ae)=>W?M(W):O({bytesWritten:J,buffer:ae}))})}get appendFile(){return(0,y.promisify)(I.appendFile)}get fdatasync(){return(0,y.promisify)(I.fdatasync)}get truncate(){return(0,y.promisify)(I.truncate)}get rename(){return(0,y.promisify)(I.rename)}get copyFile(){return(0,y.promisify)(I.copyFile)}get open(){return(0,y.promisify)(I.open)}get close(){return(0,y.promisify)(I.close)}get symlink(){return(0,y.promisify)(I.symlink)}get readlink(){return(0,y.promisify)(I.readlink)}get chmod(){return(0,y.promisify)(I.chmod)}get mkdir(){return(0,y.promisify)(I.mkdir)}get unlink(){return(0,y.promisify)(I.unlink)}get rmdir(){return(0,y.promisify)(I.rmdir)}get realpath(){return(0,y.promisify)(I.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return c}get writeFile(){return a}get rm(){return w}get move(){return b}get copy(){return A}}}),define(we[142],ye([0,1,30,5,3,15,22]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function S(C){if(y.isLinux)return C;const w=(0,t.dirname)(C);if(C===w)return C;const m=((0,t.basename)(C)||C).toLowerCase();try{const f=(0,k.readdirSync)(w).filter(p=>p.toLowerCase()===m);if(f.length===1){const p=S(w);if(p)return(0,t.join)(p,f[0])}else if(f.length>1){const p=f.indexOf(m);if(p>=0){const g=S(w);if(g)return(0,t.join)(g,f[p])}}}catch{}return null}e.realcaseSync=S;async function v(C){if(y.isLinux)return C;const w=(0,t.dirname)(C);if(C===w)return C;const m=((0,t.basename)(C)||C).toLowerCase();try{const f=(await k.Promises.readdir(w)).filter(p=>p.toLowerCase()===m);if(f.length===1){const p=await v(w);if(p)return(0,t.join)(p,f[0])}else if(f.length>1){const p=f.indexOf(m);if(p>=0){const g=await v(w);if(g)return(0,t.join)(g,f[p])}}}catch{}return null}e.realcase=v;async function D(C){try{return await k.Promises.realpath(C)}catch{const m=R(C);return await k.Promises.access(m,I.constants.R_OK),m}}e.realpath=D;function T(C){try{return I.realpathSync(C)}catch{const m=R(C);return I.accessSync(m,I.constants.R_OK),m}}e.realpathSync=T;function R(C){return(0,P.rtrim)((0,t.normalize)(C),t.sep)}}),define(we[143],ye([0,1,68]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(S,v,D,T=1){let R=!1;return new Promise(C=>{const w=setTimeout(()=>{if(!R)return R=!0,C(0)},D);y(S,v,T,m=>{if(!R)return R=!0,clearTimeout(w),C(m)})})}e.findFreePort=t;function y(S,v,D,T){if(v===0)return T(0);const R=new I.Socket;R.once("connect",()=>(k(R),y(S+D,v-1,D,T))),R.once("data",()=>{}),R.once("error",C=>(k(R),C.code!=="ECONNREFUSED"?y(S+D,v-1,D,T):T(S))),R.connect(S,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(S,v,D){let T=!1,R,C=1;const w=I.createServer({pauseOnConnect:!0});function m(E,f){T||(T=!0,w.removeAllListeners(),w.close(),R&&clearTimeout(R),f(E))}return new Promise(E=>{R=setTimeout(()=>{m(0,E)},D),w.on("listening",()=>{m(S,E)}),w.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&C<v?(S++,C++,w.listen(S,"127.0.0.1")):m(0,E)}),w.on("close",()=>{m(0,E)}),w.listen(S,"127.0.0.1")})}e.findFreePortFaster=P;function k(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(v){console.error(v)}}}),define(we[89],ye([0,1,24,5,22]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,k=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var v;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(v||(v={}));let D;switch(process.arch){case"ia32":case"x32":D=1;break;case"arm":case"arm64":D=2;break;default:D=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class R{constructor(c,n,o){this.exePath=c,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await y.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function C({useAlternateBitness:l=!1}={}){return l?D===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:l=!1,findPreview:c=!1}={}){const n=C({useAlternateBitness:l});if(!n)return null;const o=t.join(n,"PowerShell");if(!await y.SymlinkSupport.existsDirectory(o))return null;let i=-1,a=null;for(const u of await y.Promises.readdir(o)){let h=-1;if(c){const A=u.indexOf("-");if(A<0)continue;const B=u.substring(0,A);if(!P.test(B)||u.substring(A+1)!=="preview")continue;h=parseInt(B,10)}else{if(!P.test(u))continue;h=parseInt(u,10)}if(h<=i)continue;const b=t.join(o,u,"pwsh.exe");!await y.SymlinkSupport.existsFile(b)||(a=b,i=h)}if(!a)return null;const r=n.includes("x86")?" (x86)":"",s=c?" Preview":"";return new R(a,`PowerShell${s}${r}`,!0)}async function m({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=l?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const i of await y.Promises.readdir(c))if(n.test(i)){const a=t.join(c,i,"pwsh.exe");return new R(a,o)}return null}function E(){const l=t.join(I.homedir(),".dotnet","tools","pwsh.exe");return new R(l,".NET Core PowerShell Global Tool")}function f(){const l=t.join(process.env.windir,D===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(l,"Windows PowerShell",!0)}async function*p(){let l=await w();l&&(yield l),l=await w({useAlternateBitness:!0}),l&&(yield l),l=await m(),l&&(yield l),l=E(),l&&(yield l),l=await w({findPreview:!0}),l&&(yield l),l=await m({findPreview:!0}),l&&(yield l),l=await w({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=f(),l&&(yield l)}async function*g(){for await(const l of p())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=g;async function d(){for await(const l of g())return l;return null}e.getFirstAvailablePowerShellInstallation=d}),define(we[90],ye([0,1,39,8]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function y(k){return new Promise((S,v)=>{let D;const T=new Map;function R(w,m,E,f,p){const g=T.get(m);if(w===k||g){const d={name:C(E),cmd:E,pid:w,ppid:m,load:f,mem:p};T.set(w,d),w===k&&(D=d),g&&(g.children||(g.children=[]),g.children.push(d),g.children.length>1&&(g.children=g.children.sort((l,c)=>l.pid-c.pid)))}}function C(w){const m=/--vscode-window-kind=shared-process/,E=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,g=/--crashes-directory/,d=/\\pipe\\winpty-control/,l=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(g.exec(w))return"electron-crash-reporter";if(d.exec(w))return"winpty-process";if(l.exec(w))return"console-window-host (Windows internal process)";let n=c.exec(w);if(n&&n.length===2)return n[1]==="renderer"?m.exec(w)?"shared-process":E.exec(w)?"issue-reporter":f.exec(w)?"process-explorer":"window":n[1]==="utility"&&p.exec(w)?"utility-network-service":n[1];const o=/[a-zA-Z-]+\.js/g;let i="";do n=o.exec(w),n&&(i+=n+" ");while(n);return i&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron_node ${i}`:w}if(process.platform==="win32"){const w=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,E)=>{ie(["windows-process-tree"],m,E)}).then(m=>{m.getProcessList(k,E=>{if(!E){v(new Error(`Root process ${k} not found`));return}m.getProcessCpuUsage(E,f=>{const p=new Map;f.forEach(g=>{const d=w(g.commandLine||"");p.set(g.pid,{name:C(d),cmd:d,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),D=p.get(k),D?(p.forEach(g=>{const d=p.get(g.ppid);d&&(d.children||(d.children=[]),d.children.push(g))}),p.forEach(g=>{g.children&&(g.children=g.children.sort((d,l)=>d.pid-l.pid))}),S(D)):v(new Error(`Root process ${k} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let w=function(){let m=[D];const E=[];for(;m.length;){const p=m.shift();p&&(E.push(p.pid),p.children&&(m=m.concat(p.children)))}let f=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",ie).fsPath);f+=" "+E.join(" "),(0,I.exec)(f,{},(p,g,d)=>{if(p||d)v(p||new Error(d.toString()));else{const l=g.toString().split(`
`);for(let c=0;c<E.length;c++){const n=T.get(E[c]);n.load=parseFloat(l[c])}if(!D){v(new Error(`Root process ${k} not found`));return}S(D)}})};(0,I.exec)("which ps",{},(m,E,f)=>{if(m||f)if(process.platform!=="linux")v(m||new Error(f.toString()));else{const p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",ie).fsPath);(0,I.exec)(p,{},(g,d,l)=>{g||l?v(g||new Error(l.toString())):(P(d,R),w())})}else{const p=E.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${p} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,l,c)=>{d||c&&!c.includes("screen size is bogus")?v(d||new Error(c.toString())):(P(l,R),process.platform==="linux"?w():D?S(D):v(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=y;function P(k,S){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,D=k.toString().split(`
`);for(const T of D){const R=v.exec(T.trim());R&&R.length===6&&S(parseInt(R[1]),parseInt(R[2]),R[5],parseFloat(R[3]),parseFloat(R[4]))}}});var Re=this&&this.__decorate||function(ie,e,I,t){var y=arguments.length,P=y<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,I):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(ie,e,I,t);else for(var S=ie.length-1;S>=0;S--)(k=ie[S])&&(P=(y<3?k(P):y>3?k(e,I,P):k(e,I))||P);return y>3&&P&&Object.defineProperty(e,I,P),P};define(we[40],ye([0,1,16,14,17,20,81,9,6,2,45,15,12]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(O){O[O.Promise=100]="Promise",O[O.PromiseCancel=101]="PromiseCancel",O[O.EventListen=102]="EventListen",O[O.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function m(O){switch(O){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(O){O[O.Initialize=200]="Initialize",O[O.PromiseSuccess=201]="PromiseSuccess",O[O.PromiseError=202]="PromiseError",O[O.PromiseErrorObj=203]="PromiseErrorObj",O[O.EventFire=204]="EventFire"})(E=e.ResponseType||(e.ResponseType={}));function f(O){switch(O){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(O){O[O.Uninitialized=0]="Uninitialized",O[O.Idle=1]="Idle"})(p||(p={}));class g{constructor(M){this.buffer=M,this.pos=0}read(M){const W=this.buffer.slice(this.pos,this.pos+M);return this.pos+=W.byteLength,W}}class d{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var l;(function(O){O[O.Undefined=0]="Undefined",O[O.String=1]="String",O[O.Buffer=2]="Buffer",O[O.VSBuffer=3]="VSBuffer",O[O.Array=4]="Array",O[O.Object=5]="Object"})(l||(l={}));function c(O){const M=y.VSBuffer.alloc(4);return M.writeUInt32BE(O,0),M}function n(O){return O.read(4).readUInt32BE(0)}function o(O){const M=y.VSBuffer.alloc(1);return M.writeUInt8(O,0),M}const i={Undefined:o(l.Undefined),String:o(l.String),Buffer:o(l.Buffer),VSBuffer:o(l.VSBuffer),Array:o(l.Array),Object:o(l.Object)},a=typeof Buffer!="undefined";function r(O,M){if(typeof M=="undefined")O.write(i.Undefined);else if(typeof M=="string"){const W=y.VSBuffer.fromString(M);O.write(i.String),O.write(c(W.byteLength)),O.write(W)}else if(a&&Buffer.isBuffer(M)){const W=y.VSBuffer.wrap(M);O.write(i.Buffer),O.write(c(W.byteLength)),O.write(W)}else if(M instanceof y.VSBuffer)O.write(i.VSBuffer),O.write(c(M.byteLength)),O.write(M);else if(Array.isArray(M)){O.write(i.Array),O.write(c(M.length));for(const W of M)r(O,W)}else{const W=y.VSBuffer.fromString(JSON.stringify(M));O.write(i.Object),O.write(c(W.byteLength)),O.write(W)}}function s(O){switch(O.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return O.read(n(O)).toString();case l.Buffer:return O.read(n(O)).buffer;case l.VSBuffer:return O.read(n(O));case l.Array:{const W=n(O),J=[];for(let ae=0;ae<W;ae++)J.push(s(O));return J}case l.Object:return JSON.parse(O.read(n(O)).toString())}}class u{constructor(M,W,J=null,ae=1e3){this.protocol=M,this.ctx=W,this.logger=J,this.timeoutDelay=ae,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(me=>this.onRawMessage(me)),this.sendResponse({type:200})}registerChannel(M,W){this.channels.set(M,W),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const W=this.send([M.type]);this.logger?.logOutgoing(W,0,1,f(M.type));return}case 201:case 202:case 204:case 203:{const W=this.send([M.type,M.id],M.data);this.logger?.logOutgoing(W,M.id,1,f(M.type),M.data);return}}}send(M,W=void 0){const J=new d;return r(J,M),r(J,W),this.sendBuffer(J.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onRawMessage(M){const W=new g(M),J=s(W),ae=s(W),me=J[0];switch(me){case 100:return this.logger?.logIncoming(M.byteLength,J[1],1,`${m(me)}: ${J[2]}.${J[3]}`,ae),this.onPromise({type:me,id:J[1],channelName:J[2],name:J[3],arg:ae});case 102:return this.logger?.logIncoming(M.byteLength,J[1],1,`${m(me)}: ${J[2]}.${J[3]}`,ae),this.onEventListen({type:me,id:J[1],channelName:J[2],name:J[3],arg:ae});case 101:return this.logger?.logIncoming(M.byteLength,J[1],1,`${m(me)}`),this.disposeActiveRequest({type:me,id:J[1]});case 103:return this.logger?.logIncoming(M.byteLength,J[1],1,`${m(me)}`),this.disposeActiveRequest({type:me,id:J[1]})}}onPromise(M){const W=this.channels.get(M.channelName);if(!W){this.collectPendingRequest(M);return}const J=new P.CancellationTokenSource;let ae;try{ae=W.call(this.ctx,M.name,M.arg,J.token)}catch(V){ae=Promise.reject(V)}const me=M.id;ae.then(V=>{this.sendResponse({id:me,data:V,type:201}),this.activeRequests.delete(M.id)},V=>{V instanceof Error?this.sendResponse({id:me,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.sendResponse({id:me,data:V,type:203}),this.activeRequests.delete(M.id)});const fe=(0,D.toDisposable)(()=>J.cancel());this.activeRequests.set(M.id,fe)}onEventListen(M){const W=this.channels.get(M.channelName);if(!W){this.collectPendingRequest(M);return}const J=M.id,me=W.listen(this.ctx,M.name,M.arg)(fe=>this.sendResponse({id:J,data:fe,type:204}));this.activeRequests.set(M.id,me)}disposeActiveRequest(M){const W=this.activeRequests.get(M.id);W&&(W.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let W=this.pendingRequests.get(M.channelName);W||(W=[],this.pendingRequests.set(M.channelName,W));const J=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:M,timeoutTimer:J})}flushPendingRequests(M){const W=this.pendingRequests.get(M);if(W){for(const J of W)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.onPromise(J.request);break;case 102:this.onEventListen(J.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=u;var h;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(M,W=null){this.protocol=M,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(J=>this.onBuffer(J)),this.logger=W}getChannel(M){const W=this;return{call(J,ae,me){return W.isDisposed?Promise.reject(S.canceled()):W.requestPromise(M,J,ae,me)},listen(J,ae){return W.isDisposed?v.Event.None:W.requestEvent(M,J,ae)}}}requestPromise(M,W,J,ae=P.CancellationToken.None){const me=this.lastRequestId++,V={id:me,type:100,channelName:M,name:W,arg:J};if(ae.isCancellationRequested)return Promise.reject(S.canceled());let ee;return new Promise((z,te)=>{if(ae.isCancellationRequested)return te(S.canceled());const ce=()=>{const Y=re=>{switch(re.type){case 201:this.handlers.delete(me),z(re.data);break;case 202:{this.handlers.delete(me);const H=new Error(re.data.message);H.stack=re.data.stack,H.name=re.data.name,te(H);break}case 203:this.handlers.delete(me),te(re.data);break}};this.handlers.set(me,Y),this.sendRequest(V)};let Z=null;this.state===p.Idle?ce():(Z=(0,t.createCancelablePromise)(Y=>this.whenInitialized()),Z.then(()=>{Z=null,ce()}));const se=()=>{Z?(Z.cancel(),Z=null):this.sendRequest({id:me,type:101}),te(S.canceled())},ge=ae.onCancellationRequested(se);ee=(0,D.combinedDisposable)((0,D.toDisposable)(se),ge),this.activeRequests.add(ee)}).finally(()=>{this.activeRequests.delete(ee)})}requestEvent(M,W,J){const ae=this.lastRequestId++,fe={id:ae,type:102,channelName:M,name:W,arg:J};let V=null;const ee=new v.Emitter({onFirstListenerAdd:()=>{V=(0,t.createCancelablePromise)(z=>this.whenInitialized()),V.then(()=>{V=null,this.activeRequests.add(ee),this.sendRequest(fe)})},onLastListenerRemove:()=>{V?(V.cancel(),V=null):(this.activeRequests.delete(ee),this.sendRequest({id:ae,type:103}))}}),x=z=>ee.fire(z.data);return this.handlers.set(ae,x),ee.event}sendRequest(M){switch(M.type){case 100:case 102:{const W=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(W,M.id,0,`${m(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const W=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(W,M.id,0,m(M.type));return}}}send(M,W=void 0){const J=new d;return r(J,M),r(J,W),this.sendBuffer(J.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch{return 0}}onBuffer(M){const W=new g(M),J=s(W),ae=s(W),me=J[0];switch(me){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,f(me)),this.onResponse({type:J[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,J[1],0,f(me),ae),this.onResponse({type:J[0],id:J[1],data:ae})}}onResponse(M){if(M.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(M.id);W&&W(M)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Re([k.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class A{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:W,onDidClientDisconnect:J})=>{v.Event.once(W.onMessage)(me=>{const fe=new g(me),V=s(fe),ee=new u(W,V),x=new b(W);this.channels.forEach((te,ce)=>ee.registerChannel(ce,te));const z={channelServer:ee,channelClient:x,ctx:V};this._connections.add(z),this._onDidAddConnection.fire(z),J(()=>{ee.dispose(),x.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}get connections(){const M=[];return this._connections.forEach(W=>M.push(W)),M}getChannel(M,W){const J=this;return{call(ae,me,fe){let V;if((0,C.isFunction)(W)){let x=(0,I.getRandomElement)(J.connections.filter(W));V=x?Promise.resolve(x):v.Event.toPromise(v.Event.filter(J.onDidAddConnection,W))}else V=W.routeCall(J,ae,me);const ee=V.then(x=>x.channelClient.getChannel(M));return G(ee).call(ae,me,fe)},listen(ae,me){if((0,C.isFunction)(W))return J.getMulticastEvent(M,W,ae,me);const fe=W.routeEvent(J,ae,me).then(V=>V.channelClient.getChannel(M));return G(fe).listen(ae,me)}}}getMulticastEvent(M,W,J,ae){const me=this;let fe=new D.DisposableStore;const V=new v.Emitter({onFirstListenerAdd:()=>{fe=new D.DisposableStore;const ee=new v.EventMultiplexer,x=new Map,z=ce=>{const se=ce.channelClient.getChannel(M).listen(J,ae),ge=ee.add(se);x.set(ce,ge)},te=ce=>{const Z=x.get(ce);!Z||(Z.dispose(),x.delete(ce))};me.connections.filter(W).forEach(z),v.Event.filter(me.onDidAddConnection,W)(z,void 0,fe),me.onDidRemoveConnection(te,void 0,fe),ee.event(V.fire,V,fe),fe.add(ee)},onLastListenerRemove:()=>{fe.dispose()}});return V.event}registerChannel(M,W){this.channels.set(M,W),this._connections.forEach(J=>{J.channelServer.registerChannel(M,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class B{constructor(M,W,J=null){const ae=new d;r(ae,W),M.send(ae.buffer),this.channelClient=new b(M,J),this.channelServer=new u(M,W,J)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,W){this.channelServer.registerChannel(M,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=B;function G(O){return{call(M,W,J){return O.then(ae=>ae.call(M,W,J))},listen(M,W){const J=new v.Relay;return O.then(ae=>J.input=ae.listen(M,W)),J.event}}}e.getDelayedChannel=G;function Q(O){let M=!1;return{call(W,J,ae){return M?O.call(W,J,ae):(0,t.timeout)(0).then(()=>M=!0).then(()=>O.call(W,J,ae))},listen(W,J){if(M)return O.listen(W,J);const ae=new v.Relay;return(0,t.timeout)(0).then(()=>M=!0).then(()=>ae.input=O.listen(W,J)),ae.event}}}e.getNextTickChannel=Q;class _{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const W of M.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await v.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=_;var X;(function(O){function M(me,fe){const V=me,ee=fe&&fe.disableMarshalling,x=new Map;for(const z in V)J(z)&&x.set(z,v.Event.buffer(V[z],!0));return new class{listen(z,te,ce){const Z=x.get(te);if(Z)return Z;if(ae(te)){const se=V[te];if(typeof se=="function")return se.call(V,ce)}throw new Error(`Event not found: ${te}`)}call(z,te,ce){const Z=V[te];if(typeof Z=="function"){if(!ee&&Array.isArray(ce))for(let se=0;se<ce.length;se++)ce[se]=(0,T.revive)(ce[se]);return Z.apply(V,ce)}throw new Error(`Method not found: ${te}`)}}}O.fromService=M;function W(me,fe){const V=fe&&fe.disableMarshalling;return new Proxy({},{get(ee,x){if(typeof x=="string")return fe?.properties?.has(x)?fe.properties.get(x):ae(x)?function(z){return me.listen(x,z)}:J(x)?me.listen(x):async function(...z){let te;fe&&!(0,C.isUndefinedOrNull)(fe.context)?te=[fe.context,...z]:te=z;const ce=await me.call(x,te);return V?ce:(0,T.revive)(ce)};throw new Error(`Property not found: ${String(x)}`)}})}O.toService=W;function J(me){return me[0]==="o"&&me[1]==="n"&&R.isUpperAsciiLetter(me.charCodeAt(2))}function ae(me){return/^onDynamic/.test(me)&&R.isUpperAsciiLetter(me.charCodeAt(9))}})(X=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(O){if(Array.isArray(O))return O;if(O&&typeof O=="object"&&typeof O.toString=="function"){let M=O.toString();if(M!=="[object Object]")return M}return O}function le(O){return Array.isArray(O)?O.map(U):U(O)}function j(O,M,W,J,ae,me,fe){fe=le(fe);const V=F[ae],ee=V[J%V.length];let x=[`%c[${O}]%c[${String(M).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${me}`,"color: darkgreen","color: grey","color: grey",`color: ${ee}`];/\($/.test(me)?(x=x.concat(fe),x.push(")")):x.push(fe),console.log.apply(console,x)}e.logWithColors=j;class ${constructor(M,W){this._outgoingPrefix=M,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,W,J,ae,me){this._totalOutgoing+=M,j(this._outgoingPrefix,this._totalOutgoing,M,W,J,ae,me)}logIncoming(M,W,J,ae,me){this._totalIncoming+=M,j(this._incomingPrefix,this._totalIncoming,M,W,J,ae,me)}}e.IPCLogger=$}),define(we[91],ye([0,1,17,6,2,40]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(a){a.enableDiagnostics=!1,a.records=[];const r=new WeakMap;let s=0;function u(b,A){if(!r.has(b)){const B=String(++s);r.set(b,B)}return r.get(b)}function h(b,A,B,G){if(!a.enableDiagnostics)return;const Q=u(b,A);if(G instanceof I.VSBuffer||G instanceof Uint8Array||G instanceof ArrayBuffer||ArrayBuffer.isView(G)){const _=I.VSBuffer.alloc(G.byteLength);_.set(G),a.records.push({timestamp:Date.now(),id:Q,label:A,type:B,buff:_})}else a.records.push({timestamp:Date.now(),id:Q,label:A,type:B,data:G})}a.traceSocketEvent=h})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var v;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v=e.SocketCloseEventType||(e.SocketCloseEventType={}));let D=null;function T(){return D||(D=I.VSBuffer.alloc(0)),D}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,s){if(r===0)return T();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const A=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=r),A}if(this._chunks[0].byteLength>r){const A=this._chunks[0].slice(0,r);return s&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),A}let u=I.VSBuffer.alloc(r),h=0,b=0;for(;r>0;){const A=this._chunks[b];if(A.byteLength>r){const B=A.slice(0,r);u.set(B,h),h+=r,s&&(this._chunks[b]=A.slice(r),this._totalLength-=r),r-=r}else u.set(A,h),h+=A.byteLength,s?(this._chunks.shift(),this._totalLength-=A.byteLength):b++,r-=A.byteLength}return u}}e.ChunkStream=R;var C;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume"})(C||(C={}));function w(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var m;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class E{constructor(r,s,u,h){this.type=r,this.id=s,this.ack=u,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends y.Disposable{constructor(r){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:w(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,h=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new E(u,h,b,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=I.VSBuffer.alloc(13);s.writeUInt8(r.type,0),s.writeUInt32BE(r.id,1),s.writeUInt32BE(r.ack,5),s.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:w(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(s,r.data)}_bufferAdd(r,s){const u=this._totalLength===0;return this._data.push(r,s),this._totalLength+=r.byteLength+s.byteLength,u}_bufferTake(){const r=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,s){this._bufferAdd(r,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class g extends y.Disposable{constructor(r){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new E(1,0,0,r))}}e.Protocol=g;class d extends P.IPCClient{constructor(r,s,u=null){super(r,s,u);this.protocol=r}static fromSocket(r,s){return new d(new g(r),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=d;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class c{constructor(r){this.data=r,this.next=null}}class n{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],s=0,u=this._first;for(;u;)r[s++]=u.data,u=u.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const s=new c(r);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class o{constructor(){this.lastRuns=[];const r=Date.now();for(let s=0;s<o._HISTORY_LENGTH;s++)this.lastRuns[s]=r-1e3*s;setInterval(()=>{for(let s=o._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}load(){const r=Date.now(),s=(1+o._HISTORY_LENGTH)*1e3;let u=0;for(let h=0;h<o._HISTORY_LENGTH;h++)r-this.lastRuns[h]<=s&&u++;return 1-u/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class i{constructor(r,s=null,u=o.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,y.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new E(5,0,0,T());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new E(7,0,0,T());this._socketWriter.write(r)}sendResume(){const r=new E(8,0,0,T());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,s){this._isReconnecting=!0,this._socketDisposables=(0,y.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new E(3,0,this._incomingAckId,T());this._socketWriter.write(r);const s=this._outgoingUnackMsg.toArray();for(let u=0,h=s.length;u<h;u++)this._socketWriter.write(s[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new E(6,0,0,T())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let u=0,h=s.length;u<h;u++)this._socketWriter.write(s[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new E(1,s,this._incomingAckId,r);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(r){const s=new E(2,0,0,r);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),s=Date.now()-r.writtenTime,u=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&u>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const b=Math.max(2e4-s,2e4-u,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},b)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new E(3,0,this._incomingAckId,T());this._socketWriter.write(r)}}e.PersistentProtocol=i}),define(we[144],ye([0,1,14,6,2,12]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function S(R){const C=R;return C?.changed instanceof Map||C?.deleted instanceof Set}e.isStorageItemsChangeEvent=S;var v;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(v=e.StorageState||(e.StorageState={}));class D extends y.Disposable{constructor(C,w=Object.create(null)){super();this.database=C,this.options=w,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=v.None,this.cache=new Map,this.flushDelayer=new I.ThrottledDelayer(D.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(C=>this.onDidChangeItemsExternal(C)))}onDidChangeItemsExternal(C){C.changed?.forEach((w,m)=>this.accept(m,w)),C.deleted?.forEach(w=>this.accept(w,void 0))}accept(C,w){if(this.state===v.Closed)return;let m=!1;(0,P.isUndefinedOrNull)(w)?m=this.cache.delete(C):this.cache.get(C)!==w&&(this.cache.set(C,w),m=!0),m&&this._onDidChangeStorage.fire(C)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===v.None&&(this.state=v.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(C,w){const m=this.cache.get(C);return(0,P.isUndefinedOrNull)(m)?w:m}getBoolean(C,w){const m=this.get(C);return(0,P.isUndefinedOrNull)(m)?w:m==="true"}getNumber(C,w){const m=this.get(C);return(0,P.isUndefinedOrNull)(m)?w:parseInt(m,10)}async set(C,w){if(this.state===v.Closed)return;if((0,P.isUndefinedOrNull)(w))return this.delete(C);const m=String(w);if(this.cache.get(C)!==m)return this.cache.set(C,m),this.pendingInserts.set(C,m),this.pendingDeletes.delete(C),this._onDidChangeStorage.fire(C),this.doFlush()}async delete(C){if(!(this.state===v.Closed||!this.cache.delete(C)))return this.pendingDeletes.has(C)||this.pendingDeletes.add(C),this.pendingInserts.delete(C),this._onDidChangeStorage.fire(C),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=v.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const C={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(C).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(C){if(!!this.hasPending)return this.doFlush(C)}async doFlush(C){return this.flushDelayer.trigger(()=>this.flushPending(),C)}async whenFlushed(){if(!!this.hasPending)return new Promise(C=>this.whenFlushedCallbacks.push(C))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=D,D.DEFAULT_FLUSH_DELAY=100;class T{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(C){C.insert&&C.insert.forEach((w,m)=>this.items.set(m,w)),C.delete&&C.delete.forEach(w=>this.items.delete(w))}async close(){}}e.InMemoryStorageDatabase=T}),define(we[92],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class I{constructor(y,P){this.lineNumber=y,this.column=P}with(y=this.lineNumber,P=this.column){return y===this.lineNumber&&P===this.column?this:new I(y,P)}delta(y=0,P=0){return this.with(this.lineNumber+y,this.column+P)}equals(y){return I.equals(this,y)}static equals(y,P){return!y&&!P?!0:!!y&&!!P&&y.lineNumber===P.lineNumber&&y.column===P.column}isBefore(y){return I.isBefore(this,y)}static isBefore(y,P){return y.lineNumber<P.lineNumber?!0:P.lineNumber<y.lineNumber?!1:y.column<P.column}isBeforeOrEqual(y){return I.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,P){return y.lineNumber<P.lineNumber?!0:P.lineNumber<y.lineNumber?!1:y.column<=P.column}static compare(y,P){const k=y.lineNumber|0,S=P.lineNumber|0;if(k===S){const v=y.column|0,D=P.column|0;return v-D}return k-S}clone(){return new I(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new I(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}}e.Position=I}),define(we[47],ye([0,1,92]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,k,S,v){P>S||P===S&&k>v?(this.startLineNumber=S,this.startColumn=v,this.endLineNumber=P,this.endColumn=k):(this.startLineNumber=P,this.startColumn=k,this.endLineNumber=S,this.endColumn=v)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,k){return!(k.lineNumber<P.startLineNumber||k.lineNumber>P.endLineNumber||k.lineNumber===P.startLineNumber&&k.column<P.startColumn||k.lineNumber===P.endLineNumber&&k.column>P.endColumn)}static strictContainsPosition(P,k){return!(k.lineNumber<P.startLineNumber||k.lineNumber>P.endLineNumber||k.lineNumber===P.startLineNumber&&k.column<=P.startColumn||k.lineNumber===P.endLineNumber&&k.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,k){return!(k.startLineNumber<P.startLineNumber||k.endLineNumber<P.startLineNumber||k.startLineNumber>P.endLineNumber||k.endLineNumber>P.endLineNumber||k.startLineNumber===P.startLineNumber&&k.startColumn<P.startColumn||k.endLineNumber===P.endLineNumber&&k.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,k){return!(k.startLineNumber<P.startLineNumber||k.endLineNumber<P.startLineNumber||k.startLineNumber>P.endLineNumber||k.endLineNumber>P.endLineNumber||k.startLineNumber===P.startLineNumber&&k.startColumn<=P.startColumn||k.endLineNumber===P.endLineNumber&&k.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,k){let S,v,D,T;return k.startLineNumber<P.startLineNumber?(S=k.startLineNumber,v=k.startColumn):k.startLineNumber===P.startLineNumber?(S=k.startLineNumber,v=Math.min(k.startColumn,P.startColumn)):(S=P.startLineNumber,v=P.startColumn),k.endLineNumber>P.endLineNumber?(D=k.endLineNumber,T=k.endColumn):k.endLineNumber===P.endLineNumber?(D=k.endLineNumber,T=Math.max(k.endColumn,P.endColumn)):(D=P.endLineNumber,T=P.endColumn),new t(S,v,D,T)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,k){let S=P.startLineNumber,v=P.startColumn,D=P.endLineNumber,T=P.endColumn,R=k.startLineNumber,C=k.startColumn,w=k.endLineNumber,m=k.endColumn;return S<R?(S=R,v=C):S===R&&(v=Math.max(v,C)),D>w?(D=w,T=m):D===w&&(T=Math.min(T,m)),S>D||S===D&&v>T?null:new t(S,v,D,T)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,k){return!!P&&!!k&&P.startLineNumber===k.startLineNumber&&P.startColumn===k.startColumn&&P.endLineNumber===k.endLineNumber&&P.endColumn===k.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new I.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new I.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,k){return new t(this.startLineNumber,this.startColumn,P,k)}setStartPosition(P,k){return new t(P,k,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,k=P){return new t(P.lineNumber,P.column,k.lineNumber,k.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,k){return!(P.endLineNumber<k.startLineNumber||P.endLineNumber===k.startLineNumber&&P.endColumn<k.startColumn||k.endLineNumber<P.startLineNumber||k.endLineNumber===P.startLineNumber&&k.endColumn<P.startColumn)}static areIntersecting(P,k){return!(P.endLineNumber<k.startLineNumber||P.endLineNumber===k.startLineNumber&&P.endColumn<=k.startColumn||k.endLineNumber<P.startLineNumber||k.endLineNumber===P.startLineNumber&&k.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,k){if(P&&k){const D=P.startLineNumber|0,T=k.startLineNumber|0;if(D===T){const R=P.startColumn|0,C=k.startColumn|0;if(R===C){const w=P.endLineNumber|0,m=k.endLineNumber|0;if(w===m){const E=P.endColumn|0,f=k.endColumn|0;return E-f}return w-m}return R-C}return D-T}return(P?1:0)-(k?1:0)}static compareRangesUsingEnds(P,k){return P.endLineNumber===k.endLineNumber?P.endColumn===k.endColumn?P.startLineNumber===k.startLineNumber?P.startColumn-k.startColumn:P.startLineNumber-k.startLineNumber:P.endColumn-k.endColumn:P.endLineNumber-k.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(we[145],ye([0,1,6,2]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class y{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,v){return this._map.set(S,v),this.fire([S]),(0,t.toDisposable)(()=>{this._map.get(S)===v&&(this._map.delete(S),this.fire([S]))})}registerFactory(S,v){this._factories.get(S)?.dispose();const D=new P(this,S,v);return this._factories.set(S,D),(0,t.toDisposable)(()=>{const T=this._factories.get(S);!T||T!==D||(this._factories.delete(S),T.dispose())})}async getOrCreate(S){const v=this.get(S);if(v)return v;const D=this._factories.get(S);return!D||D.isResolved?null:(await D.resolve(),this.get(S))}get(S){return this._map.get(S)||null}isResolved(S){if(this.get(S))return!0;const D=this._factories.get(S);return!!(!D||D.isResolved)}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=y;class P extends t.Disposable{constructor(S,v,D){super();this._registry=S,this._languageId=v,this._factory=D,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const S=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,S&&!this._isDisposed&&this._register(this._registry.register(this._languageId,S))}}}),define(we[146],ye([0,1,38,4,47,145]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class k{constructor(b,A,B){this._tokenBrand=void 0,this.offset=b,this.type=A,this.language=B}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=k;class S{constructor(b,A){this._tokenizationResultBrand=void 0,this.tokens=b,this.endState=A}}e.TokenizationResult=S;class v{constructor(b,A){this._encodedTokenizationResultBrand=void 0,this.tokens=b,this.endState=A}}e.EncodedTokenizationResult=v;var D;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(D=e.CompletionItemKind||(e.CompletionItemKind={}));var T;(function(h){const b=new Map;b.set(0,I.Codicon.symbolMethod),b.set(1,I.Codicon.symbolFunction),b.set(2,I.Codicon.symbolConstructor),b.set(3,I.Codicon.symbolField),b.set(4,I.Codicon.symbolVariable),b.set(5,I.Codicon.symbolClass),b.set(6,I.Codicon.symbolStruct),b.set(7,I.Codicon.symbolInterface),b.set(8,I.Codicon.symbolModule),b.set(9,I.Codicon.symbolProperty),b.set(10,I.Codicon.symbolEvent),b.set(11,I.Codicon.symbolOperator),b.set(12,I.Codicon.symbolUnit),b.set(13,I.Codicon.symbolValue),b.set(15,I.Codicon.symbolEnum),b.set(14,I.Codicon.symbolConstant),b.set(15,I.Codicon.symbolEnum),b.set(16,I.Codicon.symbolEnumMember),b.set(17,I.Codicon.symbolKeyword),b.set(27,I.Codicon.symbolSnippet),b.set(18,I.Codicon.symbolText),b.set(19,I.Codicon.symbolColor),b.set(20,I.Codicon.symbolFile),b.set(21,I.Codicon.symbolReference),b.set(22,I.Codicon.symbolCustomColor),b.set(23,I.Codicon.symbolFolder),b.set(24,I.Codicon.symbolTypeParameter),b.set(25,I.Codicon.account),b.set(26,I.Codicon.issues);function A(Q){let _=b.get(Q);return _||(console.info("No codicon found for CompletionItemKind "+Q),_=I.Codicon.symbolProperty),_}h.toIcon=A;const B=new Map;B.set("method",0),B.set("function",1),B.set("constructor",2),B.set("field",3),B.set("variable",4),B.set("class",5),B.set("struct",6),B.set("interface",7),B.set("module",8),B.set("property",9),B.set("event",10),B.set("operator",11),B.set("unit",12),B.set("value",13),B.set("constant",14),B.set("enum",15),B.set("enum-member",16),B.set("enumMember",16),B.set("keyword",17),B.set("snippet",27),B.set("text",18),B.set("color",19),B.set("file",20),B.set("reference",21),B.set("customcolor",22),B.set("folder",23),B.set("type-parameter",24),B.set("typeParameter",24),B.set("account",25),B.set("issue",26);function G(Q,_){let X=B.get(Q);return typeof X=="undefined"&&!_&&(X=9),X}h.fromString=G})(T=e.CompletionItemKinds||(e.CompletionItemKinds={}));var R;(function(h){h[h.Deprecated=1]="Deprecated"})(R=e.CompletionItemTag||(e.CompletionItemTag={}));var C;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(C=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var m;(function(h){h[h.Automatic=0]="Automatic",h[h.Explicit=1]="Explicit"})(m=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var E;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(h){return h&&t.URI.isUri(h.uri)&&y.Range.isIRange(h.range)&&(y.Range.isIRange(h.originSelectionRange)||y.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=g;var d;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(d=e.SymbolKind||(e.SymbolKind={}));var l;(function(h){h[h.Deprecated=1]="Deprecated"})(l=e.SymbolTag||(e.SymbolTag={}));var c;(function(h){const b=new Map;b.set(0,I.Codicon.symbolFile),b.set(1,I.Codicon.symbolModule),b.set(2,I.Codicon.symbolNamespace),b.set(3,I.Codicon.symbolPackage),b.set(4,I.Codicon.symbolClass),b.set(5,I.Codicon.symbolMethod),b.set(6,I.Codicon.symbolProperty),b.set(7,I.Codicon.symbolField),b.set(8,I.Codicon.symbolConstructor),b.set(9,I.Codicon.symbolEnum),b.set(10,I.Codicon.symbolInterface),b.set(11,I.Codicon.symbolFunction),b.set(12,I.Codicon.symbolVariable),b.set(13,I.Codicon.symbolConstant),b.set(14,I.Codicon.symbolString),b.set(15,I.Codicon.symbolNumber),b.set(16,I.Codicon.symbolBoolean),b.set(17,I.Codicon.symbolArray),b.set(18,I.Codicon.symbolObject),b.set(19,I.Codicon.symbolKey),b.set(20,I.Codicon.symbolNull),b.set(21,I.Codicon.symbolEnumMember),b.set(22,I.Codicon.symbolStruct),b.set(23,I.Codicon.symbolEvent),b.set(24,I.Codicon.symbolOperator),b.set(25,I.Codicon.symbolTypeParameter);function A(B){let G=b.get(B);return G||(console.info("No codicon found for SymbolKind "+B),G=I.Codicon.symbolProperty),G}h.toIcon=A})(c=e.SymbolKinds||(e.SymbolKinds={}));class n{constructor(b){this.value=b}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var o;(function(h){function b(A){return!A||typeof A!="object"?!1:typeof A.id=="string"&&typeof A.title=="string"}h.is=b})(o=e.Command||(e.Command={}));var i;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(i=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(h){h[h.Unresolved=0]="Unresolved",h[h.Resolved=1]="Resolved"})(a=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var s;(function(h){h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(s=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var u;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(u=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[147],ye([10,11]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(we[148],ye([0,1,147]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,y=t*60,P=y*24,k=P*7,S=P*30,v=P*365;function D(R,C,w){typeof R!="number"&&(R=R.getTime());const m=Math.round((new Date().getTime()-R)/1e3);if(m<-30)return(0,I.localize)(0,null,D(new Date().getTime()+m*1e3,!1));if(m<30)return(0,I.localize)(1,null);let E;return m<t?(E=m,C?E===1?w?(0,I.localize)(2,null,E):(0,I.localize)(3,null,E):w?(0,I.localize)(4,null,E):(0,I.localize)(5,null,E):E===1?w?(0,I.localize)(6,null,E):(0,I.localize)(7,null,E):w?(0,I.localize)(8,null,E):(0,I.localize)(9,null,E)):m<y?(E=Math.floor(m/t),C?E===1?w?(0,I.localize)(10,null,E):(0,I.localize)(11,null,E):w?(0,I.localize)(12,null,E):(0,I.localize)(13,null,E):E===1?w?(0,I.localize)(14,null,E):(0,I.localize)(15,null,E):w?(0,I.localize)(16,null,E):(0,I.localize)(17,null,E)):m<P?(E=Math.floor(m/y),C?E===1?w?(0,I.localize)(18,null,E):(0,I.localize)(19,null,E):w?(0,I.localize)(20,null,E):(0,I.localize)(21,null,E):E===1?w?(0,I.localize)(22,null,E):(0,I.localize)(23,null,E):w?(0,I.localize)(24,null,E):(0,I.localize)(25,null,E)):m<k?(E=Math.floor(m/P),C?E===1?(0,I.localize)(26,null,E):(0,I.localize)(27,null,E):E===1?(0,I.localize)(28,null,E):(0,I.localize)(29,null,E)):m<S?(E=Math.floor(m/k),C?E===1?w?(0,I.localize)(30,null,E):(0,I.localize)(31,null,E):w?(0,I.localize)(32,null,E):(0,I.localize)(33,null,E):E===1?w?(0,I.localize)(34,null,E):(0,I.localize)(35,null,E):w?(0,I.localize)(36,null,E):(0,I.localize)(37,null,E)):m<v?(E=Math.floor(m/S),C?E===1?w?(0,I.localize)(38,null,E):(0,I.localize)(39,null,E):w?(0,I.localize)(40,null,E):(0,I.localize)(41,null,E):E===1?w?(0,I.localize)(42,null,E):(0,I.localize)(43,null,E):w?(0,I.localize)(44,null,E):(0,I.localize)(45,null,E)):(E=Math.floor(m/v),C?E===1?w?(0,I.localize)(46,null,E):(0,I.localize)(47,null,E):w?(0,I.localize)(48,null,E):(0,I.localize)(49,null,E):E===1?w?(0,I.localize)(50,null,E):(0,I.localize)(51,null,E):w?(0,I.localize)(52,null,E):(0,I.localize)(53,null,E))}e.fromNow=D;function T(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(we[149],ye([10,11]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(we[36],ye([0,1,16,12,149]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(R,C){return C&&(R.stack||R.stacktrace)?y.localize(0,null,S(R),k(R.stack)||k(R.stacktrace)):S(R)}function k(R){return Array.isArray(R)?R.join(`
`):R}function S(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?y.localize(1,null,R.message):R.message||y.localize(2,null)}function v(R=null,C=!1){if(!R)return y.localize(3,null);if(Array.isArray(R)){const w=I.coalesce(R),m=v(w[0],C);return w.length>1?y.localize(4,null,m,w.length):m}if(t.isString(R))return R;if(R.detail){const w=R.detail;if(w.error)return P(w.error,C);if(w.exception)return P(w.exception,C)}return R.stack?P(R,C):R.message?R.message:y.localize(5,null)}e.toErrorMessage=v;function D(R){const C=R;return C instanceof Error&&Array.isArray(C.actions)}e.isErrorWithActions=D;function T(R,C){let w;return typeof R=="string"?w=new Error(R):w=R,w.actions=C,w}e.createErrorWithActions=T}),define(we[150],ye([10,11]),function(ie,e){return ie.create("vs/base/common/jsonErrorMessages",e)}),define(we[151],ye([0,1,150]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(y){switch(y){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(we[152],ye([10,11]),function(ie,e){return ie.create("vs/base/node/processes",e)}),define(we[93],ye([0,1,39,33,8,21,5,3,27,53,12,139,22,152]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function m(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function E(c,n){if(S.isWindows)try{const o={stdio:["pipe","pipe","ignore"]};n&&(o.cwd=n);const i=I.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],o);return new Promise(a=>{i.once("error",r=>{a({success:!1,error:r})}),i.once("exit",(r,s)=>{a(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(o){return Promise.resolve({success:!1,error:o,code:o.status?m(o.status):1})}else if(S.isLinux||S.isMacintosh)try{const o=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",ie).fsPath;return new Promise(i=>{I.execFile(o,[c.pid.toString()],{encoding:"utf8",shell:!0},(a,r,s)=>{i(a?{success:!1,error:a}:{success:!0})})})}catch(o){return Promise.resolve({success:!1,error:o})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function f(c=v.env){return c.comspec||"cmd.exe"}e.getWindowsShell=f;class p{constructor(n,o,i,a){if(o!==void 0&&i!==void 0&&a!==void 0)this.cmd=n,this.args=o,this.shell=i,this.options=a;else{const r=n;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(v.env).forEach(s=>{r[s]=v.env[s]}),Object.keys(this.options.env).forEach(s=>{r[s]=this.options.env[s]}),this.options.env=r}}getSanitizedCommand(){let n=this.cmd.toLowerCase();const o=n.lastIndexOf(k.sep);return o!==-1&&(n=n.substring(o+1)),p.WellKnowCommands[n]?n:"other"}start(n){return S.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(v.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(o=>{let i,a;const r=new Promise((s,u)=>{i=s,a=u});if(o){let s=this.cmd;this.args&&(s=s+" "+this.args.join(" ")),this.childProcess=I.exec(s,this.options,(u,h,b)=>{this.childProcess=null;const A=u;A&&A.killed?a({killed:this.terminateRequested,stdout:h.toString(),stderr:b.toString()}):this.handleExec(i,n,u,h,b)})}else{let s=null;const u=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,i,n,a);const b={terminated:this.terminateRequested};T.isNumber(h)&&(b.cmdCode=h),i(b)};if(this.shell&&S.isWindows){const h=P.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let b=!1,A=!1;const B=[];let G=this.ensureQuotes(this.cmd);B.push(G.value),b=G.quoted,this.args&&this.args.forEach(_=>{G=this.ensureQuotes(_),B.push(G.value),A=A&&G.quoted});const Q=["/s","/c"];b?A?Q.push('"'+B.join(" ")+'"'):B.length>1?Q.push('"'+B[0]+'" '+B.slice(1).join(" ")):Q.push('"'+B[0]+'"'):Q.push(B.join(" ")),s=I.spawn(f(),Q,h)}else this.cmd&&(s=I.spawn(this.cmd,this.args,this.options));s&&(this.childProcess=s,this.childProcessPromise=Promise.resolve(s),this.pidResolve&&(this.pidResolve(T.isNumber(s.pid)?s.pid:-1),this.pidResolve=void 0),s.on("error",h=>{this.childProcess=null,a({terminated:this.terminateRequested,error:h})}),s.pid&&(this.childProcess.on("close",u),this.handleSpawn(s,i,n,a,!0)))}return r})}handleClose(n,o,i,a){}ensureQuotes(n){return p.regexp.test(n)?{value:'"'+n+'"',quoted:!0}:{value:n,quoted:n.length>0&&n[0]==='"'&&n[n.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(n=>n.pid,n=>-1):new Promise(n=>{this.pidResolve=n})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(n=>(this.terminateRequested=!0,E(n,this.options.cwd).then(o=>(o.success&&(this.childProcess=null),o))),n=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(n=>{if(!this.shell||!S.isWindows)return n(!1);const o=I.spawn(f(),["/s","/c"]);o.on("error",i=>n(!0)),o.on("exit",i=>n(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class g extends p{constructor(n,o,i,a){super(n,o,i,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(n,o,i,a,r){[a,r].forEach((s,u)=>{const h=new R.LineDecoder;h.write(s).forEach(B=>{o({line:B,source:u===0?0:1})});const A=h.end();A&&o({line:A,source:u===0?0:1})}),n({terminated:this.terminateRequested,error:i})}handleSpawn(n,o,i,a,r){const s=new R.LineDecoder,u=new R.LineDecoder;n.stdout.on("data",h=>{s.write(h).forEach(A=>i({line:A,source:0}))}),n.stderr.on("data",h=>{u.write(h).forEach(A=>i({line:A,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=u}handleClose(n,o,i,a){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&i({line:r,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&i({line:s,source:1})}}e.LineProcess=g;function d(c){let n=[],o=!1;const i=function(a){if(o){n.push(a);return}(!c.send(a,s=>{if(s&&console.error(s),o=!1,n.length>0){const u=n.slice(0);n=[],u.forEach(h=>i(h))}})||S.isWindows)&&(o=!0)};return{send:i}}e.createQueuedSender=d;var l;(function(c){async function n(o,i,a){if(k.isAbsolute(o))return o;if(i===void 0&&(i=v.cwd()),k.dirname(o)!=="."||(a===void 0&&T.isString(v.env.PATH)&&(a=v.env.PATH.split(k.delimiter)),a===void 0||a.length===0))return k.join(i,o);async function s(u){if(await C.Promises.exists(u)){let h;try{h=await C.Promises.stat(u)}catch(b){b.message.startsWith("EACCES")&&(h=await C.Promises.lstat(u))}return h?!h.isDirectory():!1}return!1}for(let u of a){let h;if(k.isAbsolute(u)?h=k.join(u,o):h=k.join(i,u,o),await s(h))return h;let b=h+".com";if(await s(b)||(b=h+".exe",await s(b)))return b}return k.join(i,o)}c.findExecutable=n})(l=e.win32||(e.win32={}))}),define(we[153],ye([0,1,24,3,89,93]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(w,m){return w===1?t.isWindows?R():P.getWindowsShell(m):D(w,m)}e.getSystemShell=k;function S(w,m){return w===1?t.isWindows?C(m):P.getWindowsShell(m):D(w,m)}e.getSystemShellSync=S;let v=null;function D(w,m){if(t.isLinux&&w===2||t.isMacintosh&&w===3)return"/bin/bash";if(!v){let E;if(t.isWindows)E="/bin/bash";else{if(E=m.SHELL,!E)try{E=(0,I.userInfo)().shell}catch{}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}v=E}return v}let T=null;async function R(){return T||(T=(await(0,y.getFirstAvailablePowerShellInstallation)()).exePath),T}function C(w){if(T)return T;const m=t.isWindows&&parseFloat((0,I.release)())>=10,E=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${w.windir}\\${E?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return m?f:P.getWindowsShell(w)}}),define(we[94],ye([0,1,39,14,17,20,84,9,6,2,21,93,53,40]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends w.ChannelServer{constructor(p){super({send:g=>{try{process.send&&process.send(g.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",g=>y.VSBuffer.wrap(Buffer.from(g,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=m;class E{constructor(p,g){this.modulePath=p,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new v.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new t.Delayer(d),this.child=null,this._client=null}getChannel(p){const g=this;return{call(d,l,c){return g.requestPromise(p,d,l,c)},listen(d,l){return g.requestEvent(p,d,l)}}}requestPromise(p,g,d,l=P.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(S.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(p),n=(0,t.createCancelablePromise)(a=>c.call(g,d,a)),o=l.onCancellationRequested(()=>n.cancel()),i=(0,D.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{o.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(p,g,d){if(!this.disposeDelayer)return v.Event.None;this.disposeDelayer.cancel();let l;const c=new v.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(p).listen(g,d)(c.fire,c),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,C.removeDangerousEnvVariables)(g.env),this.child=(0,I.fork)(this.modulePath,p,g);const d=new v.Emitter;v.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,k.isRemoteConsoleLog)(r)){(0,k.log)(r,`IPC Library: ${this.options.serverName}`);return}d.fire(y.VSBuffer.wrap(Buffer.from(r,"base64")))});const c=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,n=r=>this.child&&this.child.connected&&c.send(r.buffer.toString("base64")),o=d.event,i={send:n,onMessage:o};this._client=new w.ChannelClient(i);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,s)=>{process.removeListener("exit",a),this.activeRequests.forEach(u=>(0,D.dispose)(u)),this.activeRequests.clear(),r!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:s})})}return this._client}getCachedChannel(p){let g=this.channels.get(p);return g||(g=this.client.getChannel(p),this.channels.set(p,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(we[154],ye([10,11]),function(ie,e){return ie.create("vs/base/node/zip",e)}),define(we[155],ye([10,11]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[156],ye([10,11]),function(ie,e){return ie.create("vs/platform/environment/node/argv",e)}),define(we[157],ye([10,11]),function(ie,e){return ie.create("vs/platform/environment/node/argvHelper",e)}),define(we[158],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(we[159],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[160],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(we[161],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(we[162],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(we[163],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(we[164],ye([10,11]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[165],ye([10,11]),function(ie,e){return ie.create("vs/platform/files/common/fileService",e)}),define(we[166],ye([10,11]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(we[167],ye([10,11]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(we[168],ye([10,11]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(we[169],ye([10,11]),function(ie,e){return ie.create("vs/platform/languagePacks/common/languagePacks",e)}),define(we[170],ye([10,11]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(we[171],ye([10,11]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(we[172],ye([10,11]),function(ie,e){return ie.create("vs/platform/shell/node/shellEnv",e)}),define(we[173],ye([10,11]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryService",e)}),define(we[174],ye([10,11]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(we[175],ye([10,11]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalProfiles",e)}),define(we[176],ye([10,11]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(we[177],ye([10,11]),function(ie,e){return ie.create("vs/server/node/remoteAgentEnvironmentImpl",e)}),define(we[178],ye([10,11]),function(ie,e){return ie.create("vs/server/node/serverEnvironmentService",e)}),define(we[179],ye([10,11]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(we[180],ye([10,11]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[181],ye([0,1,6,2]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class y{constructor(){this._onCloseEmitter=new I.Emitter,this._onReloadEmitter=new I.Emitter,this._onTerminateEmitter=new I.Emitter,this._onAttachEmitter=new I.Emitter}call(S,v,D){switch(v){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:D[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:D[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:D[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:D[0],port:D[1],subId:D[2]}))}throw new Error("Method not implemented.")}listen(S,v,D){switch(v){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=y,y.ChannelName="extensionhostdebugservice";class P extends t.Disposable{constructor(S){super();this.channel=S}reload(S){this.channel.call("reload",[S])}get onReload(){return this.channel.listen("reload")}close(S){this.channel.call("close",[S])}get onClose(){return this.channel.listen("close")}attachSession(S,v,D){this.channel.call("attach",[S,v,D])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(S,v){this.channel.call("terminate",[S,v])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(S,v){return this.channel.call("openExtensionDevelopmentHostWindow",[S,v])}}e.ExtensionHostDebugChannelClient=P}),define(we[182],ye([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(k){this.service=k}listen(k,S,v){throw new Error("Invalid listen")}call(k,S,v){switch(S){case"download":return this.service.download(I.URI.revive(v[0]),I.URI.revive(v[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class y{constructor(k,S){this.channel=k,this.getUriTransformer=S}async download(k,S){const v=this.getUriTransformer();v&&(k=v.transformOutgoingURI(k),S=v.transformOutgoingURI(S)),await this.channel.call("download",[k,S])}}e.DownloadServiceChannelClient=y}),define(we[183],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var I;(function(S){S[S.ACTIVATE=1]="ACTIVATE",S[S.RESTORE=2]="RESTORE",S[S.PRESERVE=3]="PRESERVE"})(I=e.EditorActivation||(e.EditorActivation={}));var t;(function(S){S[S.PICK=0]="PICK",S[S.DISABLED=1]="DISABLED",S[S.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var y;(function(S){S[S.API=0]="API",S[S.USER=1]="USER"})(y=e.EditorOpenSource||(e.EditorOpenSource={}));var P;(function(S){S[S.Center=0]="Center",S[S.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",S[S.NearTop=2]="NearTop",S[S.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var k;(function(S){S.PROGRAMMATIC="api",S.NAVIGATION="code.navigation",S.JUMP="code.jump"})(k=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(we[184],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class I{constructor(y){this.machineId=y}encryption(){return new Promise((y,P)=>ie(["vscode-encrypt"],y,P))}async encrypt(y){try{return(await this.encryption()).encrypt(this.machineId,y)}catch{return y}}async decrypt(y){try{return(await this.encryption()).decrypt(this.machineId,y)}catch{return y}}}e.EncryptionMainService=I}),define(we[95],ye([0,1,148,81,8,5,27,19,4]),function(ie,e,I,t,y,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class D{constructor(E,f,p){this._args=E,this.paths=f,this.productService=p}get appRoot(){return(0,P.dirname)(y.FileAccess.asFileUri("",ie).fsPath)}get userHome(){return v.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return v.URI.file((0,P.join)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.paths.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return v.URI.file((0,P.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(v.URI.file((0,P.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=k.env.VSCODE_PORTABLE;return E?v.URI.file((0,P.join)(E,"argv.json")):(0,S.joinPath)(this.appSettingsHome,"argv.json")}get snippetsHome(){return(0,S.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,P.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,P.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,P.resolve)(E):(0,P.normalize)((0,P.join)(y.FileAccess.asFileUri("",ie).fsPath,"..","extensions"))}get extensionsDownloadPath(){const E=this.args["extensions-download-dir"];return E?(0,P.resolve)(E):(0,P.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,P.resolve)(E);const f=k.env.VSCODE_EXTENSIONS;if(f)return f;const p=k.env.VSCODE_PORTABLE;return p?(0,P.join)(p,"extensions"):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(f=>/^[^:/?#]+?:\/\//.test(f)?v.URI.parse(f):v.URI.file((0,P.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?v.URI.parse(E):v.URI.file((0,P.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,S.joinPath)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return v.URI.file((0,P.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const E=k.env.VSCODE_PORTABLE;return E?v.URI.file((0,P.join)(E,"policy.json")):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}Re([t.memoize],D.prototype,"appRoot",null),Re([t.memoize],D.prototype,"userHome",null),Re([t.memoize],D.prototype,"userDataPath",null),Re([t.memoize],D.prototype,"appSettingsHome",null),Re([t.memoize],D.prototype,"tmpDir",null),Re([t.memoize],D.prototype,"cacheHome",null),Re([t.memoize],D.prototype,"userRoamingDataHome",null),Re([t.memoize],D.prototype,"settingsResource",null),Re([t.memoize],D.prototype,"userDataSyncHome",null),Re([t.memoize],D.prototype,"userDataSyncLogResource",null),Re([t.memoize],D.prototype,"sync",null),Re([t.memoize],D.prototype,"machineSettingsResource",null),Re([t.memoize],D.prototype,"globalStorageHome",null),Re([t.memoize],D.prototype,"workspaceStorageHome",null),Re([t.memoize],D.prototype,"localHistoryHome",null),Re([t.memoize],D.prototype,"keybindingsResource",null),Re([t.memoize],D.prototype,"keyboardLayoutResource",null),Re([t.memoize],D.prototype,"argvResource",null),Re([t.memoize],D.prototype,"snippetsHome",null),Re([t.memoize],D.prototype,"isExtensionDevelopment",null),Re([t.memoize],D.prototype,"untitledWorkspacesHome",null),Re([t.memoize],D.prototype,"installSourcePath",null),Re([t.memoize],D.prototype,"builtinExtensionsPath",null),Re([t.memoize],D.prototype,"extensionsPath",null),Re([t.memoize],D.prototype,"extensionDevelopmentLocationURI",null),Re([t.memoize],D.prototype,"extensionDevelopmentKind",null),Re([t.memoize],D.prototype,"extensionTestsLocationURI",null),Re([t.memoize],D.prototype,"debugExtensionHost",null),Re([t.memoize],D.prototype,"serviceMachineIdResource",null),Re([t.memoize],D.prototype,"telemetryLogResource",null),Re([t.memoize],D.prototype,"disableWorkspaceTrust",null),Re([t.memoize],D.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=D;function T(m,E){return w(m["inspect-extensions"],m["inspect-brk-extensions"],5870,E,m.debugId,m.extensionEnvironment)}e.parseExtensionHostPort=T;function R(m,E){return w(m["inspect-search"],m["inspect-brk-search"],5876,E,m.extensionEnvironment)}e.parseSearchPort=R;function C(m,E){return w(m["inspect-ptyhost"],m["inspect-brk-ptyhost"],5877,E,m.extensionEnvironment)}e.parsePtyHostPort=C;function w(m,E,f,p,g,d){const c=Number(E||m)||(p?null:f),n=c?Boolean(!!E):!1;let o;if(d)try{o=JSON.parse(d)}catch{}return{port:c,break:n,debugId:g,env:o}}}),define(we[54],ye([0,1,264,3,156]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const P={o:(0,y.localize)(0,null),e:(0,y.localize)(1,null),t:(0,y.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,y.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,y.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,y.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,y.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,y.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,y.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,y.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,y.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,y.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,y.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,y.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,y.localize)(14,null)},category:{type:"string",cat:"e",description:(0,y.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,y.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,y.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,y.localize)(18,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,y.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,y.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,y.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,y.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,y.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,y.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,y.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,y.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,y.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,y.localize)(28,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,y.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,y.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,y.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,y.localize)(32,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(m,E,f=k){const p={},g=["_"],d=[];for(let o in E){const i=E[o];i.alias&&(p[o]=i.alias),i.type==="string"||i.type==="string[]"?(g.push(o),i.deprecates&&g.push(...i.deprecates)):i.type==="boolean"&&(d.push(o),i.deprecates&&d.push(...i.deprecates))}const l=I(m,{string:g,boolean:d,alias:p}),c={},n=l;c._=l._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(let o in E){const i=E[o];i.alias&&delete n[i.alias];let a=n[o];if(i.deprecates)for(const r of i.deprecates)n.hasOwnProperty(r)&&(a||(a=n[r],a&&f.onDeprecatedOption(r,i.deprecationMessage||(0,y.localize)(33,null,o))),delete n[r]);if(typeof a!="undefined"){if(i.type==="string[]"){if(Array.isArray(a)||(a=[a]),!i.allowEmptyValue){const r=a.filter(s=>s.length>0);r.length!==a.length&&(f.onEmptyValue(o),a=r.length>0?r:void 0)}}else i.type==="string"&&(Array.isArray(a)?(a=a.pop(),f.onMultipleValues(o,a)):!a&&!i.allowEmptyValue&&(f.onEmptyValue(o),a=void 0));c[o]=a,i.deprecationMessage&&f.onDeprecatedOption(o,i.deprecationMessage)}delete n[o]}for(let o in n)f.onUnknownOption(o);return c}e.parseArgs=S;function v(m,E){let f="";return E.args&&(Array.isArray(E.args)?f=` <${E.args.join("> <")}>`:f=` <${E.args}>`),E.alias?`-${E.alias} --${m}${f}`:`--${m}${f}`}function D(m,E){let f=0,p=[];for(const c in m){const n=m[c],o=v(c,n);f=Math.max(f,o.length),p.push([o,n.description])}let g=f+2+1;if(E-g<25)return p.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);let d=E-g-1,l=[];for(const c of p){let n=c[0],o=R(c[1],d),i=T(g-n.length-2);l.push("  "+n+i+o[0]);for(let a=1;a<o.length;a++)l.push(T(g)+o[a])}return l}e.formatOptions=D;function T(m){return" ".repeat(m)}function R(m,E){let f=[];for(;m.length;){let p=m.length<E?m.length:m.lastIndexOf(" ",E),g=m.slice(0,p).trim();m=m.slice(p),f.push(g)}return f}function C(m,E,f,p,g){const d=process.stdout.isTTY&&process.stdout.columns||80,l=g?.noInputFiles!==!0?`[${(0,y.localize)(34,null)}...]`:"",c=[`${m} ${f}`];c.push(""),c.push(`${(0,y.localize)(35,null)}: ${E} [${(0,y.localize)(36,null)}]${l}`),c.push(""),g?.noPipe!==!0&&(t.isWindows?c.push((0,y.localize)(37,null,E)):c.push((0,y.localize)(38,null,E)),c.push(""));const n={};for(const o in p){const i=p[o];if(i.description&&i.cat){let a=n[i.cat];a||(n[i.cat]=a={}),a[o]=i}}for(let o in n){const i=o;let a=n[i];a&&(c.push(P[i]),c.push(...D(a,d)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=C;function w(m,E){return`${m||(0,y.localize)(39,null)}
${E||(0,y.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=w}),define(we[185],ye([0,1,265,157,54]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const P=2048;function k(C,w){const m={onUnknownOption:f=>{console.warn((0,t.localize)(0,null,f))},onMultipleValues:(f,p)=>{console.warn((0,t.localize)(1,null,f,p))},onEmptyValue:f=>{console.warn((0,t.localize)(2,null,f))},onDeprecatedOption:(f,p)=>{console.warn((0,t.localize)(3,null,f,p))}},E=(0,y.parseArgs)(C,y.OPTIONS,w?m:void 0);return E.goto&&E._.forEach(f=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,t.localize)(4,null))),E["max-memory"]&&I(parseInt(E["max-memory"])>=P,`The max-memory argument cannot be specified lower than ${P} MB.`),E}function S(C){const w=C.findIndex(m=>!/^-/.test(m));if(w>-1)return[...C.slice(0,w),...C.slice(w+1)]}function v(C){let[,...w]=C;process.env.VSCODE_DEV&&(w=S(w)||[]);const m=!R(process.env);return k(w,m)}e.parseMainProcessArgv=v;function D(C){const[,,...w]=C;return k(w,!0)}e.parseCLIProcessArgv=D;function T(C,...w){const m=C.indexOf("--");return m===-1?C.push(...w):C.splice(m,0,...w),C}e.addArg=T;function R(C){return C.VSCODE_CLI==="1"}e.isLaunchedFromCli=R}),function(){"use strict";function ie(e,I,t,y){function P(S){const v=k(S),D=[v];return e.isAbsolute(v)||D.unshift(y),e.resolve(...D)}function k(S){const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let D=process.env.VSCODE_APPDATA;if(D)return e.join(D,t);const T=S["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(D=process.env.APPDATA,!D){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");D=e.join(R,"AppData","Roaming")}break;case"darwin":D=e.join(I.homedir(),"Library","Application Support");break;case"linux":D=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(D,t)}return{getUserDataPath:P}}if(typeof define=="function")define(we[186],ye([0,87,24,8,19,27]),function(e,I,t,y,P,k){const S=P.dirname(y.FileAccess.asFileUri("",e)),v=e.__$__nodeRequire(P.joinPath(S,"package.json").fsPath);return ie(I,t,v.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),I=require("path"),t=require("os");module.exports=ie(I,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(we[187],ye([0,1,24,95,186]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class P extends t.AbstractNativeEnvironmentService{constructor(S,v){super(S,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,y.getUserDataPath)(S)},v)}}e.NativeEnvironmentService=P}),define(we[69],ye([0,1,19,65,164,55]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function v(p){return p=p.trim(),p==="*"||k.test(p)}e.isValidVersionStr=v;function D(p){if(!v(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=p.match(k);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=D;function T(p){if(!p)return null;let g=p.majorBase,d=p.majorMustEqual,l=p.minorBase,c=p.minorMustEqual,n=p.patchBase,o=p.patchMustEqual;p.hasCaret&&(g===0||(c=!1),o=!1);let i=0;if(p.preRelease){const a=S.exec(p.preRelease);if(a){const[,r,s,u]=a;i=Date.UTC(Number(r),Number(s)-1,Number(u))}}return{majorBase:g,majorMustEqual:d,minorBase:l,minorMustEqual:c,patchBase:n,patchMustEqual:o,isMinimum:p.hasGreaterEquals,notBefore:i}}e.normalizeVersion=T;function R(p,g,d){let l;typeof p=="string"?l=T(D(p)):l=p;let c;g instanceof Date?c=g.getTime():typeof g=="string"&&(c=new Date(g).getTime());let n;if(typeof d=="string"?n=T(D(d)):n=d,!l||!n)return!1;let o=l.majorBase,i=l.minorBase,a=l.patchBase,r=n.majorBase,s=n.minorBase,u=n.patchBase,h=n.notBefore,b=n.majorMustEqual,A=n.minorMustEqual,B=n.patchMustEqual;return n.isMinimum?o>r?!0:o<r?!1:i>s?!0:i<s||c&&c<h?!1:a>=u:(o===1&&r===0&&(!b||!A||!B)&&(r=1,s=0,u=0,b=!0,A=!1,B=!1),o<r?!1:o>r?!b:i<s?!1:i>s?!A:a<u?!1:a>u?!B:!(c&&c<h))}e.isValidVersion=R;function C(p,g,d,l,c){const n=[];if(typeof l.publisher!="undefined"&&typeof l.publisher!="string")return n.push([t.default.Error,y.localize(0,null)]),n;if(typeof l.name!="string")return n.push([t.default.Error,y.localize(1,null,"name")]),n;if(typeof l.version!="string")return n.push([t.default.Error,y.localize(2,null,"version")]),n;if(!l.engines)return n.push([t.default.Error,y.localize(3,null,"engines")]),n;if(typeof l.engines.vscode!="string")return n.push([t.default.Error,y.localize(4,null,"engines.vscode")]),n;if(typeof l.extensionDependencies!="undefined"&&!f(l.extensionDependencies))return n.push([t.default.Error,y.localize(5,null,"extensionDependencies")]),n;if(typeof l.activationEvents!="undefined"){if(!f(l.activationEvents))return n.push([t.default.Error,y.localize(6,null,"activationEvents")]),n;if(typeof l.main=="undefined"&&typeof l.browser=="undefined")return n.push([t.default.Error,y.localize(7,null,"activationEvents","main")]),n}if(typeof l.extensionKind!="undefined"&&typeof l.main=="undefined"&&n.push([t.default.Warning,y.localize(8,null,"extensionKind")]),typeof l.main!="undefined"){if(typeof l.main!="string")return n.push([t.default.Error,y.localize(9,null,"main")]),n;{const a=(0,I.joinPath)(d,l.main);(0,I.isEqualOrParent)(a,d)||n.push([t.default.Warning,y.localize(10,null,a.path,d.path)])}if(typeof l.activationEvents=="undefined")return n.push([t.default.Error,y.localize(11,null,"activationEvents","main")]),n}if(typeof l.browser!="undefined"){if(typeof l.browser!="string")return n.push([t.default.Error,y.localize(12,null,"browser")]),n;{const a=(0,I.joinPath)(d,l.browser);(0,I.isEqualOrParent)(a,d)||n.push([t.default.Warning,y.localize(13,null,a.path,d.path)])}if(typeof l.activationEvents=="undefined")return n.push([t.default.Error,y.localize(14,null,"activationEvents","browser")]),n}if(!P.valid(l.version))return n.push([t.default.Error,y.localize(15,null)]),n;const o=[];if(!w(p,g,l,c,o))for(const a of o)n.push([t.default.Error,a]);return n}e.validateExtensionManifest=C;function w(p,g,d,l,c){return l||typeof d.main=="undefined"&&typeof d.browser=="undefined"?!0:E(p,g,d.engines.vscode,c)}e.isValidExtensionVersion=w;function m(p,g,d){return p==="*"||E(g,d,p)}e.isEngineValid=m;function E(p,g,d,l=[]){let c=T(D(d));if(!c)return l.push(y.localize(16,null,d)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return l.push(y.localize(17,null,d)),!1}else if(!c.majorMustEqual)return l.push(y.localize(18,null,d)),!1;return R(p,g,c)?!0:(l.push(y.localize(19,null,p,d)),!1)}function f(p){if(!Array.isArray(p))return!1;for(let g=0,d=p.length;g<d;g++)if(typeof p[g]!="string")return!1;return!0}}),define(we[188],ye([0,1,17,23]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function y(P,k,S){let v=S&&S.get("storage.serviceMachineId",0)||null;if(v)return v;try{const T=(await k.readFile(P.serviceMachineIdResource)).value.toString();v=(0,t.isUUID)(T)?T:null}catch{v=null}if(!v){v=(0,t.generateUuid)();try{await k.writeFile(P.serviceMachineIdResource,I.VSBuffer.fromString(v))}catch{}}return S&&S.store("storage.serviceMachineId",v,0,1),v}e.getServiceMachineId=y}),define(we[56],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(y,P=[],k=!1){this.ctor=y,this.staticArguments=P,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=I}),define(we[189],ye([0,1,56]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function y(k,S,v){S instanceof I.SyncDescriptor||(S=new I.SyncDescriptor(S,[],v)),t.push([k,S])}e.registerSingleton=y;function P(){return t}e.getSingletonServiceDescriptors=P}),define(we[190],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=I;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let k of this._nodes.values())k.outgoing.size===0&&P.push(k);return P}insertEdge(P,k){const S=this.lookupOrInsertNode(P),v=this.lookupOrInsertNode(k);S.outgoing.set(this._hashFn(k),v),v.incoming.set(this._hashFn(P),S)}removeNode(P){const k=this._hashFn(P);this._nodes.delete(k);for(let S of this._nodes.values())S.outgoing.delete(k),S.incoming.delete(k)}lookupOrInsertNode(P){const k=this._hashFn(P);let S=this._nodes.get(k);return S||(S=new I(P),this._nodes.set(k,S)),S}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[k,S]of this._nodes)P.push(`${k}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,k]of this._nodes){const S=new Set([P]),v=this._findCycle(k,S);if(v)return v}}_findCycle(P,k){for(let[S,v]of P.outgoing){if(k.has(S))return[...k,S].join(" -> ");k.add(S);const D=this._findCycle(v,k);if(D)return D;k.delete(S)}}}e.Graph=t}),define(we[7],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function S(v){return v[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=S})(I=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function t(k,S,v){S[I.DI_TARGET]===S?S[I.DI_DEPENDENCIES].push({id:k,index:v}):(S[I.DI_DEPENDENCIES]=[{id:k,index:v}],S[I.DI_TARGET]=S)}function y(k){if(I.serviceIds.has(k))return I.serviceIds.get(k);const S=function(v,D,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(S,v,T)};return S.toString=()=>k,I.serviceIds.set(k,S),S}e.createDecorator=y;function P(k){return k}e.refineServiceDecorator=P}),define(we[25],ye([0,1,12,4,7]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function P(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationOverrides=P;function k(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||I.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var S;(function(p){p[p.USER=1]="USER",p[p.USER_LOCAL=2]="USER_LOCAL",p[p.USER_REMOTE=3]="USER_REMOTE",p[p.WORKSPACE=4]="WORKSPACE",p[p.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",p[p.DEFAULT=6]="DEFAULT",p[p.MEMORY=7]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function v(p){switch(p){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=v;function D(p,g){const d=Object.create(null);for(let l in p)T(d,l,p[l],g);return d}e.toValuesTree=D;function T(p,g,d,l){const c=g.split("."),n=c.pop();let o=p;for(let i=0;i<c.length;i++){let a=c[i],r=o[a];switch(typeof r){case"undefined":r=o[a]=Object.create(null);break;case"object":break;default:l(`Ignoring ${g} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}o=r}if(typeof o=="object"&&o!==null)try{o[n]=d}catch{l(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(o)}`)}else l(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=T;function R(p,g){const d=g.split(".");C(p,d)}e.removeFromValueTree=R;function C(p,g){const d=g.shift();if(g.length===0){delete p[d];return}if(Object.keys(p).indexOf(d)!==-1){const l=p[d];typeof l=="object"&&!Array.isArray(l)&&(C(l,g),Object.keys(l).length===0&&delete p[d])}}function w(p,g,d){function l(o,i){let a=o;for(const r of i){if(typeof a!="object"||a===null)return;a=a[r]}return a}const c=g.split("."),n=l(p,c);return typeof n=="undefined"?d:n}e.getConfigurationValue=w;function m(p,g,d){Object.keys(g).forEach(l=>{l!=="__proto__"&&(l in p?I.isObject(p[l])&&I.isObject(g[l])?m(p[l],g[l],d):d&&(p[l]=g[l]):p[l]=g[l])})}e.merge=m;function E(p,g,d){const l=p.inspect(g),c=p.inspect(d);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:l.defaultValue}e.getMigratedSettingValue=E;function f(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(we[96],ye([0,1,3,15,7]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",I.isMacintosh),P.set("isLinux",I.isLinux),P.set("isWindows",I.isWindows),P.set("isWeb",I.isWeb),P.set("isMacNative",I.isMacintosh&&!I.isWeb),P.set("isEdge",I.isEdge),P.set("isFirefox",I.isFirefox),P.set("isChrome",I.isChrome),P.set("isSafari",I.isSafari);const k=Object.prototype.hasOwnProperty;var S;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return R.INSTANCE}static true(){return C.INSTANCE}static has(_){return w.create(_)}static equals(_,X){return m.create(_,X)}static notEquals(_,X){return p.create(_,X)}static regex(_,X){return i.create(_,X)}static in(_,X){return E.create(_,X)}static not(_){return g.create(_)}static and(..._){return s.create(_,null)}static or(..._){return u.create(_,null,!0)}static greater(_,X){return l.create(_,X)}static greaterEquals(_,X){return c.create(_,X)}static smaller(_,X){return n.create(_,X)}static smallerEquals(_,X){return o.create(_,X)}static deserialize(_,X=!1){if(!!_)return this._deserializeOrExpression(_,X)}static _deserializeOrExpression(_,X){let F=_.split("||");return u.create(F.map(U=>this._deserializeAndExpression(U,X)),null,!0)}static _deserializeAndExpression(_,X){let F=_.split("&&");return s.create(F.map(U=>this._deserializeOne(U,X)),null)}static _deserializeOne(_,X){if(_=_.trim(),_.indexOf("!=")>=0){let F=_.split("!=");return p.create(F[0].trim(),this._deserializeValue(F[1],X))}if(_.indexOf("==")>=0){let F=_.split("==");return m.create(F[0].trim(),this._deserializeValue(F[1],X))}if(_.indexOf("=~")>=0){let F=_.split("=~");return i.create(F[0].trim(),this._deserializeRegexValue(F[1],X))}if(_.indexOf(" in ")>=0){let F=_.split(" in ");return E.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const F=_.split(">=");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const F=_.split(">");return l.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const F=_.split("<=");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const F=_.split("<");return n.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(_)?g.create(_.substr(1).trim()):w.create(_)}static _deserializeValue(_,X){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let F=/^'([^']*)'$/.exec(_);return F?F[1].trim():_}static _deserializeRegexValue(_,X){if((0,t.isFalsyOrWhitespace)(_)){if(X)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=_.indexOf("/"),U=_.lastIndexOf("/");if(F===U||F<0){if(X)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let le=_.slice(F+1,U),j=_[U+1]==="i"?"i":"";try{return new RegExp(le,j)}catch($){if(X)throw new Error(`bad regexp-value '${_}', parse error: ${$}`);return console.warn(`bad regexp-value '${_}', parse error: ${$}`),null}}}e.ContextKeyExpr=v;function D(Q,_){const X=Q?Q.substituteConstants():void 0,F=_?_.substituteConstants():void 0;return!X&&!F?!0:!X||!F?!1:X.equals(F)}e.expressionsAreEqualWithConstantSubstitution=D;function T(Q,_){return Q.cmp(_)}class R{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return C.INSTANCE}}e.ContextKeyFalseExpr=R,R.INSTANCE=new R;class C{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return R.INSTANCE}}e.ContextKeyTrueExpr=C,C.INSTANCE=new C;class w{constructor(_,X){this.key=_,this.negated=X,this.type=2}static create(_,X=null){const F=P.get(_);return typeof F=="boolean"?F?C.INSTANCE:R.INSTANCE:new w(_,X)}cmp(_){return _.type!==this.type?this.type-_.type:b(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=P.get(this.key);return typeof _=="boolean"?_?C.INSTANCE:R.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=w;class m{constructor(_,X,F){this.key=_,this.value=X,this.negated=F,this.type=4}static create(_,X,F=null){if(typeof X=="boolean")return X?w.create(_,F):g.create(_,F);const U=P.get(_);return typeof U=="boolean"?X===(U?"true":"false")?C.INSTANCE:R.INSTANCE:new m(_,X,F)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=P.get(this.key);if(typeof _=="boolean"){const X=_?"true":"false";return this.value===X?C.INSTANCE:R.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=m;class E{constructor(_,X){this.key=_,this.valueKey=X,this.type=10,this.negated=null}static create(_,X){return new E(_,X)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const X=_.getValue(this.valueKey),F=_.getValue(this.key);return Array.isArray(X)?X.includes(F):typeof F=="string"&&typeof X=="object"&&X!==null?k.call(X,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this)),this.negated}}e.ContextKeyInExpr=E;class f{constructor(_){this._actual=_,this.type=11}static create(_){return new f(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new f(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=f;class p{constructor(_,X,F){this.key=_,this.value=X,this.negated=F,this.type=5}static create(_,X,F=null){if(typeof X=="boolean")return X?g.create(_,F):w.create(_,F);const U=P.get(_);return typeof U=="boolean"?X===(U?"true":"false")?R.INSTANCE:C.INSTANCE:new p(_,X,F)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=P.get(this.key);if(typeof _=="boolean"){const X=_?"true":"false";return this.value===X?R.INSTANCE:C.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class g{constructor(_,X){this.key=_,this.negated=X,this.type=3}static create(_,X=null){const F=P.get(_);return typeof F=="boolean"?F?R.INSTANCE:C.INSTANCE:new g(_,X)}cmp(_){return _.type!==this.type?this.type-_.type:b(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=P.get(this.key);return typeof _=="boolean"?_?R.INSTANCE:C.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function d(Q,_){if(typeof Q=="string"){const X=parseFloat(Q);isNaN(X)||(Q=X)}return typeof Q=="string"||typeof Q=="number"?_(Q):R.INSTANCE}class l{constructor(_,X,F){this.key=_,this.value=X,this.negated=F,this.type=12}static create(_,X,F=null){return d(X,U=>new l(_,U,F))}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class c{constructor(_,X,F){this.key=_,this.value=X,this.negated=F,this.type=13}static create(_,X,F=null){return d(X,U=>new c(_,U,F))}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class n{constructor(_,X,F){this.key=_,this.value=X,this.negated=F,this.type=14}static create(_,X,F=null){return d(X,U=>new n(_,U,F))}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class o{constructor(_,X,F){this.key=_,this.value=X,this.negated=F,this.type=15}static create(_,X,F=null){return d(X,U=>new o(_,U,F))}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class i{constructor(_,X){this.key=_,this.regexp=X,this.type=7,this.negated=null}static create(_,X){return new i(_,X)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const X=this.regexp?this.regexp.source:"",F=_.regexp?_.regexp.source:"";return X<F?-1:X>F?1:0}equals(_){if(_.type===this.type){const X=this.regexp?this.regexp.source:"",F=_.regexp?_.regexp.source:"";return this.key===_.key&&X===F}return!1}substituteConstants(){return this}evaluate(_){let X=_.getValue(this.key);return this.regexp?this.regexp.test(X):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=a.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class a{constructor(_){this._actual=_,this.type=8}static create(_){return new a(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new a(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;function r(Q){let _=null;for(let X=0,F=Q.length;X<F;X++){const U=Q[X].substituteConstants();if(Q[X]!==U&&_===null){_=[];for(let le=0;le<X;le++)_[le]=Q[le]}_!==null&&(_[X]=U)}return _===null?Q:_}class s{constructor(_,X){this.expr=_,this.negated=X,this.type=6}static create(_,X){return s._normalizeArr(_,X)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let X=0,F=this.expr.length;X<F;X++){const U=T(this.expr[X],_.expr[X]);if(U!==0)return U}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let X=0,F=this.expr.length;X<F;X++)if(!this.expr[X].equals(_.expr[X]))return!1;return!0}return!1}substituteConstants(){const _=r(this.expr);return _===this.expr?this:s.create(_,this.negated)}evaluate(_){for(let X=0,F=this.expr.length;X<F;X++)if(!this.expr[X].evaluate(_))return!1;return!0}static _normalizeArr(_,X){const F=[];let U=!1;for(const le of _)if(!!le){if(le.type===1){U=!0;continue}if(le.type===0)return R.INSTANCE;if(le.type===6){F.push(...le.expr);continue}F.push(le)}if(F.length===0&&U)return C.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(T);for(let le=1;le<F.length;le++)F[le-1].equals(F[le])&&(F.splice(le,1),le--);if(F.length===1)return F[0];for(;F.length>1;){const le=F[F.length-1];if(le.type!==9)break;F.pop();const j=F.pop(),$=F.length===0,O=u.create(le.expr.map(M=>s.create([M,j],null)),null,$);O&&(F.push(O),F.sort(T))}return F.length===1?F[0]:new s(F,X)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let X of this.expr)_.push(...X.keys());return _}map(_){return new s(this.expr.map(X=>X.map(_)),null)}negate(){if(!this.negated){const _=[];for(let X of this.expr)_.push(X.negate());this.negated=u.create(_,this,!0)}return this.negated}}class u{constructor(_,X){this.expr=_,this.negated=X,this.type=9}static create(_,X,F){return u._normalizeArr(_,X,F)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let X=0,F=this.expr.length;X<F;X++){const U=T(this.expr[X],_.expr[X]);if(U!==0)return U}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let X=0,F=this.expr.length;X<F;X++)if(!this.expr[X].equals(_.expr[X]))return!1;return!0}return!1}substituteConstants(){const _=r(this.expr);return _===this.expr?this:u.create(_,this.negated,!1)}evaluate(_){for(let X=0,F=this.expr.length;X<F;X++)if(this.expr[X].evaluate(_))return!0;return!1}static _normalizeArr(_,X,F){let U=[],le=!1;if(_){for(let j=0,$=_.length;j<$;j++){const O=_[j];if(!!O){if(O.type===0){le=!0;continue}if(O.type===1)return C.INSTANCE;if(O.type===9){U=U.concat(O.expr);continue}U.push(O)}}if(U.length===0&&le)return R.INSTANCE;U.sort(T)}if(U.length!==0){if(U.length===1)return U[0];for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];if(F){for(let j=0;j<U.length;j++)for(let $=j+1;$<U.length;$++)B(U[j],U[$])&&(U.splice($,1),$--);if(U.length===1)return U[0]}return new u(U,X)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let X of this.expr)_.push(...X.keys());return _}map(_){return new u(this.expr.map(X=>X.map(_)),null)}negate(){if(!this.negated){let _=[];for(let X of this.expr)_.push(X.negate());for(;_.length>1;){const X=_.shift(),F=_.shift(),U=[];for(const j of G(X))for(const $ of G(F))U.push(s.create([j,$],null));const le=_.length===0;_.unshift(u.create(U,null,le))}this.negated=_[0]}return this.negated}}class h extends w{constructor(_,X,F){super(_,null);this._defaultValue=X,typeof F=="object"?h._info.push({...F,key:_}):F!==!0&&h._info.push({key:_,description:F,type:X!=null?typeof X:void 0})}static all(){return h._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return m.create(this.key,_)}notEqualsTo(_){return p.create(this.key,_)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(Q,_){return Q<_?-1:Q>_?1:0}function A(Q,_,X,F){return Q<X?-1:Q>X?1:_<F?-1:_>F?1:0}function B(Q,_){if(_.type===6&&Q.type!==9&&Q.type!==6){for(const U of _.expr)if(Q.equals(U))return!0}const X=Q.negate(),F=G(X).concat(G(_));F.sort(T);for(let U=0;U<F.length;U++){const j=F[U].negate();for(let $=U+1;$<F.length;$++){const O=F[$];if(j.equals(O))return!0}}return!1}e.implies=B;function G(Q){return Q.type===9?Q.expr:[Q]}}),define(we[70],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(P,k){return this.secretVault[P]?.[k]??null}async setPassword(P,k,S){this.secretVault[P]=this.secretVault[P]??{},this.secretVault[P][k]=S}async deletePassword(P,k){return this.secretVault[P]?.[k]?(delete this.secretVault[P][k],Object.keys(this.secretVault[P]).length===0&&delete this.secretVault[P],!0):!1}async findPassword(P){return JSON.stringify(this.secretVault[P])??null}async findCredentials(P){const k=[];for(const S of Object.keys(this.secretVault[P]||{}))k.push({account:S,password:this.secretVault[P][S]});return k}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(we[191],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function t(P){return!!P.hostName&&!!P.errorMessage}e.isRemoteDiagnosticError=t;class y{async getPerformanceInfo(k,S){return{}}async getSystemInfo(k,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,S){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=y}),define(we[71],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,I.createDecorator)("downloadService")}),define(we[192],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(we[28],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(we[31],ye([0,1,159,7]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function P(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function k(p,g){switch(p){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function S(p,g){return g==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=S;function v(p,g,d){return S(g,d)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===d?!0:D(d).includes(p)}e.isTargetPlatformCompatible=v;function D(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=D;function T(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=T;var R;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(R=e.SortBy||(e.SortBy={}));var C;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var w;(function(p){p.Install="install",p.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var m;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var E;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(g,d){super(g);this.code=d,this.name=d}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,I.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(we[193],ye([0,1,6,2,21,4,67,31]),function(ie,e,I,t,y,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function v(E,f){return P.URI.revive(f?f.transformIncoming(E):E)}function D(E,f){return f?f.transformOutgoingURI(E):E}function T(E,f){f=f||k.DefaultURITransformer;const p=E.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...E,manifest:void 0},f),manifest:p}}function R(E,f){return f?(0,y.cloneAndChange)(E,p=>p instanceof P.URI?f.transformOutgoingURI(p):void 0):E}class C{constructor(f,p){this.service=f,this.getUriTransformer=p,this.onInstallExtension=I.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,p){const g=this.getUriTransformer(f);switch(p){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,d=>d.map(l=>({...l,local:l.local?R(l.local,g):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,p,g){const d=this.getUriTransformer(f);switch(p){case"zip":return this.service.zip(T(g[0],d)).then(l=>D(l,d));case"unzip":return this.service.unzip(v(g[0],d));case"install":return this.service.install(v(g[0],d),g[1]);case"getManifest":return this.service.getManifest(v(g[0],d));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(g[0]);case"installFromGallery":return this.service.installFromGallery(g[0],g[1]);case"uninstall":return this.service.uninstall(T(g[0],d),g[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(T(g[0],d));case"getInstalled":return this.service.getInstalled(g[0]).then(l=>l.map(c=>R(c,d)));case"updateMetadata":return this.service.updateMetadata(T(g[0],d),g[1]).then(l=>R(l,d));case"updateExtensionScope":return this.service.updateExtensionScope(T(g[0],d),g[1]).then(l=>R(l,d));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=C;class w extends t.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new I.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new I.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new I.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new I.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(p=>this._onInstallExtension.fire({identifier:p.identifier,source:this.isUriComponents(p.source)?P.URI.revive(p.source):p.source}))),this._register(this.channel.listen("onDidInstallExtensions")(p=>this._onDidInstallExtensions.fire(p.map(g=>({...g,local:g.local?T(g.local,null):g.local,source:this.isUriComponents(g.source)?P.URI.revive(g.source):g.source}))))),this._register(this.channel.listen("onUninstallExtension")(p=>this._onUninstallExtension.fire(p))),this._register(this.channel.listen("onDidUninstallExtension")(p=>this._onDidUninstallExtension.fire(p)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const p=await this.getTargetPlatform();return f.allTargetPlatforms.some(g=>(0,S.isTargetPlatformCompatible)(g,f.allTargetPlatforms,p))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(p=>P.URI.revive(p)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,p){return Promise.resolve(this.channel.call("install",[f,p])).then(g=>T(g,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,p){return Promise.resolve(this.channel.call("installFromGallery",[f,p])).then(g=>T(g,null))}uninstall(f,p){return Promise.resolve(this.channel.call("uninstall",[f,p]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(p=>p.map(g=>T(g,null)))}updateMetadata(f,p){return Promise.resolve(this.channel.call("updateMetadata",[f,p])).then(g=>T(g,null))}updateExtensionScope(f,p){return Promise.resolve(this.channel.call("updateExtensionScope",[f,p])).then(g=>T(g,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=w;class m{constructor(f){this.service=f}listen(f,p){throw new Error("Invalid listen")}call(f,p,g){switch(p){case"getConfigBasedTips":return this.service.getConfigBasedTips(P.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=m}),define(we[18],ye([0,1,9,29,5,15,12,4,166,7]),function(ie,e,I,t,y,P,k,S,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function T($){return $.create===!0}e.isFileOpenForWriteOptions=T;var R;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var C;(function($){$[$.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var w;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m($){return!!($.capabilities&2)}e.hasReadWriteCapability=m;function E($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=E;function f($){return!!($.capabilities&32768)}e.hasFileCloneCapability=f;function p($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function g($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=g;function d($){return m($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=d;var l;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(l=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(O,M){super(O);this.code=M}}e.FileSystemProviderError=c;function n($,O){const M=new c($.toString(),O);return i(M,O),M}e.createFileSystemProviderError=n;function o($){return $||n((0,v.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=o;function i($,O){return $.name=O?`${O} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=i;function a($){if(!$)return l.Unknown;if($ instanceof c)return $.code;const O=/^(.+) \(FileSystemError\)$/.exec($.name);if(!O)return l.Unknown;switch(O[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=a;function r($){if($ instanceof B)return $.fileOperationResult;switch(a($)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class u{constructor(O,M,W){this.resource=O,this.operation=M,this.target=W}isOperation(O){return this.operation===O}}e.FileOperationEvent=u;var h;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class b{constructor(O,M){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=O;const W=new Map;for(const J of O){const ae=W.get(J.type);switch(ae?ae.push([J.resource,J]):W.set(J.type,[[J.resource,J]]),J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}}for(const[J,ae]of W)switch(J){case 1:this.added=t.TernarySearchTree.forUris(()=>M),this.added.fill(ae);break;case 0:this.updated=t.TernarySearchTree.forUris(()=>M),this.updated.fill(ae);break;case 2:this.deleted=t.TernarySearchTree.forUris(()=>M),this.deleted.fill(ae);break}}contains(O,...M){return this.doContains(O,{includeChildren:!1},...M)}affects(O,...M){return this.doContains(O,{includeChildren:!0},...M)}doContains(O,M,...W){if(!O)return!1;const J=W.length>0;return!!((!J||W.includes(1))&&(this.added?.get(O)||M.includeChildren&&this.added?.findSuperstr(O))||(!J||W.includes(0))&&(this.updated?.get(O)||M.includeChildren&&this.updated?.findSuperstr(O))||(!J||W.includes(2))&&(this.deleted?.findSubstr(O)||M.includeChildren&&this.deleted?.findSuperstr(O)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=b;function A($,O,M){return!$||!O||$===O||O.length>$.length?!1:(O.charAt(O.length-1)!==y.sep&&(O+=y.sep),M?(0,P.startsWithIgnoreCase)($,O):$.indexOf(O)===0)}e.isParent=A;class B extends I.ErrorNoTelemetry{constructor(O,M,W){super(O);this.fileOperationResult=M,this.options=W}}e.FileOperationError=B;class G extends B{constructor(O,M,W){super(O,2,W);this.stat=M}}e.NotModifiedSinceFileOperationError=G;var Q;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function X($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=X;async function F($,O){if(!O.hasProvider(S.URI.from({scheme:$.scheme})))return new Promise(M=>{const W=O.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===$.scheme&&J.added&&(W.dispose(),M())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(O){return(0,k.isNumber)(O)||(O=0),O<U.KB?(0,v.localize)(1,null,O.toFixed(0)):O<U.MB?(0,v.localize)(2,null,(O/U.KB).toFixed(2)):O<U.GB?(0,v.localize)(3,null,(O/U.MB).toFixed(2)):O<U.TB?(0,v.localize)(4,null,(O/U.GB).toFixed(2)):(0,v.localize)(5,null,(O/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var le;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(le=e.Arch||(e.Arch={}));function j($){return{maxFileSize:$===0?300*U.MB:16*U.GB,maxHeapSize:$===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=j}),define(we[194],ye([0,1,17,36,9,6,2,44,4,23,18]),function(ie,e,I,t,y,P,k,S,v,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class R extends k.Disposable{constructor(w,m){super();this.channel=w,this.extraCapabilities=m,this.onDidChangeCapabilities=P.Event.None,this._onDidChange=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,D.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(w){return this.channel.call("stat",[w])}readdir(w){return this.channel.call("readdir",[w])}async readFile(w,m){const{buffer:E}=await this.channel.call("readFile",[w,m]);return E}readFileStream(w,m,E){const f=(0,S.newWriteableStream)(g=>I.VSBuffer.concat(g.map(d=>I.VSBuffer.wrap(d))).buffer),p=this.channel.listen("readFileStream",[w,m])(g=>{if(g instanceof I.VSBuffer)f.write(g.buffer);else{if(g==="end")f.end();else{let d=g;d instanceof Error||(d=(0,T.createFileSystemProviderError)((0,t.toErrorMessage)(d),T.FileSystemProviderErrorCode.Unknown)),f.error(d),f.end()}p.dispose()}});return E.onCancellationRequested(()=>{f.error((0,y.canceled)()),f.end(),p.dispose()}),f}writeFile(w,m,E){return this.channel.call("writeFile",[w,I.VSBuffer.wrap(m),E])}open(w,m){return this.channel.call("open",[w,m])}close(w){return this.channel.call("close",[w])}async read(w,m,E,f,p){const[g,d]=await this.channel.call("read",[w,m,p]);return E.set(g.buffer.slice(0,d),f),d}write(w,m,E,f,p){return this.channel.call("write",[w,m,I.VSBuffer.wrap(E),f,p])}mkdir(w){return this.channel.call("mkdir",[w])}delete(w,m){return this.channel.call("delete",[w,m])}rename(w,m,E){return this.channel.call("rename",[w,m,E])}copy(w,m,E){return this.channel.call("copy",[w,m,E])}cloneFile(w,m){return this.channel.call("cloneFile",[w,m])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(w=>{if(Array.isArray(w)){const m=w;this._onDidChange.fire(m.map(E=>({resource:v.URI.revive(E.resource),type:E.type})))}else{const m=w;this._onDidWatchError.fire(m)}}))}watch(w,m){const E=(0,D.generateUuid)();return this.channel.call("watch",[this.sessionId,E,w,m]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,E]))}}e.DiskFileSystemProviderClient=R}),define(we[97],ye([0,1,17,9,167,18]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(T,R,C,w,m,E){let f;try{await S(T,R,C,w,m,E)}catch(p){f=p}finally{f&&m.errorTransformer&&(f=m.errorTransformer(f)),typeof f!="undefined"&&C.error(f),C.end()}}e.readFileIntoStream=k;async function S(T,R,C,w,m,E){v(E);const f=await T.open(R,{create:!1});try{v(E);let p=0,g=0,d=m&&typeof m.length=="number"?m.length:void 0,l=I.VSBuffer.alloc(Math.min(m.bufferSize,typeof d=="number"?d:m.bufferSize)),c=m&&typeof m.position=="number"?m.position:0,n=0;do g=await T.read(f,c,l.buffer,n,l.byteLength-n),c+=g,n+=g,p+=g,typeof d=="number"&&(d-=g),n===l.byteLength&&(await C.write(w(l)),l=I.VSBuffer.alloc(Math.min(m.bufferSize,typeof d=="number"?d:m.bufferSize)),n=0);while(g>0&&(typeof d!="number"||d>0)&&v(E)&&D(p,m));if(n>0){let o=n;typeof d=="number"&&(o=Math.min(n,d)),C.write(w(l.slice(0,o)))}}catch(p){throw(0,P.ensureFileSystemProviderError)(p)}finally{await T.close(f)}}function v(T){if(T.isCancellationRequested)throw(0,t.canceled)();return!0}function D(T,R){if(R?.limits){if(typeof R.limits.memory=="number"&&T>R.limits.memory)throw(0,P.createFileSystemProviderError)((0,y.localize)(0,null),P.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof R.limits.size=="number"&&T>R.limits.size)throw(0,P.createFileSystemProviderError)((0,y.localize)(1,null),P.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(we[57],ye([0,1,66,2,5,3,4,18]),function(ie,e,I,t,y,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function v(f){return f.recursive===!0}e.isRecursiveWatchRequest=v;class D extends t.Disposable{constructor(p,g,d,l){super();this.onFileChanges=p,this.onLogMessage=g,this.verboseLogging=d,this.options=l,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const p=new t.DisposableStore;this.watcherDisposables.value=p,this.watcher=this.createWatcher(p),this.watcher.setVerboseLogging(this.verboseLogging),p.add(this.watcher.onDidChangeFile(g=>this.onFileChanges(g))),p.add(this.watcher.onDidLogMessage(g=>this.onLogMessage(g))),p.add(this.watcher.onDidError(g=>this.onError(g)))}onError(p){this.options.restartOnError?this.restartCounter<D.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${p}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${p}`):this.error(p)}restart(p){this.restartCounter++,this.init(),this.watch(p)}async watch(p){this.requests=p,await this.watcher?.watch(p)}async setVerboseLogging(p){this.verboseLogging=p,await this.watcher?.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${p}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=D,D.MAX_RESTARTS=5;class T extends D{constructor(p,g,d){super(p,g,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class R extends D{constructor(p,g,d){super(p,g,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=R;function C(f){return f.map(p=>({type:p.type,resource:k.URI.file(p.path)}))}e.toFileChanges=C;function w(f){const p=new E;for(const g of f)p.processEvent(g);return p.coalesce()}e.coalesceEvents=w;function m(f,p){const g=[];for(const d of p){let l=d;typeof l=="string"&&!l.startsWith(I.GLOBSTAR)&&!(0,y.isAbsolute)(l)&&(l={base:f,pattern:l}),g.push((0,I.parse)(l))}return g}e.parseWatcherPatterns=m;class E{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(p){return P.isLinux?p.path:p.path.toLowerCase()}processEvent(p){const g=this.mapPathToChange.get(this.toKey(p));let d=!1;if(g){const l=g.type,c=p.type;g.path!==p.path&&(p.type===2||p.type===1)?d=!0:l===1&&c===2?(this.mapPathToChange.delete(this.toKey(p)),this.coalesced.delete(g)):l===2&&c===1?g.type=0:l===1&&c===0||(g.type=c)}else d=!0;d&&(this.coalesced.add(p),this.mapPathToChange.set(this.toKey(p),p))}coalesce(){const p=[],g=[];return Array.from(this.coalesced).filter(d=>d.type!==2?(p.push(d),!1):!0).sort((d,l)=>d.path.length-l.path.length).filter(d=>g.some(l=>(0,S.isParent)(d.path,l,!P.isLinux))?!1:(g.push(d.path),!0)).concat(p)}}}),define(we[195],ye([0,1,30,14,20,33,2,83,5,3,142,22,57]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class w extends k.Disposable{constructor(f,p,g,d){super();this.request=f,this.onDidFilesChange=p,this.onLogMessage=g,this.verboseLogging=d,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(w.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,C.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,C.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new y.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const f=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await R.Promises.stat(f);this._register(await this.doWatch(f,p.isDirectory()))}catch(f){f.code!=="ENOENT"?this.error(f):this.trace(f)}}async normalizePath(f){let p=f.path;try{p=await R.Promises.realpath(f.path),f.path===p&&(p=await(0,T.realcase)(f.path)??f.path),f.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${p})`)}catch{}return p}async doWatch(f,p){if(D.isMacintosh&&(0,P.isEqualOrParent)(f,"/Volumes/",!0))return this.error(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const g=new y.CancellationTokenSource(this.cts.token);let d=new k.DisposableStore;try{const l=(0,v.basename)(f),c=(0,I.watch)(f);d.add((0,k.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${f}'`);const n=new Set;if(p)try{for(const i of await R.Promises.readdir(f))n.add(i)}catch(i){this.error(i)}const o=new Map;d.add((0,k.toDisposable)(()=>{for(const[,i]of o)i.dispose();o.clear()})),c.on("error",(i,a)=>{this.error(`Failed to watch ${f} for changes using fs.watch() (${i}, ${a})`),this.dispose()}),c.on("change",(i,a)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${a}`);let r="";if(a&&(r=a.toString(),D.isMacintosh&&(r=(0,S.normalizeNFC)(r))),!(!r||i!=="change"&&i!=="rename"))if(p)if(i==="rename"){o.get(r)?.dispose();const s=setTimeout(async()=>{if(o.delete(r),r===l&&!await R.Promises.exists(f)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,v.join)(f,r));if(g.token.isCancellationRequested)return;let h;u?n.has(r)?h=0:(h=1,n.add(r)):(n.delete(r),h=2),this.onFileChange({path:(0,v.join)(this.request.path,r),type:h})},w.FILE_DELETE_HANDLER_DELAY);o.set(r,(0,k.toDisposable)(()=>clearTimeout(s)))}else{let s;n.has(r)?s=0:(s=1,n.add(r)),this.onFileChange({path:(0,v.join)(this.request.path,r),type:s})}else if(i==="rename"||r!==l){const s=setTimeout(async()=>{const u=await R.Promises.exists(f);g.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),d.add(await this.doWatch(f,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},w.FILE_DELETE_HANDLER_DELAY);d.clear(),d.add((0,k.toDisposable)(()=>clearTimeout(s)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await R.Promises.exists(f)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${f} for changes using fs.watch() (${l.toString()})`)}return(0,k.toDisposable)(()=>{g.dispose(!0),d.dispose()})}async onFileChange(f,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!p&&this.excludes.some(g=>g(f.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${f.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(f.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${f.path}`):this.fileChangesBuffer.push(f);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const d=(0,C.coalesceEvents)(g);if(d.length>0){if(this.verboseLogging)for(const c of d)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(d)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(f){if(D.isLinux)return R.Promises.exists(f);try{const p=(0,v.basename)(f);return(await R.Promises.readdir((0,v.dirname)(f))).some(d=>d===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(f){this.verboseLogging=f}error(f){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}warn(f){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}trace(f){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=w,w.FILE_DELETE_HANDLER_DELAY=100,w.FILE_CHANGES_HANDLER_DELAY=50;async function m(E,f,p,g,d=512){const l=await R.Promises.open(E,"r"),c=Buffer.allocUnsafe(d),n=new y.CancellationTokenSource(g);let o,i=!1;const a={path:E,excludes:[],recursive:!1},r=new w(a,s=>{(async()=>{for(const{type:u}of s)if(u===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:h}=await R.Promises.read(l,c,0,d,null);if(!h||n.token.isCancellationRequested)break;f(c.slice(0,h))}}catch(h){o=new Error(h),n.dispose(!0)}finally{i=!1}}})()});return await r.ready,p(),new Promise((s,u)=>{n.token.onCancellationRequested(async()=>{r.dispose();try{await R.Promises.close(l)}catch(h){o=new Error(h)}o?u(o):s()})})}e.watchFileContents=m}),define(we[196],ye([0,1,6,66,2,3,195]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class S extends y.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new I.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=I.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(D){const T=this.normalizeRequests(D),R=T.filter(w=>{const m=this.watchers.get(w.path);return m?!(0,t.patternsEquals)(m.request.excludes,w.excludes)||!(0,t.patternsEquals)(m.request.includes,w.includes):!0}),C=Array.from(this.watchers.values()).filter(({request:w})=>!T.find(m=>m.path===w.path&&(0,t.patternsEquals)(m.excludes,w.excludes)&&(0,t.patternsEquals)(m.includes,w.includes))).map(({request:w})=>w.path);R.length&&this.trace(`Request to start watching: ${R.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?w.includes:"<all>"})`).join(",")}`),C.length&&this.trace(`Request to stop watching: ${C.join(",")}`);for(const w of C)this.stopWatching(w);for(const w of R)this.startWatching(w)}startWatching(D){const T=new k.NodeJSFileWatcherLibrary(D,C=>this._onDidChangeFile.fire(C),C=>this._onDidLogMessage.fire(C),this.verboseLogging),R={request:D,instance:T};this.watchers.set(D.path,R)}async stop(){for(const[D]of this.watchers)this.stopWatching(D);this.watchers.clear()}stopWatching(D){const T=this.watchers.get(D);T&&(this.watchers.delete(D),T.instance.dispose())}normalizeRequests(D){const T=new Map;for(const R of D){const C=P.isLinux?R.path:R.path.toLowerCase();T.set(C,R)}return Array.from(T.values())}async setVerboseLogging(D){this.verboseLogging=D;for(const[,T]of this.watchers)T.instance.setVerboseLogging(D)}trace(D){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(D)})}toMessage(D,T){return T?`[File Watcher (node.js)] ${D} (path: ${T.request.path})`:`[File Watcher (node.js)] ${D}`}}e.NodeJSWatcher=S}),define(we[197],ye([0,1,57,196]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class y extends I.AbstractNonRecursiveWatcherClient{constructor(k,S,v){super(k,S,v);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=y}),define(we[198],ye([0,1,8,40,94,57]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends P.AbstractUniversalWatcherClient{constructor(v,D,T){super(v,D,T);this.init()}createWatcher(v){const D=v.add(new y.Client(I.FileAccess.asFileUri("bootstrap-fork",ie).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(D.onDidProcessExit(({code:T,signal:R})=>this.onError(`terminated by itself with code ${T}, signal: ${R}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(D.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(we[72],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...y){this._entries=new Map;for(let[P,k]of y)this.set(P,k)}set(y,P){const k=this._entries.get(y);return this._entries.set(y,P),k}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=I}),define(we[98],ye([0,1,14,9,56,190,7,72]),function(ie,e,I,t,y,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class D extends Error{constructor(m){super("cyclic dependency between services");this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class T{constructor(m=new S.ServiceCollection,E=!1,f){this._activeInstantiations=new Set,this._services=m,this._strict=E,this._parent=f,this._services.set(k.IInstantiationService,this)}createChild(m){return new T(m,this._strict,this)}invokeFunction(m,...E){let f=C.traceInvocation(m),p=!1;try{return m({get:d=>{if(p)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(d,f);if(!l)throw new Error(`[invokeFunction] unknown service '${d}'`);return l}},...E)}finally{p=!0,f.stop()}}createInstance(m,...E){let f,p;return m instanceof y.SyncDescriptor?(f=C.traceCreation(m.ctor),p=this._createInstance(m.ctor,m.staticArguments.concat(E),f)):(f=C.traceCreation(m),p=this._createInstance(m,E,f)),f.stop(),p}_createInstance(m,E=[],f){let p=k._util.getServiceDependencies(m).sort((l,c)=>l.index-c.index),g=[];for(const l of p){let c=this._getOrCreateServiceInstance(l.id,f);c||this._throwIfStrict(`[createInstance] ${m.name} depends on UNKNOWN service ${l.id}.`,!1),g.push(c)}let d=p.length>0?p[0].index:E.length;if(E.length!==d){console.trace(`[createInstance] First service dependency of ${m.name} at position ${d+1} conflicts with ${E.length} static arguments`);let l=d-E.length;l>0?E=E.concat(new Array(l)):E=E.slice(0,d)}return new m(...[...E,...g])}_setServiceInstance(m,E){if(this._services.get(m)instanceof y.SyncDescriptor)this._services.set(m,E);else if(this._parent)this._parent._setServiceInstance(m,E);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(m){let E=this._services.get(m);return!E&&this._parent?this._parent._getServiceInstanceOrDescriptor(m):E}_getOrCreateServiceInstance(m,E){let f=this._getServiceInstanceOrDescriptor(m);return f instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(m,f,E.branch(m,!0)):(E.branch(m,!1),f)}_safeCreateAndCacheServiceInstance(m,E,f){if(this._activeInstantiations.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this._activeInstantiations.add(m);try{return this._createAndCacheServiceInstance(m,E,f)}finally{this._activeInstantiations.delete(m)}}_createAndCacheServiceInstance(m,E,f){const p=new P.Graph(l=>l.id.toString());let g=0;const d=[{id:m,desc:E,_trace:f}];for(;d.length;){const l=d.pop();if(p.lookupOrInsertNode(l),g++>1e3)throw new D(p);for(let c of k._util.getServiceDependencies(l.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(c.id);if(n||this._throwIfStrict(`[createInstance] ${m} depends on ${c.id} which is NOT registered.`,!0),n instanceof y.SyncDescriptor){const o={id:c.id,desc:n,_trace:l._trace.branch(c.id,!0)};p.insertEdge(l,o),d.push(o)}}}for(;;){const l=p.roots();if(l.length===0){if(!p.isEmpty())throw new D(p);break}for(const{data:c}of l){if(this._getServiceInstanceOrDescriptor(c.id)instanceof y.SyncDescriptor){const o=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,o)}p.removeNode(c)}}return this._getServiceInstanceOrDescriptor(m)}_createServiceInstanceWithOwner(m,E,f=[],p,g){if(this._services.get(m)instanceof y.SyncDescriptor)return this._createServiceInstance(E,f,p,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(m,E,f,p,g);throw new Error(`illegalState - creating UNKNOWN service instance ${E.name}`)}_createServiceInstance(m,E=[],f,p){if(f){const g=new I.IdleValue(()=>this._createInstance(m,E,p));return new Proxy(Object.create(null),{get(d,l){if(l in d)return d[l];let c=g.value,n=c[l];return typeof n!="function"||(n=n.bind(c),d[l]=n),n},set(d,l,c){return g.value[l]=c,!0}})}else return this._createInstance(m,E,p)}_throwIfStrict(m,E){if(E&&console.warn(E),this._strict)throw new Error(m)}}e.InstantiationService=T;var R;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(R||(R={}));class C{constructor(m,E){this.type=m,this.name=E,this._start=Date.now(),this._dep=[]}static traceInvocation(m){return v?new C(1,m.name||m.toString().substring(0,42).replace(/\n/g,"")):C._None}static traceCreation(m){return v?new C(0,m.name):C._None}branch(m,E){let f=new C(2,m.toString());return this._dep.push([m,E,f]),f}stop(){let m=Date.now()-this._start;C._totals+=m;let E=!1;function f(g,d){let l=[],c=new Array(g+1).join("	");for(const[n,o,i]of d._dep)if(o&&i){E=!0,l.push(`${c}CREATES -> ${n}`);let a=f(g+1,i);a&&l.push(a)}else l.push(`${c}uses -> ${n}`);return l.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${C._totals.toFixed(2)}ms)`];(m>2||E)&&console.log(p.join(`
`))}}e.Trace=C,C._None=new class extends C{constructor(){super(-1,null)}stop(){}branch(){return this}},C._totals=0}),define(we[199],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,I.createDecorator)("labelService")});var Oe=this&&this.__param||function(ie,e){return function(I,t){e(I,t,ie)}};define(we[73],ye([0,1,20,2,3,169,31,7]),function(ie,e,I,t,y,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,S.createDecorator)("languagePackService");let v=class extends t.Disposable{constructor(T){super();this.extensionGalleryService=T}async getAvailableLanguages(){const T=new I.CancellationTokenSource;setTimeout(()=>T.cancel(),1e3);let R;try{R=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},T.token)}catch{return[]}const w=R.firstPage.filter(m=>m.properties.localizedLanguages?.length&&m.tags.some(E=>E.startsWith("lp-"))).map(m=>{const E=m.properties.localizedLanguages?.[0],f=m.tags.find(g=>g.startsWith("lp-")).split("lp-")[1];return{...this.createQuickPickItem({locale:f,label:E}),extensionId:m.identifier.id,galleryExtension:m}});return w.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),w}createQuickPickItem(T){const R=T.label??T.locale;let C=T.locale!==T.label?T.locale:void 0;return T.locale.toLowerCase()===y.language.toLowerCase()&&(C||(C=""),C+=(0,P.localize)(0,null)),{id:T.locale,label:R,description:C}}};v=Re([Oe(0,k.IExtensionGalleryService)],v),e.LanguagePackBaseService=v}),define(we[13],ye([0,1,36,6,2,3,7]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function S(){return new Date().toISOString()}var v;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function D(o,i,a){switch(i){case v.Trace:o.trace(a);break;case v.Debug:o.debug(a);break;case v.Info:o.info(a);break;case v.Warning:o.warn(a);break;case v.Error:o.error(a);break;case v.Critical:o.critical(a);break;default:throw new Error("Invalid log level")}}e.log=D;function T(o){let i="";for(let a=0;a<o.length;a++){let r=o[a];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}i+=(a>0?" ":"")+r}return i}e.format=T;class R extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=R;class C extends R{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...a){this.checkLogLevel(v.Trace)&&this.log(v.Trace,T([i,...a]))}debug(i,...a){this.checkLogLevel(v.Debug)&&this.log(v.Debug,T([i,...a]))}info(i,...a){this.checkLogLevel(v.Info)&&this.log(v.Info,T([i,...a]))}warn(i,...a){this.checkLogLevel(v.Warning)&&this.log(v.Warning,T([i,...a]))}error(i,...a){if(this.checkLogLevel(v.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(v.Error,T(r))}else this.log(v.Error,T([i,...a]))}critical(i,...a){this.checkLogLevel(v.Critical)&&this.log(v.Critical,T([i,...a]))}flush(){}}e.AbstractMessageLogger=C;class w extends R{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!P.isWindows}trace(i,...a){this.getLevel()<=v.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,i,...a):console.log(`[main ${S()}]`,i,...a))}debug(i,...a){this.getLevel()<=v.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,i,...a):console.log(`[main ${S()}]`,i,...a))}info(i,...a){this.getLevel()<=v.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,i,...a):console.log(`[main ${S()}]`,i,...a))}warn(i,...a){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,i,...a):console.warn(`[main ${S()}]`,i,...a))}error(i,...a){this.getLevel()<=v.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,i,...a):console.error(`[main ${S()}]`,i,...a))}critical(i,...a){this.getLevel()<=v.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,i,...a):console.error(`[main ${S()}]`,i,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class m extends R{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...a){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",i,...a)}debug(i,...a){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...a)}info(i,...a){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",i,...a)}warn(i,...a){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",i,...a)}error(i,...a){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",i,...a)}critical(i,...a){this.getLevel()<=v.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...a)}dispose(){}flush(){}}e.ConsoleLogger=m;class E extends R{constructor(i,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(a)}trace(i,...a){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(i),...a])}debug(i,...a){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(i),...a])}info(i,...a){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(i),...a])}warn(i,...a){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(i),...a])}error(i,...a){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(i),...a])}critical(i,...a){this.getLevel()<=v.Critical&&this.adapter.log(v.Critical,[this.extractMessage(i),...a])}extractMessage(i){return typeof i=="string"?i:(0,I.toErrorMessage)(i,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class f extends R{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const a of this.logServices)a.setLevel(i);super.setLevel(i)}trace(i,...a){for(const r of this.logServices)r.trace(i,...a)}debug(i,...a){for(const r of this.logServices)r.debug(i,...a)}info(i,...a){for(const r of this.logServices)r.info(i,...a)}warn(i,...a){for(const r of this.logServices)r.warn(i,...a)}error(i,...a){for(const r of this.logServices)r.error(i,...a)}critical(i,...a){for(const r of this.logServices)r.critical(i,...a)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=f;class p extends y.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...a){this.logger.trace(i,...a)}debug(i,...a){this.logger.debug(i,...a)}info(i,...a){this.logger.info(i,...a)}warn(i,...a){this.logger.warn(i,...a)}error(i,...a){this.logger.error(i,...a)}critical(i,...a){this.logger.critical(i,...a)}flush(){this.logger.flush()}}e.LogService=p;class g extends y.Disposable{constructor(i,a){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,a){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,a?.always?v.Trace:this.logLevel,a),this.loggers.set(i.toString(),r),a?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class d{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return v.Info}trace(i,...a){}debug(i,...a){}info(i,...a){}warn(i,...a){}error(i,...a){}critical(i,...a){}dispose(){}flush(){}}e.NullLogService=d;function l(o){if(o.verbose)return v.Trace;if(typeof o.logLevel=="string"){const i=c(o.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function c(o){switch(o){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Critical;case"off":return v.Off}}e.parseLogLevel=c;function n(o){switch(o){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Critical:return"critical";case v.Off:return"off"}}e.LogLevelToString=n}),define(we[200],ye([0,1,70,6,2,13,3]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let S=class $t extends y.Disposable{constructor(D){super();this.logService=D,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(D,T){let R;try{R=await this.withKeytar()}catch{return null}const C=await R.getPassword(D,T);if(C)try{let{content:w,hasNextChunk:m}=JSON.parse(C);if(!w||!m)return C;let E=1;for(;m;){const f=await R.getPassword(D,`${T}-${E}`),p=JSON.parse(f);w+=p.content,m=p.hasNextChunk,E++}return w}catch{return C}return C}async setPassword(D,T,R){let C;try{C=await this.withKeytar()}catch(E){throw this.surfaceKeytarLoadError?.(E),E}const w=3,m=async(E,f,p)=>{let g=0,d;for(;g<w;)try{await C.setPassword(E,f,p);return}catch(l){d=l,this.logService.warn("Error attempting to set a password: ",l?.message??l),g++,await new Promise(c=>setTimeout(c,200))}throw d};if(k.isWindows&&R.length>$t.MAX_PASSWORD_LENGTH){let E=0,f=0,p=!0;for(;p;){const g=R.substring(E,E+$t.PASSWORD_CHUNK_SIZE);E+=$t.PASSWORD_CHUNK_SIZE,p=R.length-E>0;const d={content:g,hasNextChunk:p};await m(D,f?`${T}-${f}`:T,JSON.stringify(d)),f++}}else await m(D,T,R);this._onDidChangePassword.fire({service:D,account:T})}async deletePassword(D,T){let R;try{R=await this.withKeytar()}catch(m){throw this.surfaceKeytarLoadError?.(m),m}const C=await R.getPassword(D,T);if(!C)return!1;const w=await R.deletePassword(D,T);try{let{content:m,hasNextChunk:E}=JSON.parse(C);if(m&&E){let f=1;for(;E;){const p=`${T}-${f}`,g=await R.getPassword(D,p);await R.deletePassword(D,p),E=JSON.parse(g).hasNextChunk,f++}}}catch{}return w&&this._onDidChangePassword.fire({service:D,account:T}),w}async findPassword(D){let T;try{T=await this.withKeytar()}catch{return null}return T.findPassword(D)}async findCredentials(D){let T;try{T=await this.withKeytar()}catch{return[]}return T.findCredentials(D)}clear(){return this._keytarCache instanceof I.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};S.MAX_PASSWORD_LENGTH=2500,S.PASSWORD_CHUNK_SIZE=S.MAX_PASSWORD_LENGTH-100,S=Re([Oe(0,P.ILogService)],S),e.BaseCredentialsMainService=S}),define(we[201],ye([0,1,39,14,36,6,2,8,5,22,28,13]),function(ie,e,I,t,y,P,k,S,v,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let C=class extends k.Disposable{constructor(m,E){super();this.environmentService=m,this.logService=E,this.processesLimiter=new t.Limiter(5)}async postUninstall(m){const E=this.parseScript(m,"uninstall");return E&&(this.logService.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(E.script,"uninstall",E.args,!0,m).then(()=>this.logService.info(m.identifier.id,m.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(m.identifier.id,m.manifest.version,`Failed to run post uninstall script: ${f}`)))),D.Promises.rm(this.getExtensionStoragePath(m)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(m,E){const f=`vscode:${E}`;if(m.location.scheme===S.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[f]=="string"){const p=m.manifest.scripts[f].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(m.identifier.id,m.manifest.version,`${f} should be a node script`),null):{script:(0,v.join)(m.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(m,E,f,p,g){return new Promise((d,l)=>{const c=this.start(m,E,f,g);let n;const o=i=>{n&&(clearTimeout(n),n=null),i?l(i):d(void 0)};c.on("error",i=>{o((0,y.toErrorMessage)(i)||"Unknown")}),c.on("exit",(i,a)=>{o(i?`post-${E} process exited with code ${i}`:void 0)}),p&&(n=setTimeout(()=>{n=null,c.kill(),l("timed out")},5e3))})}start(m,E,f,p){const g={silent:!0,execArgv:void 0},d=(0,I.fork)(m,[`--type=extension-post-${E}`,...f],g);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const l=P.Event.fromNodeEventEmitter(d.stdout,"data"),c=P.Event.fromNodeEventEmitter(d.stderr,"data");l(i=>this.logService.info(p.identifier.id,p.manifest.version,`post-${E}`,i)),c(i=>this.logService.error(p.identifier.id,p.manifest.version,`post-${E}`,i));const n=P.Event.any(P.Event.map(l,i=>({data:`%c${i}`,format:[""]})),P.Event.map(c,i=>({data:`%c${i}`,format:["color: red"]})));return P.Event.debounce(n,(i,a)=>i?{data:i.data+a.data,format:[...i.format,...a.format]}:{data:a.data,format:a.format},100)(i=>{console.group(p.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),d}getExtensionStoragePath(m){return(0,v.join)(this.environmentService.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};C=Re([Oe(0,T.IEnvironmentService),Oe(1,R.ILogService)],C),e.ExtensionsLifecycle=C}),define(we[202],ye([0,1,16,14,9,6,2,5,57,13]),function(ie,e,I,t,y,P,k,S,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends k.Disposable{constructor(C,w){super();this.logService=C,this.options=w,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(C,w){return w.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(C,w):this.watchNonRecursive(C,w)}watchUniversal(C,w){const m={path:this.toFilePath(C),excludes:w.excludes,includes:w.includes,recursive:w.recursive},E=(0,I.insert)(this.universalPathsToWatch,m);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(C=>(0,y.onUnexpectedError)(C))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(w=>this._onDidChangeFile.fire((0,v.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===D.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)})));const C=this.options?.watcher?.recursive?.usePolling;if(C===!0)for(const w of this.universalPathsToWatch)(0,v.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(C))for(const w of this.universalPathsToWatch)(0,v.isRecursiveWatchRequest)(w)&&C.includes(w.path)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(C,w){const m={path:this.toFilePath(C),excludes:w.excludes,includes:w.includes,recursive:!1},E=(0,I.insert)(this.nonRecursivePathsToWatch,m);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(C=>(0,y.onUnexpectedError)(C))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(C=>this._onDidChangeFile.fire((0,v.toFileChanges)(C)),C=>this.onWatcherLogMessage(C),this.logService.getLevel()===D.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(C){C.type==="error"&&this._onDidWatchError.fire(C.message),this.logService[C.type](C.message)}toFilePath(C){return(0,S.normalize)(C.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(we[99],ye([0,1,16,14,17,20,6,136,43,2,29,8,46,19,44,165,18,97,13]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let d=class extends D.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,n){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${c}`);const o=new D.DisposableStore;return this.provider.set(c,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:n}),o.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new f.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&o.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),o.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:c}))),(0,D.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:n}),this.provider.delete(c),(0,D.dispose)(o)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(o){n.push(o)}}),!this.provider.has(c)&&await t.Promises.settled(n)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,n){const o=this.provider.get(c.scheme);return!!(o&&o.capabilities&n)}listCapabilities(){return v.Iterable.map(this.provider,([c,n])=>({scheme:c,capabilities:n.capabilities}))}async withProvider(c){if(!(0,w.isAbsolutePath)(c))throw new f.FileOperationError((0,E.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const n=this.provider.get(c.scheme);if(!n){const o=new Error;throw o.name="ENOPRO",o.message=(0,E.localize)(1,null,c.toString()),o}return n}async withReadProvider(c){const n=await this.withProvider(c);if((0,f.hasOpenReadWriteCloseCapability)(n)||(0,f.hasReadWriteCapability)(n)||(0,f.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const n=await this.withProvider(c);if((0,f.hasOpenReadWriteCloseCapability)(n)||(0,f.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,n){try{return await this.doResolveFile(c,n)}catch(o){throw(0,f.toFileSystemProviderErrorCode)(o)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,E.localize)(2,null,this.resourceForError(c)),1):(0,f.ensureFileSystemProviderError)(o)}}async doResolveFile(c,n){const o=await this.withProvider(c),i=this.isPathCaseSensitive(o),a=n?.resolveTo,r=n?.resolveSingleChildDescendants,s=n?.resolveMetadata,u=await o.stat(c);let h;return this.toFileStat(o,c,u,void 0,!!s,(b,A)=>(h||(h=T.TernarySearchTree.forUris(()=>!i),h.set(c,!0),a&&h.fill(!0,a)),h.get(b.resource)||h.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&r?A===1:!1))}async toFileStat(c,n,o,i,a,r){const{providerExtUri:s}=this.getExtUri(c),u={resource:n,name:s.basename(n),isFile:(o.type&f.FileType.File)!=0,isDirectory:(o.type&f.FileType.Directory)!=0,isSymbolicLink:(o.type&f.FileType.SymbolicLink)!=0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&f.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,f.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(u.isDirectory&&r(u,i)){try{const h=await c.readdir(n),b=await t.Promises.settled(h.map(async([A,B])=>{try{const G=s.joinPath(n,A),Q=a?await c.stat(G):{type:B};return await this.toFileStat(c,G,Q,h.length,a,r)}catch(G){return this.logService.trace(G),null}}));u.children=(0,I.coalesce)(b)}catch(h){this.logService.trace(h),u.children=[]}return u}return u}async resolveAll(c){return t.Promises.settled(c.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(c){const n=await this.withProvider(c),o=await n.stat(c);return this.toFileStat(n,c,o,void 0,!0,()=>!1)}async exists(c){const n=await this.withProvider(c);try{return!!await n.stat(c)}catch{return!1}}async canCreateFile(c,n){try{await this.doValidateCreateFile(c,n)}catch(o){return o}return!0}async doValidateCreateFile(c,n){if(!n?.overwrite&&await this.exists(c))throw new f.FileOperationError((0,E.localize)(3,null,this.resourceForError(c)),3,n)}async createFile(c,n=y.VSBuffer.fromString(""),o){await this.doValidateCreateFile(c,o);const i=await this.writeFile(c,n);return this._onDidRunOperation.fire(new f.FileOperationEvent(c,0,i)),i}async writeFile(c,n,o){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:a}=this.getExtUri(i);try{await this.validateWriteFile(i,c,o)||await this.mkdirp(i,a.dirname(c));let s;if((0,f.hasReadWriteCapability)(i)&&!(n instanceof y.VSBuffer))if((0,m.isReadableStream)(n)){const u=await(0,m.peekStream)(n,3);u.ended?s=y.VSBuffer.concat(u.buffer):s=u}else s=(0,m.peekReadable)(n,u=>y.VSBuffer.concat(u),3);else s=n;!(0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasReadWriteCapability)(i)&&s instanceof y.VSBuffer?await this.doWriteUnbuffered(i,c,o,s):await this.doWriteBuffered(i,c,o,s instanceof y.VSBuffer?(0,y.bufferToReadable)(s):s),this._onDidRunOperation.fire(new f.FileOperationEvent(c,4))}catch(r){throw new f.FileOperationError((0,E.localize)(4,null,this.resourceForError(c),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),o)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,n,o){if(!!o?.unlock&&!(c.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(n)));let a;try{a=await c.stat(n)}catch{return}if((a.type&f.FileType.Directory)!=0)throw new f.FileOperationError((0,E.localize)(6,null,this.resourceForError(n)),0,o);if(this.throwIfFileIsReadonly(n,a),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==f.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&o.mtime<a.mtime&&o.etag!==(0,f.etag)({mtime:o.mtime,size:a.size}))throw new f.FileOperationError((0,E.localize)(7,null),3,o);return a}async readFile(c,n,o){const i=await this.withReadProvider(c);return n?.atomic?this.doReadFileAtomic(i,c,n,o):this.doReadFile(i,c,n,o)}async doReadFileAtomic(c,n,o,i){return new Promise((a,r)=>{this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(c,n,o,i);a(s)}catch(s){r(s)}})})}async doReadFile(c,n,o,i){const a=await this.doReadFileStream(c,n,{...o,preferUnbuffered:!0},i);return{...a,value:await(0,y.streamToBuffer)(a.value)}}async readFileStream(c,n,o){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,n,o)}async doReadFileStream(c,n,o,i){const a=new P.CancellationTokenSource(i),r=this.validateReadFile(n,o).then(u=>u,u=>{throw a.cancel(),u});let s;try{return typeof o?.etag=="string"&&o.etag!==f.ETAG_DISABLED&&await r,o?.atomic&&(0,f.hasFileAtomicReadCapability)(c)||!((0,f.hasOpenReadWriteCloseCapability)(c)||(0,f.hasFileReadStreamCapability)(c))||(0,f.hasReadWriteCapability)(c)&&o?.preferUnbuffered?s=this.readFileUnbuffered(c,n,o):(0,f.hasFileReadStreamCapability)(c)?s=this.readFileStreamed(c,n,a.token,o):s=this.readFileBuffered(c,n,a.token,o),{...await r,value:s}}catch(u){s&&await(0,m.consumeStream)(s);const h=(0,E.localize)(8,null,this.resourceForError(n),(0,f.ensureFileSystemProviderError)(u).toString());throw u instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(h,u.stat,o):new f.FileOperationError(h,(0,f.toFileOperationResult)(u),o)}}readFileStreamed(c,n,o,i=Object.create(null)){const a=c.readFileStream(n,i,o);return(0,m.transform)(a,{data:r=>r instanceof y.VSBuffer?r:y.VSBuffer.wrap(r),error:r=>new f.FileOperationError((0,E.localize)(9,null,this.resourceForError(n),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),i)},r=>y.VSBuffer.concat(r))}readFileBuffered(c,n,o,i=Object.create(null)){const a=(0,y.newWriteableBufferStream)();return(0,p.readFileIntoStream)(c,n,a,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new f.FileOperationError((0,E.localize)(10,null,this.resourceForError(n),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),i)},o),a}readFileUnbuffered(c,n,o){const i=(0,m.newWriteableStream)(a=>y.VSBuffer.concat(a));return(async()=>{try{let a;o?.atomic&&(0,f.hasFileAtomicReadCapability)(c)?a=await c.readFile(n,{atomic:!0}):a=await c.readFile(n),typeof o?.position=="number"&&(a=a.slice(o.position)),typeof o?.length=="number"&&(a=a.slice(0,o.length)),this.validateReadFileLimits(n,a.byteLength,o),i.end(y.VSBuffer.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async validateReadFile(c,n){const o=await this.resolve(c,{resolveMetadata:!0});if(o.isDirectory)throw new f.FileOperationError((0,E.localize)(11,null,this.resourceForError(c)),0,n);if(typeof n?.etag=="string"&&n.etag!==f.ETAG_DISABLED&&n.etag===o.etag)throw new f.NotModifiedSinceFileOperationError((0,E.localize)(12,null),o,n);return this.validateReadFileLimits(c,o.size,n),o}validateReadFileLimits(c,n,o){if(o?.limits){let i;if(typeof o.limits.memory=="number"&&n>o.limits.memory&&(i=9),typeof o.limits.size=="number"&&n>o.limits.size&&(i=7),typeof i=="number")throw new f.FileOperationError((0,E.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,n,o){return this.doCanMoveCopy(c,n,"move",o)}async canCopy(c,n,o){return this.doCanMoveCopy(c,n,"copy",o)}async doCanMoveCopy(c,n,o,i){if(c.toString()!==n.toString())try{const a=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(a,c,r,n,o,i)}catch(a){return a}return!0}async move(c,n,o){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),r=await this.doMoveCopy(i,c,a,n,"move",!!o),s=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(c,r==="move"?2:3,s)),s}async copy(c,n,o){const i=await this.withReadProvider(c),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),r=await this.doMoveCopy(i,c,a,n,"copy",!!o),s=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(c,r==="copy"?3:2,s)),s}async doMoveCopy(c,n,o,i,a,r){if(n.toString()===i.toString())return a;const{exists:s,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(c,n,o,i,a,r);if(s&&!u&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(i)),a==="copy"){if(c===o&&(0,f.hasFileFolderCopyCapability)(c))await c.copy(n,i,{overwrite:r});else{const h=await this.resolve(n);h.isDirectory?await this.doCopyFolder(c,h,o,i):await this.doCopyFile(c,n,o,i)}return a}else return c===o?(await c.rename(n,i,{overwrite:r}),a):(await this.doMoveCopy(c,n,o,i,"copy",r),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(c,n,o,i){if((0,f.hasOpenReadWriteCloseCapability)(c)&&(0,f.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(c,n,o,i);if((0,f.hasOpenReadWriteCloseCapability)(c)&&(0,f.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(c,n,o,i);if((0,f.hasReadWriteCapability)(c)&&(0,f.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(c,n,o,i);if((0,f.hasReadWriteCapability)(c)&&(0,f.hasReadWriteCapability)(o))return this.doPipeUnbuffered(c,n,o,i)}async doCopyFolder(c,n,o,i){await o.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async a=>{const r=this.getExtUri(o).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.doCopyFolder(c,await this.resolve(a.resource),o,r):this.doCopyFile(c,a.resource,o,r)}))}async doValidateMoveCopy(c,n,o,i,a,r){let s=!1;if(c===o){const{providerExtUri:h,isPathCaseSensitive:b}=this.getExtUri(c);if(b||(s=h.isEqual(n,i)),s&&a==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!s&&h.isEqualOrParent(i,n))throw new Error((0,E.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const u=await this.exists(i);if(u&&!s){if(!r)throw new f.FileOperationError((0,E.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(c===o){const{providerExtUri:h}=this.getExtUri(c);if(h.isEqualOrParent(n,i))throw new Error((0,E.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:u,isSameResourceWithDifferentPathCase:s}}getExtUri(c){const n=this.isPathCaseSensitive(c);return{providerExtUri:n?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(n,c);const o=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(c,0,o)),o}async mkdirp(c,n){const o=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(n,i.dirname(n));)try{if(((await c.stat(n)).type&f.FileType.Directory)==0)throw new Error((0,E.localize)(18,null,this.resourceForError(n)));break}catch(a){if((0,f.toFileSystemProviderErrorCode)(a)!==f.FileSystemProviderErrorCode.FileNotFound)throw a;o.push(i.basename(n)),n=i.dirname(n)}for(let a=o.length-1;a>=0;a--){n=i.joinPath(n,o[a]);try{await c.mkdir(n)}catch(r){if((0,f.toFileSystemProviderErrorCode)(r)!==f.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,n){try{await this.doValidateDelete(c,n)}catch(o){return o}return!0}async doValidateDelete(c,n){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!n?.useTrash&&!(o.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(c)));let a;try{a=await o.stat(c)}catch{}if(a)this.throwIfFileIsReadonly(c,a);else throw new f.FileOperationError((0,E.localize)(20,null,this.resourceForError(c)),1);if(!!!n?.recursive){const s=await this.resolve(c);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,E.localize)(21,null,this.resourceForError(c)))}return o}async del(c,n){const o=await this.doValidateDelete(c,n),i=!!n?.useTrash,a=!!n?.recursive;await o.delete(c,{recursive:a,useTrash:i}),this._onDidRunOperation.fire(new f.FileOperationEvent(c,1))}async cloneFile(c,n){const o=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(o===i&&this.getExtUri(o).providerExtUri.isEqual(c,n))return;if(o===i&&(0,f.hasFileCloneCapability)(o))return o.cloneFile(c,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const a=this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri);return o===i&&(0,f.hasFileFolderCopyCapability)(o)?a.queue(()=>o.copy(c,n,{overwrite:!0})):a.queue(()=>this.doCopyFile(o,c,i,n))}watch(c,n={recursive:!1,excludes:[]}){const o=new D.DisposableStore;let i=!1,a=()=>{i=!0};return o.add((0,D.toDisposable)(()=>a())),(async()=>{try{const r=await this.doWatch(c,n);i?(0,D.dispose)(r):a=()=>(0,D.dispose)(r)}catch(r){this.logService.error(r)}})(),o}async doWatch(c,n){const o=await this.withProvider(c),i=(0,S.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(c),n]);let a=this.activeWatchers.get(i);return a||(a={count:0,disposable:o.watch(c,n)},this.activeWatchers.set(i,a)),a.count+=1,(0,D.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,D.dispose)(a.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,D.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,n,o,i){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{const a=await c.open(n,{create:!0,unlock:o?.unlock??!1});try{(0,m.isReadableStream)(i)||(0,m.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,a,i):await this.doWriteReadableBufferedQueued(c,a,i)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await c.close(a)}})}async doWriteStreamBufferedQueued(c,n,o){let i=0,a;if((0,m.isReadableBufferedStream)(o)){if(o.buffer.length>0){const r=y.VSBuffer.concat(o.buffer);await this.doWriteBuffer(c,n,r,r.byteLength,i,0),i+=r.byteLength}if(o.ended)return;a=o.stream}else a=o;return new Promise((r,s)=>{(0,m.listenStream)(a,{onData:async u=>{a.pause();try{await this.doWriteBuffer(c,n,u,u.byteLength,i,0)}catch(h){return s(h)}i+=u.byteLength,setTimeout(()=>a.resume())},onError:u=>s(u),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,n,o){let i=0,a;for(;(a=o.read())!==null;)await this.doWriteBuffer(c,n,a,a.byteLength,i,0),i+=a.byteLength}async doWriteBuffer(c,n,o,i,a,r){let s=0;for(;s<i;)s+=await c.write(n,a+s,o.buffer,r+s,i-s)}async doWriteUnbuffered(c,n,o,i){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,n,o,i))}async doWriteUnbufferedQueued(c,n,o,i){let a;i instanceof y.VSBuffer?a=i:(0,m.isReadableStream)(i)?a=await(0,y.streamToBuffer)(i):(0,m.isReadableBufferedStream)(i)?a=await(0,y.bufferedStreamToBuffer)(i):a=(0,y.readableToBuffer)(i),await c.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(c,n,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,n,o,i))}async doPipeBufferedQueued(c,n,o,i){let a,r;try{a=await c.open(n,{create:!1}),r=await o.open(i,{create:!0,unlock:!1});const s=y.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,h=0,b=0;do b=await c.read(a,u,s.buffer,h,s.byteLength-h),await this.doWriteBuffer(o,r,s,b,u,h),u+=b,h+=b,h===s.byteLength&&(h=0);while(b>0)}catch(s){throw(0,f.ensureFileSystemProviderError)(s)}finally{await t.Promises.settled([typeof a=="number"?c.close(a):Promise.resolve(),typeof r=="number"?o.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,n,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,n,o,i))}async doPipeUnbufferedQueued(c,n,o,i){return o.writeFile(i,await c.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,n,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,n,o,i))}async doPipeUnbufferedToBufferedQueued(c,n,o,i){const a=await o.open(i,{create:!0,unlock:!1});try{const r=await c.readFile(n);await this.doWriteBuffer(o,a,y.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await o.close(a)}}async doPipeBufferedToUnbuffered(c,n,o,i){const a=await(0,y.streamToBuffer)(this.readFileBuffered(c,n,P.CancellationToken.None));await this.doWriteUnbuffered(o,i,void 0,a)}throwIfFileSystemIsReadonly(c,n){if(c.capabilities&2048)throw new f.FileOperationError((0,E.localize)(22,null,this.resourceForError(n)),6);return c}throwIfFileIsReadonly(c,n){if((n.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,E.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===R.Schemas.file?c.fsPath:c.toString(!0)}};d=Re([Oe(0,g.ILogService)],d),e.FileService=d}),define(we[58],ye([0,1,30,266,14,29,17,6,33,2,5,3,19,44,22,168,18,97,202,36,198,197]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f,p,g,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(I)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(o)}`)}})();class n extends g.AbstractDiskFileSystemProvider{constructor(i,a){super(i,a);this.onDidChangeCapabilities=S.Event.None,this.resourceLocks=new P.ResourceMap(r=>C.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:a,symbolicLink:r}=await m.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(a,r),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(i){try{const a=await m.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(a.map(async s=>{try{let u;s.isSymbolicLink()?u=(await this.stat((0,C.joinPath)(i,s.name))).type:u=this.toType(s),r.push([s.name,u])}catch(u){this.logService.trace(u)}})),r}catch(a){throw this.toFileSystemProviderError(a)}}toType(i,a){let r;return a?.dangling?r=f.FileType.Unknown:i.isFile()?r=f.FileType.File:i.isDirectory()?r=f.FileType.Directory:r=f.FileType.Unknown,a&&(r|=f.FileType.SymbolicLink),r}async createResourceLock(i){const a=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let r;for(;r=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await r.wait();const s=new y.Barrier;return this.resourceLocks.set(i,s),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,D.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.resourceLocks.get(i)===s&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),s.open()})}async readFile(i,a){let r;try{a?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),r=await this.createResourceLock(i));const s=this.toFilePath(i);return await m.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{r?.dispose()}}readFileStream(i,a,r){const s=(0,w.newWriteableStream)(u=>k.VSBuffer.concat(u.map(h=>k.VSBuffer.wrap(h))).buffer);return(0,p.readFileIntoStream)(this,i,s,u=>u.buffer,{...a,bufferSize:256*1024},r),s}async writeFile(i,a,r){let s;try{const u=this.toFilePath(i);if(!r.create||!r.overwrite){if(await m.Promises.exists(u)){if(!r.overwrite)throw(0,f.createFileSystemProviderError)((0,E.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,f.createFileSystemProviderError)((0,E.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(s,0,a,0,a.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(i,u)}finally{typeof s=="number"&&await this.close(s)}}async open(i,a){const r=this.toFilePath(i);let s;(0,f.isFileOpenForWriteOptions)(a)&&(s=await this.createResourceLock(i));let u;try{if((0,f.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:b}=await m.SymlinkSupport.stat(r);b.mode&128||await m.Promises.chmod(r,b.mode|128)}catch(b){this.logService.trace(b)}let h;if((0,f.isFileOpenForWriteOptions)(a)){if(R.isWindows)try{await m.Promises.truncate(r,0),h="r+"}catch(b){b.code!=="ENOENT"&&this.logService.trace(b)}h||(h="w")}else h="r";u=await m.Promises.open(r,h)}catch(h){throw s?.dispose(),(0,f.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(i,h):this.toFileSystemProviderError(h)}if(this.mapHandleToPos.set(u,0),(0,f.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(u,i),s){const h=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${r})`),this.mapHandleToLock.set(u,s),h&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${r})`),h.dispose())}return u}async close(i){const a=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await m.Promises.fdatasync(i)}catch(r){this.canFlush=!1,this.logService.error(r)}return await m.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}finally{a&&(this.mapHandleToLock.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),a.dispose())}}async read(i,a,r,s,u){const h=this.normalizePos(i,a);let b=null;try{b=(await m.Promises.read(i,r,s,u,h)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(i,h,b)}return b}normalizePos(i,a){return a===this.mapHandleToPos.get(i)?null:a}updatePos(i,a,r){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof a=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,s+r):this.mapHandleToPos.delete(i)))}async write(i,a,r,s,u){return(0,y.retry)(()=>this.doWrite(i,a,r,s,u),100,3)}async doWrite(i,a,r,s,u){const h=this.normalizePos(i,a);let b=null;try{b=(await m.Promises.write(i,r,s,u,h)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),A)}finally{this.updatePos(i,h,b)}return b}async mkdir(i){try{await m.Promises.mkdir(this.toFilePath(i))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(i,a){try{const r=this.toFilePath(i);a.recursive?await m.Promises.rm(r,m.RimRafMode.MOVE):await m.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(i,a,r){const s=this.toFilePath(i),u=this.toFilePath(a);if(s!==u)try{await this.validateTargetDeleted(i,a,"move",r.overwrite),await m.Promises.move(s,u)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,E.localize)(2,null,(0,T.basename)(s),(0,T.basename)((0,T.dirname)(u)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(i,a,r){const s=this.toFilePath(i),u=this.toFilePath(a);if(s!==u)try{await this.validateTargetDeleted(i,a,"copy",r.overwrite),await m.Promises.copy(s,u,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,E.localize)(3,null,(0,T.basename)(s),(0,T.basename)((0,T.dirname)(u)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(i,a,r,s){const u=this.toFilePath(i),h=this.toFilePath(a);let b=!1;if(!!(this.capabilities&1024)||(b=(0,v.isEqual)(u,h,!0)),b&&r==="copy")throw(0,f.createFileSystemProviderError)((0,E.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!b&&await m.Promises.exists(h)){if(!s)throw(0,f.createFileSystemProviderError)((0,E.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(i,a){return this.doCloneFile(i,a,!1)}async doCloneFile(i,a,r){const s=this.toFilePath(i),u=this.toFilePath(a),h=!!(this.capabilities&1024);if((0,v.isEqual)(s,u,!h))return;const b=new D.DisposableStore;try{const[A,B]=await Promise.all([this.createResourceLock(i),this.createResourceLock(a)]);b.add(A),b.add(B),r&&await m.Promises.mkdir((0,T.dirname)(u),{recursive:!0}),await m.Promises.copyFile(s,u)}catch(A){if(A.code==="ENOENT"&&!r)return this.doCloneFile(i,a,!0);throw this.toFileSystemProviderError(A)}finally{b.dispose()}}createUniversalWatcher(i,a,r){return new l.UniversalWatcherClient(s=>i(s),s=>a(s),r)}createNonRecursiveWatcher(i,a,r){return new c.NodeJSWatcherClient(s=>i(s),s=>a(s),r)}toFileSystemProviderError(i){if(i instanceof f.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=f.FileSystemProviderErrorCode.NoPermissions;break;default:a=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(i,a)}async toFileSystemProviderWriteError(i,a){let r=this.toFileSystemProviderError(a);if(i&&r.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await m.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(r=(0,f.createFileSystemProviderError)(a,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return r}}e.DiskFileSystemProvider=n}),define(we[203],ye([0,1,6,58,2,17,44,20]),function(ie,e,I,t,y,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class v extends y.Disposable{constructor(R,C){super();this.provider=R,this.logService=C,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(R,C,w){const m=this.getUriTransformer(R);switch(C){case"stat":return this.stat(m,w[0]);case"readdir":return this.readdir(m,w[0]);case"open":return this.open(m,w[0],w[1]);case"close":return this.close(w[0]);case"read":return this.read(w[0],w[1],w[2]);case"readFile":return this.readFile(m,w[0],w[1]);case"write":return this.write(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.writeFile(m,w[0],w[1],w[2]);case"rename":return this.rename(m,w[0],w[1],w[2]);case"copy":return this.copy(m,w[0],w[1],w[2]);case"cloneFile":return this.cloneFile(m,w[0],w[1]);case"mkdir":return this.mkdir(m,w[0]);case"delete":return this.delete(m,w[0],w[1]);case"watch":return this.watch(m,w[0],w[1],w[2],w[3]);case"unwatch":return this.unwatch(w[0],w[1])}throw new Error(`IPC Command ${C} not found`)}listen(R,C,w){const m=this.getUriTransformer(R);switch(C){case"fileChange":return this.onFileChange(m,w[0]);case"readFileStream":return this.onReadFileStream(m,w[0],w[1])}throw new Error(`Unknown event ${C}`)}stat(R,C){const w=this.transformIncoming(R,C,!0);return this.provider.stat(w)}readdir(R,C){const w=this.transformIncoming(R,C);return this.provider.readdir(w)}async readFile(R,C,w){const m=this.transformIncoming(R,C,!0),E=await this.provider.readFile(m,w);return P.VSBuffer.wrap(E)}onReadFileStream(R,C,w){const m=this.transformIncoming(R,C,!0),E=new S.CancellationTokenSource,f=new I.Emitter({onLastListenerRemove:()=>{E.cancel()}}),p=this.provider.readFileStream(m,w,E.token);return(0,k.listenStream)(p,{onData:g=>f.fire(P.VSBuffer.wrap(g)),onError:g=>f.fire(g),onEnd:()=>{f.fire("end"),f.dispose(),E.dispose()}}),f.event}writeFile(R,C,w,m){const E=this.transformIncoming(R,C);return this.provider.writeFile(E,w.buffer,m)}open(R,C,w){const m=this.transformIncoming(R,C,!0);return this.provider.open(m,w)}close(R){return this.provider.close(R)}async read(R,C,w){const m=P.VSBuffer.alloc(w),E=0,f=await this.provider.read(R,C,m.buffer,E,w);return[m,f]}write(R,C,w,m,E){return this.provider.write(R,C,w.buffer,m,E)}mkdir(R,C){const w=this.transformIncoming(R,C);return this.provider.mkdir(w)}delete(R,C,w){const m=this.transformIncoming(R,C);return this.provider.delete(m,w)}rename(R,C,w,m){const E=this.transformIncoming(R,C),f=this.transformIncoming(R,w);return this.provider.rename(E,f,m)}copy(R,C,w,m){const E=this.transformIncoming(R,C),f=this.transformIncoming(R,w);return this.provider.copy(E,f,m)}cloneFile(R,C,w){const m=this.transformIncoming(R,C),E=this.transformIncoming(R,w);return this.provider.cloneFile(m,E)}onFileChange(R,C){const w=new I.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(C,this.createSessionFileWatcher(R,w))},onLastListenerRemove:()=>{(0,y.dispose)(this.sessionToWatcher.get(C)),this.sessionToWatcher.delete(C)}});return w.event}async watch(R,C,w,m,E){const f=this.sessionToWatcher.get(C);if(f){const p=this.transformIncoming(R,m),g=f.watch(w,p,E);this.watchRequests.set(C+w,g)}}async unwatch(R,C){const w=R+C,m=this.watchRequests.get(w);m&&((0,y.dispose)(m),this.watchRequests.delete(w))}dispose(){super.dispose();for(const[,R]of this.watchRequests)R.dispose();this.watchRequests.clear();for(const[,R]of this.sessionToWatcher)R.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=v;class D extends y.Disposable{constructor(R,C,w,m){super();this.uriTransformer=R,this.logService=w,this.environmentService=m,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(C)}registerListeners(R){const C=this._register(new I.Emitter);this._register(C.event(w=>{R.fire(w.map(m=>({resource:this.uriTransformer.transformOutgoingURI(m.resource),type:m.type})))})),this._register(this.fileWatcher.onDidChangeFile(w=>C.fire(w))),this._register(this.fileWatcher.onDidWatchError(w=>R.fire(w)))}getRecursiveWatcherOptions(R){}getExtraExcludes(R){}watch(R,C,w){const m=this.getExtraExcludes(this.environmentService);return Array.isArray(m)&&(w.excludes=[...w.excludes,...m]),this.watcherRequests.set(R,this.fileWatcher.watch(C,w)),(0,y.toDisposable)(()=>{(0,y.dispose)(this.watcherRequests.get(R)),this.watcherRequests.delete(R)})}dispose(){super.dispose();for(const[,R]of this.watcherRequests)R.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=D}),define(we[100],ye([0,1,6,4,13]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class P{constructor(C){this.service=C,this.onDidChangeLogLevel=I.Event.buffer(C.onDidChangeLogLevel,!0)}listen(C,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(C,w,m){switch(w){case"setLevel":return this.service.setLevel(m)}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=P;class k{constructor(C){this.channel=C}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(C){k.setLevel(this.channel,C)}static setLevel(C,w){return C.call("setLevel",w)}}e.LogLevelChannelClient=k;class S{constructor(C){this.loggerService=C,this.loggers=new Map}listen(C,w){throw new Error(`Event not found: ${w}`)}async call(C,w,m){switch(w){case"createLogger":this.createLogger(t.URI.revive(m[0]),m[1]);return;case"log":return this.log(t.URI.revive(m[0]),m[1]);case"consoleLog":return this.consoleLog(m[0],m[1])}throw new Error(`Call not found: ${w}`)}createLogger(C,w){this.loggers.set(C.toString(),this.loggerService.createLogger(C,w))}consoleLog(C,w){let m=console.log;switch(C){case y.LogLevel.Error:m=console.error;break;case y.LogLevel.Warning:m=console.warn;break;case y.LogLevel.Info:m=console.info;break}m.call(console,...w)}log(C,w){const m=this.loggers.get(C.toString());if(!m)throw new Error("Create the logger before logging");for(const[E,f]of w)(0,y.log)(m,E,f)}}e.LoggerChannel=S;class v extends y.AbstractLoggerService{constructor(C,w,m){super(C,w);this.channel=m}createConsoleMainLogger(){return new y.AdapterLogger({log:(C,w)=>{this.channel.call("consoleLog",[C,w])}})}doCreateLogger(C,w,m){return new D(this.channel,C,w,m)}}e.LoggerChannelClient=v;class D extends y.AbstractMessageLogger{constructor(C,w,m,E){super(E?.always);this.channel=C,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.channel.call("createLogger",[w,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(C,w){const m=[[C,w]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(C){this.channel.call("log",[this.file,C])}}class T extends y.LogService{constructor(C,w){super(w);this.parent=C,this._register(C.onDidChangeLogLevel(m=>w.setLevel(m)))}setLevel(C){super.setLevel(C),this.parent.setLevel(C)}}e.FollowerLogService=T}),define(we[101],ye([0,1,18,13]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function y(S,v,D,T,R){try{const C=await new Promise((m,E)=>{ie(["spdlog"],m,E)});C.setFlushOn(t.LogLevel.Trace);const w=await C.createAsyncRotatingLogger(S,v,D,T);return R&&w.clearFormatters(),w}catch(C){console.error(C)}return null}function P(S,v,D){switch(v){case t.LogLevel.Trace:S.trace(D);break;case t.LogLevel.Debug:S.debug(D);break;case t.LogLevel.Info:S.info(D);break;case t.LogLevel.Warning:S.warn(D);break;case t.LogLevel.Error:S.error(D);break;case t.LogLevel.Critical:S.critical(D);break;default:throw new Error("Invalid log level")}}class k extends t.AbstractMessageLogger{constructor(v,D,T,R,C){super();this.buffer=[],this.setLevel(C),this._loggerCreationPromise=this._createSpdLogLogger(v,D,T,R),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}async _createSpdLogLogger(v,D,T,R){const C=T?6:1,w=30/C*I.ByteSize.MB,m=await y(v,D,w,C,R);if(m){this._logger=m,this._logger.setLevel(this.getLevel());for(const{level:E,message:f}of this.buffer)P(this._logger,E,f);this.buffer=[]}}log(v,D){this._logger?P(this._logger,v,D):this.getLevel()<=v&&this.buffer.push({level:v,message:D})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(we[204],ye([0,1,65,170,7]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var k;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(v){function D(m,E){return E-m}v.compare=D;const T=Object.create(null);T[v.Error]=(0,t.localize)(0,null),T[v.Warning]=(0,t.localize)(1,null),T[v.Info]=(0,t.localize)(2,null);function R(m){return T[m]||""}v.toString=R;function C(m){switch(m){case I.default.Error:return v.Error;case I.default.Warning:return v.Warning;case I.default.Info:return v.Info;case I.default.Ignore:return v.Hint}}v.fromSeverity=C;function w(m){switch(m){case v.Error:return I.default.Error;case v.Warning:return I.default.Warning;case v.Info:return I.default.Info;case v.Hint:return I.default.Ignore}}v.toSeverity=w}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var S;(function(v){const D="";function T(C){return R(C,!0)}v.makeKey=T;function R(C,w){let m=[D];return C.source?m.push(C.source.replace("\xA6","\\\xA6")):m.push(D),C.code?typeof C.code=="string"?m.push(C.code.replace("\xA6","\\\xA6")):m.push(C.code.value.replace("\xA6","\\\xA6")):m.push(D),C.severity!==void 0&&C.severity!==null?m.push(k.toString(C.severity)):m.push(D),C.message&&w?m.push(C.message.replace("\xA6","\\\xA6")):m.push(D),C.startLineNumber!==void 0&&C.startLineNumber!==null?m.push(C.startLineNumber.toString()):m.push(D),C.startColumn!==void 0&&C.startColumn!==null?m.push(C.startColumn.toString()):m.push(D),C.endLineNumber!==void 0&&C.endLineNumber!==null?m.push(C.endLineNumber.toString()):m.push(D),C.endColumn!==void 0&&C.endColumn!==null?m.push(C.endColumn.toString()):m.push(D),m.push(D),m.join("\xA6")}v.makeKeyOptionalMessage=R})(S=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(we[59],ye([0,1,6,43,2,7]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,P.createDecorator)("policy");class k extends y.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(D){const T=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...D,...this.policyDefinitions},T!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(D),t.Iterable.reduce(this.policies.entries(),(R,[C,w])=>({...R,[C]:w}),{})}getPolicyValue(D){return this.policies.get(D)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(D,[T,R])=>({...D,[T]:{definition:R,value:this.policies.get(T)}}),{})}}e.AbstractPolicyService=k;class S{constructor(){this.onDidChange=I.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=S}),define(we[48],ye([0,1,8,3,27,19]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const S=t.globals.vscode.context.configuration();if(S)k=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof ie?.__$__nodeRequire=="function"){const S=(0,P.dirname)(I.FileAccess.asFileUri("",ie));k=ie.__$__nodeRequire((0,P.joinPath)(S,"product.json").fsPath);const v=ie.__$__nodeRequire((0,P.joinPath)(S,"package.json").fsPath);y.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),Object.assign(k,{version:v.version,extensionsGallery:y.env.EXTENSIONS_GALLERY?JSON.parse(y.env.EXTENSIONS_GALLERY):k.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else k={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/3c8520fab514b9f56070214496b26ff68d1b1cb5/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.68.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.2",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"4.5.1",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],version:"1.68.1",commit:"30d9c6cd9483b2cc586687151bcbcd635f373630",date:"2022-07-19T16:29:15.252Z"},Object.keys(k).length===0&&Object.assign(k,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(we[26],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(we[34],ye([0,1,129,12]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(k,S){I.ok(t.isString(k)),I.ok(t.isObject(S)),I.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,S)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new y}),define(we[205],ye([0,1,6,34]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class P{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,D){this.schemasById[y(v)]=D,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new P;t.Registry.add(e.Extensions.JSONContribution,k)}),define(we[49],ye([0,1,16,6,12,155,25,205,34]),function(ie,e,I,t,y,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=v.Registry.as(S.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,o=!0){this.registerConfigurations([n],o)}registerConfigurations(n,o=!0){const i=this.doRegisterConfigurations(n,o);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const o=this.doDeregisterConfigurations(n);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:n,remove:o}){const i=[];i.push(...this.doDeregisterConfigurations(o)),i.push(...this.doRegisterConfigurations(n,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,I.distinct)(i)})}registerDefaultConfigurations(n){const o=[],i=[];for(const{overrides:a,source:r}of n)for(const s in a)if(o.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const u=this.configurationDefaultsOverrides.get(s),h=u?.valuesSources??new Map;if(r)for(const G of Object.keys(a[s]))h.set(G,r);const b={...u?.value||{},...a[s]};this.configurationDefaultsOverrides.set(s,{source:r,value:b,valuesSources:h});const A=(0,k.getLanguageTagSettingPlainKey)(s),B={type:"object",default:b,description:P.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:b,source:y.isString(r)?void 0:r,defaultValueSource:r};i.push(...E(s)),this.configurationProperties[s]=B,this.defaultLanguageConfigurationOverridesNode.properties[s]=B}else{this.configurationDefaultsOverrides.set(s,{value:a[s],source:r});const u=this.configurationProperties[s];u&&(this.updatePropertyDefaultValue(s,u),this.updateSchema(s,u))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const o=[];for(const{overrides:i,source:a}of n)for(const r in i){const s=this.configurationDefaultsOverrides.get(r),u=y.isString(a)?a:a?.id,h=y.isString(s?.source)?s?.source:s?.source?.id;if(u===h)if(o.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const b=this.configurationProperties[r];b&&(this.updatePropertyDefaultValue(r,b),this.updateSchema(r,b))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const o of n)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,o){const i=[];return n.forEach(a=>{i.push(...this.validateAndRegisterProperties(a,o,a.extensionInfo,a.restrictedProperties)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),i}doDeregisterConfigurations(n){const o=[],i=a=>{if(a.properties)for(const r in a.properties){o.push(r);const s=this.configurationProperties[r];s?.policy?.name&&this.policyConfigurations.delete(s.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,a.properties[r])}a.allOf&&a.allOf.forEach(r=>i(r))};for(const a of n){i(a);const r=this.configurationContributors.indexOf(a);r!==-1&&this.configurationContributors.splice(r,1)}return o}validateAndRegisterProperties(n,o=!0,i,a,r=3){r=y.isUndefinedOrNull(n.scope)?r:n.scope;let s=[],u=n.properties;if(u)for(let b in u){const A=u[b];if(o&&d(b,A)){delete u[b];continue}if(A.source=i,A.defaultDefaultValue=u[b].default,this.updatePropertyDefaultValue(b,A),e.OVERRIDE_PROPERTY_REGEX.test(b)?A.scope=void 0:(A.scope=y.isUndefinedOrNull(A.scope)?r:A.scope,A.restricted=y.isUndefinedOrNull(A.restricted)?!!a?.includes(b):A.restricted),u[b].hasOwnProperty("included")&&!u[b].included){this.excludedConfigurationProperties[b]=u[b],delete u[b];continue}else this.configurationProperties[b]=u[b],u[b].policy?.name&&this.policyConfigurations.set(u[b].policy.name,b);!u[b].deprecationMessage&&u[b].markdownDeprecationMessage&&(u[b].deprecationMessage=u[b].markdownDeprecationMessage),s.push(b)}let h=n.allOf;if(h)for(let b of h)s.push(...this.validateAndRegisterProperties(b,o,i,a,r));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const o=i=>{let a=i.properties;if(a)for(const s in a)this.updateSchema(s,a[s]);let r=i.allOf;r&&r.forEach(o)};o(n)}updateSchema(n,o){switch(e.allSettings.properties[n]=o,o.scope){case 1:e.applicationSettings.properties[n]=o;break;case 2:e.machineSettings.properties[n]=o;break;case 6:e.machineOverridableSettings.properties[n]=o;break;case 3:e.windowSettings.properties[n]=o;break;case 4:e.resourceSettings.properties[n]=o;break;case 5:e.resourceSettings.properties[n]=o,this.resourceLanguageSettingsSchema.properties[n]=o;break}}removeFromSchema(n,o){switch(delete e.allSettings.properties[n],o.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const o=`[${n}]`,i={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,i),e.allSettings.properties[o]=i,e.applicationSettings.properties[o]=i,e.machineSettings.properties[o]=i,e.machineOverridableSettings.properties[o]=i,e.windowSettings.properties[o]=i,e.resourceSettings.properties[o]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,o){const i=this.configurationDefaultsOverrides.get(n);let a=i?.value,r=i?.source;y.isUndefined(a)&&(a=o.defaultDefaultValue,r=void 0),y.isUndefined(a)&&(a=p(o.type)),o.default=a,o.defaultValueSource=r}}const w="\\[([^\\]]+)\\]",m=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(c){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let o=m.exec(c);for(;o?.length;){const i=o[1].trim();i&&n.push(i),o=m.exec(c)}}return(0,I.distinct)(n)}e.overrideIdentifiersFromKey=E;function f(c){return c.reduce((n,o)=>`${n}[${o}]`,"")}e.keyFromOverrideIdentifiers=f;function p(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const g=new C;v.Registry.add(e.Extensions.Configuration,g);function d(c,n){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?P.localize(7,null,c):g.getConfigurationProperties()[c]!==void 0?P.localize(8,null,c):n.policy?.name&&g.getPolicyConfigurations().get(n.policy?.name)!==void 0?P.localize(9,null,c,n.policy?.name,g.getPolicyConfigurations().get(n.policy?.name)):null:P.localize(6,null)}e.validateProperty=d;function l(){const c=[],n=g.getConfigurationProperties();for(const o of Object.keys(n))c.push([o,n[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=l}),define(we[102],ye([0,1,16,6,63,2,29,21,12,4,25,49,34]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class w{constructor(o={},i=[],a=[]){this._contents=o,this._keys=i,this._overrides=a,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(o){return o?(0,T.getConfigurationValue)(this.contents,o):this.contents}getOverrideValue(o,i){const a=this.getContentsForOverrideIdentifer(i);return a?o?(0,T.getConfigurationValue)(a,o):a:void 0}getKeysForOverrideIdentifier(o){const i=[];for(const a of this.overrides)a.identifiers.includes(o)&&i.push(...a.keys);return I.distinct(i)}getAllOverrideIdentifiers(){const o=[];for(const i of this.overrides)o.push(...i.identifiers);return I.distinct(o)}override(o){let i=this.overrideConfigurations.get(o);return i||(i=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,i)),i}merge(...o){const i=S.deepClone(this.contents),a=S.deepClone(this.overrides),r=[...this.keys];for(const s of o){this.mergeContents(i,s.contents);for(const u of s.overrides){const[h]=a.filter(b=>I.equals(b.identifiers,u.identifiers));h?(this.mergeContents(h.contents,u.contents),h.keys.push(...u.keys),h.keys=I.distinct(h.keys)):a.push(S.deepClone(u))}for(const u of s.keys)r.indexOf(u)===-1&&r.push(u)}return new w(i,r,a)}freeze(){return this.frozen=!0,this}clone(){return new w(S.deepClone(this.contents),[...this.keys],S.deepClone(this.overrides))}createOverrideConfigurationModel(o){const i=this.getContentsForOverrideIdentifer(o);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let a={};for(const r of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[r],u=i[r];u&&(typeof s=="object"&&typeof u=="object"?(s=S.deepClone(s),this.mergeContents(s,u)):s=u),a[r]=s}return new w(a,this.keys,this.overrides)}mergeContents(o,i){for(const a of Object.keys(i)){if(a in o&&v.isObject(o[a])&&v.isObject(i[a])){this.mergeContents(o[a],i[a]);continue}o[a]=S.deepClone(i[a])}}checkAndFreeze(o){return this.frozen&&!Object.isFrozen(o)?S.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let i=null,a=null;const r=s=>{s&&(a?this.mergeContents(a,s):a=S.deepClone(s))};for(const s of this.overrides)I.equals(s.identifiers,[o])?i=s.contents:s.identifiers.includes(o)&&r(s.contents);return r(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,i){this.addKey(o),(0,T.addToValueTree)(this.contents,o,i,a=>{throw new Error(a)})}removeValue(o){this.removeKey(o)&&(0,T.removeFromValueTree)(this.contents,o)}addKey(o){let i=this.keys.length;for(let a=0;a<i;a++)o.indexOf(this.keys[a])===0&&(i=a);this.keys.splice(i,1,o)}removeKey(o){let i=this.keys.indexOf(o);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=w;class m{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,i){if(!v.isUndefinedOrNull(o)){const a=this.doParseContent(o);this.parseRaw(a,i)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,i){this._raw=o;const{contents:a,keys:r,overrides:s,restricted:u}=this.doParseRaw(o,i);this._configurationModel=new w(a,r,s),this._restrictedConfigurations=u||[]}doParseContent(o){let i={},a=null,r=[],s=[],u=[];function h(A){Array.isArray(r)?r.push(A):a!==null&&(r[a]=A)}let b={onObjectBegin:()=>{let A={};h(A),s.push(r),r=A,a=null},onObjectProperty:A=>{a=A},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{let A=[];h(A),s.push(r),r=A,a=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:h,onError:(A,B,G)=>{u.push({error:A,offset:B,length:G})}};if(o)try{y.visit(o,b),i=r[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return i}doParseRaw(o,i){const a=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),r=this.filter(o,a,!0,i);o=r.raw;const s=(0,T.toValuesTree)(o,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),u=Object.keys(o),h=this.toOverrides(o,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:s,keys:u,overrides:h,restricted:r.restricted}}filter(o,i,a,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:o,restricted:[]};const s={},u=[];for(let h in o)if(R.OVERRIDE_PROPERTY_REGEX.test(h)&&a){const b=this.filter(o[h],i,!1,r);s[h]=b.raw,u.push(...b.restricted)}else{const b=i[h],A=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&u.push(h),(A===void 0||r.scopes===void 0||r.scopes.includes(A))&&(r.skipRestricted&&b?.restricted||(s[h]=o[h]))}return{raw:s,restricted:u}}toOverrides(o,i){const a=[];for(const r of Object.keys(o))if(R.OVERRIDE_PROPERTY_REGEX.test(r)){const s={};for(const u in o[r])s[u]=o[r][u];a.push({identifiers:(0,R.overrideIdentifiersFromKey)(r),keys:Object.keys(s),contents:(0,T.toValuesTree)(s,i)})}return a}}e.ConfigurationModelParser=m;class E extends P.Disposable{constructor(o,i,a,r){super();this.userSettingsResource=o,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&a.isEqual(s.resource,o)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class f{constructor(o,i,a,r=new w,s=new w,u=new k.ResourceMap,h=new w,b=new k.ResourceMap,A=!0){this._defaultConfiguration=o,this._policyConfiguration=i,this._localUserConfiguration=a,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=h,this._memoryConfigurationByResource=b,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(o,i,a){return this.getConsolidatedConfigurationModel(o,i,a).getValue(o)}updateValue(o,i,a={}){let r;a.resource?(r=this._memoryConfigurationByResource.get(a.resource),r||(r=new w,this._memoryConfigurationByResource.set(a.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(o):r.setValue(o,i),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,i,a){const r=this.getConsolidatedConfigurationModel(o,i,a),s=this.getFolderConfigurationModelForResource(i.resource,a),u=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,h=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this._defaultConfiguration.freeze().getValue(o),b=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(o),A=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.userConfiguration.freeze().getValue(o),B=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.localUserConfiguration.freeze().getValue(o),G=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this.remoteUserConfiguration.freeze().getValue(o),Q=a?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(o):this._workspaceConfiguration.freeze().getValue(o):void 0,_=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(o):s.freeze().getValue(o):void 0,X=i.overrideIdentifier?u.override(i.overrideIdentifier).getValue(o):u.getValue(o),F=r.getValue(o),U=I.distinct(r.overrides.map(le=>le.identifiers).flat()).filter(le=>r.getOverrideValue(o,le)!==void 0);return{defaultValue:h,policyValue:b,userValue:A,userLocalValue:B,userRemoteValue:G,workspaceValue:Q,workspaceFolderValue:_,memoryValue:X,value:F,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,policy:b!==void 0?{value:b}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,userLocal:B!==void 0?{value:this.localUserConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,userRemote:G!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(o),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:s?.freeze().getValue(o),override:i.overrideIdentifier?s?.freeze().getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,memory:X!==void 0?{value:u.getValue(o),override:i.overrideIdentifier?u.getOverrideValue(o,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:U.length?U:void 0}}keys(o){const i=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(o){this._policyConfiguration=o}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,i){this._folderConfigurations.set(o,i),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,i){const a=[];if(!i){const{added:r,updated:s,removed:u}=l(this._defaultConfiguration,o);i=[...r,...s,...u]}for(const r of i)for(const s of(0,R.overrideIdentifiersFromKey)(r)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(s),h=o.getKeysForOverrideIdentifier(s),b=[...h.filter(A=>u.indexOf(A)===-1),...u.filter(A=>h.indexOf(A)===-1),...u.filter(A=>!S.equals(this._defaultConfiguration.override(s).getValue(A),o.override(s).getValue(A)))];a.push([s,b])}return this.updateDefaultConfiguration(o),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(o){const{added:i,updated:a,removed:r}=l(this._policyConfiguration,o),s=[...i,...a,...r];return s.length&&this.updatePolicyConfiguration(o),{keys:s,overrides:[]}}compareAndUpdateLocalUserConfiguration(o){const{added:i,updated:a,removed:r,overrides:s}=l(this.localUserConfiguration,o),u=[...i,...a,...r];return u.length&&this.updateLocalUserConfiguration(o),{keys:u,overrides:s}}compareAndUpdateRemoteUserConfiguration(o){const{added:i,updated:a,removed:r,overrides:s}=l(this.remoteUserConfiguration,o);let u=[...i,...a,...r];return u.length&&this.updateRemoteUserConfiguration(o),{keys:u,overrides:s}}compareAndUpdateWorkspaceConfiguration(o){const{added:i,updated:a,removed:r,overrides:s}=l(this.workspaceConfiguration,o);let u=[...i,...a,...r];return u.length&&this.updateWorkspaceConfiguration(o),{keys:u,overrides:s}}compareAndUpdateFolderConfiguration(o,i){const a=this.folderConfigurations.get(o),{added:r,updated:s,removed:u,overrides:h}=l(a,i);let b=[...r,...s,...u];return(b.length||!a)&&this.updateFolderConfiguration(o,i),{keys:b,overrides:h}}compareAndDeleteFolderConfiguration(o){const i=this.folderConfigurations.get(o);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:a,updated:r,removed:s,overrides:u}=l(i,void 0);return{keys:[...a,...r,...s],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(o,i,a){let r=this.getConsolidatedConfigurationModelForResource(i,a);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(o)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:o},i){let a=this.getWorkspaceConsolidatedConfiguration();if(i&&o){const r=i.getFolder(o);r&&(a=this.getFolderConsolidatedConfiguration(r.uri)||a);const s=this._memoryConfigurationByResource.get(o);s&&(a=a.merge(s))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let i=this._foldersConsolidatedConfigurations.get(o);if(!i){const a=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(o);r?(i=a.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(o,i)):i=a}return i}getFolderConfigurationModelForResource(o,i){if(i&&o){const a=i.getFolder(o);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,i)=>{const{contents:a,overrides:r,keys:s}=this._folderConfigurations.get(i);return o.push([i,{contents:a,overrides:r,keys:s}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>o.add(i)),this.userConfiguration.freeze().keys.forEach(i=>o.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(a=>o.add(a))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(a=>o.add(a))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(a=>i.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(o).forEach(r=>i.add(r))),[...i.values()]}static parse(o){const i=this.parseConfigurationModel(o.defaults),a=this.parseConfigurationModel(o.policy),r=this.parseConfigurationModel(o.user),s=this.parseConfigurationModel(o.workspace),u=o.folders.reduce((h,b)=>(h.set(D.URI.revive(b[0]),this.parseConfigurationModel(b[1])),h),new k.ResourceMap);return new f(i,a,r,new w,s,u,new w,new k.ResourceMap,!1)}static parseConfigurationModel(o){return new w(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=f;function p(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const o=new Set,i=new Map;for(const r of n)r.keys.forEach(s=>o.add(s)),r.overrides.forEach(([s,u])=>{const h=(0,k.getOrSet)(i,s,new Set);u.forEach(b=>h.add(b))});const a=[];return i.forEach((r,s)=>a.push([s,[...r.values()]])),{keys:[...o.values()],overrides:a}}e.mergeChanges=p;class g{constructor(o,i,a,r){this.change=o,this.previous=i,this.currentConfiguraiton=a,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;o.keys.forEach(h=>s.add(h)),o.overrides.forEach(([,h])=>h.forEach(b=>s.add(b))),this.affectedKeys=[...s.values()];const u=new w;this.affectedKeys.forEach(h=>u.setValue(h,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(o,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(o,i,this.currentWorkspace);return!S.equals(a,r)}return!0}return!1}doesAffectedKeysTreeContains(o,i){let a=(0,T.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(o=o[r],!o)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=g;class d extends g{constructor(o,i,a,r){super({keys:o.allKeys(),overrides:[]},void 0,o,i);this.source=a,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=d;function l(n,o){const{added:i,removed:a,updated:r}=c(o,n),s=[],u=n?.getAllOverrideIdentifiers()||[],h=o?.getAllOverrideIdentifiers()||[];if(o){const b=h.filter(A=>!u.includes(A));for(const A of b)s.push([A,o.getKeysForOverrideIdentifier(A)])}if(n){const b=u.filter(A=>!h.includes(A));for(const A of b)s.push([A,n.getKeysForOverrideIdentifier(A)])}if(o&&n){for(const b of u)if(h.includes(b)){const A=c({contents:n.getOverrideValue(void 0,b)||{},keys:n.getKeysForOverrideIdentifier(b)},{contents:o.getOverrideValue(void 0,b)||{},keys:o.getKeysForOverrideIdentifier(b)});s.push([b,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:a,updated:r,overrides:s}}function c(n,o){const i=n?o?n.keys.filter(s=>o.keys.indexOf(s)===-1):[...n.keys]:[],a=o?n?o.keys.filter(s=>n.keys.indexOf(s)===-1):[...o.keys]:[],r=[];if(n&&o){for(const s of o.keys)if(n.keys.indexOf(s)!==-1){const u=(0,T.getConfigurationValue)(o.contents,s),h=(0,T.getConfigurationValue)(n.contents,s);S.equals(u,h)||r.push(s)}}return{added:i,removed:a,updated:r}}}),define(we[206],ye([0,1,16,6,2,21,12,25,102,49,13,59,34]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class w extends y.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new m(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(C.Registry.as(D.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:d})=>this.onDidUpdateConfiguration(g,d))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,d){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=w;class m extends v.ConfigurationModel{constructor(g={}){const d=C.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(d),c=Object.create(null),n=[];for(const o in d){const i=g[o],a=i!==void 0?i:d[o].default;(0,S.addToValueTree)(c,o,a,r=>console.error(`Conflict in default settings: ${r}`))}for(const o of Object.keys(c))D.OVERRIDE_PROPERTY_REGEX.test(o)&&n.push({identifiers:(0,D.overrideIdentifiersFromKey)(o),keys:Object.keys(c[o]),contents:(0,S.toValuesTree)(c[o],i=>console.error(`Conflict in default settings file: ${i}`))});super(c,l,n)}}e.DefaultConfigurationModel=m;class E{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new v.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=E;let f=class extends y.Disposable{constructor(g,d,l){super();this.defaultConfiguration=g,this.policyService=d,this.logService=l,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new v.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const d={},l=[],c=C.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(const n of g){const o=c[n];if(!o){l.push(n);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}l.push(n),d[o.policy.name]={type:o.type}}}return(0,k.isEmptyObject)(d)||await this.policyService.registerPolicyDefinitions(d),l}onDidChangePolicies(g){const d=C.Registry.as(D.Extensions.Configuration).getPolicyConfigurations(),l=(0,I.coalesce)(g.map(c=>d.get(c)));this.update(l,!0)}update(g,d){const l=C.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),c=[],n=this._configurationModel.isEmpty();for(const o of g){const i=l[o]?.policy?.name;if(i){const a=this.policyService.getPolicyValue(i);(n?a!==void 0:!(0,P.equals)(this._configurationModel.getValue(o),a))&&c.push([o,a])}else this._configurationModel.getValue(o)!==void 0&&c.push([o,void 0])}if(c.length){const o=this._configurationModel;this._configurationModel=new v.ConfigurationModel;for(const i of o.keys)this._configurationModel.setValue(i,o.getValue(i));for(const[i,a]of c)a===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,a);d&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};f=Re([Oe(1,R.IPolicyService),Oe(2,T.ILogService)],f),e.PolicyConfiguration=f}),define(we[103],ye([0,1,14,6,2,19,25,102,206,59]),function(ie,e,I,t,y,P,k,S,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends y.Disposable{constructor(C,w,m,E){super();this.settingsResource=C,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new v.DefaultConfiguration),this.policyConfiguration=m instanceof D.NullPolicyService?new v.NullPolicyConfiguration:this._register(new v.PolicyConfiguration(this.defaultConfiguration,m,E)),this.userConfiguration=this._register(new S.UserSettings(this.settingsResource,void 0,P.extUriBiasedIgnorePathCase,w)),this.configuration=new S.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new S.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:f,properties:p})=>this.onDidDefaultConfigurationChange(f,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(f=>this.onDidPolicyConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[C,w,m]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new S.Configuration(C,w,m)}getConfigurationData(){return this.configuration.toData()}getValue(C,w){const m=typeof C=="string"?C:void 0,E=(0,k.isConfigurationOverrides)(C)?C:(0,k.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(m,E,void 0)}updateValue(C,w,m,E){return Promise.reject(new Error("not supported"))}inspect(C){return this.configuration.inspect(C,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const C=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(C)}onDidChangeUserConfiguration(C){const w=this.configuration.toData(),m=this.configuration.compareAndUpdateLocalUserConfiguration(C);this.trigger(m,w,1)}onDidDefaultConfigurationChange(C,w){const m=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(C,w);this.trigger(E,m,6)}onDidPolicyConfigurationChange(C){const w=this.configuration.toData(),m=this.configuration.compareAndUpdatePolicyConfiguration(C);this.trigger(m,w,6)}trigger(C,w,m){const E=new S.ConfigurationChangeEvent(C,{data:w},this.configuration);E.source=m,E.sourceConfig=this.getTargetConfiguration(m),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(C){switch(C){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(we[104],ye([0,1,9,7]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var y;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends I.ErrorNoTelemetry{constructor(S,v=y.Unknown,D){super(S);this._message=S,this._code=v,this._detail=D,this.isHandled=v===y.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(S){return S instanceof P&&S._code===y.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof P&&S._code===y.NoResolverFound}static isHandled(S){return S instanceof P&&S.isHandled}}e.RemoteAuthorityResolverError=P}),define(we[74],ye([0,1,8]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(k){return k.scheme===I.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=t;function y(k){if(!k)return;const S=k.indexOf("+");return S<0?k:k.substr(0,S)}e.getRemoteName=y;function P(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=P}),define(we[41],ye([0,1,15,7,74]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=P;function k(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));var v;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(v=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,E){if(typeof m=="undefined"||m===null)return typeof E=="undefined"||E===null;if(typeof E=="undefined"||E===null)return!1;if(typeof m=="string"||typeof E=="string"){let f=typeof m=="string"?m:m.value,p=typeof E=="string"?E:E.value;return I.equalsIgnoreCase(f,p)}return m._lower===E._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=D;function T(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function R(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function C(w,m){if(m){const E=`onResolveRemoteAuthority:${(0,y.getRemoteName)(m)}`;return w.activationEvents?.indexOf(E)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[35],ye([0,1,15,31,41,3,4,9,27]),function(ie,e,I,t,y,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function D(i,a){return i.uuid&&a.uuid?i.uuid===a.uuid:i.id===a.id?!0:(0,I.compareIgnoreCase)(i.id,a.id)===0}e.areSameExtensions=D;const T=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class R{constructor(a,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=a.id}static create(a){const r=a.manifest?a.manifest.version:a.version,s=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new R(a.identifier,r,s)}static parse(a){const r=T.exec(a);return r&&r[1]&&r[2]?new R({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof R?D(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=R;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(i){const a=C.exec(i);return a&&a[1]?[E(a[1]),a[2]]:[E(i),void 0]}e.getIdAndVersion=w;function m(i,a){return`${i}.${a}`}e.getExtensionId=m;function E(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function f(i,a){return E(m(i,a))}e.getGalleryExtensionId=f;function p(i,a){const r=[],s=u=>{for(const h of r)if(h.some(b=>D(a(b),a(u))))return h;return null};for(const u of i){const h=s(u);h?h.push(u):r.push([u])}return r}e.groupByExtension=p;function g(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function d(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function l(i){const a=new Set;if(i.malicious)for(const r of i.malicious)a.add(r.id);return a}e.getMaliciousExtensionsSet=l;function c(i,a){const r=[],s=a.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const u=s.shift();if(u&&r.every(h=>!D(h.identifier,{id:u}))){const h=i.filter(b=>D(b.identifier,{id:u}));h.length===1&&(r.push(h[0]),s.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=c;async function n(i,a){if(!P.isLinux)return!1;let r;try{r=(await i.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){a.debug("Error while getting the os-release file.",(0,S.getErrorMessage)(u))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=n;async function o(i,a){const r=await n(i,a),s=(0,t.getTargetPlatform)(r?"alpine":P.platform,v.arch);return a.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=o}),define(we[105],ye([0,1,20,9,86,8,55,4,160,31,35,41]),function(ie,e,I,t,y,P,k,S,v,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=void 0;const C=f=>(0,v.localize)(0,null,f),w=(0,v.localize)(1,null,"ms-dotnettools.csharp");function m(f,p){return p?`${f.publisher}.${f.name}@${f.version}`:`${f.publisher}.${f.name}`}let E=class{constructor(p,g){this.extensionManagementService=p,this.extensionGalleryService=g}get location(){}async listExtensions(p,g,d=console){let l=await this.extensionManagementService.getInstalled(1);const c=R.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(g&&g!==""){if(c.indexOf(g.toLowerCase())<0){d.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}l=l.filter(o=>o.manifest.categories?o.manifest.categories.map(a=>a.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){d.log("Possible Categories: "),c.forEach(o=>{d.log(o)});return}this.location&&d.log((0,v.localize)(2,null,this.location)),l=l.sort((o,i)=>o.identifier.id.localeCompare(i.identifier.id));let n;for(let o of l)n!==o.identifier.id&&(n=o.identifier.id,d.log(m(o.manifest,p)))}async installExtensions(p,g,d,l,c=console){const n=[],o=[];p.length&&c.log(this.location?(0,v.localize)(3,null,this.location):(0,v.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1),a=(h,b)=>{const A=i.find(B=>(0,T.areSameExtensions)(B.identifier,{id:h}));if(A){if(!l&&(!b||b==="prerelease"&&A.preRelease))return c.log((0,v.localize)(5,null,h,A.manifest.version,h)),!1;if(b&&A.manifest.version===b)return c.log((0,v.localize)(6,null,`${h}@${b}`)),!1}return!0},r=(h,b,A)=>{u.push({id:h,version:b!=="prerelease"?b:void 0,installOptions:{...d,isBuiltin:A,installPreReleaseVersion:b==="prerelease"||d.installPreReleaseVersion}})},s=[],u=[];for(const h of p)if(h instanceof S.URI)s.push(h);else{const[b,A]=(0,T.getIdAndVersion)(h);a(b,A)&&r(b,A,!1)}for(const h of g){const[b,A]=(0,T.getIdAndVersion)(h);a(b,A)&&r(b,A,!0)}if(s.length&&await Promise.all(s.map(async h=>{try{const b=await this.installVSIX(h,{...d,isBuiltin:!1},l,c);b&&o.push(b)}catch(b){c.error(b.message||b.stack||b),n.push(h.toString())}})),u.length){const h=await this.getGalleryExtensions(u);await Promise.all(u.map(async b=>{const A=h.get(b.id.toLowerCase());if(A)try{const B=await this.installFromGallery(b,A,i,l,c);B&&o.push(B)}catch(B){c.error(B.message||B.stack||B),n.push(b.id)}else c.error(`${C(b.version?`${b.id}@${b.version}`:b.id)}
${w}`),n.push(b.id)}))}if(n.length)throw new Error((0,v.localize)(7,null,n.join(", ")))}async installVSIX(p,g,d,l){const c=await this.extensionManagementService.getManifest(p);if(!c)throw new Error("Invalid vsix");if(await this.validateVSIX(c,d,l))try{return await this.extensionManagementService.install(p,g),l.log((0,v.localize)(8,null,(0,y.getBaseLabel)(p))),c}catch(o){if((0,t.isCancellationError)(o))return l.log((0,v.localize)(9,null,(0,y.getBaseLabel)(p))),null;throw o}return null}async getGalleryExtensions(p){const g=new Map,d=p.some(c=>c.installOptions.installPreReleaseVersion),l=await this.extensionGalleryService.getExtensions(p.map(c=>({...c,preRelease:d})),I.CancellationToken.None);for(const c of l)g.set(c.identifier.id.toLowerCase(),c);return g}async installFromGallery({id:p,version:g,installOptions:d},l,c,n,o){const i=await this.extensionGalleryService.getManifest(l,I.CancellationToken.None);if(i&&!this.validateExtensionKind(i,o))return null;const a=c.find(r=>(0,T.areSameExtensions)(r.identifier,l.identifier));if(a){if(l.version===a.manifest.version)return o.log((0,v.localize)(10,null,g?`${p}@${g}`:p)),null;o.log((0,v.localize)(11,null,p,l.version))}try{return d.isBuiltin?o.log(g?(0,v.localize)(12,null,p,g):(0,v.localize)(13,null,p)):o.log(g?(0,v.localize)(14,null,p,g):(0,v.localize)(15,null,p)),await this.extensionManagementService.installFromGallery(l,{...d,installGivenVersion:!!g}),o.log((0,v.localize)(16,null,p,l.version)),i}catch(r){if((0,t.isCancellationError)(r))return o.log((0,v.localize)(17,null,p)),null;throw r}}validateExtensionKind(p,g){return!0}async validateVSIX(p,g,d){const l={id:(0,T.getGalleryExtensionId)(p.publisher,p.name)},n=(await this.extensionManagementService.getInstalled(1)).find(o=>(0,T.areSameExtensions)(l,o.identifier)&&(0,k.gt)(o.manifest.version,p.version));return n&&!g?(d.log((0,v.localize)(18,null,n.identifier.id,n.manifest.version,p.version)),!1):this.validateExtensionKind(p,d)}async uninstallExtensions(p,g,d=console){const l=async n=>{if(n instanceof S.URI){const o=await this.extensionManagementService.getManifest(n);return m(o)}return n},c=[];for(const n of p){const o=await l(n),a=(await this.extensionManagementService.getInstalled()).filter(r=>(0,T.areSameExtensions)(r.identifier,{id:o}));if(!a.length)throw new Error(`${this.notInstalled(o)}
${w}`);if(a.some(r=>r.type===0)){d.log((0,v.localize)(19,null,o));return}if(!g&&a.some(r=>r.isBuiltin)){d.log((0,v.localize)(20,null,o));return}d.log((0,v.localize)(21,null,o));for(const r of a)await this.extensionManagementService.uninstall(r),c.push(r);this.location?d.log((0,v.localize)(22,null,o,this.location)):d.log((0,v.localize)(23,null,o))}}async locateExtension(p,g=console){const d=await this.extensionManagementService.getInstalled();p.forEach(l=>{d.forEach(c=>{if(c.identifier.id===l&&c.location.scheme===P.Schemas.file){g.log(c.location.fsPath);return}})})}notInstalled(p){return this.location?(0,v.localize)(24,null,p,this.location):(0,v.localize)(25,null,p)}};E=Re([Oe(0,D.IExtensionManagementService),Oe(1,D.IExtensionGalleryService)],E),e.ExtensionManagementCLIService=E}),define(we[50],ye([0,1,16,14,21,17,9,63,151,2,8,5,3,19,55,65,12,4,161,28,35,41,69,18,7,13,26,6,45]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f,p,g,d,l,c,n,o,i,a,r,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var h;(function(X){function F(U,le){if(U===le)return!0;let j=Object.keys(U),$=new Set;for(let O of Object.keys(le))$.add(O);if(j.length!==$.size)return!1;for(let O of j){if(U[O]!==le[O])return!1;$.delete(O)}return $.size===0}X.equals=F})(h=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let b=class extends D.Disposable{constructor(F,U,le,j,$,O,M,W){super();this.systemExtensionsLocation=F,this.userExtensionsLocation=U,this.extensionsControlLocation=le,this.cacheLocation=j,this.fileService=$,this.logService=O,this.environmentService=M,this.productService=W,this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.systemExtensionsCachedScanner=this._register(new G((0,w.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new G((0,w.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.extensionsScanner=this._register(new B(this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(F){const[U,le]=await Promise.all([this.scanSystemExtensions(F),this.scanUserExtensions(F)]),j=await this.scanExtensionsUnderDevelopment(F,[...U,...le]);return this.dedupExtensions([...U,...le,...j],await this.getTargetPlatform(),!0)}async scanSystemExtensions(F){const U=[];U.push(this.scanDefaultSystemExtensions(!!F.useCache,F.language)),U.push(this.scanDevSystemExtensions(F.language,!!F.checkControlFile));const[le,j]=await Promise.all(U);return this.applyScanOptions([...le,...j],F,!1)}async scanUserExtensions(F){this.logService.trace("Started scanning user extensions");const U=await this.createExtensionScannerInput(this.userExtensionsLocation,1,!F.includeUninstalled,F.language);let j=await(F.useCache&&!U.devMode&&U.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(U);return j=await this.applyScanOptions(j,F,!0),this.logService.trace("Scanned user extensions:",j.length),j}async scanExtensionsUnderDevelopment(F,U){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const le=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(j=>j.scheme===T.Schemas.file).map(async j=>{const $=await this.createExtensionScannerInput(j,1,!0,F.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(M=>(M.type=U.find(W=>(0,l.areSameExtensions)(W.identifier,M.identifier))?.type??M.type,this.extensionsScanner.validate(M,$)))}))).flat();return this.applyScanOptions(le,F,!0)}return[]}async scanExistingExtension(F,U,le){const j=await this.createExtensionScannerInput(F,U,!0,le.language),$=await this.extensionsScanner.scanExtension(j);return!$||!le.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(F,U,le){const j=await this.createExtensionScannerInput(F,U,!0,le.language),$=await this.extensionsScanner.scanOneOrMultipleExtensions(j);return this.applyScanOptions($,le,!0)}async updateMetadata(F,U){const le=(0,w.joinPath)(F,"package.json"),j=(await this.fileService.readFile(le)).value.toString(),$=JSON.parse(j);U.isMachineScoped=U.isMachineScoped||void 0,U.isBuiltin=U.isBuiltin||void 0,U.installedTimestamp=U.installedTimestamp||void 0,$.__metadata={...$.__metadata,...U},await this.fileService.writeFile((0,w.joinPath)(F,"package.json"),P.VSBuffer.fromString(JSON.stringify($,null,"	")))}async applyScanOptions(F,U,le){return U.includeAllVersions||(F=this.dedupExtensions(F,await this.getTargetPlatform(),le)),U.includeInvalid||(F=F.filter(j=>j.isValid)),F.sort((j,$)=>{const O=R.basename(j.location.fsPath),M=R.basename($.location.fsPath);return O<M?-1:O>M?1:0})}dedupExtensions(F,U,le){const j=new Map;for(const $ of F){const O=c.ExtensionIdentifier.toKey($.identifier.id),M=j.get(O);if(M){if(M.isValid&&!$.isValid)continue;if(M.isValid===$.isValid){if(le&&m.gt(M.manifest.version,$.manifest.version)){this.logService.debug(`Skipping extension ${$.location.path} with lower version ${$.manifest.version}.`);continue}if(m.eq(M.manifest.version,$.manifest.version)&&M.targetPlatform===U){this.logService.debug(`Skipping extension ${$.location.path} from different target platform ${$.targetPlatform}`);continue}}M.type===0?this.logService.debug(`Overwriting system extension ${M.location.path} with ${$.location.path}.`):this.logService.warn(`Overwriting user extension ${M.location.path} with ${$.location.path}.`)}j.set(O,$)}return[...j.values()]}async scanDefaultSystemExtensions(F,U){this.logService.trace("Started scanning system extensions");const le=await this.createExtensionScannerInput(this.systemExtensionsLocation,0,!0,U),$=await(F&&!le.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(le);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(F,U){const le=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!le?.length)return[];this.logService.trace("Started scanning dev system extensions");const j=U?await this.getBuiltInExtensionControl():{},$=[],O=p.URI.file(R.normalize(R.join(T.FileAccess.asFileUri("",ie).fsPath,"..",".build","builtInExtensions")));for(const W of le){const J=j[W.name]||"marketplace";switch(J){case"disabled":break;case"marketplace":$.push((0,w.joinPath)(O,W.name));break;default:$.push(p.URI.file(J));break}}const M=await Promise.all($.map(async W=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(W,0,!0,F))));return this.logService.trace("Scanned dev system extensions:",M.length),(0,I.coalesce)(M)}async getBuiltInExtensionControl(){try{const F=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(F.value.toString())}catch{return{}}}async createExtensionScannerInput(F,U,le,j,$=!0){const O=await this.getTranslations(j??C.language);let M;try{const W=await this.fileService.stat(F);typeof W.mtime=="number"&&(M=W.mtime)}catch{}return new A(F,M,U,le,$,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,j,O)}};b=Re([Oe(4,o.IFileService),Oe(5,a.ILogService),Oe(6,d.IEnvironmentService),Oe(7,r.IProductService)],b),e.AbstractExtensionsScannerService=b;class A{constructor(F,U,le,j,$,O,M,W,J,ae,me){this.location=F,this.mtime=U,this.type=le,this.excludeObsolete=j,this.validate=$,this.productVersion=O,this.productDate=M,this.productCommit=W,this.devMode=J,this.language=ae,this.translations=me}static createNlsConfiguration(F){return{language:F.language,pseudo:F.language==="pseudo",devMode:F.devMode,translations:F.translations}}static equals(F,U){return(0,w.isEqual)(F.location,U.location)&&F.mtime===U.mtime&&F.type===U.type&&F.excludeObsolete===U.excludeObsolete&&F.validate===U.validate&&F.productVersion===U.productVersion&&F.productDate===U.productDate&&F.productCommit===U.productCommit&&F.devMode===U.devMode&&F.language===U.language&&h.equals(F.translations,U.translations)}}class B extends D.Disposable{constructor(F,U){super();this.fileService=F,this.logService=U}async scanExtensions(F){const U=await this.fileService.resolve(F.location);if(U.children){let le={};if(F.excludeObsolete&&F.type===1)try{const $=(await this.fileService.readFile((0,w.joinPath)(F.location,".obsolete"))).value.toString();le=JSON.parse($)}catch{}const j=await Promise.all(U.children.map(async $=>{if(!$.isDirectory||F.type===1&&(0,w.basename)($.resource).indexOf(".")===0)return null;const O=new A($.resource,F.mtime,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations),M=await this.scanExtension(O);return M&&!le[l.ExtensionKey.create(M).toString()]?M:null}));return(0,I.coalesce)(j)}return[]}async scanOneOrMultipleExtensions(F){try{if(await this.fileService.exists((0,w.joinPath)(F.location,"package.json"))){const U=await this.scanExtension(F);return U?[U]:[]}else return await this.scanExtensions(F)}catch(U){return this.logService.error(`Error scanning extensions at ${F.location.path}:`,(0,k.getErrorMessage)(U)),[]}}async scanExtension(F){try{let U=await this.scanExtensionManifest(F.location);if(U){U.publisher||(U.publisher=c.UNDEFINED_PUBLISHER);const le=U.__metadata;delete U.__metadata;const j=(0,l.getGalleryExtensionId)(U.publisher,U.name),$=le?.id?{id:j,uuid:le.id}:{id:j},O=le?.isSystem?0:F.type,M=O===0||!!le?.isBuiltin;U=await this.translateManifest(F.location,U,A.createNlsConfiguration(F));const W={type:O,identifier:$,manifest:U,location:F.location,isBuiltin:M,targetPlatform:le?.targetPlatform??"undefined",metadata:le,isValid:!0,validations:[]};return F.validate?this.validate(W,F):W}}catch(U){F.type!==0&&this.logService.error(U)}return null}validate(F,U){let le=!0;const j=(0,n.validateExtensionManifest)(U.productVersion,U.productDate,U.location,F.manifest,F.isBuiltin);for(const[$,O]of j)$===E.default.Error&&(le=!1,this.logService.error(this.formatMessage(U.location,O)));return F.isValid=le,F.validations=j,F}async scanExtensionManifest(F){const U=(0,w.joinPath)(F,"package.json");let le;try{le=(await this.fileService.readFile(U)).value.toString()}catch($){return(0,o.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(F,(0,g.localize)(0,null,U.path,$.message))),null}let j;try{j=JSON.parse(le)}catch{const O=[];(0,S.parse)(le,O);for(const M of O)this.logService.error(this.formatMessage(F,(0,g.localize)(1,null,U.path,M.offset,M.length,(0,v.getParseErrorMessage)(M.error))));return null}return(0,S.getNodeType)(j)!=="object"?(this.logService.error(this.formatMessage(F,(0,g.localize)(2,null,U.path))),null):j}async translateManifest(F,U,le){const j=await this.getLocalizedMessages(F,U,le);if(j)try{const $=[],O=await this.resolveOriginalMessageBundle(j.default,$);if($.length>0)return $.forEach(W=>{this.logService.error(this.formatMessage(F,(0,g.localize)(3,null,j.default?.path,(0,v.getParseErrorMessage)(W.error))))}),U;if((0,S.getNodeType)(j)!=="object")return this.logService.error(this.formatMessage(F,(0,g.localize)(4,null,j.default?.path))),U;const M=j.values||Object.create(null);this.replaceNLStrings(le.pseudo,U,M,O,F)}catch{}return U}async getLocalizedMessages(F,U,le){const j=(0,w.joinPath)(F,"package.nls.json"),$=(J,ae)=>{ae.forEach(me=>{this.logService.error(this.formatMessage(F,(0,g.localize)(5,null,J?.path,(0,v.getParseErrorMessage)(me.error))))})},O=J=>{this.logService.error(this.formatMessage(F,(0,g.localize)(6,null,J?.path)))},M=`${U.publisher}.${U.name}`,W=le.translations[M];if(W)try{const J=p.URI.file(W),ae=(await this.fileService.readFile(J)).value.toString();let me=[],fe=(0,S.parse)(ae,me);return me.length>0?($(J,me),{values:void 0,default:j}):(0,S.getNodeType)(fe)!=="object"?(O(J),{values:void 0,default:j}):{values:fe.contents?fe.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.fileService.exists(j))return;let ae;try{ae=await this.findMessageBundles(F,le)}catch{return}if(!ae.localized)return{values:void 0,default:ae.original};try{const me=(await this.fileService.readFile(ae.localized)).value.toString();let fe=[],V=(0,S.parse)(me,fe);return fe.length>0?($(ae.localized,fe),{values:void 0,default:ae.original}):(0,S.getNodeType)(V)!=="object"?(O(ae.localized),{values:void 0,default:ae.original}):{values:V,default:ae.original}}catch{return{values:void 0,default:ae.original}}}}async resolveOriginalMessageBundle(F,U){if(F)try{const le=(await this.fileService.readFile(F)).value.toString();return(0,S.parse)(le,U)}catch{return null}else return null}findMessageBundles(F,U){return new Promise((le,j)=>{const $=O=>{let M=(0,w.joinPath)(F,`package.nls.${O}.json`);this.fileService.exists(M).then(W=>{W&&le({localized:M,original:(0,w.joinPath)(F,"package.nls.json")});let J=O.lastIndexOf("-");J===-1?le({localized:(0,w.joinPath)(F,"package.nls.json"),original:null}):(O=O.substring(0,J),$(O))})};if(U.devMode||U.pseudo||!U.language)return le({localized:(0,w.joinPath)(F,"package.nls.json"),original:null});$(U.language)})}replaceNLStrings(F,U,le,j,$){const O=(M,W,J)=>{const ae=M[W];if((0,f.isString)(ae)){const me=ae,fe=me.length;if(fe>1&&me[0]==="%"&&me[fe-1]==="%"){const V=me.substr(1,fe-2);let ee=le[V];ee===void 0&&j&&(ee=j[V]);let x=typeof ee=="string"?ee:typeof ee?.message=="string"?ee.message:void 0;x!==void 0?(F&&(x="\uFF3B"+x.replace(/[aouei]/g,"$&$&")+"\uFF3D"),M[W]=J&&(W==="title"||W==="category")&&j?{value:x,original:j[V]}:x):this.logService.warn(this.formatMessage($,(0,g.localize)(7,null,V)))}}else if((0,f.isObject)(ae))for(let me in ae)ae.hasOwnProperty(me)&&(me==="commands"?O(ae,me,!0):O(ae,me,J));else if((0,f.isArray)(ae))for(let me=0;me<ae.length;me++)O(ae,me,J)};for(let M in U)U.hasOwnProperty(M)&&O(U,M)}formatMessage(F,U){return`[${F.path}]: ${U}`}}class G extends B{constructor(F,U,le){super(U,le);this.cacheFile=F,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(F){const U=await this.readExtensionCache();if(this.input=F,U&&U.input&&A.equals(U.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),U.result.map(j=>(j.location=p.URI.revive(j.location),j));const le=await super.scanExtensions(F);return await this.writeExtensionCache({input:F,result:le}),le}async readExtensionCache(){try{const F=await this.fileService.readFile(this.cacheFile),U=JSON.parse(F.value.toString());return{result:U.result,input:(0,u.revive)(U.input)}}catch(F){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(F))}return null}async writeExtensionCache(F){try{await this.fileService.writeFile(this.cacheFile,P.VSBuffer.fromString(JSON.stringify(F)))}catch(U){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(U))}}async validateCache(){if(!this.input)return;const F=await this.readExtensionCache();if(!F)return;const U=F.result,le=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!y.equals(le,U))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(j){this.logService.error(j)}}}function Q(X,F){const U=(0,l.getExtensionId)(X.manifest.publisher,X.manifest.name);return{id:U,identifier:new c.ExtensionIdentifier(U),isBuiltin:X.type===0,isUserBuiltin:X.type===1&&X.isBuiltin,isUnderDevelopment:F,extensionLocation:X.location,uuid:X.identifier.uuid,targetPlatform:X.targetPlatform,...X.manifest}}e.toExtensionDescription=Q;class _ extends b{constructor(F,U,le,j,$,O,M,W){super(F,U,(0,w.joinPath)(le,".vscode-oss-dev","extensions","control.json"),(0,w.joinPath)(j,c.MANIFEST_CACHE_FOLDER),$,O,M,W);this.translationsPromise=(async()=>{if(C.translationsConfigFile)try{const J=await this.fileService.readFile(p.URI.file(C.translationsConfigFile));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}getTranslations(F){return this.translationsPromise}}e.NativeExtensionsScannerService=_}),define(we[207],ye([0,1,14,9,2,3,19,55,4,23,22,28,31,35,18,13]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let f=class extends y.Disposable{constructor(g,d,l,c){super();this.fileService=d,this.extensionGalleryService=l,this.logService=c,this.extensionsDownloadDir=v.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,d){await this.cleanUpPromise;const l=this.getName(g),c=(0,k.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(c)){const n=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,D.generateUuid)()}`);await this.fileService.exists(n)||await this.extensionGalleryService.download(g,n,d);try{await this.rename(n,c,Date.now()+2*60*1e3)}catch(o){try{await this.fileService.del(n)}catch{}if(o.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(o)}. Deleted the vsix from downloaded location`,n.path),o}}return c}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,d,l){try{await T.Promises.rename(g.fsPath,d.fsPath)}catch(c){if(P.isWindows&&c&&c.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${g} to ${d} with 'EPERM' error. Trying again...`),this.rename(g,d,l);throw c}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const d=[],l=[];for(const o of g.children){const i=w.ExtensionKey.parse(o.name);i&&l.push([i,o])}const c=(0,w.groupByExtension)(l,([o])=>o),n=[];for(const o of c)o.sort((i,a)=>S.rcompare(i[0].version,a[0].version)),d.push(...o.slice(1).map(i=>i[1].resource)),n.push(o[0][1]);n.sort((o,i)=>o.mtime-i.mtime),d.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(o=>o.resource)),await I.Promises.settled(d.map(o=>(this.logService.trace("Deleting vsix from cache",o.path),this.fileService.del(o))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?w.ExtensionKey.create(g).toString().toLowerCase():(0,D.generateUuid)()}};f=Re([Oe(0,R.INativeEnvironmentService),Oe(1,m.IFileService),Oe(2,C.IExtensionGalleryService),Oe(3,E.ILogService)],f),e.ExtensionsDownloader=f}),define(we[208],ye([0,1,2,5,22,41]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends I.Disposable{constructor(v,D){super();this.environmentService=v,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,P.MANIFEST_CACHE_FOLDER,P.USER_MANIFEST_CACHE_FILE),this._register(D.onDidInstallExtensions(T=>this.onDidInstallExtensions(T))),this._register(D.onDidUninstallExtension(T=>this.onDidUnInstallExtension(T)))}onDidInstallExtensions(v){v.some(D=>!!D.local)&&this.invalidate()}onDidUnInstallExtension(v){v.error||this.invalidate()}invalidate(){y.Promises.rm(this.extensionsManifestCache,y.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(we[106],ye([0,1,75,16,14,2,8,5,22,28,31,35,13,73]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let m=class extends w.LanguagePackBaseService{constructor(g,d,l,c){super(l);this.extensionManagementService=g,this.logService=c,this.cache=this._register(new E(d,c)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),d=Object.keys(g).map(l=>{const c=g[l];return{...this.createQuickPickItem({locale:l,label:c.label}),extensionId:c.extensions[0].extensionIdentifier.id}});return d.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),d}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const d=await this.cache.getLanguagePacks();Object.keys(d).some(l=>d[l]&&d[l].extensions.some(c=>(0,R.areSameExtensions)(c.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,d]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),l=await this.cache.update(d);return!(0,t.equals)(Object.keys(g),Object.keys(l))}};m=Re([Oe(0,T.IExtensionManagementService),Oe(1,D.INativeEnvironmentService),Oe(2,T.IExtensionGalleryService),Oe(3,C.ILogService)],m),e.NativeLanguagePackService=m;let E=class extends P.Disposable{constructor(g,d){super();this.logService=d,this.languagePacks={},this.languagePacksFilePath=(0,S.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new y.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(d=>{Object.keys(d).forEach(l=>delete d[l]),this.createLanguagePacksFromExtensions(d,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...d){for(const l of d)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,l);Object.keys(g).forEach(l=>this.updateHash(g[l]))}createLanguagePacksFromExtension(g,d){const l=d.identifier,c=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const n of c)if(d.location.scheme===k.Schemas.file&&f(n)){let o=g[n.languageId];o||(o={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},g[n.languageId]=o);let i=o.extensions.filter(a=>(0,R.areSameExtensions)(a.extensionIdentifier,l))[0];i?i.version=d.manifest.version:o.extensions.push({extensionIdentifier:l,version:d.manifest.version});for(const a of n.translations)o.translations[a.id]=(0,S.join)(d.location.fsPath,a.path)}}updateHash(g){if(g){const d=(0,I.createHash)("md5");for(const l of g.extensions)d.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);g.hash=d.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let d=null;return v.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(d=g(l),l)).then(l=>{for(const n of Object.keys(l))l[n]||delete l[n];this.languagePacks=l,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),v.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>d,l=>this.logService.error(l))})}};E=Re([Oe(0,D.INativeEnvironmentService),Oe(1,C.ILogService)],E);function f(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const g of p.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(we[51],ye([0,1,17,171,49,7,34]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,P.createDecorator)("requestService");function S(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.isSuccess=S;function v(E){return E.res.statusCode===204}async function D(E){return v(E)?null:(await(0,I.streamToBuffer)(E.stream)).toString()}e.asText=D;async function T(E){if(!S(E))throw new Error("Server returned "+E.res.statusCode);return D(E)}e.asTextOrError=T;async function R(E){if(!S(E))throw new Error("Server returned "+E.res.statusCode);if(v(E))return null;const p=(await(0,I.streamToBuffer)(E.stream)).toString();try{return JSON.parse(p)}catch(g){throw g.message+=`:
`+p,g}}e.asJson=R;function C(E){m(E)}e.updateProxyConfigurationsScope=C;let w;function m(E){const f=k.Registry.as(y.Extensions.Configuration),p=w;w={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[w],remove:p?[p]:[]})}m(2)}),define(we[209],ye([0,1,20,8,18,51]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(v,D){this.requestService=v,this.fileService=D}async download(v,D,T=I.CancellationToken.None){if(v.scheme===t.Schemas.file||v.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(v,D);return}const R={type:"GET",url:v.toString()},C=await this.requestService.request(R,T);if(C.res.statusCode===200)await this.fileService.writeFile(D,C.stream);else{const w=await(0,P.asTextOrError)(C);throw new Error(`Expected 200, got back ${C.res.statusCode} instead.

${w}`)}}};k=Re([Oe(0,P.IRequestService),Oe(1,y.IFileService)],k),e.DownloadService=k}),define(we[210],ye([0,1,17,20]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class y{constructor(S){this.service=S}listen(S,v){throw new Error("Invalid listen")}call(S,v,D){switch(v){case"request":return this.service.request(D[0],t.CancellationToken.None).then(async({res:T,stream:R})=>{const C=await(0,I.streamToBuffer)(R);return[{statusCode:T.statusCode,headers:T.headers},C]})}throw new Error("Invalid call")}}e.RequestChannel=y;class P{constructor(S){this.channel=S}async request(S,v){return P.request(this.channel,S,v)}static async request(S,v,D){const[T,R]=await S.call("request",[v]);return{res:T,stream:(0,I.bufferToStream)(R)}}}e.RequestChannelClient=P}),define(we[211],ye([0,1,76,12]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function y(k,S){return k.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:k.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function P(k,S,v={}){const D=(0,I.parse)(k),T=v.proxyUrl||y(D,S);if(!T)return null;const R=(0,I.parse)(T);if(!/^https?:$/.test(R.protocol||""))return null;const C={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,t.isBoolean)(v.strictSSL)?v.strictSSL:!0};return D.protocol==="http:"?new(await new Promise((w,m)=>{ie(["http-proxy-agent"],w,m)}))(C):new(await new Promise((w,m)=>{ie(["https-proxy-agent"],w,m)}))(C)}e.getProxyAgent=P}),define(we[77],ye([0,1,39,5,172,20,36,9,3,23,153,185,14]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const w=1e4;let m;async function E(p,g,d){return g["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.isLaunchedFromCli)(d)&&!g["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.isLaunchedFromCli)(d)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=C.Promises.withAsyncBody(async(l,c)=>{const n=new P.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),c(new Error((0,y.localize)(0,null)))},w);try{l(await f(p,n.token))}catch(i){!(0,S.isCancellationError)(i)&&!n.token.isCancellationRequested?c(new Error((0,y.localize)(1,null,(0,k.toErrorMessage)(i)))):l({})}finally{clearTimeout(o),n.dispose()}})),m)}e.getResolvedShellEnv=E;async function f(p,g){const d=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",d);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",l);const c=(0,D.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"(.*)"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",o);const i=await(0,T.getSystemShell)(v.OS,o);return p.trace("getUnixShellEnvironment#shell",i),new Promise((a,r)=>{if(g.isCancellationRequested)return r((0,S.canceled)());const s=(0,t.basename)(i);let u,h;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(u=`& '${process.execPath}' ${b} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,h=["-Login","-Command"]):(u=`'${process.execPath}' ${b} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,s==="tcsh"?h=["-ic"]:h=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),u);const A=(0,I.spawn)(i,[...h,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});g.onCancellationRequested(()=>(A.kill(),r((0,S.canceled)()))),A.on("error",Q=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(Q)),r(Q)});const B=[];A.stdout.on("data",Q=>B.push(Q));const G=[];A.stderr.on("data",Q=>G.push(Q)),A.on("close",(Q,_)=>{const X=Buffer.concat(B).toString("utf8");p.trace("getUnixShellEnvironment#raw",X);const F=Buffer.concat(G).toString("utf8");if(F.trim()&&p.trace("getUnixShellEnvironment#stderr",F),Q||_)return r(new Error((0,y.localize)(2,null,Q,_)));const U=n.exec(X),le=U?U[1]:"{}";try{const j=JSON.parse(le);d?j.ELECTRON_RUN_AS_NODE=d:delete j.ELECTRON_RUN_AS_NODE,l?j.ELECTRON_NO_ATTACH_CONSOLE=l:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",j),a(j)}catch(j){p.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(j)),r(j)}})})}}),define(we[212],ye([0,1,14,6,2,46,12,144,7]),function(ie,e,I,t,y,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const D="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var T;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(T=e.WillSaveStateReason||(e.WillSaveStateReason={}));var R;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(R=e.StorageScope||(e.StorageScope={}));var C;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));class w extends y.Disposable{constructor(p={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=p,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new y.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,y.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,P.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(p,g){g===D?(p===0?this._globalKeyTargets=void 0:p===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:p})):this._onDidChangeValue.fire({scope:p,key:g,target:this.getKeyTargets(p)[g]})}emitWillSaveState(p){this._onWillSaveState.fire({reason:p})}get(p,g,d){return this.getStorage(g)?.get(p,d)}getBoolean(p,g,d){return this.getStorage(g)?.getBoolean(p,d)}getNumber(p,g,d){return this.getStorage(g)?.getNumber(p,d)}store(p,g,d,l){if((0,k.isUndefinedOrNull)(g)){this.remove(p,d);return}this.withPausedEmitters(()=>{this.updateKeyTarget(p,d,l),this.getStorage(d)?.set(p,g)})}remove(p,g){this.withPausedEmitters(()=>{this.updateKeyTarget(p,g,void 0),this.getStorage(g)?.delete(p)})}withPausedEmitters(p){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{p()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(p,g){const d=[],l=this.getKeyTargets(p);for(const c of Object.keys(l))l[c]===g&&d.push(c);return d}updateKeyTarget(p,g,d){const l=this.getKeyTargets(g);typeof d=="number"?l[p]!==d&&(l[p]=d,this.getStorage(g)?.set(D,JSON.stringify(l))):typeof l[p]=="number"&&(delete l[p],this.getStorage(g)?.set(D,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(p){return p===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(p){const g=this.get(D,p);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=T.NONE){this._onWillSaveState.fire({reason:p});const g=this.getStorage(0),d=this.getStorage(1);switch(p){case T.NONE:await I.Promises.settled([g?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await I.Promises.settled([g?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve()]);break}}async logStorage(){const p=this.getStorage(0)?.items??new Map,g=this.getStorage(1)?.items??new Map;return E(p,g,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class m extends w{constructor(){super();this.globalStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(p=>this.emitDidChangeValue(1,p))),this._register(this.globalStorage.onDidChangeStorage(p=>this.emitDidChangeValue(0,p)))}getStorage(p){return p===0?this.globalStorage:this.workspaceStorage}getLogDetails(p){return p===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(p){}}e.InMemoryStorageService=m;async function E(f,p,g,d){const l=s=>{try{return JSON.parse(s)}catch{return s}},c=new Map,n=new Map;f.forEach((s,u)=>{c.set(u,s),n.set(u,l(s))});const o=new Map,i=new Map;p.forEach((s,u)=>{o.set(u,s),i.set(u,l(s))}),console.group(`Storage: Global (path: ${g})`);let a=[];c.forEach((s,u)=>{a.push({key:u,value:s})}),console.table(a),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${d})`);let r=[];o.forEach((s,u)=>{r.push({key:u,value:s})}),console.table(r),console.groupEnd(),console.log(i)}e.logStorage=E}),define(we[213],ye([0,1,3,27,4,23]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(D){if(I.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}async function S(D,T,R,C,w,m,E,f,p,g){const d=Object.create(null);d["common.machineId"]=E,d.sessionID=(0,P.generateUuid)()+Date.now(),d.commitHash=w,d.version=m,d["common.platformVersion"]=(T||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,I.PlatformToString)(I.platform),d["common.nodePlatform"]=t.platform,d["common.nodeArch"]=C,d["common.product"]=g||"desktop";const l=v(f||[]);l&&(d["common.msftInternal"]=l);let c=0;const n=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),I.isLinuxSnap&&(d["common.snap"]="true");const o=k(R);o&&(d["common.platformDetail"]=o);try{const i=await D.readFile(y.URI.file(p));d["common.source"]=i.value.toString().slice(0,30)}catch{}return d}e.resolveCommonProperties=S;function v(D){const T=t.env.USERDNSDOMAIN;if(!T)return!1;const R=T.toLowerCase();return D.some(C=>R===C)}e.verifyMicrosoftInternalDomain=v}),define(we[214],ye([0,1,16,9,2,21]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var k;(function(v){function D(T,R){return T.callstack<R.callstack?-1:T.callstack>R.callstack?1:0}v.compare=D})(k=e.ErrorEvent||(e.ErrorEvent={}));class S{constructor(D,T=S.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new y.DisposableStore,this._telemetryService=D,this._flushDelay=T;const R=t.errorHandler.addListener(C=>this._onErrorEvent(C));this._disposables.add((0,y.toDisposable)(R)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(D){if(!D||(D.detail&&D.detail.stack&&(D=D.detail),D instanceof t.ErrorNoTelemetry))return;let T=Array.isArray(D.stack)?D.stack.join(`
`):D.stack,R=D.message?D.message:(0,P.safeStringify)(D);!T||this._enqueue({msg:R,callstack:T})}_enqueue(D){const T=(0,I.binarySearch)(this._buffer,D,k.compare);T<0?(D.count=1,this._buffer.splice(~T,0,D)):(this._buffer[T].count||(this._buffer[T].count=0),this._buffer[T].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let D of this._buffer)this._telemetryService.publicLogError2("UnhandledError",D);this._buffer.length=0}}e.default=S,S.ERROR_FLUSH_TIMEOUT=5*1e3}),define(we[215],ye([0,1,2]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class t extends I.Disposable{constructor(P,k){super();this.telemetryService=P,this.telemetryAppender=k}async call(P,k,S){switch(k){case"updateTelemetryLevel":{const{telemetryLevel:v}=S;return this.telemetryService.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:D}=S;return this.telemetryAppender?this.telemetryAppender.log(v,D):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${k} not found`)}listen(P,k,S){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=t}),define(we[32],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var y;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(y=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(we[216],ye([0,1,24,43,14,63,8,5,3,4,88,22,90,191,18,26,32]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function g(o,i){const a=`${o}::${i.join(":")}`,r=p.get(a);if(r)return r;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,h=new Map,b=2e4;function A(G,Q,_,X){const F=Q.substring(G.length+1);return y.Promises.withAsyncBody(async U=>{let le;try{le=await R.Promises.readdir(Q,{withFileTypes:!0})}catch{U();return}if(X.count>=b){X.count+=le.length,X.maxReached=!0,U();return}let j=le.length;if(j===0){U();return}let $=le;X.count+le.length>b&&(X.maxReached=!0,j=b-X.count,$=le.slice(0,j)),X.count+=le.length;for(const O of $)if(O.isDirectory()){if(_.includes(O.name)||await A(G,(0,S.join)(Q,O.name),_,X),--j==0){U();return}}else{const M=O.name.lastIndexOf(".");if(M>=0){const W=O.name.substring(M+1);W&&u.set(W,(u.get(W)??0)+1)}for(const W of s)W.relativePathPattern?.test(F)!==!1&&W.filePattern.test(O.name)&&h.set(W.tag,(h.get(W.tag)??0)+1);if(--j==0){U();return}}})}const B=y.Promises.withAsyncBody(async G=>{const Q={count:0,maxReached:!1};await A(o,o,i,Q);const _=await c(o);G({configFiles:d(h),fileTypes:d(u),fileCount:Q.count,maxFilesReached:Q.maxReached,launchConfigFiles:_})});return p.set(a,B),B}e.collectWorkspaceStats=g;function d(o){return[...t.Iterable.map(o.entries(),([i,a])=>({name:i,count:a}))].sort((i,a)=>a.count-i.count)}function l(){const o={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(T.virtualMachineHint.value()*100)}%`},i=I.cpus();return i&&i.length>0&&(o.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),o}e.getMachineInfo=l;async function c(o){try{const i=new Map,a=(0,S.join)(o,".vscode","launch.json"),r=await R.Promises.readFile(a),s=[],u=(0,P.parse)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${a}`),[];if((0,P.getNodeType)(u)==="object"&&u.configurations)for(const h of u.configurations){const b=h.type;b&&(i.has(b)?i.set(b,i.get(b)+1):i.set(b,1))}return d(i)}catch{return[]}}e.collectLaunchConfigs=c;let n=class{constructor(i,a){this.telemetryService=i,this.productService=a}formatMachineInfo(i){const a=[];return a.push(`OS Version:       ${i.os}`),a.push(`CPUs:             ${i.cpus}`),a.push(`Memory (System):  ${i.memory}`),a.push(`VM:               ${i.vmHint}`),a.join(`
`)}formatEnvironment(i){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const r=I.cpus();return r&&r.length>0&&a.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),a.push(`Memory (System):  ${(I.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),v.isWindows||a.push(`Load (avg):       ${I.loadavg().map(s=>Math.round(s)).join(", ")}`),a.push(`VM:               ${Math.round(T.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${i.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(i,a){return Promise.all([(0,C.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async r=>{let[s,u]=r,h=this.formatProcessList(i,s);return a.forEach(b=>{if((0,w.isRemoteDiagnosticError)(b))h+=`
${b.errorMessage}`,u+=`
${b.errorMessage}`;else if(h+=`

Remote: ${b.hostName}`,b.processes&&(h+=`
${this.formatProcessList(i,b.processes)}`),b.workspaceMetadata){u+=`
|  Remote: ${b.hostName}`;for(const A of Object.keys(b.workspaceMetadata)){const B=b.workspaceMetadata[A];let G=`${B.fileCount} files`;B.maxFilesReached&&(G=`more than ${G}`),u+=`|    Folder (${A}): ${G}`,u+=this.formatWorkspaceStats(B)}}}),{processInfo:h,workspaceInfo:u}})}async getSystemInfo(i,a){const{memory:r,vmHint:s,os:u,cpus:h}=l(),b={os:u,memory:r,cpus:h,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:a};return v.isWindows||(b.load=`${I.loadavg().map(A=>Math.round(A)).join(", ")}`),v.isLinux&&(b.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(b)}async getDiagnostics(i,a){const r=[];return(0,C.listProcesses)(i.mainPID).then(async s=>(r.push(""),r.push(this.formatEnvironment(i)),r.push(""),r.push(this.formatProcessList(i,s)),i.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(i))),a.forEach(u=>{if((0,w.isRemoteDiagnosticError)(u))r.push(`
${u.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${u.hostName}`),r.push(this.formatMachineInfo(u.machineInfo)),u.processes&&r.push(this.formatProcessList(i,u.processes)),u.workspaceMetadata)for(const h of Object.keys(u.workspaceMetadata)){const b=u.workspaceMetadata[h];let A=`${b.fileCount} files`;b.maxFilesReached&&(A=`more than ${A}`),r.push(`Folder (${h}): ${A}`),r.push(this.formatWorkspaceStats(b))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(i){const a=[],r=60;let s=0;const u=(B,G)=>{const Q=` ${B}(${G})`;s+Q.length>r?(a.push(h),h="|                 ",s=h.length):s+=Q.length,h+=Q};let h="|      File types:";const b=10;let A=i.fileTypes.length>b?b:i.fileTypes.length;for(let B=0;B<A;B++){const G=i.fileTypes[B];u(G.name,G.count)}if(a.push(h),i.configFiles.length>=0&&(h="|      Conf files:",s=0,i.configFiles.forEach(B=>{u(B.name,B.count)}),a.push(h)),i.launchConfigFiles.length>0){let B="|      Launch Configs:";i.launchConfigFiles.forEach(G=>{B+=G.count>1?` ${G.name}(${G.count})`:` ${G.name}`}),a.push(B)}return a.join(`
`)}expandGPUFeatures(i){const a=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(a-r.length)}  ${i[r]}`).join(`
                  `)}formatWorkspaceMetadata(i){const a=[],r=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(a.push(`|  Window (${s.title})`),s.folderURIs.forEach(u=>{const h=D.URI.revive(u);if(h.scheme===k.Schemas.file){const b=h.fsPath;r.push(g(b,["node_modules",".git"]).then(A=>{let B=`${A.fileCount} files`;A.maxFilesReached&&(B=`more than ${B}`),a.push(`|    Folder (${(0,S.basename)(b)}): ${B}`),a.push(this.formatWorkspaceStats(A))}).catch(A=>{a.push(`|      Error: Unable to collect workspace stats for folder ${b} (${A.toString()})`)}))}else a.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>a.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,a){const r=new Map;i.windows.forEach(u=>r.set(u.pid,u.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(i.mainPID,r,s,a,0),s.join(`
`)}formatProcessItem(i,a,r,s,u){const h=u===0;let b;h?b=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(b=`${"  ".repeat(u)} ${s.name}`,s.name==="window"&&(b=`${b} (${a.get(s.pid)})`));const A=process.platform==="win32"?s.mem:I.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(A/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${b}`),Array.isArray(s.children)&&s.children.forEach(B=>this.formatProcessItem(i,a,r,B,u+1))}async getWorkspaceFileExtensions(i){const a=new Set;for(const{uri:r}of i.folders){const s=D.URI.revive(r);if(s.scheme!==k.Schemas.file)continue;const u=s.fsPath;try{(await g(u,["node_modules",".git"])).fileTypes.forEach(b=>a.add(b.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(i){for(const{uri:a}of i.folders){const r=D.URI.revive(a);if(r.scheme!==k.Schemas.file)continue;const s=r.fsPath;try{const u=await g(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),u.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:h.name,count:h.count})}),u.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:h.name,count:h.count})}),u.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};n=Re([Oe(0,f.ITelemetryService),Oe(1,E.IProductService)],n),e.DiagnosticsService=n}),define(we[217],ye([0,1,16,14,20,9,6,2,3,4,158,31,35,13,26,32]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let f=class extends S.Disposable{constructor(n,o,i,a){super();this.galleryService=n,this.telemetryService=o,this.logService=i,this.productService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,S.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const o=await this.getTargetPlatform();return n.allTargetPlatforms.some(i=>(0,R.isTargetPlatformCompatible)(i,n.allTargetPlatforms,o))}async installFromGallery(n,o={}){try{if(!this.galleryService.isEnabled())throw new R.ExtensionManagementError(T.localize(0,null),R.ExtensionManagementErrorCode.Internal);const i=await this.checkAndGetCompatibleVersion(n,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.installExtension(i.manifest,i.extension,o)}catch(i){throw d(this.telemetryService,"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(n),error:i}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(i),g(i)}}async uninstall(n,o={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.unininstallExtension(n,o)}async reinstallFromGallery(n){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",n.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(1,null));const o=await this.getTargetPlatform(),[i]=await this.galleryService.getExtensions([{...n.identifier,preRelease:n.preRelease}],{targetPlatform:o,compatible:!0},y.CancellationToken.None);if(!i)throw new Error(T.localize(2,null));await this.createUninstallExtensionTask(n,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,o,i){if(!D.URI.isUri(o)){let h=this.installingExtensions.get(C.ExtensionKey.create(o).toString());if(h)return this.logService.info("Extensions is already requested to install",o.identifier.id),h.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],r=[],s=this.createInstallExtensionTask(n,o,i);D.URI.isUri(o)||this.installingExtensions.set(C.ExtensionKey.create(o).toString(),s),this._onInstallExtension.fire({identifier:s.identifier,source:o}),this.logService.info("Installing extension:",s.identifier.id),a.push({task:s,manifest:n});let u=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",s.identifier.id);else try{const b=await this.getAllDepsAndPackExtensionsToInstall(s.identifier,n,!!i.installOnlyNewlyAddedFromExtensionPack,!!i.installPreReleaseVersion);for(const{gallery:A,manifest:B}of b){u=u||!!B.extensionDependencies?.some(Q=>(0,C.areSameExtensions)({id:Q},s.identifier));const G=C.ExtensionKey.create(A).toString();if(this.installingExtensions.has(G))this.logService.info("Extension is already requested to install",A.identifier.id);else{const Q=this.createInstallExtensionTask(B,A,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(G,Q),this._onInstallExtension.fire({identifier:Q.identifier,source:A}),this.logService.info("Installing extension:",Q.identifier.id),a.push({task:Q,manifest:B})}}}catch(b){if(D.URI.isUri(s.source))(0,I.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",s.identifier.id,b.message),(0,I.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",s.identifier.id,b.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",s.identifier.id),b}const h=a.reduce((b,{task:A,manifest:B})=>(b.set(A.identifier.id.toLowerCase(),{task:A,manifest:B}),b),new Map);for(;h.size;){let b;const A=[...h.values()].filter(({manifest:B})=>!B.extensionDependencies?.some(G=>h.has(G.toLowerCase())));A.length?b=h.size===1?A:A.filter(({task:B})=>!(B===s&&!u)):(this.logService.info("Found extensions with circular dependencies",A.map(({task:B})=>B.identifier.id)),b=[...h.values()]),await this.joinAllSettled(b.map(async({task:B})=>{const G=new Date().getTime();try{const Q=await B.run();if(await this.joinAllSettled(this.participants.map(_=>_.postInstall(Q,B.source,i,y.CancellationToken.None))),!D.URI.isUri(B.source)){const _=B.operation===3;if(d(this.telemetryService,_?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(B.source),duration:new Date().getTime()-G,durationSinceUpdate:_?void 0:new Date().getTime()-B.source.lastUpdated}),v.isWeb&&B.operation!==3)try{await this.galleryService.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}r.push({local:Q,identifier:B.identifier,operation:B.operation,source:B.source})}catch(Q){throw D.URI.isUri(B.source)||d(this.telemetryService,B.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(B.source),duration:new Date().getTime()-G,error:Q}),this.logService.error("Error while installing the extension:",B.identifier.id),Q}finally{h.delete(B.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:b})=>this.logService.info("Extension installed successfully:",b.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:b})=>(0,C.areSameExtensions)(b,s.identifier))[0].local}catch(h){if(a.forEach(({task:b})=>b.cancel()),r.length)try{const b=await Promise.allSettled(r.map(({local:A})=>this.createUninstallExtensionTask(A,{versionOnly:!0}).run()));for(let A=0;A<b.length;A++){const B=b[A],{identifier:G}=r[A];B.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",G.id):this.logService.warn("Rollback: Error while uninstalling extension",G.id,(0,P.getErrorMessage)(B.reason))}}catch(b){this.logService.warn("Error while rolling back extensions",(0,P.getErrorMessage)(b),r.map(({identifier:A})=>A.id))}throw this._onDidInstallExtensions.fire(a.map(({task:b})=>({identifier:b.identifier,operation:2,source:b.source}))),h}finally{for(const{task:h}of a)if(!D.URI.isUri(h.source)){const b=C.ExtensionKey.create(h.source).toString();this.installingExtensions.delete(b)||this.logService.warn("Installation task is not found in the cache",b)}}}async joinAllSettled(n){const o=[],i=[],a=await Promise.allSettled(n);for(const r of a)r.status==="fulfilled"?o.push(r.value):i.push(r.reason);if(i.length)throw p(i);return o}async getAllDepsAndPackExtensionsToInstall(n,o,i,a){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const s=[n,...r.map(b=>b.identifier)],u=[],h=async(b,A)=>{const B=A.extensionDependencies||[],G=[...B];if(A.extensionPack){const Q=i?r.find(_=>(0,C.areSameExtensions)(_.identifier,b)):void 0;for(const _ of A.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(X=>(0,C.areSameExtensions)({id:X},{id:_}))||G.every(X=>!(0,C.areSameExtensions)({id:X},{id:_}))&&G.push(_)}if(G.length){const Q=[...s,...u.map(X=>X.gallery.identifier)],_=G.filter(X=>Q.every(F=>!(0,C.areSameExtensions)(F,{id:X})));if(_.length){const X=await this.galleryService.getExtensions(_.map(F=>({id:F,preRelease:a})),y.CancellationToken.None);for(const F of X){if(Q.find(j=>(0,C.areSameExtensions)(j,F.identifier)))continue;const U=B.some(j=>(0,C.areSameExtensions)({id:j},F.identifier));let le;try{le=await this.checkAndGetCompatibleVersion(F,!1,a)}catch(j){if(j instanceof R.ExtensionManagementError&&j.code===R.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!U){this.logService.info("Skipping the packed extension as it cannot be installed",F.identifier.id);continue}else throw j}u.push({gallery:le.extension,manifest:le.manifest}),await h(le.extension.identifier,le.manifest)}}}};return await h(n,o),r=await this.getInstalled(),u.filter(b=>!r.some(A=>(0,C.areSameExtensions)(A.identifier,b.gallery.identifier)))}async checkAndGetCompatibleVersion(n,o,i){const a=await this.getExtensionsControlManifest();if((0,C.getMaliciousExtensionsSet)(a).has(n.identifier.id))throw new R.ExtensionManagementError(T.localize(3,null,n.identifier.id),R.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const u=await this.getTargetPlatform();throw new R.ExtensionManagementError(T.localize(4,null,n.identifier.id,this.productService.nameLong,(0,R.TargetPlatformToString)(u)),R.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const r=await this.getCompatibleVersion(n,o,i);if(r){if(i&&!o&&n.hasPreReleaseVersion&&!r.properties.isPreReleaseVersion)throw new R.ExtensionManagementError(T.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!i&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],y.CancellationToken.None))[0]?new R.ExtensionManagementError(T.localize(6,null,n.identifier.id),R.ExtensionManagementErrorCode.ReleaseVersionNotFound):new R.ExtensionManagementError(T.localize(7,null,n.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",r.identifier.id);const s=await this.galleryService.getManifest(r,y.CancellationToken.None);if(s===null)throw new R.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,R.ExtensionManagementErrorCode.Invalid);if(s.version!==r.version)throw new R.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,R.ExtensionManagementErrorCode.Invalid);return{extension:r,manifest:s}}async getCompatibleVersion(n,o,i){const a=await this.getTargetPlatform();let r=null;return!o&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==i&&(r=(await this.galleryService.getExtensions([{...n.identifier,preRelease:i}],{targetPlatform:a,compatible:!0},y.CancellationToken.None))[0]||null),!r&&await this.galleryService.isExtensionCompatible(n,i,a)&&(r=n),r||(o?r=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:a,compatible:!0},y.CancellationToken.None))[0]||null:r=await this.galleryService.getCompatibleExtension(n,i,a)),r}async unininstallExtension(n,o){const i=this.uninstallingExtensions.get(n.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),i.waitUntilTaskIsFinished();const a=(h,b)=>{const A=this.createUninstallExtensionTask(h,b);return this.uninstallingExtensions.set(A.extension.identifier.id.toLowerCase(),A),this.logService.info("Uninstalling extension:",h.identifier.id),this._onUninstallExtension.fire(h.identifier),A},r=(h,b)=>{b?this.logService.error("Failed to uninstall extension:",h.identifier.id,b.message):this.logService.info("Successfully uninstalled extension:",h.identifier.id),d(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,C.getLocalExtensionTelemetryData)(h),error:b}),this._onDidUninstallExtension.fire({identifier:h.identifier,error:b?.code})},s=[],u=[];try{s.push(a(n,{}));const h=await this.getInstalled(1);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",n.identifier.id);else{const b=this.getAllPackExtensionsToUninstall(n,h);for(const A of b)this.uninstallingExtensions.has(A.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",A.identifier.id):s.push(a(A,{}))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",n.identifier.id):this.checkForDependents(s.map(b=>b.extension),h,n),await this.joinAllSettled(s.map(async b=>{try{if(await b.run(),await this.joinAllSettled(this.participants.map(A=>A.postUninstall(b.extension,o,y.CancellationToken.None))),b.extension.identifier.uuid)try{await this.galleryService.reportStatistic(b.extension.manifest.publisher,b.extension.manifest.name,b.extension.manifest.version,"uninstall")}catch{}r(b.extension)}catch(A){const B=A instanceof R.ExtensionManagementError?A:new R.ExtensionManagementError((0,P.getErrorMessage)(A),R.ExtensionManagementErrorCode.Internal);throw r(b.extension,B),B}finally{u.push(b)}}))}catch(h){const b=h instanceof R.ExtensionManagementError?h:new R.ExtensionManagementError((0,P.getErrorMessage)(h),R.ExtensionManagementErrorCode.Internal);for(const A of s){try{A.cancel()}catch{}u.includes(A)||r(A.extension,b)}throw b}finally{for(const h of s)this.uninstallingExtensions.delete(h.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",h.extension.identifier.id)}}checkForDependents(n,o,i){for(const a of n){const r=this.getDependents(a,o);if(r.length){const s=r.filter(u=>!n.some(h=>(0,C.areSameExtensions)(h.identifier,u.identifier)));if(s.length)throw new Error(this.getDependentsErrorMessage(a,s,i))}}}getDependentsErrorMessage(n,o,i){return i===n?o.length===1?T.localize(8,null,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?T.localize(9,null,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):T.localize(10,null,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?T.localize(11,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?T.localize(12,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):T.localize(13,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(n,o,i=[]){if(i.indexOf(n)!==-1)return[];i.push(n);const a=n.manifest.extensionPack?n.manifest.extensionPack:[];if(a.length){const r=o.filter(u=>!u.isBuiltin&&a.some(h=>(0,C.areSameExtensions)({id:h},u.identifier))),s=[];for(const u of r)s.push(...this.getAllPackExtensionsToUninstall(u,o,i));return[...r,...s]}return[]}getDependents(n,o){return o.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(a=>(0,C.areSameExtensions)({id:a},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};f=Re([Oe(0,R.IExtensionGalleryService),Oe(1,E.ITelemetryService),Oe(2,w.ILogService),Oe(3,m.IProductService)],f),e.AbstractExtensionManagementService=f;function p(c){const n=Array.isArray(c)?c:[c];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((o,i)=>new Error(`${o.message}${o.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}e.joinErrors=p;function g(c){if(c instanceof R.ExtensionManagementError)return c;const n=new R.ExtensionManagementError(c.message,R.ExtensionManagementErrorCode.Internal);return n.stack=c.stack,n}function d(c,n,{extensionData:o,duration:i,error:a,durationSinceUpdate:r}){const s=a?a instanceof R.ExtensionManagementError?a.code:R.ExtensionManagementErrorCode.Internal:void 0;c.publicLog(n,{...o,success:!a,duration:i,errorcode:s,durationSinceUpdate:r})}e.reportTelemetry=d;class l{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>new Promise((o,i)=>{const a=n.onCancellationRequested(()=>{a.dispose(),i(new P.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(we[42],ye([0,1,21,82,12,25,32]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(l,c){return Promise.resolve(void 0)}publicLog2(l,c){return this.publicLog(l,c)}publicLogError(l,c){return Promise.resolve(void 0)}publicLogError2(l,c){return this.publicLogError(l,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class v{async publicLog(l,c,n){}async publicLogError(l,c,n){}}e.NullEndpointTelemetryService=v,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function D(d,l){return l.onDidChangeConfiguration(c=>{c.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(c.source),configurationKeys:f(c.sourceConfig)})})}e.configurationTelemetry=D;function T(d,l){return!(l.disableTelemetry||!d.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=T;function R(d){const l=d.getValue(k.TELEMETRY_SETTING_ID),c=d.getValue("telemetry.enableCrashReporter");if(d.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=R;function C(d){const l=Object.create(null),c=Object.create(null),n=Object.create(null);E(d,n);for(let o in n){o=o.length>150?o.substr(o.length-149):o;const i=n[o];typeof i=="number"?c[o]=i:typeof i=="boolean"?c[o]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${i.length}`),l[o]=i.substring(0,8191)):typeof i!="undefined"&&i!==null&&(l[o]=i)}return{properties:l,measurements:c}}e.validateTelemetryData=C;const w=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function m(d){if(!d)return"none";for(const l of w)if(d.startsWith(`${l}+`))return l;return"other"}e.cleanRemoteAuthority=m;function E(d,l,c=0,n){if(!!d)for(let o of Object.getOwnPropertyNames(d)){const i=d[o],a=n?n+o:o;Array.isArray(i)?l[a]=(0,I.safeStringify)(i):i instanceof Date?l[a]=i.toISOString():(0,y.isObject)(i)?c<2?E(i,l,c+1,a+"."):l[a]=(0,I.safeStringify)(i):l[a]=i}}function f(d){if(!d)return[];const l=[];return p(l,"",d),l}function p(d,l,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(n=>p(d,l?`${l}.${n}`:n,c[n])):d.push(l)}function g(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.getPiiPathsFromEnvironment=g}),define(we[218],ye([0,1,188,42]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function y(P,k,S,v,D,T){const R={"X-Market-Client-Id":`VSCode ${P}`,"User-Agent":`VSCode ${P} (${k.nameShort})`},C=await(0,I.getServiceMachineId)(S,D,T);return(0,t.supportsTelemetry)(k,S)&&(0,t.getTelemetryLevel)(v)===3&&(R["X-Market-User-Id"]=C),R}e.resolveMarketplaceHeaders=y}),define(we[107],ye([0,1,16,20,9,21,3,27,12,4,25,28,31,35,69,18,13,26,51,218,212,32]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f,p,g,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const n=k.isWeb?"web":(0,C.getTargetPlatform)(k.platform,S.arch);var o;(function(ee){ee[ee.None=0]="None",ee[ee.IncludeVersions=1]="IncludeVersions",ee[ee.IncludeFiles=2]="IncludeFiles",ee[ee.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",ee[ee.IncludeSharedAccounts=8]="IncludeSharedAccounts",ee[ee.IncludeVersionProperties=16]="IncludeVersionProperties",ee[ee.ExcludeNonValidated=32]="ExcludeNonValidated",ee[ee.IncludeInstallationTargets=64]="IncludeInstallationTargets",ee[ee.IncludeAssetUri=128]="IncludeAssetUri",ee[ee.IncludeStatistics=256]="IncludeStatistics",ee[ee.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",ee[ee.Unpublished=4096]="Unpublished",ee[ee.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function i(...ee){return String(ee.reduce((x,z)=>x|z,0))}var a;(function(ee){ee[ee.Tag=1]="Tag",ee[ee.ExtensionId=4]="ExtensionId",ee[ee.Category=5]="Category",ee[ee.ExtensionName=7]="ExtensionName",ee[ee.Target=8]="Target",ee[ee.Featured=9]="Featured",ee[ee.SearchText=10]="SearchText",ee[ee.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class b{constructor(x=h){this.state=x}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(x,z=this.state.pageSize){return new b({...this.state,pageNumber:x,pageSize:z})}withFilter(x,...z){const te=[...this.state.criteria,...z.length?z.map(ce=>({filterType:x,value:ce})):[{filterType:x}]];return new b({...this.state,criteria:te})}withSortBy(x){return new b({...this.state,sortBy:x})}withSortOrder(x){return new b({...this.state,sortOrder:x})}withFlags(...x){return new b({...this.state,flags:x.reduce((z,te)=>z|te,0)})}withAssetTypes(...x){return new b({...this.state,assetTypes:x})}withSource(x){return new b({...this.state,source:x})}get raw(){const{criteria:x,pageNumber:z,pageSize:te,sortBy:ce,sortOrder:Z,flags:se,assetTypes:ge}=this.state;return{filters:[{criteria:x,pageNumber:z,pageSize:te,sortBy:ce,sortOrder:Z}],assetTypes:ge,flags:se}}get searchText(){const x=this.state.criteria.filter(z=>z.filterType===a.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(x=>String(x.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function A(ee,x){const z=(ee||[]).filter(te=>te.statisticName===x)[0];return z?z.value:0}function B(ee){const x="Microsoft.VisualStudio.Code.Translation.";return ee.files.filter(te=>te.assetType.indexOf(x)===0).reduce((te,ce)=>{const Z=_(ee,ce.assetType);return Z&&te.push([ce.assetType.substring(x.length),Z]),te},[])}function G(ee){if(ee.properties){const x=ee.properties.filter(ce=>ce.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),te=x.filter(ce=>z.test(ce.value))[0];return te?{uri:te.value,fallbackUri:te.value}:null}return _(ee,r.Repository)}function Q(ee){return{uri:`${ee.fallbackAssetUri}/${r.VSIX}?redirect=true${ee.targetPlatform?`&targetPlatform=${ee.targetPlatform}`:""}`,fallbackUri:`${ee.fallbackAssetUri}/${r.VSIX}${ee.targetPlatform?`?targetPlatform=${ee.targetPlatform}`:""}`}}function _(ee,x){return ee.files.filter(te=>te.assetType===x)[0]?{uri:`${ee.assetUri}/${x}${ee.targetPlatform?`?targetPlatform=${ee.targetPlatform}`:""}`,fallbackUri:`${ee.fallbackAssetUri}/${x}${ee.targetPlatform?`?targetPlatform=${ee.targetPlatform}`:""}`}:null}function X(ee,x){const z=ee.properties?ee.properties.filter(ce=>ce.key===x):[],te=z.length>0&&z[0].value;return te?te.split(",").map(ce=>(0,w.adoptToGalleryExtensionId)(ce)):[]}function F(ee){const x=ee.properties?ee.properties.filter(z=>z.key===s.Engine):[];return x.length>0&&x[0].value||""}function U(ee){const x=ee.properties?ee.properties.filter(z=>z.key===s.PreRelease):[];return x.length>0&&x[0].value==="true"}function le(ee){const x=ee.properties?ee.properties.filter(te=>te.key===s.LocalizedLanguages):[],z=x.length>0&&x[0].value||"";return z?z.split(","):[]}function j(ee){return ee.properties?.find(x=>x.key===s.SponsorLink)?.value}function $(ee){return ee.indexOf("preview")!==-1}function O(ee){return ee.targetPlatform?(0,C.toTargetPlatform)(ee.targetPlatform):"undefined"}function M(ee){const x=(0,I.distinct)(ee.versions.map(O)),z=!!ee.tags?.includes(C.WEB_EXTENSION_TAG),te=x.indexOf("web");return z?te===-1&&x.push("web"):te!==-1&&x.splice(te,1),x}function W(ee,x){const z=(0,C.getFallbackTargetPlarforms)(x);for(let te=0;te<ee.length;te++){const ce=ee[te];if(ce.version===ee[te-1]?.version){let Z=te;const se=O(ce);if(se===x)for(;Z>0&&ee[Z-1].version===ce.version;)Z--;else if(z.includes(se))for(;Z>0&&ee[Z-1].version===ce.version&&O(ee[Z-1])!==x;)Z--;Z!==te&&(ee.splice(te,1),ee.splice(Z,0,ce))}}return ee}e.sortExtensionVersions=W;function J(ee,x,z){ee.telemetryData={index:x,querySource:z}}function ae(ee,x,z){const te=ee.versions[0],ce={manifest:_(x,r.Manifest),readme:_(x,r.Details),changelog:_(x,r.Changelog),license:_(x,r.License),repository:G(x),download:Q(x),icon:_(x,r.Icon),coreTranslations:B(x)};return{identifier:{id:(0,w.getGalleryExtensionId)(ee.publisher.publisherName,ee.extensionName),uuid:ee.extensionId},name:ee.extensionName,version:x.version,displayName:ee.displayName,publisherId:ee.publisher.publisherId,publisher:ee.publisher.publisherName,publisherDisplayName:ee.publisher.displayName,publisherDomain:ee.publisher.domain?{link:ee.publisher.domain,verified:!!ee.publisher.isDomainVerified}:void 0,publisherSponsorLink:j(te),description:ee.shortDescription||"",installCount:A(ee.statistics,"install"),rating:A(ee.statistics,"averagerating"),ratingCount:A(ee.statistics,"ratingcount"),categories:ee.categories||[],tags:ee.tags||[],releaseDate:Date.parse(ee.releaseDate),lastUpdated:Date.parse(ee.lastUpdated),allTargetPlatforms:z,assets:ce,properties:{dependencies:X(x,s.Dependency),extensionPack:X(x,s.ExtensionPack),engine:F(x),localizedLanguages:le(x),targetPlatform:O(x),isPreReleaseVersion:U(x)},hasPreReleaseVersion:U(te),hasReleaseVersion:!0,preview:$(ee.flags)}}let me=class{constructor(x,z,te,ce,Z,se,ge,Y){this.requestService=z,this.logService=te,this.environmentService=ce,this.telemetryService=Z,this.fileService=se,this.productService=ge,this.configurationService=Y;const re=ge.extensionsGallery;this.extensionsGalleryUrl=re&&re.serviceUrl,this.extensionsControlUrl=re&&re.controlUrl,this.commonHeadersPromise=(0,d.resolveMarketplaceHeaders)(ge.version,ge,this.environmentService,this.configurationService,this.fileService,x)}api(x=""){return`${this.extensionsGalleryUrl}${x}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(x,z,te){const ce=t.CancellationToken.isCancellationToken(z)?{}:z,Z=t.CancellationToken.isCancellationToken(z)?z:te,se=[],ge=[],Y=[],re=[];let H=!0;for(const pe of x){pe.uuid?ge.push(pe.uuid):se.push(pe.id);const De=!!(pe.version||pe.preRelease);Y.push({id:pe.id,uuid:pe.uuid,includePreRelease:De}),pe.version&&re.push({id:pe.id,uuid:pe.uuid,version:pe.version}),H=H&&!!pe.hasPreRelease&&!De}if(!ge.length&&!se.length)return[];let K=new b().withPage(1,x.length);ge.length&&(K=K.withFilter(a.ExtensionId,...ge)),se.length&&(K=K.withFilter(a.ExtensionName,...se)),(ce.queryAllVersions||H)&&(K=K.withFlags(K.flags,o.IncludeVersions)),ce.source&&(K=K.withSource(ce.source));const{extensions:ue}=await this.queryGalleryExtensions(K,{targetPlatform:ce.targetPlatform??n,includePreRelease:Y,versions:re,compatible:!!ce.compatible},Z);return ce.source&&ue.forEach((pe,De)=>J(pe,De,ce.source)),ue}async getCompatibleExtension(x,z,te){if((0,C.isNotWebExtensionInWebTargetPlatform)(x.allTargetPlatforms,te))return null;if(await this.isExtensionCompatible(x,z,te))return x;const ce=new b().withFlags(o.IncludeVersions).withPage(1,1).withFilter(a.ExtensionId,x.identifier.uuid),{extensions:Z}=await this.queryGalleryExtensions(ce,{targetPlatform:te,compatible:!0,includePreRelease:z},t.CancellationToken.None);return Z[0]||null}async isExtensionCompatible(x,z,te){if(!(0,C.isTargetPlatformCompatible)(x.properties.targetPlatform,x.allTargetPlatforms,te)||!z&&x.properties.isPreReleaseVersion)return!1;let ce=x.properties.engine;if(!ce){const Z=await this.getManifest(x,t.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");ce=Z.engines.vscode}return(0,m.isEngineValid)(ce,this.productService.version,this.productService.date)}async isValidVersion(x,z,te,ce,Z){if(!(0,C.isTargetPlatformCompatible)(O(x),ce,Z)||z!=="any"&&U(x)!==(z==="prerelease"))return!1;if(te)try{const se=await this.getEngine(x);if(!(0,m.isEngineValid)(se,this.productService.version,this.productService.date))return!1}catch(se){return this.logService.error(`Error while getting the engine for the version ${x.version}.`,(0,y.getErrorMessage)(se)),!1}return!0}async query(x,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let te=x.text||"";const ce=(0,P.getOrDefault)(x,H=>H.pageSize,50);let Z=new b().withPage(1,ce);te?(te=te.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(H,K,ue)=>(Z=Z.withFilter(a.Category,ue||K),"")),te=te.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(H,K,ue)=>(Z=Z.withFilter(a.Tag,ue||K),"")),te=te.replace(/\bfeatured(\s+|\b|$)/g,()=>(Z=Z.withFilter(a.Featured),"")),te=te.trim(),te&&(te=te.length<200?te:te.substring(0,200),Z=Z.withFilter(a.SearchText,te)),Z=Z.withSortBy(0)):x.ids?Z=Z.withFilter(a.ExtensionId,...x.ids):x.names?Z=Z.withFilter(a.ExtensionName,...x.names):Z=Z.withSortBy(4),typeof x.sortBy=="number"&&(Z=Z.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(Z=Z.withSortOrder(x.sortOrder)),x.source&&(Z=Z.withSource(x.source));const se=async(H,K)=>{const{extensions:ue,total:pe}=await this.queryGalleryExtensions(H,{targetPlatform:n,compatible:!1,includePreRelease:!!x.includePreRelease},K);return ue.forEach((De,Te)=>J(De,(H.pageNumber-1)*H.pageSize+Te,x.source)),{extensions:ue,total:pe}},{extensions:ge,total:Y}=await se(Z,z),re=async(H,K)=>{if(K.isCancellationRequested)throw new y.CancellationError;const{extensions:ue}=await se(Z.withPage(H+1),K);return ue};return{firstPage:ge,total:Y,pageSize:Z.pageSize,getPage:re}}async queryGalleryExtensions(x,z,te){const ce=x.flags;!!(x.flags&o.IncludeLatestVersionOnly)&&!!(x.flags&o.IncludeVersions)&&(x=x.withFlags(x.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(x.flags&o.IncludeLatestVersionOnly)&&!(x.flags&o.IncludeVersions)&&(x=x.withFlags(x.flags,o.IncludeLatestVersionOnly)),z.versions?.length&&(x=x.withFlags(x.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),x=x.withFlags(x.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:Z,total:se}=await this.queryRawGalleryExtensions(x,te);if(!(x.flags&o.IncludeLatestVersionOnly)){const H=[];for(const K of Z){const ue=await this.toGalleryExtensionWithCriteria(K,z);ue&&H.push(ue)}return{extensions:H,total:se}}const Y=[],re=new Map;for(let H=0;H<Z.length;H++){const K=Z[H],ue={id:(0,w.getGalleryExtensionId)(K.publisher.publisherName,K.extensionName),uuid:K.extensionId},pe=(0,v.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Te=>(0,w.areSameExtensions)(Te,ue))?.includePreRelease;if(z.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(M(K),z.targetPlatform))continue;const De=await this.toGalleryExtensionWithCriteria(K,z);!De||De.properties.isPreReleaseVersion&&(!pe||!De.hasReleaseVersion)||!De.properties.isPreReleaseVersion&&De.properties.targetPlatform!==z.targetPlatform&&De.hasPreReleaseVersion?re.set(K.extensionId,H):Y.push([H,De])}if(re.size){const H=new Date().getTime(),K=new b().withFlags(ce&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,re.size).withFilter(a.ExtensionId,...re.keys()),{extensions:ue}=await this.queryGalleryExtensions(K,z,te);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-H,count:re.size});for(const pe of ue){const De=re.get(pe.identifier.uuid);Y.push([De,pe])}}return{extensions:Y.sort((H,K)=>H[0]-K[0]).map(([,H])=>H),total:se}}async toGalleryExtensionWithCriteria(x,z){const te={id:(0,w.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},ce=z.versions?.find(Y=>(0,w.areSameExtensions)(Y,te))?.version,Z=(0,v.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Y=>(0,w.areSameExtensions)(Y,te))?.includePreRelease,se=M(x),ge=W(x.versions,z.targetPlatform);if(z.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(se,z.targetPlatform))return null;for(let Y=0;Y<ge.length;Y++){const re=ge[Y];if(!(ce&&re.version!==ce)){if(await this.isValidVersion(re,Z?"any":"release",z.compatible,se,z.targetPlatform))return ae(x,re,se);if(ce&&re.version===ce)return null}}return ce||z.compatible?null:ae(x,x.versions[0],se)}async queryRawGalleryExtensions(x,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,o.ExcludeNonValidated).withFilter(a.Target,"Microsoft.VisualStudio.Code").withFilter(a.ExcludeWithFlags,i(o.Unpublished));const te=await this.commonHeadersPromise,ce=JSON.stringify(x.raw),Z={...te,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ce.length)},se=new Date().getTime();let ge,Y,re=0;try{if(ge=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ce,headers:Z},z),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:re};const H=await(0,g.asJson)(ge);if(H){const K=H.results[0],ue=K.extensions,pe=K.resultMetadata&&K.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return re=pe&&pe.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:ue,total:re}}return{galleryExtensions:[],total:re}}catch(H){throw Y=H,H}finally{this.telemetryService.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(ce.length),duration:new Date().getTime()-se,success:!!ge&&(0,g.isSuccess)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:Y?(0,y.isCancellationError)(Y)?"canceled":(0,y.getErrorMessage)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(re)})}}async reportStatistic(x,z,te,ce){if(!this.isEnabled())return;const Z=k.isWeb?this.api(`/itemName/${x}.${z}/version/${te}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${x}/extensions/${z}/${te}/stats?statType=${ce}`),se=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Y={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:Z,headers:Y},t.CancellationToken.None)}catch{}}async download(x,z,te){this.logService.trace("ExtensionGalleryService#download",x.identifier.id);const ce=(0,w.getGalleryExtensionTelemetryData)(x),Z=new Date().getTime(),se=H=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:H}),ge=te===2?"install":te===3?"update":"",Y=ge?{uri:`${x.assets.download.uri}${D.URI.parse(x.assets.download.uri).query?"&":"?"}${ge}=true`,fallbackUri:`${x.assets.download.fallbackUri}${D.URI.parse(x.assets.download.fallbackUri).query?"&":"?"}${ge}=true`}:x.assets.download,re=await this.getAsset(Y);await this.fileService.writeFile(z,re.stream),se(new Date().getTime()-Z)}async getReadme(x,z){if(x.assets.readme){const te=await this.getAsset(x.assets.readme,{},z);return await(0,g.asTextOrError)(te)||""}return""}async getManifest(x,z){if(x.assets.manifest){const te=await this.getAsset(x.assets.manifest,{},z),ce=await(0,g.asTextOrError)(te);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(x,z){const te=_(x,r.Manifest);if(!te)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},Z=await this.getAsset(te,{headers:ce});return await(0,g.asJson)(Z)}async getCoreTranslation(x,z){const te=x.assets.coreTranslations.filter(ce=>ce[0]===z.toUpperCase())[0];if(te){const ce=await this.getAsset(te[1]),Z=await(0,g.asTextOrError)(ce);return Z?JSON.parse(Z):null}return null}async getChangelog(x,z){if(x.assets.changelog){const te=await this.getAsset(x.assets.changelog,{},z);return await(0,g.asTextOrError)(te)||""}return""}async getAllCompatibleVersions(x,z,te){let ce=new b().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);x.identifier.uuid?ce=ce.withFilter(a.ExtensionId,x.identifier.uuid):ce=ce.withFilter(a.ExtensionName,x.identifier.id);const{galleryExtensions:Z}=await this.queryRawGalleryExtensions(ce,t.CancellationToken.None);if(!Z.length)return[];const se=M(Z[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(se,te))return[];const ge=[];await Promise.all(Z[0].versions.map(async H=>{try{await this.isValidVersion(H,z?"any":"release",!0,se,te)&&ge.push(H)}catch{}}));const Y=[],re=new Set;for(const H of W(ge,te))re.has(H.version)||(re.add(H.version),Y.push({version:H.version,date:H.lastUpdated,isPreReleaseVersion:U(H)}));return Y}async getAsset(x,z={},te=t.CancellationToken.None){const ce=await this.commonHeadersPromise,Z={type:"GET"},se={...ce,...z.headers||{}};z={...z,...Z,headers:se};const ge=x.uri,Y=x.fallbackUri,re={...z,url:ge};try{const H=await this.requestService.request(re,te);if(H.res.statusCode===200)return H;const K=await(0,g.asTextOrError)(H);throw new Error(`Expected 200, got back ${H.res.statusCode} instead.

${K}`)}catch(H){if((0,y.isCancellationError)(H))throw H;const K=(0,y.getErrorMessage)(H);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ge,message:K});const ue={...z,url:Y};return this.requestService.request(ue,te)}}async getEngine(x){let z=F(x);if(!z){const te=await this.getManifestFromRawExtensionVersion(x,t.CancellationToken.None);if(!te)throw new Error("Manifest was not found");z=te.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const x=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,g.asJson)(x),te=[],ce={};if(z){for(const Z of z.malicious)te.push({id:Z});if(z.migrateToPreRelease)for(const[Z,se]of Object.entries(z.migrateToPreRelease))(!se.engine||(0,m.isEngineValid)(se.engine,this.productService.version,this.productService.date))&&(ce[Z.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[Z,se]of Object.entries(z.deprecated))se&&(ce[Z.toLowerCase()]=(0,v.isBoolean)(se)?{}:se)}return{malicious:te,deprecated:ce}}};me=Re([Oe(1,g.IRequestService),Oe(2,f.ILogService),Oe(3,R.IEnvironmentService),Oe(4,c.ITelemetryService),Oe(5,E.IFileService),Oe(6,p.IProductService),Oe(7,T.IConfigurationService)],me);let fe=class extends me{constructor(x,z,te,ce,Z,se,ge,Y){super(x,z,te,ce,Z,se,ge,Y)}};fe=Re([Oe(0,l.IStorageService),Oe(1,g.IRequestService),Oe(2,f.ILogService),Oe(3,R.IEnvironmentService),Oe(4,c.ITelemetryService),Oe(5,E.IFileService),Oe(6,p.IProductService),Oe(7,T.IConfigurationService)],fe),e.ExtensionGalleryService=fe;let V=class extends me{constructor(x,z,te,ce,Z,se,ge){super(void 0,x,z,te,ce,Z,se,ge)}};V=Re([Oe(0,g.IRequestService),Oe(1,f.ILogService),Oe(2,R.IEnvironmentService),Oe(3,c.ITelemetryService),Oe(4,E.IFileService),Oe(5,p.IProductService),Oe(6,T.IConfigurationService)],V),e.ExtensionGalleryServiceWithNoStorageService=V}),define(we[219],ye([0,1,2,21,82,3,15,173,25,49,48,26,34,32,42]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(g,d,l){this._configurationService=d,this._productService=l,this._experimentProperties={},this.telemetryLevel=new y.MutableObservableValue(3),this._disposables=new I.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,d){this._experimentProperties[g]=d}_updateTelemetryLevel(){let g=(0,m.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const l=d.usage?3:d.error?2:0;g=Math.min(g,l)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties;let d=g.sessionID,l=g["common.machineId"],c=g["common.firstSessionDate"],n=g["common.msftInternal"];return{sessionId:d,machineId:l,firstSessionDate:c,msftInternal:n}}dispose(){this._disposables.dispose()}_log(g,d,l,c){return this.telemetryLevel.value<d?Promise.resolve(void 0):this._commonProperties.then(n=>{l=(0,t.mixin)(l,n),l=(0,t.mixin)(l,this._experimentProperties),l=(0,t.cloneAndChange)(l,o=>{if(typeof o=="string")return this._cleanupInfo(o,c)}),this._appenders.forEach(o=>o.log(g,l))},n=>{console.error(n)})}publicLog(g,d,l){return this._log(g,3,d,l)}publicLog2(g,d,l){return this.publicLog(g,d,l)}publicLogError(g,d){return this._sendErrorTelemetry?this._log(g,2,d,!0):Promise.resolve(void 0)}publicLogError2(g,d){return this.publicLogError(g,d)}_anonymizeFilePaths(g){let d=g;const l=[];for(let i of this._cleanupPatterns)for(;;){const a=i.exec(g);if(!a)break;l.push([a.index,i.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(d="";;){const i=n.exec(g);if(!i)break;!c.test(i[0])&&l.every(([a,r])=>i.index<a||i.index>=r)&&(d+=g.substring(o,i.index)+"<REDACTED: user-file-path>",o=n.lastIndex)}return o<g.length&&(d+=g.substr(o)),d}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const d=g.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of l)if(c.regex.test(d))return`<REDACTED: ${c.label}>`;return g}_cleanupInfo(g,d){let l=g;d&&(l=this._anonymizeFilePaths(l));for(let c of this._cleanupPatterns)l=l.replace(c,"");return l=this._removePropertiesWithPossibleUserInfo(l),l}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=Re([Oe(1,v.IConfigurationService),Oe(2,R.IProductService)],E),e.TelemetryService=E;function f(){const p=(0,S.localize)(0,null,T.default.nameLong),g=T.default.privacyStatementUrl?(0,S.localize)(2,null,"https://aka.ms/vscode-telemetry",T.default.privacyStatementUrl):(0,S.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=P.isWeb?"":(0,S.localize)(3,null),l=(0,S.localize)(4,null),c=(0,S.localize)(5,null),n=(0,S.localize)(6,null),o=(0,S.localize)(7,null),i=`
|       | ${l} | ${c} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,S.localize)(8,null);return`
${p} ${g} ${d}

&nbsp;

${o}
${i}

&nbsp;

${a}
`}C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,S.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,S.localize)(10,null),(0,S.localize)(11,null),(0,S.localize)(12,null),(0,S.localize)(13,null)],markdownDescription:f(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,S.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:T.default.privacyStatementUrl?(0,S.localize)(16,null,T.default.nameLong,T.default.privacyStatementUrl):(0,S.localize)(15,null,T.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,S.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(we[220],ye([0,1,25,7,26,32,219,42]),function(ie,e,I,t,y,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let v=class extends k.TelemetryService{constructor(T,R,C,w){super(T,C,w);this._injectedTelemetryLevel=R}publicLog(T,R,C){return this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(T,R,C)}publicLog2(T,R,C){return this.publicLog(T,R,C)}publicLogError(T,R){return this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(T,R)}publicLogError2(T,R){return this.publicLogError(T,R)}async updateInjectedTelemetryLevel(T){if(T===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,T):T,this._injectedTelemetryLevel===0&&this.dispose()}};v=Re([Oe(2,I.IConfigurationService),Oe(3,y.IProductService)],v),e.ServerTelemetryService=v,e.ServerNullTelemetryService=new class extends S.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,t.refineServiceDecorator)(P.ITelemetryService)}),define(we[221],ye([0,1,9,21,42]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function P(S){const v=await new Promise((T,R)=>{ie(["applicationinsights"],T,R)});let D;return v.defaultClient?(D=new v.TelemetryClient(S),D.channel.setUseDiskRetryCaching(!0)):(v.setup(S).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),D=v.defaultClient),S.indexOf("AIF-")===0&&(D.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),D}class k{constructor(v,D,T){this._eventPrefix=v,this._defaultData=D,this._defaultData||(this._defaultData=Object.create(null)),typeof T=="function"?this._aiClient=T():this._aiClient=T,this._asyncAIClient=null}_withAIClient(v){if(!!this._aiClient){if(typeof this._aiClient!="string"){v(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=P(this._aiClient)),this._asyncAIClient.then(D=>{v(D)},D=>{(0,I.onUnexpectedError)(D),console.error(D)})}}log(v,D){if(!!this._aiClient){D=(0,t.mixin)(D,this._defaultData),D=(0,y.validateTelemetryData)(D);try{this._withAIClient(T=>T.trackEvent({name:this._eventPrefix+"/"+v,properties:D.properties,measurements:D.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(v=>{this._withAIClient(D=>{try{D.flush({callback:()=>{this._aiClient=void 0,v(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(we[222],ye([0,1,9,214]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class y extends t.default{installErrorListeners(){(0,I.setUnexpectedErrorHandler)(S=>console.error(S));const k=[];process.on("unhandledRejection",(S,v)=>{k.push(v),setTimeout(()=>{const D=k.indexOf(v);D>=0&&v.catch(T=>{k.splice(D,1),(0,I.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),S&&(0,I.onUnexpectedError)(S))})},1e3)}),process.on("rejectionHandled",S=>{const v=k.indexOf(S);v>=0&&k.splice(v,1)}),process.on("uncaughtException",S=>{(0,I.onUnexpectedError)(S)})}}e.default=y}),define(we[223],ye([0,1,14,20,6,2,13]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let S=class extends P.Disposable{constructor(D,T){super();this._logService=T,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new y.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=D===void 0?15e3:D}createRequest(D){return new Promise((T,R)=>{const C=++this._lastRequestId;this._pendingRequests.set(C,T),this._onCreateRequest.fire({requestId:C,...D});const w=new t.CancellationTokenSource;(0,I.timeout)(this._timeout,w.token).then(()=>R(`Request ${C} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(C,[(0,P.toDisposable)(()=>w.cancel())])})}acceptReply(D,T){const R=this._pendingRequests.get(D);R?(this._pendingRequests.delete(D),(0,P.dispose)(this._pendingRequestDisposables.get(D)||[]),this._pendingRequestDisposables.delete(D),R(T)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${D}`)}};S=Re([Oe(1,k.ILogService)],S),e.RequestStore=S}),define(we[108],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var y;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",f.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",f.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(y=e.TerminalSettingId||(e.TerminalSettingId={}));var P;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(P=e.PosixShellType||(e.PosixShellType={}));var k;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var S;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(S=e.TitleEventSource||(e.TitleEventSource={}));var v;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(v=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,I.createDecorator)("ptyService");var D;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions",f.FailedShellIntegrationActivation="failedShellIntegrationActivation"})(D=e.ProcessPropertyType||(e.ProcessPropertyType={}));var T;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(T=e.HeartbeatConstants||(e.HeartbeatConstants={}));var R;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(R=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(f){f.TerminalView="view",f.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var w;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(w=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var m;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(m=e.FlowControlConstants||(e.FlowControlConstants={}));var E;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(E=e.ProfileSource||(e.ProfileSource={}))}),define(we[224],ye([0,1,24,8,21,5,3,27,15,12,22]),function(ie,e,I,t,y,P,k,S,v,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function R(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());let c=0;return l&&l.length===4&&(c=parseInt(l[3])),c}e.getWindowsBuildNumber=R;async function C(l,c,n,o=S.env,i=T.Promises.exists){if(P.isAbsolute(l))return await i(l)?l:void 0;if(c===void 0&&(c=S.cwd()),P.dirname(l)!=="."){const u=P.join(c,l);return await i(u)?u:void 0}const r=(0,y.getCaseInsensitive)(o,"PATH");if(n===void 0&&(0,D.isString)(r)&&(n=r.split(P.delimiter)),n===void 0||n.length===0){const u=P.join(c,l);return await i(u)?u:void 0}for(let u of n){let h;if(P.isAbsolute(u)?h=P.join(u,l):h=P.join(c,u,l),await i(h))return h;if(k.isWindows){let b=h+".com";if(await i(b)||(b=h+".exe",await i(b)))return b}}const s=P.join(c,l);return await i(s)?s:void 0}e.findExecutable=C;function w(l,c,n){if(!c.enabled||!l.executable||l.isFeatureTerminal||l.hideFromUser)return;const o=l.args,i=S.platform==="win32"?P.basename(l.executable).toLowerCase():P.basename(l.executable),a=P.dirname(t.FileAccess.asFileUri("",ie).fsPath);let r;if(k.isWindows){if(i==="pwsh.exe")return!o||g(o)?r=e.shellIntegrationArgs.get(m.WindowsPwsh):p(o)&&(r=e.shellIntegrationArgs.get(m.WindowsPwshLogin)),r?(r&&(r=[...r],r[r.length-1]=(0,v.format)(r[r.length-1],a,"")),{newArgs:r}):void 0;n.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}const s={};switch(i){case"bash":return!o||o.length===0?r=e.shellIntegrationArgs.get(m.Bash):d(o)&&(s.VSCODE_SHELL_LOGIN="1",r=e.shellIntegrationArgs.get(m.Bash)),r?(r=[...r],r[r.length-1]=(0,v.format)(r[r.length-1],a),{newArgs:r,envMixin:s}):void 0;case"pwsh":return!o||g(o)?r=e.shellIntegrationArgs.get(m.Pwsh):p(o)&&(r=e.shellIntegrationArgs.get(m.PwshLogin)),r?(r=[...r],r[r.length-1]=(0,v.format)(r[r.length-1],a,""),{newArgs:r}):void 0;case"zsh":{if(!o||o.length===0?r=e.shellIntegrationArgs.get(m.Zsh):d(o)?r=e.shellIntegrationArgs.get(m.ZshLogin):(o===e.shellIntegrationArgs.get(m.Zsh)||o===e.shellIntegrationArgs.get(m.ZshLogin))&&(r=o),!r)return;r=[...r],r[r.length-1]=(0,v.format)(r[r.length-1],a);const u=P.join(I.tmpdir(),"vscode-zsh");s.ZDOTDIR=u;const h=[];return h.push({source:P.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:P.join(u,".zshrc")}),h.push({source:P.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:P.join(u,".zprofile")}),h.push({source:P.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:P.join(u,".zshenv")}),h.push({source:P.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:P.join(u,".zlogin")}),{newArgs:r,envMixin:s,filesToCopy:h}}}n.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}e.getShellIntegrationInjection=w;var m;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(m=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(m.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(m.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(m.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(m.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(m.Zsh,["-i"]),e.shellIntegrationArgs.set(m.ZshLogin,["-il"]),e.shellIntegrationArgs.set(m.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],f=["-nol","-nologo"];function p(l){return typeof l=="string"?E.includes(l.toLowerCase()):l.length===1&&E.includes(l[0].toLowerCase())||l.length===2&&(E.includes(l[0].toLowerCase())||E.includes(l[1].toLowerCase()))&&(f.includes(l[0].toLowerCase())||f.includes(l[1].toLowerCase()))}function g(l){return typeof l=="string"?f.includes(l.toLowerCase()):l.length===0||l?.length===1&&f.includes(l[0].toLowerCase())}function d(l){return l==="string"&&E.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&E.includes(l[0].toLowerCase())}}),define(we[225],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var I;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(I=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===I.HIGH_CONTRAST_DARK||P===I.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function y(P){return P===I.DARK||P===I.HIGH_CONTRAST_DARK}e.isDark=y}),define(we[109],ye([0,1,38,6,2,7,34,225]),function(ie,e,I,t,y,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var v;(function(f){function p(g){return g&&typeof g=="object"&&typeof g.id=="string"}f.isThemeColor=p})(v=e.ThemeColor||(e.ThemeColor={}));function D(f){return{id:f}}e.themeColorFromId=D;var T;(function(f){function p(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||v.isThemeColor(a.color))}f.isThemeIcon=p;const g=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function d(a){const r=g.exec(a);if(!r)return;let[,s]=r;return{id:s}}f.fromString=d;function l(a){return{id:a}}f.fromId=l;function c(a,r){let s=a.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),r&&(s=`${s}~${r}`),{id:s}}f.modify=c;function n(a){const r=a.id.lastIndexOf("~");if(r!==-1)return a.id.substring(r+1)}f.getModifier=n;function o(a,r){return a.id===r.id&&a.color?.id===r.color?.id}f.isEqual=o;function i(a,r){return{id:a.id,color:r?D(r):void 0}}f.asThemeIcon=i,f.asClassNameArray=I.CSSIcon.asClassNameArray,f.asClassName=I.CSSIcon.asClassName,f.asCSSSelector=I.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function R(f){switch(f){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case S.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=R,e.Extensions={ThemingContribution:"base.contributions.theming"};class C{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,y.toDisposable)(()=>{const g=this.themingParticipants.indexOf(p);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new C;k.Registry.add(e.Extensions.ThemingContribution,w);function m(f){return w.onColorThemeChange(f)}e.registerThemingParticipant=m;class E extends y.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,g){let d=this.theme.getColor(p);return d&&g&&(d=g(d,this.theme)),d?d.toString():null}}e.Themable=E}),define(we[226],ye([0,1,38,4,175,109]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function k(C,w){const m=[{name:null,description:(0,y.localize)(0,null)}];return m.push(...C.map(E=>({name:E.profileName,description:S(E)}))),w&&m.push(...w.map(E=>({name:E.title,description:v(E)}))),{values:m.map(E=>E.name),markdownDescriptions:m.map(E=>E.description)}}e.createProfileSchemaEnums=k;function S(C){let w=`$(${P.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:I.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?w+=`
- args: "${C.args}"`:w+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(w+=`
- overrideName: ${C.overrideName}`),C.color&&(w+=`
- color: ${C.color}`),C.env&&(w+=`
- env: ${JSON.stringify(C.env)}`),w}function v(C){return`$(${P.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:I.Codicon.terminal.id}) ${C.title}
- extensionIdentifier: ${C.extensionIdentifier}`}function D(C,w){if(!C&&!w)return!0;if(typeof C=="string"&&typeof w=="string")return C===w;if(Array.isArray(C)&&Array.isArray(w)){if(C.length!==w.length)return!1;for(let m=0;m<C.length;m++)if(C[m]!==w[m])return!1;return!0}return!1}e.terminalProfileArgsMatch=D;function T(C,w){if(!C&&!w)return!0;if(!C||!w)return!1;if(P.ThemeIcon.isThemeIcon(C)&&P.ThemeIcon.isThemeIcon(w))return C.id===w.id&&C.color===w.color;if(typeof C=="object"&&C&&"light"in C&&"dark"in C&&typeof w=="object"&&w&&"light"in w&&"dark"in w){const m=C,E=w;if((t.URI.isUri(m.light)||R(m.light))&&(t.URI.isUri(m.dark)||R(m.dark))&&(t.URI.isUri(E.light)||R(E.light))&&(t.URI.isUri(E.dark)||R(E.dark)))return m.light.path===E.light.path&&m.dark.path===E.dark.path}if(t.URI.isUri(C)&&t.URI.isUri(w)||R(C)||R(w)){const m=C,E=w;return m.path===E.path&&m.scheme===E.scheme}return!1}e.terminalIconsEqual=T;function R(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=R}),define(we[227],ye([0,1,38,174,49,34,226]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const S={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(I.Codicon.getAll(),l=>l.id),markdownEnumDescriptions:Array.from(I.Codicon.getAll(),l=>`$(${l.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},v={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...S}},D={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...S}},T=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),R=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),w=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),m=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),E=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),f={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...S}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...S}},{type:"null"},v]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...S}},{type:"null"},v]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...S}},{type:"null"},v]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function p(){P.Registry.as(y.Extensions.Configuration).registerConfiguration(f),d()}e.registerTerminalPlatformConfiguration=p;let g;function d(l,c){const n=P.Registry.as(y.Extensions.Configuration);let o;l&&(o=(0,k.createProfileSchemaEnums)(l?.profiles,c));const i=g;g={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:l?.os===3?o?.values:void 0,markdownEnumDescriptions:l?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:l?.os===2?o?.values:void 0,markdownEnumDescriptions:l?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:l?.os===1?o?.values:void 0,markdownEnumDescriptions:l?.os===1?o?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[g],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=d}),define(we[228],ye([0,1,39,38,5,3,22,89,224,109]),function(ie,e,I,t,y,P,k,S,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let T,R=!0;function C(o,i,a,r,s=process.env,u,h,b,A){return u=u||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},P.isWindows?w(a,u,s,h,r.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:r.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:r.getValue("terminal.integrated.defaultProfile.windows"),A,b):l(u,h,a,o&&typeof o=="object"?{...o}:r.getValue(P.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:r.getValue(P.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,b,s)}e.detectAvailableProfiles=C;async function w(o,i,a,r,s,u,h,b,A){const B=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),G=`${process.env.windir}\\${B?"Sysnative":"System32"}`;let Q=!1;(0,v.getWindowsBuildNumber)()>=16299&&(Q=!0),await f(b);const _=new Map;o&&(_.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Windows PowerShell",{path:`${G}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),_.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),_.set("Command Prompt",{path:`${G}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),c(u,_);const X=await m(_.entries(),h,i,a,r,A);if(o||!o&&s)try{const F=await g(`${G}\\${Q?"wsl":"bash"}.exe`,h);for(const U of F)(!u||!(U.profileName in u))&&X.push(U)}catch{R&&(r?.info("WSL is not installed, so could not detect WSL profiles"),R=!1)}return X}async function m(o,i,a,r=process.env,s,u){const h=[];for(const[b,A]of o){if(A===null)continue;let B,G,Q;if("source"in A){const F=T?.get(A.source);if(!F)continue;B=F.paths,G=A.args||F.args,A.icon?Q=E(A.icon):F.icon&&(Q=F.icon)}else B=Array.isArray(A.path)?A.path:[A.path],G=P.isWindows||Array.isArray(A.args)?A.args:void 0,Q=E(A.icon);const _=await u?.(B)||B.slice(),X=await n(b,i,_,a,r,G,A.env,A.overrideName,A.isAutoDetected,s);X?(X.isAutoDetected=A.isAutoDetected,X.icon=Q,X.color=A.color,h.push(X)):s?.trace("profile not validated",b,B)}return h}function E(o){return typeof o=="string"?{id:o}:o}async function f(o){T&&!o||(T=new Map,T.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),T.set("PowerShell",{profileName:"PowerShell",paths:o||await p(),icon:D.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function p(){const o=[];for await(const i of(0,S.enumeratePowerShellInstallations)())o.push(i.exePath);return o}async function g(o,i){const a=[],r=await new Promise((h,b)=>{I.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(A,B)=>{if(A)return b("Problem occurred when getting wsl distros");h(B)})});if(!r)return[];const s=new RegExp(/[\r?\n]/),u=r.split(s).filter(h=>h.trim().length>0&&h!=="");for(const h of u){if(h===""||h.startsWith("docker-desktop"))continue;const b=`${h} (WSL)`,A={profileName:b,path:o,args:["-d",`${h}`],isDefault:b===i,icon:d(h),isAutoDetected:!1};a.push(A)}return a}function d(o){return o.includes("Ubuntu")?D.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):o.includes("Debian")?D.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):D.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function l(o,i,a,r,s,u,h,b){const A=new Map;if(a){const B=(await o.readFile("/etc/shells")).toString(),G=u||B.split(`
`).filter(_=>_.trim().indexOf("#")!==0&&_.trim().length>0),Q=new Map;for(const _ of G){let X=(0,y.basename)(_),F=Q.get(X)||0;F++,F>1&&(X=`${X} (${F})`),Q.set(X,F),A.set(X,{path:_,isAutoDetected:!0})}}return c(r,A),await m(A.entries(),s,o,b,i,h)}function c(o,i){if(!!o)for(const[a,r]of Object.entries(o))r===null||!("path"in r)&&!("source"in r)?i.delete(a):(r.icon=r.icon||i.get(a)?.icon,i.set(a,r))}async function n(o,i,a,r,s,u,h,b,A,B){if(a.length===0)return Promise.resolve(void 0);const G=a.shift();if(G==="")return n(o,i,a,r,s,u,h,b,A);const Q={profileName:o,path:G,args:u,env:h,overrideName:b,isAutoDetected:A,isDefault:o===i};if((0,y.basename)(G)===G){const X=s.PATH?s.PATH.split(y.delimiter):void 0,F=await(0,v.findExecutable)(G,void 0,X,void 0,r.existsFile);return F?(Q.path=F,Q.isFromPath=!0,Q):n(o,i,a,r,s,u)}return await r.existsFile((0,y.normalize)(G))?Q:n(o,i,a,r,s,u,h,b,A)}}),define(we[229],ye([0,1,6,2,8,3,40,94,25,28,95,77,13,100,223,108,227,228]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let d=0,l=class extends t.Disposable{constructor(n,o,i,a){super();this._reconnectConstants=n,this._configurationService=o,this._environmentService=i,this._logService=a,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new I.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new I.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new I.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new I.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new I.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new I.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new I.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new I.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new I.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new I.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new I.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new I.Emitter),this.onProcessExit=this._onProcessExit.event,(0,f.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new m.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(P.isWindows)return process.env;try{return await(0,R.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(n){return this._logService.error("ptyHost was unable to resolve shell environment",n),{}}}_startPtyHost(){const n={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:d,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},o=(0,T.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);o&&(o.break&&o.port?n.debugBrk=o.port:!o.break&&o.port&&(n.debug=o.port));const i=new S.Client(y.FileAccess.asFileUri("bootstrap-fork",ie).fsPath,n);this._onPtyHostStart.fire(),k.ProxyChannel.toService(i.getChannel(E.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(u=>{this._onPtyHostExit.fire(u.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}, giving up`))}));const r=i.getChannel(E.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const s=k.ProxyChannel.toService(i.getChannel(E.TerminalIpcChannels.PtyHost));return this._register(s.onProcessData(u=>this._onProcessData.fire(u))),this._register(s.onProcessReady(u=>this._onProcessReady.fire(u))),this._register(s.onProcessExit(u=>this._onProcessExit.fire(u))),this._register(s.onDidChangeProperty(u=>this._onDidChangeProperty.fire(u))),this._register(s.onProcessReplay(u=>this._onProcessReplay.fire(u))),this._register(s.onProcessOrphanQuestion(u=>this._onProcessOrphanQuestion.fire(u))),this._register(s.onDidRequestDetach(u=>this._onDidRequestDetach.fire(u))),[i,s]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(n,o,i,a,r,s,u,h,b,A,B){const G=setTimeout(()=>this._handleUnresponsiveCreateProcess(),E.HeartbeatConstants.CreateProcessTimeout),Q=await this._proxy.createProcess(n,o,i,a,r,s,u,h,b,A,B);return clearTimeout(G),d=Math.max(d,Q),Q}updateTitle(n,o,i){return this._proxy.updateTitle(n,o,i)}updateIcon(n,o,i){return this._proxy.updateIcon(n,o,i)}attachToProcess(n){return this._proxy.attachToProcess(n)}detachFromProcess(n){return this._proxy.detachFromProcess(n)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(n){return this._proxy.start(n)}shutdown(n,o){return this._proxy.shutdown(n,o)}input(n,o){return this._proxy.input(n,o)}processBinary(n,o){return this._proxy.processBinary(n,o)}resize(n,o,i){return this._proxy.resize(n,o,i)}acknowledgeDataEvent(n,o){return this._proxy.acknowledgeDataEvent(n,o)}setUnicodeVersion(n,o){return this._proxy.setUnicodeVersion(n,o)}getInitialCwd(n){return this._proxy.getInitialCwd(n)}getCwd(n){return this._proxy.getCwd(n)}getLatency(n){return this._proxy.getLatency(n)}orphanQuestionReply(n){return this._proxy.orphanQuestionReply(n)}installAutoReply(n,o){return this._proxy.installAutoReply(n,o)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(n){return this._proxy.uninstallAutoReply(n)}getDefaultSystemShell(n){return this._proxy.getDefaultSystemShell(n)}async getProfiles(n,o,i,a=!1){const r=await this._shellEnv;return(0,p.detectAvailableProfiles)(o,i,a,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,n))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(n){return this._proxy.getWslPath(n)}setTerminalLayoutInfo(n){return this._proxy.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this._proxy.getTerminalLayoutInfo(n)}async requestDetachInstance(n,o){return this._proxy.requestDetachInstance(n,o)}async acceptDetachInstanceReply(n,o){return this._proxy.acceptDetachInstanceReply(n,o)}async serializeTerminalState(n){return this._proxy.serializeTerminalState(n)}async reviveTerminalProcesses(n,o){return this._proxy.reviveTerminalProcesses(n,o)}async refreshProperty(n,o){return this._proxy.refreshProperty(n,o)}async updateProperty(n,o,i){return this._proxy.updateProperty(n,o,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier+E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${E.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(n,o){return this._resolveVariablesRequestStore.createRequest({workspaceId:n,originalText:o})}async acceptPtyHostResolvedVariables(n,o){this._resolveVariablesRequestStore.acceptReply(n,o)}};l=Re([Oe(1,v.IConfigurationService),Oe(2,D.IEnvironmentService),Oe(3,C.ILogService)],l),e.PtyHostService=l}),define(we[52],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(we[230],ye([0,1,6,2,4,28,35,18,13,52]),function(ie,e,I,t,y,P,k,S,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let T=class extends t.Disposable{constructor(C,w,m,E,f){super();this.extensionsManagementService=C,this.logService=E,this.uriIdentityService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new I.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(d=>d.identifier),this.startTimestamp=Date.now()}),this._register(C.onInstallExtension(g=>this.onInstallExtension(g))),this._register(C.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(C.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const p=y.URI.file(m.extensionsPath);this._register(w.watch(p)),this._register(I.Event.filter(w.onDidFilesChange,g=>g.rawChanges.some(d=>this.doesChangeAffects(d,p)))(()=>this.onDidChange()))}doesChangeAffects(C,w){return C.type!==1&&C.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(C.resource),w)?!1:this.uriIdentityService.extUri.isEqual(C.resource,this.uriIdentityService.extUri.joinPath(w,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(C.resource).startsWith(".")}onInstallExtension(C){this.addInstallingExtension(C.identifier)}onDidInstallExtensions(C){for(const w of C)this.removeInstallingExtension(w.identifier),w.local&&this.addInstalledExtension(w.identifier)}onDidUninstallExtension(C){C.error||this.removeInstalledExtension(C.identifier)}addInstallingExtension(C){this.removeInstallingExtension(C),this.installingExtensions.push(C)}removeInstallingExtension(C){this.installingExtensions=this.installingExtensions.filter(w=>!(0,k.areSameExtensions)(w,C))}addInstalledExtension(C){this.installedExtensions&&(this.removeInstalledExtension(C),this.installedExtensions.push(C))}removeInstalledExtension(C){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(w=>!(0,k.areSameExtensions)(w,C)))}async onDidChange(){if(this.installedExtensions){const C=await this.extensionsManagementService.getInstalled(),w=C.filter(E=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,k.areSameExtensions)(f,E.identifier))?!1:E.installedTimestamp&&E.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",E.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",E.identifier.id),!1)),m=this.installedExtensions.filter(E=>this.installingExtensions.some(f=>(0,k.areSameExtensions)(f,E))?!1:C.every(f=>!(0,k.areSameExtensions)(f.identifier,E))?(this.logService.info("Detected extension removed from another source",E.id),!0):!1);this.installedExtensions=C.map(E=>E.identifier),(w.length||m.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:w,removed:m})}}};T=Re([Oe(1,S.IFileService),Oe(2,P.INativeEnvironmentService),Oe(3,v.ILogService),Oe(4,D.IUriIdentityService)],T),e.ExtensionsWatcher=T}),define(we[110],ye([0,1,52,189,18,19,133,6,2]),function(ie,e,I,t,y,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class D{constructor(C){this.uri=C,this.time=D._clock++}touch(){return this.time=D._clock++,this}}D._clock=0;let T=class{constructor(C){this._fileService=C,this._dispooables=new v.DisposableStore,this._limit=2**16;const w=new Map,m=E=>{let f=w.get(E.scheme);return f===void 0&&(f=C.hasProvider(E)&&!this._fileService.hasCapability(E,1024),w.set(E.scheme,f)),f};this._dispooables.add(S.Event.any(C.onDidChangeFileSystemProviderRegistrations,C.onDidChangeFileSystemProviderCapabilities)(E=>{w.delete(E.scheme)})),this.extUri=new P.ExtUri(m),this._canonicalUris=new k.SkipList((E,f)=>this.extUri.compare(E,f,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(C){this._fileService.hasProvider(C)&&(C=(0,P.normalizePath)(C));let w=this._canonicalUris.get(C);return w?w.touch().uri.with({fragment:C.fragment}):(this._canonicalUris.set(C,new D(C)),this._checkTrim(),C)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const C=[...this._canonicalUris.entries()].sort((m,E)=>m[1].touch<E[1].touch?1:m[1].touch>E[1].touch?-1:0);D._clock=0,this._canonicalUris.clear();const w=this._limit*.5;for(let m=0;m<w;m++)this._canonicalUris.set(C[m][0],C[m][1].touch())}};T=Re([Oe(0,y.IFileService)],T),e.UriIdentityService=T,(0,t.registerSingleton)(I.IUriIdentityService,T,!0)}),define(we[111],ye([0,1,176,5,29,19,4,7,8]),function(ie,e,I,t,y,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");function D(i){const a=i;return typeof a?.id=="string"&&k.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=D;function T(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=T;function R(i){const a=i;return typeof a?.id=="string"&&k.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=R;function C(i){const a=i;if(a?.uri)return{id:a.id,uri:k.URI.revive(a.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:k.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=C;var w;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(w=e.WorkbenchState||(e.WorkbenchState={}));function m(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=m;function E(i){const a=i;return!!(a&&typeof a=="object"&&k.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=E;class f{constructor(a,r,s,u,h){this._id=a,this._transient=s,this._configuration=u,this._ignorePathCasing=h,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(a){this._id=a.id,this._configuration=a.configuration,this._transient=a.transient,this._ignorePathCasing=a._ignorePathCasing,this.folders=a.folders}get folders(){return this._folders}set folders(a){this._folders=a,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(a){this._configuration=a}getFolder(a){return a&&this._foldersMap.findSubstr(a)||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const a of this.folders)this._foldersMap.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class p{constructor(a,r){this.raw=r,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,P.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function g(i){return new p({uri:i,index:0,name:(0,P.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(i,a){return P.extUriBiasedIgnorePathCase.isEqualOrParent(i,a.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function c(i){let a;return k.URI.isUri(i)?a=i:a=i.configuration,a?.scheme===v.Schemas.tmp}e.isTemporaryWorkspace=c;function n(i,a){return!l(i,a)&&!c(i)}e.isSavedWorkspace=n;function o(i){return(typeof i=="string"?(0,t.extname)(i):(0,P.extname)(i))===d}e.hasWorkspaceFileExtension=o}),define(we[112],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,I.createDecorator)("extensionHostStatusService");class t{constructor(){this._exitInfo=new Map}setExitInfo(P,k){this._exitInfo.set(P,k)}getExitInfo(P){return this._exitInfo.get(P)||null}}e.ExtensionHostStatusService=t}),define(we[231],ye([0,1,6,14]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function y(k){let S=0,v=0,D=0;k>=1e3&&(D=Math.floor(k/1e3),k-=D*1e3),D>=60&&(v=Math.floor(D/60),D-=v*60),v>=60&&(S=Math.floor(v/60),v-=S*60);const T=S?`${S}h`:"",R=v?`${v}m`:"",C=D?`${D}s`:"",w=k?`${k}ms`:"";return`${T}${R}${C}${w}`}e.printTime=y;class P{constructor(S,v,D,T){this._logService=S,this._reconnectionToken=v,this._onClose=new I.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=D,this.protocol=T,this._disposed=!1,this._disconnectRunner1=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${y(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${y(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${y(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(S){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${S}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${y(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const S=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),S.end(),this._onClose.fire(void 0)}acceptReconnection(S,v,D){this._remoteAddress=S,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(v,D),this.protocol.endAcceptReconnection()}}e.ManagementConnection=P}),define(we[78],ye([0,1,30,8,5,140,48]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const S=y.join(t.FileAccess.asFileUri("",ie).fsPath,"nls.metadata.json"),v=new Map;function D(m){return new Promise(E=>I.exists(m,E))}function T(m,E){return D(S).then(f=>{if(!f||!k.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let p=`${m}||${E}`,g=v.get(p);return g||(g=P.getNLSConfiguration(k.default.commit,E,S,m).then(d=>(R.is(d)&&(d._languagePackSupport=!0),d.locale!=="en"&&d.locale!=="en-us"&&Object.keys(d.availableLanguages).length===0&&v.delete(p),d)),v.set(p,g)),g})}e.getNLSConfiguration=T;var R;(function(m){function E(f){let p=f;return p&&typeof p._languagePackId=="string"}m.is=E})(R=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}));const C=async m=>{try{const E=w(await I.promises.readFile(m,"utf8"));return JSON.parse(E).locale}catch(E){return E.code!=="ENOENT"&&console.warn(E),"en"}};e.getLocaleFromConfig=C;const w=m=>{const E=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return m.replace(E,(f,p,g,d,l)=>{if(d)return"";if(l){const c=l.length;return c>2&&l[c-1]===`
`?l[c-2]==="\r"?`\r
`:`
`:""}else return f})}}),define(we[113],ye([0,1,19,4,28,50,41,18,13,26,78]),function(ie,e,I,t,y,P,k,S,v,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let R=class extends P.AbstractExtensionsScannerService{constructor(w,m,E,f){super(t.URI.file(E.builtinExtensionsPath),t.URI.file(E.extensionsPath),(0,I.joinPath)(E.userHome,".vscode-oss-dev","extensions","control.json"),(0,I.joinPath)(t.URI.file(E.userDataPath),k.MANIFEST_CACHE_FOLDER),w,m,E,f);this.nativeEnvironmentService=E}async getTranslations(w){const m=await(0,T.getNLSConfiguration)(w,this.nativeEnvironmentService.userDataPath);if(T.InternalNLSConfiguration.is(m))try{const E=await this.fileService.readFile(t.URI.file(m._translationsConfigFile));return JSON.parse(E.value.toString())}catch{}return Object.create(null)}};R=Re([Oe(0,S.IFileService),Oe(1,v.ILogService),Oe(2,y.INativeEnvironmentService),Oe(3,D.IProductService)],R),e.ExtensionsScannerService=R}),define(we[232],ye([0,1,233,30,5,23,8,22]),function(ie,e,I,t,y,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z-]+$/;var D;(function(p){p[p.None=0]="None",p[p.Optional=1]="Optional",p[p.Mandatory=2]="Mandatory"})(D=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class T{constructor(){this.type=0}validate(g){return!0}}e.NoneServerConnectionToken=T;class R{constructor(g){this.value=g,this.type=1}validate(g){return g===this.value}}e.OptionalServerConnectionToken=R;class C{constructor(g){this.value=g,this.type=2}validate(g){return g===this.value}}e.MandatoryServerConnectionToken=C;class w{constructor(g){this.message=g}}e.ServerConnectionTokenParseError=w;async function m(p,g){const d=p["without-connection-token"],l=p["connection-token"],c=p["connection-token-file"],n=p.compatibility==="1.63";if(d)return typeof l!="undefined"||typeof c!="undefined"?new w("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new T;if(typeof c!="undefined"){if(typeof l!="undefined")return new w("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let o;try{o=t.readFileSync(c).toString().replace(/\r?\n$/,"")}catch{return new w(`Unable to read the connection token file at '${c}'.`)}return v.test(o)?new C(o):new w(`The connection token defined in '${c} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof l!="undefined"?v.test(l)?n?new R(l):new C(l):new w(`The connection token '${l} does not adhere to the characters 0-9, a-z, A-Z or -.`):n?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new R(await g())):new C(await g())}e.parseServerConnectionToken=m;async function E(p){return m(p,async()=>{if(!p["user-data-dir"])return(0,P.generateUuid)();const d=y.join(p["user-data-dir"],"token");try{const n=(await S.Promises.readFile(d)).toString().replace(/\r?\n$/,"");if(v.test(n))return n}catch{}const l=(0,P.generateUuid)();try{await S.Promises.writeFile(d,l,{mode:384})}catch{}return l})}e.determineServerConnectionToken=E;function f(p,g,d){if(p.validate(d.query[k.connectionTokenQueryName]))return!0;const l=I.parse(g.headers.cookie||"");return p.validate(l[k.connectionTokenCookieName])}e.requestHasValidConnectionToken=f}),define(we[37],ye([0,1,178,187,54,7,28]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},host:{type:"string",cat:"o",args:"ip-address",description:I.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:I.localize(1,null)},"pick-port":{type:"string",deprecationMessage:"Use the range notation in 'port' instead."},"socket-path":{type:"string",cat:"o",args:"path",description:I.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:I.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:I.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:I.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:I.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:I.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:I.localize(8,null)},"user-data-dir":y.OPTIONS["user-data-dir"],"enable-smoke-test-driver":y.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":y.OPTIONS["disable-telemetry"],"disable-workspace-trust":y.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:y.OPTIONS.log,logsPath:y.OPTIONS.logsPath,"force-disable-user-env":y.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:I.localize(9,null)},"default-workspace":{type:"string",description:I.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":y.OPTIONS["extensions-dir"],"extensions-download-dir":y.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":y.OPTIONS["builtin-extensions-dir"],"install-extension":y.OPTIONS["install-extension"],"install-builtin-extension":y.OPTIONS["install-builtin-extension"],"uninstall-extension":y.OPTIONS["uninstall-extension"],"list-extensions":y.OPTIONS["list-extensions"],"locate-extension":y.OPTIONS["locate-extension"],"show-versions":y.OPTIONS["show-versions"],category:y.OPTIONS.category,force:y.OPTIONS.force,"do-not-sync":y.OPTIONS["do-not-sync"],"pre-release":y.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:I.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:y.OPTIONS.help,version:y.OPTIONS.version,compatibility:{type:"string"},_:y.OPTIONS._},e.IServerEnvironmentService=(0,P.refineServiceDecorator)(k.IEnvironmentService);class S extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=S}),define(we[234],ye([0,1,70,13,37,26,200,23,16]),function(ie,e,I,t,y,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let D=class extends k.BaseCredentialsMainService{constructor(R,C,w){super(R);this.environmentMainService=C,this.productService=w,this.environmentMainService.args["github-auth"]&&this.storeGitHubToken(this.environmentMainService.args["github-auth"]).catch(m=>{this.logService.error("Failed to store provided GitHub token",m)})}async getSecretStoragePrefix(){return Promise.resolve(`${this.productService.urlProtocol}-server`)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new I.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((R,C)=>{ie(["keytar"],R,C)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(R){this.logService.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${R.message??R}`),this._keytarCache=new I.InMemoryCredentialsProvider}return this._keytarCache}async storeGitHubToken(R){const C="vscode.github-authentication",w=`${await this.getSecretStoragePrefix()}${C}`,m="github.auth",f=[["read:user","user:email","repo"]].map(d=>({id:(0,S.generateUuid)(),scopes:d.sort(),accessToken:R})),p=await this.getPassword(w,m);let g;if(p)try{const d=JSON.parse(p);d.content=JSON.parse(d.content),g=d}catch(d){this.logService.error("Failed to parse existing GitHub credentials",d)}return g?.content&&(g.content=g.content.filter(d=>{const l=d.scopes.sort();return!f.find(c=>(0,v.equals)(l,c.scopes)&&c.account?.label===d.account?.label)})),this.setPassword(w,m,JSON.stringify({extensionId:C,...g||{},content:JSON.stringify([...f,...g?.content||[]])}))}};D=Re([Oe(0,t.ILogService),Oe(1,y.IServerEnvironmentService),Oe(2,P.IProductService)],D),e.CredentialsWebMainService=D}),define(we[235],ye([0,1,267,236,24]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class P{get _sender(){throw new Error("unimplemented")}get _buffer(){throw new Error("unimplemented")}setUseDiskRetryCaching(){throw new Error("unimplemented")}send(){throw new Error("unimplemented")}triggerSend(){throw new Error("unimplemented")}}class k{constructor(v){this.endpoint=v,this._telemetryProcessors=void 0,this.context=void 0,this.commonProperties=void 0,this.config={},this.quickPulseClient=void 0,this.channel=new P}addTelemetryProcessor(){throw new Error("unimplemented")}clearTelemetryProcessors(){this._telemetryProcessors&&(this._telemetryProcessors=void 0)}runTelemetryProcessors(){throw new Error("unimplemented")}trackTrace(){throw new Error("unimplemented")}trackMetric(){throw new Error("unimplemented")}trackException(){throw new Error("unimplemented")}trackRequest(){throw new Error("unimplemented")}trackDependency(){throw new Error("unimplemented")}track(){throw new Error("unimplemented")}trackNodeHttpRequestSync(){throw new Error("unimplemented")}trackNodeHttpRequest(){throw new Error("unimplemented")}trackNodeHttpDependency(){throw new Error("unimplemented")}trackEvent(v){v.properties||(v.properties={}),v.measurements||(v.measurements={});try{const D=y.cpus();v.measurements.cores=D.length,v.properties["common.cpuModel"]=D[0].model}catch{}try{v.measurements.memoryFree=y.freemem(),v.measurements.memoryTotal=y.totalmem()}catch{}try{v.properties["common.shell"]=y.userInfo().shell,v.properties["common.release"]=y.release(),v.properties["common.arch"]=y.arch()}catch{}try{const D=(/^http:/.test(this.endpoint)?t:I).request(this.endpoint,{method:"POST",headers:{"Content-Type":"application/json"}});D.on("error",()=>{}),D.write(JSON.stringify(v)),D.end()}catch{}}flush(v){v.callback&&v.callback("")}}e.TelemetryClient=k}),define(we[237],ye([0,1,30,87,76,233,75,33,64,3,13,37,5,8,23,26,51,20,4,17,12,78,74]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f,p,g,d,l,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOriginalUrl=e.relativePath=e.relativeRoot=e.normalizeUrlPath=e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const o={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function i(G,Q,_,X){Q.writeHead(_,{"Content-Type":"text/plain"}),Q.end(X)}e.serveError=i;var a;(function(G){G[G.NO_CACHING=0]="NO_CACHING",G[G.ETAG=1]="ETAG",G[G.NO_EXPIRY=2]="NO_EXPIRY"})(a=e.CacheControl||(e.CacheControl={}));async function r(G,Q,_,X,F,U){try{const le=await I.promises.stat(G);if(Q===1){const j=`W/"${[le.ino,le.size,le.mtime.getTime()].join("-")}"`;if(X.headers["if-none-match"]===j)return F.writeHead(304),F.end();U.Etag=j}else Q===2?U["Cache-Control"]="public, max-age=31536000":Q===0&&(U["Cache-Control"]="no-store");U["Content-Type"]=o[(0,C.extname)(G)]||(0,v.getMediaMime)(G)||"text/plain",F.writeHead(200,U),(0,I.createReadStream)(G).pipe(F)}catch(le){return le.code!=="ENOENT"?(_.error(le),console.error(le.toString())):console.error(`File not found: ${G}`),F.writeHead(404,{"Content-Type":"text/plain"}),F.end("Not found")}}e.serveFile=r;const s=(0,C.dirname)(w.FileAccess.asFileUri("",ie).fsPath);let u=class{constructor(Q,_,X,F,U){this._connectionToken=Q,this._environmentService=_,this._logService=X,this._requestService=F,this._productService=U,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?g.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0;const le=(0,n.getRemoteServerRootPath)(U);this._staticRoute=`${le}/static`,this._callbackRoute=`${le}/callback`,this._webExtensionRoute="/web-extension-resource"}async handle(Q,_,X){try{const F=X.pathname;return F.startsWith(this._staticRoute)&&F.charCodeAt(this._staticRoute.length)===47?this._handleStatic(Q,_,X):F==="/"?this._handleRoot(Q,_,X):F===this._callbackRoute?this._handleCallback(_):F.startsWith(this._webExtensionRoute)&&F.charCodeAt(this._webExtensionRoute.length)===47?this._handleWebExtensionResource(Q,_,X):i(Q,_,404,"Not found.")}catch(F){return this._logService.error(F),console.error(F.toString()),i(Q,_,500,"Internal Server Error.")}}async _handleStatic(Q,_,X){const F=Object.create(null),le=decodeURIComponent(X.pathname).substring(this._staticRoute.length+1),j=(0,C.join)(s,le);return(0,S.isEqualOrParent)(j,s,!D.isLinux)?r(j,this._environmentService.isBuilt?2:1,this._logService,Q,_,F):i(Q,_,400,"Bad request.")}_getResourceURLTemplateAuthority(Q){const _=Q.authority.indexOf(".");return _!==-1?Q.authority.substring(_+1):void 0}async _handleWebExtensionResource(Q,_,X){if(!this._webExtensionResourceUrlTemplate)return i(Q,_,500,"No extension gallery service configured.");const F=decodeURIComponent(X.pathname),U=(0,C.normalize)(F.substring(this._webExtensionRoute.length+1)),le=g.URI.parse(U).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:U.substring(0,U.indexOf("/")),path:U.substring(U.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(le))return i(Q,_,403,"Request Forbidden");const j={},$=me=>{const fe=Q.headers[me];fe&&((0,l.isString)(fe)||fe[0])?j[me]=(0,l.isString)(fe)?fe:fe[0]:me!==me.toLowerCase()&&$(me.toLowerCase())};$("X-Client-Name"),$("X-Client-Version"),$("X-Machine-Id"),$("X-Client-Commit");const O=await this._requestService.request({type:"GET",url:le.toString(!0),headers:j},p.CancellationToken.None),M=O.res.statusCode||500;if(M!==200){let me=null;try{me=await(0,f.asTextOrError)(O)}catch{}return i(Q,_,M,me||`Request failed with status ${M}`)}const W=Object.create(null),J=me=>{const fe=O.res.headers[me];fe?W[me]=fe:me!==me.toLowerCase()&&J(me.toLowerCase())};J("Cache-Control"),J("Content-Type"),_.writeHead(200,W);const ae=await(0,d.streamToBuffer)(O.stream);return _.end(ae.buffer)}async _handleRoot(Q,_,X){const F=X.query[w.connectionTokenQueryName];if(typeof F=="string"){const ce=Object.create(null);ce["Set-Cookie"]=P.serialize(w.connectionTokenCookieName,F,{sameSite:"lax",maxAge:60*60*24*7});const Z=Object.create(null);for(let ge in X.query)ge!==w.connectionTokenQueryName&&(Z[ge]=X.query[ge]);const se=y.format({pathname:"/",query:Z});return ce.Location=se,_.writeHead(302,ce),_.end()}const U="remote";function le(ce){return JSON.stringify(ce).replace(/"/g,"&quot;")}let j;this._environmentService.args["enable-smoke-test-driver"]&&(j=!1);const $=ce=>ce&&g.URI.file(t.resolve(ce)).with({scheme:w.Schemas.vscodeRemote,authority:U}),O=w.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",ie).fsPath,M=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,m.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,W=(0,e.relativeRoot)((0,e.getOriginalUrl)(Q)),J=(0,e.relativePath)((0,e.getOriginalUrl)(Q)),ae=this._environmentService.args.locale||await(0,c.getLocaleFromConfig)(this._environmentService.argvResource.fsPath),me=await(0,c.getNLSConfiguration)(ae,this._environmentService.userDataPath),fe={remoteAuthority:U,webviewEndpoint:J+this._staticRoute+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this._environmentService.userDataPath,isEnabledFileDownloads:!this._environmentService.args["disable-file-downloads"],_wrapWebWorkerExtHostInIframe:j,developmentOptions:{enableSmokeTestDriver:this._environmentService.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this._logService.getLevel()},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this._environmentService.args["disable-workspace-trust"],folderUri:$(this._environmentService.args["default-folder"]),workspaceUri:$(this._environmentService.args["default-workspace"]),productConfiguration:{codeServerVersion:this._productService.codeServerVersion,rootEndpoint:W,updateEndpoint:this._environmentService.args["disable-update-check"]?void 0:W+"/update/check",logoutEndpoint:this._environmentService.args.auth?W+"/logout":void 0,proxyEndpointTemplate:W+"/proxy/{{port}}",serviceWorker:{scope:J+"/",path:W+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this._productService.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this._productService.extensionsGallery},callbackRoute:this._callbackRoute};let V=this._productService.extensionsGallery?.nlsBaseUrl;V?.endsWith("/")||(V+="/");const ee={WORKBENCH_WEB_CONFIGURATION:le(fe),WORKBENCH_AUTH_SESSION:M?le(M):"",WORKBENCH_WEB_BASE_URL:J+this._staticRoute,WORKBENCH_NLS_BASE_URL:J+(V?`${V}${this._productService.commit}/${this._productService.version}/`:""),BASE:W,VS_BASE:J,NLS_CONFIGURATION:le(me)};let x;try{x=(await I.promises.readFile(O)).toString().replace(/\{\{([^}]+)\}\}/g,(Z,se)=>ee[se]??"undefined")}catch{return _.writeHead(404,{"Content-Type":"text/plain"}),_.end("Not found")}const z=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(x).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${U} ${V??""};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),te={"Content-Type":"text/html","Content-Security-Policy":z};return this._connectionToken.type!==0&&(te["Set-Cookie"]=P.serialize(w.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),_.writeHead(200,te),_.end(x)}_getScriptCspHashes(Q){const _=/<script>([\s\S]+?)<\/script>/img,X=[];let F;for(;F=_.exec(Q);){const U=k.createHash("sha256"),le=F[1].replace(/\r\n/g,`
`),j=U.update(Buffer.from(le)).digest().toString("base64");X.push(`'sha256-${j}'`)}return X}async _handleCallback(Q){const _=w.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",ie).fsPath,X=(await I.promises.readFile(_)).toString(),F=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(X).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return Q.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":F}),Q.end(X)}};u=Re([Oe(1,R.IServerEnvironmentService),Oe(2,T.ILogService),Oe(3,f.IRequestService),Oe(4,E.IProductService)],u),e.WebClientServer=u;const h=(G,Q=!1)=>G.replace(/\/\/+/g,"/").replace(/\/+$/,Q?"/":"");e.normalizeUrlPath=h;const b=G=>{const Q=(G.split("?",1)[0].match(/\//g)||[]).length;return(0,e.normalizeUrlPath)("./"+(Q>1?"../".repeat(Q-1):""))};e.relativeRoot=b;const A=G=>{const Q=G.split("?",1)[0].split("/");return(0,e.normalizeUrlPath)("./"+Q[Q.length-1])};e.relativePath=A;const B=G=>G.originalUrl||G.url;e.getOriginalUrl=B}),define(we[238],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,I.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var St=this&&this.__classPrivateFieldSet||function(ie,e,I,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(ie,I):y?y.value=I:e.set(ie,I),I},et=this&&this.__classPrivateFieldGet||function(ie,e,I,t){if(I==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!t:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return I==="m"?t:I==="a"?t.call(ie):t?t.value:e.get(ie)};define(we[114],ye([0,1,16,9,85,29,64,15,12,4,23,18,104]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C){"use strict";var w,m,E,f,p,g,d,l,c,n,o,i,a,r,s,u,h,b,A,B,G,Q;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(N){function L(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(L,N),Object.setPrototypeOf(L.prototype,N.prototype),L}let X=g=class{constructor(L){w.set(this,void 0),St(this,w,L,"f")}static from(...L){let ne=L;return new g(function(){if(ne){for(const Ce of ne)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();ne=void 0}})}dispose(){typeof et(this,w,"f")=="function"&&(et(this,w,"f").call(this),St(this,w,void 0,"f"))}};w=new WeakMap,X=g=Re([_],X),e.Disposable=X;let F=d=class{constructor(L,ne){if(L<0)throw(0,t.illegalArgument)("line must be non-negative");if(ne<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=L,this._character=ne}static Min(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Ce=1;Ce<L.length;Ce++){const ze=L[Ce];ze.isBefore(ne)&&(ne=ze)}return ne}static Max(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Ce=1;Ce<L.length;Ce++){const ze=L[Ce];ze.isAfter(ne)&&(ne=ze)}return ne}static isPosition(L){if(!L)return!1;if(L instanceof d)return!0;let{line:ne,character:Ce}=L;return typeof ne=="number"&&typeof Ce=="number"}static of(L){if(L instanceof d)return L;if(this.isPosition(L))return new d(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ne=0){if(L===null||ne===null)throw(0,t.illegalArgument)();let Ce;return typeof L=="undefined"?Ce=0:typeof L=="number"?Ce=L:(Ce=typeof L.lineDelta=="number"?L.lineDelta:0,ne=typeof L.characterDelta=="number"?L.characterDelta:0),Ce===0&&ne===0?this:new d(this.line+Ce,this.character+ne)}with(L,ne=this.character){if(L===null||ne===null)throw(0,t.illegalArgument)();let Ce;return typeof L=="undefined"?Ce=this.line:typeof L=="number"?Ce=L:(Ce=typeof L.line=="number"?L.line:this.line,ne=typeof L.character=="number"?L.character:this.character),Ce===this.line&&ne===this.character?this:new d(Ce,ne)}toJSON(){return{line:this.line,character:this.character}}};F=d=Re([_],F),e.Position=F;let U=l=class{constructor(L,ne,Ce,ze){let Ve,Xe;if(typeof L=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof ze=="number"?(Ve=new F(L,ne),Xe=new F(Ce,ze)):F.isPosition(L)&&F.isPosition(ne)&&(Ve=F.of(L),Xe=F.of(ne)),!Ve||!Xe)throw new Error("Invalid arguments");Ve.isBefore(Xe)?(this._start=Ve,this._end=Xe):(this._start=Xe,this._end=Ve)}static isRange(L){return L instanceof l?!0:L?F.isPosition(L.start)&&F.isPosition(L.end):!1}static of(L){if(L instanceof l)return L;if(this.isRange(L))return new l(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(L){return l.isRange(L)?this.contains(L.start)&&this.contains(L.end):F.isPosition(L)?!(F.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ne=F.Max(L.start,this._start),Ce=F.Min(L.end,this._end);if(!ne.isAfter(Ce))return new l(ne,Ce)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ne=F.Min(L.start,this._start),Ce=F.Max(L.end,this.end);return new l(ne,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ne=this.end){if(L===null||ne===null)throw(0,t.illegalArgument)();let Ce;return L?F.isPosition(L)?Ce=L:(Ce=L.start||this.start,ne=L.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&ne.isEqual(this.end)?this:new l(Ce,ne)}toJSON(){return[this.start,this.end]}};U=l=Re([_],U),e.Range=U;let le=c=class extends U{constructor(L,ne,Ce,ze){let Ve,Xe;if(typeof L=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof ze=="number"?(Ve=new F(L,ne),Xe=new F(Ce,ze)):F.isPosition(L)&&F.isPosition(ne)&&(Ve=F.of(L),Xe=F.of(ne)),!Ve||!Xe)throw new Error("Invalid arguments");super(Ve,Xe);this._anchor=Ve,this._active=Xe}static isSelection(L){return L instanceof c?!0:L?U.isRange(L)&&F.isPosition(L.anchor)&&F.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};le=c=Re([_],le),e.Selection=le;class j{constructor(L,ne,Ce){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,t.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,t.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ne),this.connectionToken=Ce}}e.ResolvedAuthority=j;class $ extends Error{constructor(L,ne=C.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(L);this._message=L,this._code=ne,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(L,ne){return new $(L,C.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(L){return new $(L,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var O;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(O=e.EndOfLine||(e.EndOfLine={}));var M;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(M=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=n=class{constructor(L,ne){this._range=L,this._newText=ne}static isTextEdit(L){return L instanceof n?!0:L?U.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ne){return new n(L,ne)}static insert(L,ne){return n.replace(new U(L,L),ne)}static delete(L){return n.replace(L,"")}static setEndOfLine(L){const ne=new n(new U(new F(0,0),new F(0,0)),"");return ne.newEol=L,ne}get range(){return this._range}set range(L){if(L&&!U.isRange(L))throw(0,t.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,t.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,t.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=n=Re([_],W),e.TextEdit=W;let J=o=class{constructor(L,ne){this.range=L,this.newCells=ne}static isNotebookCellEdit(L){return L instanceof o?!0:L?yt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ne){return new o(L,ne)}static insertCells(L,ne){return new o(new yt(L,L),ne)}static deleteCells(L){return new o(L,[])}static updateCellMetadata(L,ne){const Ce=new o(new yt(L,L),[]);return Ce.newCellMetadata=ne,Ce}static updateNotebookMetadata(L){const ne=new o(new yt(0,0),[]);return ne.newNotebookMetadata=L,ne}};J=o=Re([_],J),e.NotebookEdit=J;class ae{constructor(L,ne){this.range=L,this.snippet=ne}}e.SnippetTextEdit=ae;var me;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(me=e.FileEditType||(e.FileEditType={}));let fe=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ne,Ce,ze){this._edits.push({_type:1,from:L,to:ne,options:Ce,metadata:ze})}createFile(L,ne,Ce){this._edits.push({_type:1,from:void 0,to:L,options:ne,metadata:Ce})}deleteFile(L,ne,Ce){this._edits.push({_type:1,from:L,to:void 0,options:ne,metadata:Ce})}replaceNotebookMetadata(L,ne,Ce){this._edits.push({_type:3,metadata:Ce,uri:L,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(L,ne,Ce,ze,Ve){let Xe,Je,ot=[],lt;if(yt.isNotebookRange(ne)&&kt.isNotebookCellDataArray(Ce)&&!kt.isNotebookCellDataArray(ze)?(Xe=ne.start,Je=ne.end,ot=Ce,lt=ze):typeof ne=="number"&&typeof Ce=="number"&&kt.isNotebookCellDataArray(ze)&&(Xe=ne,Je=Ce,ot=ze,lt=Ve),Xe===void 0||Je===void 0)throw new Error("Invalid arguments");(Xe!==Je||ot.length>0)&&this._edits.push({_type:5,uri:L,index:Xe,count:Je-Xe,cells:ot,metadata:lt})}replaceNotebookCellMetadata(L,ne,Ce,ze){this._edits.push({_type:3,metadata:ze,uri:L,edit:{editType:8,index:ne,metadata:Ce}})}replace(L,ne,Ce,ze){this._edits.push({_type:2,uri:L,edit:new W(ne,Ce),metadata:ze})}insert(L,ne,Ce,ze){this.replace(L,new U(ne,ne),Ce,ze)}delete(L,ne,Ce){this.replace(L,ne,"",Ce)}has(L){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===L.toString())}set(L,ne){if(ne)for(const Ce of ne)Ce&&(J.isNotebookCellEdit(Ce)?Ce.newCellMetadata?this.replaceNotebookCellMetadata(L,Ce.range.start,Ce.newCellMetadata):Ce.newNotebookMetadata?this.replaceNotebookMetadata(L,Ce.newNotebookMetadata):this.replaceNotebookCells(L,Ce.range,Ce.newCells):this._edits.push({_type:2,uri:L,edit:Ce}));else{for(let Ce=0;Ce<this._edits.length;Ce++){const ze=this._edits[Ce];ze._type===2&&ze.uri.toString()===L.toString()&&(this._edits[Ce]=void 0)}(0,I.coalesceInPlace)(this._edits)}}get(L){const ne=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===L.toString()&&ne.push(Ce.edit);return ne}entries(){const L=new P.ResourceMap;for(let ne of this._edits)if(ne._type===2){let Ce=L.get(ne.uri);Ce||(Ce=[ne.uri,[]],L.set(ne.uri,Ce)),Ce[1].push(ne.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};fe=Re([_],fe),e.WorkspaceEdit=fe;let V=i=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof i?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=i._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ne=this._tabstop++){if(typeof L=="function"){const Ce=new i;Ce._tabstop=this._tabstop,L(Ce),this._tabstop=Ce._tabstop,L=Ce.value}else L=i._escape(L);return this.value+="${",this.value+=ne,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ne=this._tabstop++){const Ce=L.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(L,ne){if(typeof ne=="function"){const Ce=new i;Ce._tabstop=this._tabstop,ne(Ce),this._tabstop=Ce._tabstop,ne=Ce.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};V=i=Re([_],V),e.SnippetString=V;var ee;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(ee=e.DiagnosticTag||(e.DiagnosticTag={}));var x;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(x=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let z=a=class{constructor(L,ne){if(this.uri=L,ne)if(U.isRange(ne))this.range=U.of(ne);else if(F.isPosition(ne))this.range=new U(ne,ne);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof a?!0:L?U.isRange(L.range)&&D.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};z=a=Re([_],z),e.Location=z;let te=class{constructor(L,ne){this.location=L,this.message=ne}static is(L){return L?typeof L.message=="string"&&L.location&&U.isRange(L.location.range)&&D.URI.isUri(L.location.uri):!1}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.location.range.isEqual(ne.location.range)&&L.location.uri.toString()===ne.location.uri.toString()}};te=Re([_],te),e.DiagnosticRelatedInformation=te;let ce=class{constructor(L,ne,Ce=x.Error){if(!U.isRange(L))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=L,this.message=ne,this.severity=Ce}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.severity===ne.severity&&L.code===ne.code&&L.severity===ne.severity&&L.source===ne.source&&L.range.isEqual(ne.range)&&(0,I.equals)(L.tags,ne.tags)&&(0,I.equals)(L.relatedInformation,ne.relatedInformation,te.isEqual)}};ce=Re([_],ce),e.Diagnostic=ce;let Z=class{constructor(L,ne){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ne}};Z=Re([_],Z),e.Hover=Z;var se;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(se=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ge=class{constructor(L,ne=se.Text){this.range=L,this.kind=ne}toJSON(){return{range:this.range,kind:se[this.kind]}}};ge=Re([_],ge),e.DocumentHighlight=ge;var Y;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Y=e.SymbolKind||(e.SymbolKind={}));var re;(function(N){N[N.Deprecated=1]="Deprecated"})(re=e.SymbolTag||(e.SymbolTag={}));let H=r=class{constructor(L,ne,Ce,ze,Ve){this.name=L,this.kind=ne,this.containerName=Ve,typeof Ce=="string"&&(this.containerName=Ce),ze instanceof z?this.location=ze:Ce instanceof U&&(this.location=new z(ze,Ce)),r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Y[this.kind],location:this.location,containerName:this.containerName}}};H=r=Re([_],H),e.SymbolInformation=H;let K=s=class{constructor(L,ne,Ce,ze,Ve){this.name=L,this.detail=ne,this.kind=Ce,this.range=ze,this.selectionRange=Ve,this.children=[],s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(s.validate)}};K=s=Re([_],K),e.DocumentSymbol=K;var ue;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ue=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(L,ne){this.title=L,this.kind=ne}};pe=Re([_],pe),e.CodeAction=pe;let De=u=class{constructor(L){this.value=L}append(L){return new u(this.value?this.value+u.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+u.sep)}};De.sep=".",De=u=Re([_],De),e.CodeActionKind=De,De.Empty=new De(""),De.QuickFix=De.Empty.append("quickfix"),De.Refactor=De.Empty.append("refactor"),De.RefactorExtract=De.Refactor.append("extract"),De.RefactorInline=De.Refactor.append("inline"),De.RefactorRewrite=De.Refactor.append("rewrite"),De.Source=De.Empty.append("source"),De.SourceOrganizeImports=De.Source.append("organizeImports"),De.SourceFixAll=De.Source.append("fixAll");let Te=class{constructor(L,ne){if(this.range=L,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Te=Re([_],Te),e.SelectionRange=Te;class Me{constructor(L,ne,Ce,ze,Ve,Xe){this.kind=L,this.name=ne,this.detail=Ce,this.uri=ze,this.range=Ve,this.selectionRange=Xe}}e.CallHierarchyItem=Me;class Ue{constructor(L,ne){this.fromRanges=ne,this.from=L}}e.CallHierarchyIncomingCall=Ue;class de{constructor(L,ne){this.fromRanges=ne,this.to=L}}e.CallHierarchyOutgoingCall=de;var Se;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(Se=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ve=class{constructor(L,ne){this.range=L,this.command=ne}get isResolved(){return!!this.command}};ve=Re([_],ve),e.CodeLens=ve;let Le=h=class{constructor(L,ne=!1){m.set(this,void 0),St(this,m,new y.MarkdownString(L,{supportThemeIcons:ne}),"f")}static isMarkdownString(L){return L instanceof h?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return et(this,m,"f").value}set value(L){et(this,m,"f").value=L}get isTrusted(){return et(this,m,"f").isTrusted}set isTrusted(L){et(this,m,"f").isTrusted=L}get supportThemeIcons(){return et(this,m,"f").supportThemeIcons}set supportThemeIcons(L){et(this,m,"f").supportThemeIcons=L}get supportHtml(){return et(this,m,"f").supportHtml}set supportHtml(L){et(this,m,"f").supportHtml=L}get baseUri(){return et(this,m,"f").baseUri}set baseUri(L){et(this,m,"f").baseUri=L}appendText(L){return et(this,m,"f").appendText(L),this}appendMarkdown(L){return et(this,m,"f").appendMarkdown(L),this}appendCodeblock(L,ne){return et(this,m,"f").appendCodeblock(ne??"",L),this}};m=new WeakMap,Le=h=Re([_],Le),e.MarkdownString=Le;let Ne=class{constructor(L,ne){this.label=L,this.documentation=ne}};Ne=Re([_],Ne),e.ParameterInformation=Ne;let Ze=class{constructor(L,ne){this.label=L,this.documentation=ne,this.parameters=[]}};Ze=Re([_],Ze),e.SignatureInformation=Ze;let $e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};$e=Re([_],$e),e.SignatureHelp=$e;var He;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(He=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var je;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(je=e.InlayHintKind||(e.InlayHintKind={}));let Ye=class{constructor(L){this.value=L}};Ye=Re([_],Ye),e.InlayHintLabelPart=Ye;let oe=class{constructor(L,ne,Ce){this.position=L,this.label=ne,this.kind=Ce}};oe=Re([_],oe),e.InlayHint=oe;var be;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ke;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(ke=e.CompletionItemKind||(e.CompletionItemKind={}));var _e;(function(N){N[N.Deprecated=1]="Deprecated"})(_e=e.CompletionItemTag||(e.CompletionItemTag={}));let Be=class{constructor(L,ne){this.label=L,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Be=Re([_],Be),e.CompletionItem=Be;let Fe=class{constructor(L=[],ne=!1){this.items=L,this.isIncomplete=ne}};Fe=Re([_],Fe),e.CompletionList=Fe;let qe=class{constructor(L,ne,Ce){this.insertText=L,this.range=ne,this.command=Ce}};qe=Re([_],qe),e.InlineSuggestion=qe;let Ge=class{constructor(L){this.commands=void 0,this.items=L}};Ge=Re([_],Ge),e.InlineSuggestionList=Ge;let Ke=class{constructor(L,ne,Ce){this.insertText=L,this.range=ne,this.command=Ce}};Ke=Re([_],Ke),e.InlineSuggestionNew=Ke;let xe=class{constructor(L,ne){this.items=L,this.commands=ne}};xe=Re([_],xe),e.InlineSuggestionsNew=xe;var tt;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(tt=e.ViewColumn||(e.ViewColumn={}));var nt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(nt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var at;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ht;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(ht=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Tt;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Tt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ct;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ct=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var st;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(st=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var vt;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(vt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function L(ne){switch(ne){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=L}(Ct=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ct=class{constructor(L,ne){if(ne&&!D.URI.isUri(ne))throw(0,t.illegalArgument)("target");if(!U.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.target=ne}};ct=Re([_],ct),e.DocumentLink=ct;let ut=class{constructor(L,ne,Ce,ze){this.red=L,this.green=ne,this.blue=Ce,this.alpha=ze}};ut=Re([_],ut),e.Color=ut;let It=class{constructor(L,ne){if(ne&&!(ne instanceof ut))throw(0,t.illegalArgument)("color");if(!U.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.color=ne}};It=Re([_],It),e.ColorInformation=It;let Dt=class{constructor(L){if(!L||typeof L!="string")throw(0,t.illegalArgument)("label");this.label=L}};Dt=Re([_],Dt),e.ColorPresentation=Dt;var Lt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Lt=e.ColorFormat||(e.ColorFormat={}));var Ft;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Ft=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ot{constructor(L,ne,Ce){if(this.startIndex=L,this.length=ne,this.tooltip=Ce,typeof L!="number"||L<0)throw(0,t.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,t.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Ot;var Rt;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Rt=e.TerminalLocation||(e.TerminalLocation={}));class Nt{constructor(L){if(this.options=L,typeof L!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Nt;var Ee;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Ee=e.TaskRevealKind||(e.TaskRevealKind={}));var Ie;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(Ie=e.TaskPanelKind||(e.TaskPanelKind={}));let he=b=class{constructor(L,ne){if(this.label=ne,typeof L!="string"||typeof ne!="string")throw(0,t.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return b.Clean;case"build":return b.Build;case"rebuild":return b.Rebuild;case"test":return b.Test;default:return}}get id(){return this._id}};he.Clean=new b("clean","Clean"),he.Build=new b("build","Build"),he.Rebuild=new b("rebuild","Rebuild"),he.Test=new b("test","Test"),he=b=Re([_],he),e.TaskGroup=he;function q(N){let L="";for(let ne=0;ne<N.length;ne++)L+=N[ne].replace(/,/g,",,")+",";return L}let Pe=class{constructor(L,ne,Ce){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=L,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Ce):this._options=ne)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)L.push(ne);return q(L)}};Pe=Re([_],Pe),e.ProcessExecution=Pe;let Ae=class{constructor(L,ne,Ce){if(this._args=[],Array.isArray(ne)){if(!L)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L,this._args=ne,this._options=Ce}else{if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)L.push(typeof ne=="string"?ne:ne.value);return q(L)}};Ae=Re([_],Ae),e.ShellExecution=Ae;var Qe;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(Qe=e.ShellQuoting||(e.ShellQuoting={}));var We;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(We=e.TaskScope||(e.TaskScope={}));class it{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=it;let rt=A=class{constructor(L,ne,Ce,ze,Ve,Xe){this.__deprecated=!1,this._definition=this.definition=L;let Je;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Ce,this.execution=ze,Je=Ve,this.__deprecated=!0):ne===We.Global||ne===We.Workspace?(this.target=ne,this._name=this.name=Ce,this._source=this.source=ze,this.execution=Ve,Je=Xe):(this.target=ne,this._name=this.name=Ce,this._source=this.source=ze,this.execution=Ve,Je=Xe),typeof Je=="string"?(this._problemMatchers=[Je],this._hasDefinedMatchers=!0):Array.isArray(Je)?(this._problemMatchers=Je,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Pe?this._definition={type:A.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ae?this._definition={type:A.ShellType,id:this._execution.computeId()}:this._execution instanceof it?this._definition={type:A.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:A.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ne=this._definition.type;(A.EmptyType===ne||A.ProcessType===ne||A.ShellType===ne||A.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};rt.ExtensionCallbackType="customExecution",rt.ProcessType="process",rt.ShellType="shell",rt.EmptyType="$empty",rt=A=Re([_],rt),e.Task=rt;var Pt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Pt=e.ProgressLocation||(e.ProgressLocation={}));let dt=class{constructor(L,ne=ft.None){this.collapsibleState=ne,D.URI.isUri(L)?this.resourceUri=L:this.label=L}};dt=Re([_],dt),e.TreeItem=dt;var ft;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(ft=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let mt=class{constructor(L){this.value=L}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};mt=Re([_],mt),e.DataTransferItem=mt;let Wt=class{constructor(L){E.set(this,new Map);for(const[ne,Ce]of L??[]){const ze=et(this,E,"f").get(ne);ze?ze.push(Ce):et(this,E,"f").set(ne,[Ce])}}get(L){return et(this,E,"f").get(L)?.[0]}set(L,ne){et(this,E,"f").set(L,[ne])}forEach(L){for(const[ne,Ce]of et(this,E,"f"))Ce.forEach(ze=>L(ze,ne))}};E=new WeakMap,Wt=Re([_],Wt),e.DataTransfer=Wt;let bt=class{constructor(L,ne){this.id=L,this.color=ne}};bt=Re([_],bt),e.ThemeIcon=bt,bt.File=new bt("file"),bt.Folder=new bt("folder");let Ht=class{constructor(L){this.id=L}};Ht=Re([_],Ht),e.ThemeColor=Ht;var vn;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(vn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let jt=class{constructor(L,ne){if(typeof L!="string"&&(!L||!D.URI.isUri(L)&&!D.URI.isUri(L.uri)))throw(0,t.illegalArgument)("base");if(typeof ne!="string")throw(0,t.illegalArgument)("pattern");typeof L=="string"?this.baseUri=D.URI.file(L):D.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ne}get base(){return this._base}set base(L){this._base=L,this._baseUri=D.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};jt=Re([_],jt),e.RelativePattern=jt;let _t=class{constructor(L,ne,Ce,ze){this.enabled=typeof L=="boolean"?L:!0,typeof ne=="string"&&(this.condition=ne),typeof Ce=="string"&&(this.hitCondition=Ce),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};_t=Re([_],_t),e.Breakpoint=_t;let qt=class extends _t{constructor(L,ne,Ce,ze,Ve){super(ne,Ce,ze,Ve);if(L===null)throw(0,t.illegalArgument)("location");this.location=L}};qt=Re([_],qt),e.SourceBreakpoint=qt;let Vt=class extends _t{constructor(L,ne,Ce,ze,Ve){super(ne,Ce,ze,Ve);this.functionName=L}};Vt=Re([_],Vt),e.FunctionBreakpoint=Vt;let Gt=class extends _t{constructor(L,ne,Ce,ze,Ve,Xe,Je){super(ze,Ve,Xe,Je);if(!ne)throw(0,t.illegalArgument)("dataId");this.label=L,this.dataId=ne,this.canPersist=Ce}};Gt=Re([_],Gt),e.DataBreakpoint=Gt;let xt=class{constructor(L,ne,Ce){this.command=L,this.args=ne||[],this.options=Ce}};xt=Re([_],xt),e.DebugAdapterExecutable=xt;let Kt=class{constructor(L,ne){this.port=L,this.host=ne}};Kt=Re([_],Kt),e.DebugAdapterServer=Kt;let Qt=class{constructor(L){this.path=L}};Qt=Re([_],Qt),e.DebugAdapterNamedPipeServer=Qt;let Xt=class{constructor(L){this.implementation=L}};Xt=Re([_],Xt),e.DebugAdapterInlineImplementation=Xt;let Yt=class{constructor(L,ne){this.range=L,this.expression=ne}};Yt=Re([_],Yt),e.EvaluatableExpression=Yt;var wn;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(wn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var yn;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(yn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Jt=class{constructor(L,ne){this.range=L,this.text=ne}};Jt=Re([_],Jt),e.InlineValueText=Jt;let Zt=class{constructor(L,ne,Ce=!0){this.range=L,this.variableName=ne,this.caseSensitiveLookup=Ce}};Zt=Re([_],Zt),e.InlineValueVariableLookup=Zt;let en=class{constructor(L,ne){this.range=L,this.expression=ne}};en=Re([_],en),e.InlineValueEvaluatableExpression=en;let tn=class{constructor(L,ne){this.frameId=L,this.stoppedLocation=ne}};tn=Re([_],tn),e.InlineValueContext=tn;var En;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(En=e.FileChangeType||(e.FileChangeType={}));let nn=B=class extends Error{constructor(L,ne=R.FileSystemProviderErrorCode.Unknown,Ce){super(D.URI.isUri(L)?L.toString(!0):L);this.code=Ce?.name??"Unknown",(0,R.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,B.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(L){return new B(L,R.FileSystemProviderErrorCode.FileExists,B.FileExists)}static FileNotFound(L){return new B(L,R.FileSystemProviderErrorCode.FileNotFound,B.FileNotFound)}static FileNotADirectory(L){return new B(L,R.FileSystemProviderErrorCode.FileNotADirectory,B.FileNotADirectory)}static FileIsADirectory(L){return new B(L,R.FileSystemProviderErrorCode.FileIsADirectory,B.FileIsADirectory)}static NoPermissions(L){return new B(L,R.FileSystemProviderErrorCode.NoPermissions,B.NoPermissions)}static Unavailable(L){return new B(L,R.FileSystemProviderErrorCode.Unavailable,B.Unavailable)}};nn=B=Re([_],nn),e.FileSystemError=nn;let rn=class{constructor(L,ne,Ce){this.start=L,this.end=ne,this.kind=Ce}};rn=Re([_],rn),e.FoldingRange=rn;var Sn;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(Sn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var bn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(bn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Cn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Cn=e.CommentMode||(e.CommentMode={}));var In;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(In=e.CommentThreadState||(e.CommentThreadState={}));class Dn{constructor(L,ne=[]){this.tokenTypes=L,this.tokenModifiers=ne}}e.SemanticTokensLegend=Dn;function Pn(N){return typeof N=="undefined"||(0,v.isStringArray)(N)}class sn{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ne=0,Ce=L.tokenTypes.length;ne<Ce;ne++)this._tokenTypeStrToInt.set(L.tokenTypes[ne],ne);for(let ne=0,Ce=L.tokenModifiers.length;ne<Ce;ne++)this._tokenModifierStrToInt.set(L.tokenModifiers[ne],ne)}}push(L,ne,Ce,ze,Ve){if(typeof L=="number"&&typeof ne=="number"&&typeof Ce=="number"&&typeof ze=="number"&&(typeof Ve=="number"||typeof Ve=="undefined"))return typeof Ve=="undefined"&&(Ve=0),this._pushEncoded(L,ne,Ce,ze,Ve);if(U.isRange(L)&&typeof ne=="string"&&Pn(Ce))return this._push(L,ne,Ce);throw(0,t.illegalArgument)()}_push(L,ne,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const ze=L.start.line,Ve=L.start.character,Xe=L.end.character-L.start.character,Je=this._tokenTypeStrToInt.get(ne);let ot=0;if(Ce)for(const lt of Ce){if(!this._tokenModifierStrToInt.has(lt))throw new Error("`tokenModifier` is not in the provided legend");const pt=this._tokenModifierStrToInt.get(lt);ot|=1<<pt>>>0}this._pushEncoded(ze,Ve,Xe,Je,ot)}_pushEncoded(L,ne,Ce,ze,Ve){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const ot=this._data.length/5|0;let lt=0,pt=0;for(let wt=0;wt<ot;wt++){let Et=this._data[5*wt],Mt=this._data[5*wt+1];Et===0?(Et=lt,Mt+=pt):Et+=lt,this._data[5*wt]=Et,this._data[5*wt+1]=Mt,lt=Et,pt=Mt}}let Xe=L,Je=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Xe-=this._prevLine,Xe===0&&(Je-=this._prevChar)),this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Ve,this._prevLine=L,this._prevChar=ne}static _sortAndDeltaEncode(L){let ne=[];const Ce=L.length/5|0;for(let Je=0;Je<Ce;Je++)ne[Je]=Je;ne.sort((Je,ot)=>{const lt=L[5*Je],pt=L[5*ot];if(lt===pt){const wt=L[5*Je+1],Et=L[5*ot+1];return wt-Et}return lt-pt});const ze=new Uint32Array(L.length);let Ve=0,Xe=0;for(let Je=0;Je<Ce;Je++){const ot=5*ne[Je],lt=L[ot+0],pt=L[ot+1],wt=L[ot+2],Et=L[ot+3],Mt=L[ot+4],pn=lt-Ve,ai=pn===0?pt-Xe:pt,Ut=5*Je;ze[Ut+0]=pn,ze[Ut+1]=ai,ze[Ut+2]=wt,ze[Ut+3]=Et,ze[Ut+4]=Mt,Ve=lt,Xe=pt}return ze}build(L){return this._dataIsSortedAndDeltaEncoded?new on(new Uint32Array(this._data),L):new on(sn._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=sn;class on{constructor(L,ne){this.resultId=ne,this.data=L}}e.SemanticTokens=on;class kn{constructor(L,ne,Ce){this.start=L,this.deleteCount=ne,this.data=Ce}}e.SemanticTokensEdit=kn;class Tn{constructor(L,ne){this.resultId=ne,this.edits=L}}e.SemanticTokensEdits=Tn;var Rn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Rn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Bt=class{constructor(){}};Bt.Back={iconPath:new bt("arrow-left")},Bt=Re([_],Bt),e.QuickInputButtons=Bt;var _n;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(_n=e.QuickPickItemKind||(e.QuickPickItemKind={}));var An;(function(N){N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(An=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ln;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Ln=e.ExtensionKind||(e.ExtensionKind={}));class Fn{constructor(L,ne,Ce){this.badge=L,this.tooltip=ne,this.color=Ce}static validate(L){if(L.badge){let ne=(0,S.nextCharLength)(L.badge,0);if(ne<L.badge.length&&(ne+=(0,S.nextCharLength)(L.badge,ne)),L.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Fn;let an=class{constructor(L){this.kind=L}};an=Re([_],an),e.ColorTheme=an;var On;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast",N[N.HighContrastLight=4]="HighContrastLight"})(On=e.ColorThemeKind||(e.ColorThemeKind={}));class yt{constructor(L,ne){if(L<0)throw(0,t.illegalArgument)("start must be positive");if(ne<0)throw(0,t.illegalArgument)("end must be positive");L<=ne?(this._start=L,this._end=ne):(this._start=ne,this._end=L)}static isNotebookRange(L){return L instanceof yt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ne=this._start,Ce=this._end;return L.start!==void 0&&(ne=L.start),L.end!==void 0&&(Ce=L.end),ne===this._start&&Ce===this._end?this:new yt(ne,Ce)}}e.NotebookRange=yt;class kt{constructor(L,ne,Ce,ze,Ve,Xe,Je){this.kind=L,this.value=ne,this.languageId=Ce,this.mime=ze,this.outputs=Ve??[],this.metadata=Xe,this.executionSummary=Je,kt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ne=>kt.isNotebookCellData(ne))}static isNotebookCellData(L){return!0}}e.NotebookCellData=kt;class Nn{constructor(L){this.cells=L}}e.NotebookData=Nn;class gt{constructor(L,ne){this.data=L,this.mime=ne;const Ce=(0,k.normalizeMimeType)(ne,!0);if(!Ce)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(L){return L instanceof gt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ne={name:L.name,message:L.message,stack:L.stack};return gt.json(ne,"application/vnd.code.notebook.error")}static stdout(L){return gt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return gt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ne="application/octet-stream"){return new gt(L,ne)}static text(L,ne=k.Mimes.text){const Ce=et(gt,f,"f",p).encode(String(L));return new gt(Ce,ne)}static json(L,ne="text/x-json"){const Ce=JSON.stringify(L,void 0,"	");return gt.text(Ce,ne)}}e.NotebookCellOutputItem=gt,f=gt,p={value:new TextEncoder};class zt{constructor(L,ne,Ce){this.items=zt.ensureUniqueMimeTypes(L,!0),typeof ne=="string"?(this.id=ne,this.metadata=Ce):(this.id=(0,T.generateUuid)(),this.metadata=ne??Ce)}static isNotebookCellOutput(L){return L instanceof zt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,v.isArray)(L.items)}static ensureUniqueMimeTypes(L,ne=!1){const Ce=new Set,ze=new Set;for(let Ve=0;Ve<L.length;Ve++){const Xe=L[Ve],Je=(0,k.normalizeMimeType)(Xe.mime);if(!Ce.has(Je)){Ce.add(Je);continue}ze.add(Ve),ne&&console.warn(`DUPLICATED mime type '${Xe.mime}' will be dropped`)}return ze.size===0?L:L.filter((Ve,Xe)=>!ze.has(Xe))}}e.NotebookCellOutput=zt;var Mn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Mn=e.NotebookCellKind||(e.NotebookCellKind={}));var Un;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Un=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Bn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Bn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var zn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(zn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class $n{constructor(L,ne){this.text=L,this.alignment=ne}}e.NotebookCellStatusBarItem=$n;var Wn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Wn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Hn{constructor(L,ne=[]){this.uri=L,this.provides=(0,I.asArray)(ne)}}e.NotebookRendererScript=Hn;let ln=class{constructor(L,ne){this.label=L,this.timestamp=ne}};ln=Re([_],ln),e.TimelineItem=ln;var jn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(jn=e.ExtensionMode||(e.ExtensionMode={}));var qn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(qn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Vn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(Vn=e.StandardTokenType||(e.StandardTokenType={}));class Gn{constructor(L,ne){this.ranges=L,this.wordPattern=ne}}e.LinkedEditingRanges=Gn;class xn{constructor(L,ne){this._port=L,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=xn;var Kn;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Kn=e.TestResultState||(e.TestResultState={}));var Qn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Qn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let cn=class{constructor(L=void 0,ne=void 0,Ce=void 0){this.include=L,this.exclude=ne,this.profile=Ce}};cn=Re([_],cn),e.TestRunRequest=cn;let un=G=class{constructor(L){this.message=L}static diff(L,ne,Ce){const ze=new G(L);return ze.expectedOutput=ne,ze.actualOutput=Ce,ze}};un=G=Re([_],un),e.TestMessage=un;let hn=class{constructor(L){this.id=L}};hn=Re([_],hn),e.TestTag=hn;let At=class{constructor(L,ne){this.covered=L,this.total=ne}};At=Re([_],At),e.CoveredCount=At;let fn=Q=class{constructor(L,ne,Ce,ze){this.uri=L,this.statementCoverage=ne,this.branchCoverage=Ce,this.functionCoverage=ze}static fromDetails(L,ne){const Ce=new At(0,0),ze=new At(0,0),Ve=new At(0,0);for(const Je of ne)if("branches"in Je){Ce.total+=1,Ce.covered+=Je.executionCount>0?1:0;for(const ot of Je.branches)ze.total+=1,ze.covered+=ot.executionCount>0?1:0}else Ve.total+=1,Ve.covered+=Je.executionCount>0?1:0;const Xe=new Q(L,Ce,ze.total>0?ze:void 0,Ve.total>0?Ve:void 0);return Xe.detailedCoverage=ne,Xe}};fn=Q=Re([_],fn),e.FileCoverage=fn;let dn=class{constructor(L,ne,Ce=[]){this.executionCount=L,this.location=ne,this.branches=Ce}};dn=Re([_],dn),e.StatementCoverage=dn;let mn=class{constructor(L,ne){this.executionCount=L,this.location=ne}};mn=Re([_],mn),e.BranchCoverage=mn;let gn=class{constructor(L,ne){this.executionCount=L,this.location=ne}};gn=Re([_],gn),e.FunctionCoverage=gn;var Xn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Xn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Yn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(Yn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Jn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Zn{constructor(L,ne,Ce,ze,Ve,Xe){this.kind=L,this.name=ne,this.detail=Ce,this.uri=ze,this.range=Ve,this.selectionRange=Xe}}e.TypeHierarchyItem=Zn;class ei{constructor(L){this.uri=L}}e.TextTabInput=ei;class ti{constructor(L,ne){this.original=L,this.modified=ne}}e.TextDiffTabInput=ti;class ni{constructor(L,ne){this.uri=L,this.viewType=ne}}e.CustomEditorTabInput=ni;class ii{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=ii;class ri{constructor(L,ne){this.uri=L,this.notebookType=ne}}e.NotebookEditorTabInput=ri;class si{constructor(L,ne,Ce){this.original=L,this.modified=ne,this.notebookType=Ce}}e.NotebookDiffEditorTabInput=si;class oi{constructor(){}}e.TerminalEditorTabInput=oi}),define(we[60],ye([0,1,67]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:P,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function y(P){return new I.URITransformer(t(P))}e.createURITransformer=y}),define(we[239],ye([0,1,3,46,4,60,177,8,41,67,96,90,216,5,27,50]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class f{constructor(g,d,l,c,n,o){if(this._connectionToken=g,this._environmentService=d,this._logService=c,this._extensionHostStatusService=n,this._extensionsScannerService=o,d.args["install-builtin-extension"]){const a={isMachineScoped:!!d.args["do-not-sync"],installPreReleaseVersion:!!d.args["pre-release"]};this.whenExtensionsReady=l.installExtensions([],d.args["install-builtin-extension"],a,!!d.args.force).then(null,r=>{c.error(r)})}else this.whenExtensionsReady=Promise.resolve();const i=d.args["install-extension"];if(i){const a=i.map(r=>/\.vsix$/i.test(r)?y.URI.file((0,w.isAbsolute)(r)?r:(0,w.join)((0,m.cwd)(),r)):r);this.whenExtensionsReady.then(()=>l.installExtensions(a,[],{isMachineScoped:!!d.args["do-not-sync"],installPreReleaseVersion:!!d.args["pre-release"]},!!d.args.force)).then(null,r=>{c.error(r)})}}async call(g,d,l){switch(d){case"getEnvironmentData":{const c=l,n=(0,P.createURITransformer)(c.remoteAuthority);let o=await this._getEnvironmentData();return o=(0,D.transformOutgoingURIs)(o,n),o}case"getExtensionHostExitInfo":{const c=l;return this._extensionHostStatusService.getExitInfo(c.reconnectionToken)}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const c=l,n=c.language;this._logService.trace(`Scanning extensions using UI language: ${n}`);const o=(0,P.createURITransformer)(c.remoteAuthority),i=c.extensionDevelopmentPath&&c.extensionDevelopmentPath.map(s=>y.URI.revive(o.transformIncoming(s))),a=i?i.filter(s=>s.scheme===S.Schemas.file).map(s=>s.fsPath):void 0;let r=await this._scanExtensions(n,a);return r=(0,D.transformOutgoingURIs)(r,o),this._logService.trace("Scanned Extensions",r),f._massageWhenConditions(r),r}case"scanSingleExtension":{await this.whenExtensionsReady;const c=l,n=c.language,o=c.isBuiltin,i=(0,P.createURITransformer)(c.remoteAuthority),a=y.URI.revive(i.transformIncoming(c.extensionLocation)),r=a.scheme===S.Schemas.file?a.fsPath:null;if(!r)return null;let s=await this._scanSingleExtension(r,o,n);return s?(s=(0,D.transformOutgoingURIs)(s,i),f._massageWhenConditions([s]),s):null}case"getDiagnosticInfo":{const c=l,n={machineInfo:(0,C.getMachineInfo)()},o=c.includeProcesses?(0,R.listProcesses)(process.pid):Promise.resolve();let i=[];const a={};if(c.folders){const r=(0,P.createURITransformer)("");i=c.folders.map(u=>y.URI.revive(r.transformIncoming(u))).filter(u=>u.scheme==="file").map(u=>(0,C.collectWorkspaceStats)(u.fsPath,["node_modules",".git"]).then(h=>{a[(0,w.basename)(u.fsPath)]=h}))}return Promise.all([o,...i]).then(([r,s])=>(n.processes=r||void 0,n.workspaceMetadata=c.folders?a:void 0,n))}}throw new Error(`IPC Command ${d} not found`)}listen(g,d,l){throw new Error("Not supported")}static _massageWhenConditions(g){const d=(a,r)=>a.replace(/file/g,"vscode-remote"),l=a=>{let r="";return r+=a.global?"g":"",r+=a.ignoreCase?"i":"",r+=a.multiline?"m":"",new RegExp(d(a.source,!0),r)},c=new class{mapDefined(a){return T.ContextKeyDefinedExpr.create(a)}mapNot(a){return T.ContextKeyNotExpr.create(a)}mapEquals(a,r){return a==="resourceScheme"&&typeof r=="string"?T.ContextKeyEqualsExpr.create(a,d(r,!1)):T.ContextKeyEqualsExpr.create(a,r)}mapNotEquals(a,r){return a==="resourceScheme"&&typeof r=="string"?T.ContextKeyNotEqualsExpr.create(a,d(r,!1)):T.ContextKeyNotEqualsExpr.create(a,r)}mapGreater(a,r){return T.ContextKeyGreaterExpr.create(a,r)}mapGreaterEquals(a,r){return T.ContextKeyGreaterEqualsExpr.create(a,r)}mapSmaller(a,r){return T.ContextKeySmallerExpr.create(a,r)}mapSmallerEquals(a,r){return T.ContextKeySmallerEqualsExpr.create(a,r)}mapRegex(a,r){return a==="resourceScheme"&&r?T.ContextKeyRegexExpr.create(a,l(r)):T.ContextKeyRegexExpr.create(a,r)}mapIn(a,r){return T.ContextKeyInExpr.create(a,r)}},n=a=>{if(!a||!a.when||!/resourceScheme/.test(a.when))return;const r=T.ContextKeyExpr.deserialize(a.when);if(!r)return;const s=r.map(c);a.when=s.serialize()},o=a=>{if(Array.isArray(a))for(let r of a)n(r);else n(a)},i=a=>{for(let r in a)o(a[r])};g.forEach(a=>{a.contributes&&(a.contributes.menus&&i(a.contributes.menus),a.contributes.keybindings&&o(a.contributes.keybindings),a.contributes.views&&i(a.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:y.URI.file(this._environmentService.appRoot),settingsPath:this._environmentService.machineSettingsResource,logsPath:y.URI.file(this._environmentService.logsPath),extensionsPath:y.URI.file(this._environmentService.extensionsPath),extensionHostLogsPath:y.URI.file((0,w.join)(this._environmentService.logsPath,`exthost${f._namePool++}`)),globalStorageHome:this._environmentService.globalStorageHome,workspaceStorageHome:this._environmentService.workspaceStorageHome,localHistoryHome:this._environmentService.localHistoryHome,userHome:this._environmentService.userHome,os:I.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this._environmentService.args["use-host-proxy"]}}async _scanExtensions(g,d){const[l,c,n]=await Promise.all([this._scanBuiltinExtensions(g),this._scanInstalledExtensions(g),this._scanDevelopedExtensions(g,d)]);let o=new Map;l.forEach(a=>{!a||o.set(v.ExtensionIdentifier.toKey(a.identifier),a)}),c.forEach(a=>{!a||(o.has(v.ExtensionIdentifier.toKey(a.identifier))&&console.warn(k.localize(0,null,o.get(v.ExtensionIdentifier.toKey(a.identifier)).extensionLocation.fsPath,a.extensionLocation.fsPath)),o.set(v.ExtensionIdentifier.toKey(a.identifier),a))}),n.forEach(a=>{!a||o.set(v.ExtensionIdentifier.toKey(a.identifier),a)});const i=[];return o.forEach(a=>i.push(a)),i}async _scanDevelopedExtensions(g,d){return d?(await Promise.all(d.map(l=>this._extensionsScannerService.scanOneOrMultipleExtensions(y.URI.file((0,w.resolve)(l)),1,{language:g})))).flat().map(l=>(0,E.toExtensionDescription)(l,!0)):[]}async _scanBuiltinExtensions(g){return(await this._extensionsScannerService.scanSystemExtensions({language:g,useCache:!0})).map(l=>(0,E.toExtensionDescription)(l,!1))}async _scanInstalledExtensions(g){return(await this._extensionsScannerService.scanUserExtensions({language:g,useCache:!0})).map(l=>(0,E.toExtensionDescription)(l,!1))}async _scanSingleExtension(g,d,l){const c=y.URI.file((0,w.resolve)(g)),n=d?0:1,o=await this._extensionsScannerService.scanExistingExtension(c,n,{language:l});return o?(0,E.toExtensionDescription)(o,!1):null}}e.RemoteAgentEnvironmentChannel=f,f._namePool=1}),define(we[240],ye([0,1,4,60,58,5,203]),function(ie,e,I,t,y,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class S extends k.AbstractDiskFileSystemProviderChannel{constructor(T,R){super(new y.DiskFileSystemProvider(T),T);this.environmentService=R,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(T){let R=this.uriTransformerCache.get(T.remoteAuthority);return R||(R=(0,t.createURITransformer)(T.remoteAuthority),this.uriTransformerCache.set(T.remoteAuthority,R)),R}transformIncoming(T,R,C=!1){if(C&&R.path==="/vscode-resource"&&R.query){const w=JSON.parse(R.query).requestResourcePath;return I.URI.from({scheme:"file",path:w})}return I.URI.revive(T.transformIncoming(R))}createSessionFileWatcher(T,R){return new v(T,R,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=S;class v extends k.AbstractSessionFileWatcher{constructor(T,R,C,w){super(T,R,C,w)}getRecursiveWatcherOptions(T){const R=T.args["file-watcher-polling"];if(R){const C=R.split(P.delimiter),w=Number(C[0]);if(w>0)return{usePolling:C.length>1?C.slice(1):!0,pollingInterval:w}}}getExtraExcludes(T){if(T.extensionsPath)return[P.posix.join(T.extensionsPath,"**")]}}}),define(we[115],ye([0,1,179,12,4,2,7,34,18,16,8]),function(ie,e,I,t,y,P,k,S,v,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(j){j[j.PROGRAMMATIC=1]="PROGRAMMATIC",j[j.USER=2]="USER",j[j.EDIT=3]="EDIT",j[j.NAVIGATION=4]="NAVIGATION",j[j.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var C;(function(j){j[j.IDENTICAL=1]="IDENTICAL",j[j.SIMILAR=2]="SIMILAR",j[j.DIFFERENT=3]="DIFFERENT"})(C=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function w(j){const $=j;return!!$&&typeof $.getSelection=="function"&&!!$.onDidChangeSelection}e.isEditorPaneWithSelection=w;function m(j,$,O){for(const M of O.visibleEditorPanes)if(M.group.id===$&&j.matches(M.input))return M.getViewState()}e.findViewStateForEditor=m;function E(j){if(i(j))return!1;const $=j;return y.URI.isUri($?.resource)}e.isResourceEditorInput=E;function f(j){if(i(j))return!1;const $=j;return $?.original!==void 0&&$.modified!==void 0}e.isResourceDiffEditorInput=f;function p(j){if(i(j)||f(j))return!1;const $=j;return $?.primary!==void 0&&$.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function g(j){if(i(j))return!1;const $=j;return $?$.resource===void 0||$.resource.scheme===T.Schemas.untitled||$.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;var d;(function(j){j[j.SHORT=0]="SHORT",j[j.MEDIUM=1]="MEDIUM",j[j.LONG=2]="LONG"})(d=e.Verbosity||(e.Verbosity={}));var l;(function(j){j[j.EXPLICIT=1]="EXPLICIT",j[j.AUTO=2]="AUTO",j[j.FOCUS_CHANGE=3]="FOCUS_CHANGE",j[j.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.mapIdToSaveSource=new Map}registerSource($,O){let M=this.mapIdToSaveSource.get($);return M||(M={source:$,label:O},this.mapIdToSaveSource.set($,M)),M.source}getSourceLabel($){return this.mapIdToSaveSource.get($)?.label??$}}e.SaveSourceRegistry=new c;var n;(function(j){j[j.None=0]="None",j[j.Readonly=2]="Readonly",j[j.Untitled=4]="Untitled",j[j.Singleton=8]="Singleton",j[j.RequiresTrust=16]="RequiresTrust",j[j.CanSplitInGroup=32]="CanSplitInGroup",j[j.ForceDescription=64]="ForceDescription",j[j.CanDropIntoEditor=128]="CanDropIntoEditor"})(n=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends P.Disposable{}e.AbstractEditorInput=o;function i(j){return j instanceof o}e.isEditorInput=i;function a(j){const $=j;return y.URI.isUri($?.preferredResource)}function r(j){const $=j;return i($?.primary)&&i($?.secondary)}e.isSideBySideEditorInput=r;function s(j){const $=j;return i($?.modified)&&i($?.original)}e.isDiffEditorInput=s;function u(j){return i(j?.editor)}e.isEditorInputWithOptions=u;function h(j){const $=j;return u(j)&&$?.group!==void 0}e.isEditorInputWithOptionsAndGroup=h;function b(j){const $=j;return typeof $?.groupId=="number"&&i($.editor)}e.isEditorIdentifier=b;var A;(function(j){j[j.UNKNOWN=0]="UNKNOWN",j[j.REPLACE=1]="REPLACE",j[j.MOVE=2]="MOVE",j[j.UNPIN=3]="UNPIN"})(A=e.EditorCloseContext||(e.EditorCloseContext={}));var B;(function(j){j[j.GROUP_ACTIVE=0]="GROUP_ACTIVE",j[j.GROUP_INDEX=1]="GROUP_INDEX",j[j.GROUP_LOCKED=2]="GROUP_LOCKED",j[j.EDITOR_OPEN=3]="EDITOR_OPEN",j[j.EDITOR_CLOSE=4]="EDITOR_CLOSE",j[j.EDITOR_MOVE=5]="EDITOR_MOVE",j[j.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",j[j.EDITOR_LABEL=7]="EDITOR_LABEL",j[j.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",j[j.EDITOR_PIN=9]="EDITOR_PIN",j[j.EDITOR_STICKY=10]="EDITOR_STICKY",j[j.EDITOR_DIRTY=11]="EDITOR_DIRTY",j[j.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(B=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var G;(function(j){j[j.PRIMARY=1]="PRIMARY",j[j.SECONDARY=2]="SECONDARY",j[j.BOTH=3]="BOTH",j[j.ANY=4]="ANY"})(G=e.SideBySideEditor||(e.SideBySideEditor={}));class Q{getOriginalUri($,O){if(!$)return;if(O?.supportSideBySide){const{primary:W,secondary:J}=this.getSideEditors($);if(W&&J){if(O?.supportSideBySide===G.BOTH)return{primary:this.getOriginalUri(W,{filterByScheme:O.filterByScheme}),secondary:this.getOriginalUri(J,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===G.ANY)return this.getOriginalUri(W,{filterByScheme:O.filterByScheme})??this.getOriginalUri(J,{filterByScheme:O.filterByScheme});$=O.supportSideBySide===G.PRIMARY?W:J}}if(f($)||p($))return;const M=a($)?$.preferredResource:$.resource;return!M||!O||!O.filterByScheme?M:this.filterUri(M,O.filterByScheme)}getSideEditors($){return r($)||p($)?{primary:$.primary,secondary:$.secondary}:s($)||f($)?{primary:$.modified,secondary:$.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($,O){if(!$)return;if(O?.supportSideBySide){const{primary:W,secondary:J}=this.getSideEditors($);if(W&&J){if(O?.supportSideBySide===G.BOTH)return{primary:this.getCanonicalUri(W,{filterByScheme:O.filterByScheme}),secondary:this.getCanonicalUri(J,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===G.ANY)return this.getCanonicalUri(W,{filterByScheme:O.filterByScheme})??this.getCanonicalUri(J,{filterByScheme:O.filterByScheme});$=O.supportSideBySide===G.PRIMARY?W:J}}if(f($)||p($))return;const M=$.resource;return!M||!O||!O.filterByScheme?M:this.filterUri(M,O.filterByScheme)}filterUri($,O){if(Array.isArray(O)){if(O.some(M=>$.scheme===M))return $}else if(O===$.scheme)return $}}e.EditorResourceAccessor=new Q;var _;(function(j){j[j.LEFT=0]="LEFT",j[j.RIGHT=1]="RIGHT"})(_=e.CloseDirection||(e.CloseDirection={}));class X{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start($){const O=this.instantiationService=$.get(k.IInstantiationService);for(const[M,W]of this.editorSerializerConstructors)this.createEditorSerializer(M,W,O);this.editorSerializerConstructors.clear()}createEditorSerializer($,O,M){const W=M.createInstance(O);this.editorSerializerInstances.set($,W)}registerFileEditorFactory($){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=$}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer($,O){if(this.editorSerializerConstructors.has($)||this.editorSerializerInstances.has($))throw new Error(`A editor serializer with type ID '${$}' was already registered.`);return this.instantiationService?this.createEditorSerializer($,O,this.instantiationService):this.editorSerializerConstructors.set($,O),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete($),this.editorSerializerInstances.delete($)})}getEditorSerializer($){return this.editorSerializerInstances.get(typeof $=="string"?$:$.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new X);async function F(j,$){if(!j||!j.length)return[];const O=await Promise.all(j.map(async M=>{const W=y.URI.revive(M.fileUri);if(!W||!await $.canHandleResource(W))return;let ae=M.exists,me=M.type;if(typeof ae!="boolean"||typeof me!="number")try{me=(await $.stat(W)).isDirectory?v.FileType.Directory:v.FileType.Unknown,ae=!0}catch{ae=!1}if(!ae&&M.openOnlyIfExists||me===v.FileType.Directory)return;const fe={...M.options,pinned:!0};let V;return ae?V={resource:W,options:fe}:V={resource:W,options:fe,forceUntitled:!0},V}));return(0,D.coalesce)(O)}e.pathsToEditors=F;var U;(function(j){j[j.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",j[j.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}));function le(j){const $=j;if(!$)return!1;const O=$;if(O.modified)return le(O.modified);const M=$;return!!(M.contributionsState&&M.viewState&&Array.isArray(M.cursorState))}e.isTextEditorViewState=le}),define(we[241],ye([0,1,66,43,64,8,5,3,96]),function(ie,e,I,t,y,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var D;(function(r){r[r.Markup=1]="Markup",r[r.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(r){r[r.Running=1]="Running",r[r.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var R;(function(r){r[r.Unconfirmed=1]="Unconfirmed",r[r.Pending=2]="Pending",r[r.Executing=3]="Executing"})(R=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(r){r[r.WithHardKernelDependency=0]="WithHardKernelDependency",r[r.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",r[r.Pure=2]="Pure",r[r.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var w;(function(r){r.Always="always",r.Never="never",r.Optional="optional"})(w=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(r){r[r.ModelChange=1]="ModelChange",r[r.Move=2]="Move",r[r.ChangeCellLanguage=5]="ChangeCellLanguage",r[r.Initialize=6]="Initialize",r[r.ChangeCellMetadata=7]="ChangeCellMetadata",r[r.Output=8]="Output",r[r.OutputItem=9]="OutputItem",r[r.ChangeCellContent=10]="ChangeCellContent",r[r.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",r[r.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",r[r.ChangeCellMime=13]="ChangeCellMime",r[r.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var E;(function(r){r[r.Handle=0]="Handle",r[r.Index=1]="Index"})(E=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(r){r[r.Replace=1]="Replace",r[r.Output=2]="Output",r[r.Metadata=3]="Metadata",r[r.CellLanguage=4]="CellLanguage",r[r.DocumentMetadata=5]="DocumentMetadata",r[r.Move=6]="Move",r[r.OutputItems=7]="OutputItems",r[r.PartialMetadata=8]="PartialMetadata",r[r.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var p;(function(r){r.scheme=P.Schemas.vscodeNotebookCell;const s=/^ch(\d{7,})/;function u(Q,_){return Q.with({scheme:r.scheme,fragment:`ch${_.toString().padStart(7,"0")}${Q.scheme!==P.Schemas.file?Q.scheme:""}`})}r.generate=u;function h(Q){if(Q.scheme!==r.scheme)return;const _=s.exec(Q.fragment);return _?{handle:Number(_[1]),notebook:Q.with({scheme:Q.fragment.substring(_[0].length)||P.Schemas.file,fragment:null})}:void 0}r.parse=h;function b(Q,_){return Q.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${_??""},${Q.scheme!==P.Schemas.file?Q.scheme:""}`})}r.generateCellOutputUri=b;function A(Q){if(Q.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const _=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Q.fragment);if(!_)return;const X=_[1]&&_[1]!==""?_[1]:void 0,F=_[2];return{outputId:X,notebook:Q.with({scheme:F||P.Schemas.file,fragment:null})}}r.parseCellOutputUri=A;function B(Q,_,X){return Q.with({scheme:X,fragment:`ch${_.toString().padStart(7,"0")}${Q.scheme!==P.Schemas.file?Q.scheme:""}`})}r.generateCellUri=B;function G(Q,_){if(Q.scheme!==_)return;const X=s.exec(Q.fragment);return X?{handle:Number(X[1]),notebook:Q.with({scheme:Q.fragment.substring(X[0].length)||P.Schemas.file,fragment:null})}:void 0}r.parseCellUri=G})(p=e.CellUri||(e.CellUri={}));const g=r=>S.isWindows?r.replace(/\//g,"\\"):r;class d{constructor(s=[],u=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=u,this.order=[...new Set(s)].map(h=>({pattern:h,matches:I.parse(g(h))}))}sort(s){const u=new Map(t.Iterable.map(s,b=>[b,g(b)]));let h=[];for(const{matches:b}of this.order)for(const[A,B]of u)if(b(B)){h.push(A),u.delete(A);break}return u.size&&(h=h.concat([...u.keys()].sort((b,A)=>this.defaultOrder.indexOf(b)-this.defaultOrder.indexOf(A)))),h}prioritize(s,u){const h=this.findIndex(s);if(h===-1){this.order.unshift({pattern:s,matches:I.parse(g(s))});return}const b=new Set(u.map(B=>this.findIndex(B,h)));b.delete(-1);const A=Array.from(b).sort();this.order.splice(h+1,0,...A.map(B=>this.order[B]));for(let B=A.length-1;B>=0;B--)this.order.splice(A[B],1)}toArray(){return this.order.map(s=>s.pattern)}findIndex(s,u=this.order.length){const h=g(s);for(let b=0;b<u;b++)if(this.order[b].matches(h))return b;return-1}}e.MimeTypeDisplayOrder=d;function l(r,s,u,h=(b,A)=>b===A){const b=[];function A(Q,_,X){if(_===0&&X.length===0)return;const F=b[b.length-1];F&&F.start+F.deleteCount===Q?(F.deleteCount+=_,F.toInsert.push(...X)):b.push({start:Q,deleteCount:_,toInsert:X})}let B=0,G=0;for(;;){if(B===r.length){A(B,0,s.slice(G));break}if(G===s.length){A(B,r.length-B,[]);break}const Q=r[B],_=s[G];if(h(Q,_)){B+=1,G+=1;continue}u(_)?(A(B,1,[]),B+=1):(A(B,0,[_]),G+=1)}return b}e.diff=l,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new v.RawContextKey("notebookEditorCursorAtBoundary","none");var c;(function(r){r.default="default",r.option="option"})(c=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(r){const s=r;return!!((typeof s.include=="string"||I.isRelativePattern(s.include))&&(typeof s.exclude=="string"||I.isRelativePattern(s.exclude)))}e.isDocumentExcludePattern=n;function o(r,s,u){if(Array.isArray(r.viewType)&&r.viewType.indexOf(s)>=0||r.viewType===s)return!0;if(r.filenamePattern){const h=n(r.filenamePattern)?r.filenamePattern.include:r.filenamePattern,b=n(r.filenamePattern)?r.filenamePattern.exclude:void 0;if(I.match(h,(0,k.basename)(u.fsPath).toLowerCase()))return!(b&&I.match(b,(0,k.basename)(u.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",interactiveWindowAlwaysScrollOnNewCell:"interactiveWindow.alwaysScrollOnNewCell"};var i;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create(s){return`${a._prefix}${s}`}static parse(s){if(s.startsWith(a._prefix))return s.substring(a._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a._prefix="notebook/"}),define(we[116],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,I.createDecorator)("environmentVariableService");var t;(function(y){y[y.Replace=1]="Replace",y[y.Append=2]="Append",y[y.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(we[242],ye([0,1,3,116]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class y{constructor(v){this.map=new Map,v.forEach((D,T)=>{const R=D.map.entries();let C=R.next();for(;!C.done;){const w=C.value[0];let m=this.map.get(w);if(m||(m=[],this.map.set(w,m)),m.length>0&&m[0].type===t.EnvironmentVariableMutatorType.Replace){C=R.next();continue}const E=C.value[1];m.unshift({extensionIdentifier:T,value:E.value,type:E.type}),C=R.next()}})}async applyToProcessEnvironment(v,D){let T;I.isWindows&&(T={},Object.keys(v).forEach(R=>T[R.toLowerCase()]=R));for(const[R,C]of this.map){const w=I.isWindows&&T[R.toLowerCase()]||R;for(const m of C){const E=D?await D(m.value):m.value;switch(m.type){case t.EnvironmentVariableMutatorType.Append:v[w]=(v[w]||"")+E;break;case t.EnvironmentVariableMutatorType.Prepend:v[w]=E+(v[w]||"");break;case t.EnvironmentVariableMutatorType.Replace:v[w]=E;break}}}}diff(v){const D=new Map,T=new Map,R=new Map;if(v.map.forEach((C,w)=>{const m=this.map.get(w),E=P(C,m);E&&D.set(w,E)}),this.map.forEach((C,w)=>{const m=v.map.get(w),E=P(C,m);E&&R.set(w,E)}),this.map.forEach((C,w)=>{const m=v.map.get(w),E=k(C,m);E&&T.set(w,E)}),!(D.size===0&&T.size===0&&R.size===0))return{added:D,changed:T,removed:R}}}e.MergedEnvironmentVariableCollection=y;function P(S,v){if(!v)return S;const D=new Set;v.forEach(R=>D.add(R.extensionIdentifier));const T=[];return S.forEach(R=>{D.has(R.extensionIdentifier)||T.push(R)}),T.length===0?void 0:T}function k(S,v){if(!v)return;const D=new Map;v.forEach(R=>D.set(R.extensionIdentifier,R));const T=[];return S.forEach(R=>{const C=D.get(R.extensionIdentifier);C&&(R.type!==C.type||R.value!==C.value)&&T.push(C)}),T.length===0?void 0:T}}),define(we[117],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function I(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=I;function t(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=t}),define(we[243],ye([0,1,5,53,3]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function P(l,c){if(!!c)if(y.isWindows)for(const n in c){let o=n;for(const a in l)if(n.toLowerCase()===a.toLowerCase()){o=a;break}const i=c[n];i!==void 0&&k(l,o,i)}else Object.keys(c).forEach(n=>{const o=c[n];o!==void 0&&k(l,n,o)})}e.mergeEnvironments=P;function k(l,c,n){typeof n=="string"?l[c]=n:delete l[c]}function S(l,c,n,o){l.TERM_PROGRAM="vscode",c&&(l.TERM_PROGRAM_VERSION=c),T(l,o)&&(l.LANG=R(n)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=S;function v(l,c){if(!!c)for(const n of Object.keys(c)){const o=c[n];o&&(l[n]=o)}}async function D(l,c){return await Promise.all(Object.entries(c).map(async([n,o])=>{if(typeof o=="string")try{c[n]=await l(o)}catch{c[n]=o}})),c}function T(l,c){if(c==="on")return!0;if(c==="auto"){const n=l.LANG;return!n||n.search(/\.UTF\-8$/)===-1&&n.search(/\.utf8$/)===-1&&n.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function R(l){const c=l?l.split("-"):[],n=c.length;if(n===0)return"en_US.UTF-8";if(n===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};c[0]in o&&c.push(o[c[0]])}else c[1]=c[1].toUpperCase();return c.join("_")+".UTF-8"}e.getLangEnvVariable=R;async function C(l,c,n,o,i,a){if(l.cwd){const s=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,u=await w(s,n);return m(u||s)}let r;return!l.ignoreConfigurationCwd&&i&&(n&&(i=await w(i,n,a)),i&&(I.isAbsolute(i)?r=i:o&&(r=I.join(o.fsPath,i)))),r||(r=o?o.fsPath:c||""),m(r)}e.getCwd=C;async function w(l,c,n){if(c)try{return await c(l)}catch(o){n?.error("Could not resolve terminal cwd",o);return}return l}function m(l){return y.OS===1&&l&&l[1]===":"?l[0].toUpperCase()+l.substr(1):l}function E(l,c,n){if(!!n)return o=>n.resolveWithEnvironment(c,l,o)}e.createVariableResolver=E;async function f(l,c,n,o,i,a,r,s=y.platform){let u;r&&(u=g(l,"automationShell",s)),u||(u=g(l,"shell",s));let h=u||c;if(s===3&&!n&&o){const b=I.join(o,"Sysnative").replace(/\//g,"\\").toLowerCase();h&&h.toLowerCase().indexOf(b)===0&&(h=I.join(o,"System32",h.substr(b.length+1)))}if(h&&s===3&&(h=h.replace(/\//g,"\\")),i)try{h=await i(h)}catch(b){a.error("Could not resolve shell",b)}return h}e.getDefaultShell=f;async function p(l,c,n,o,i=y.platform){if(c&&g(l,"automationShell",i))return[];const a=i===3?"windows":i===1?"osx":"linux";let r=l(`terminal.integrated.shellArgs.${a}`);if(!r)return[];if(typeof r=="string"&&i===3)return n?await n(r):r;if(n){const s=[];for(const u of r)try{s.push(await n(u))}catch(h){o.error(`Could not resolve terminal.integrated.shellArgs.${a}`,h),s.push(u)}r=s}return r}e.getDefaultShellArgs=p;function g(l,c,n=y.platform){return l(`terminal.integrated.${c}.${n===3?"windows":n===1?"osx":"linux"}`)}async function d(l,c,n,o,i,a){const r={};if(l.strictEnv)v(r,l.env);else{v(r,a);const s={...c};n&&(s&&await D(n,s),l.env&&await D(n,l.env)),(0,t.sanitizeProcessEnvironment)(r,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),P(r,s),P(r,l.env),S(r,o,y.locale,i)}return r}e.createTerminalEnvironment=d}),define(we[79],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(P){P.Delimiter="\0"})(I=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class y{constructor(k,S=k.length){if(this.path=k,this.viewEnd=S,k.length===0||S<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,S,v=k.parent){if(k.id===S)return new y([S]);let D=[k.id];for(let T=v;T&&T.id!==S;T=T.parent)D.push(T.id);return D.push(S),new y(D.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const S=k.indexOf("\0");return S===-1?k:k.slice(0,S)}static fromString(k){return new y(k.split("\0"))}static join(k,S){return new y([...k.path,S])}static joinToString(k,S){return k.toString()+"\0"+S}static compare(k,S){return k===S?0:S.startsWith(k+"\0")?2:k.startsWith(S+"\0")?3:1}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new y(this.path,k)}compare(k){if(typeof k=="string")return y.compare(this.toString(),k);for(let S=0;S<k.viewEnd&&S<this.viewEnd;S++)if(k.path[S]!==this.path[S])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=y}),define(we[80],ye([0,1,4,47]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var y;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(y=e.TestResultState||(e.TestResultState={}));var P;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(r){r.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),r.deserialize=s=>({range:t.Range.lift(s.range),uri:I.URI.revive(s.uri)})})(k=e.IRichLocation||(e.IRichLocation={}));var S;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var v;(function(r){r.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&k.serialize(s.location)}),r.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&k.deserialize(s.location)})})(v=e.ITestErrorMessage||(e.ITestErrorMessage={}));var D;(function(r){r.serialize=s=>({message:s.message,type:1,offset:s.offset,location:s.location&&k.serialize(s.location)}),r.deserialize=s=>({message:s.message,type:1,offset:s.offset,location:s.location&&k.deserialize(s.location)})})(D=e.ITestOutputMessage||(e.ITestOutputMessage={}));var T;(function(r){r.serialize=s=>s.type===0?v.serialize(s):D.serialize(s),r.deserialize=s=>s.type===0?v.deserialize(s):D.deserialize(s)})(T=e.ITestMessage||(e.ITestMessage={}));var R;(function(r){r.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(T.serialize)}),r.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(T.deserialize)})})(R=e.ITestTaskState||(e.ITestTaskState={}));const C="\0",w=(r,s)=>r+C+s;e.namespaceTestTag=w;const m=r=>{const s=r.indexOf(C);return{ctrlId:r.slice(0,s),tagId:r.slice(s+1)}};e.denamespaceTestTag=m;var E;(function(r){r.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),r.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?I.URI.revive(s.uri):void 0,range:s.range?t.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(E=e.ITestItem||(e.ITestItem={}));var f;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(f=e.TestItemExpandState||(e.TestItemExpandState={}));var p;(function(r){r.serialize=s=>({controllerId:s.controllerId,expand:s.expand,parent:s.parent,item:E.serialize(s.item)}),r.deserialize=s=>({controllerId:s.controllerId,expand:s.expand,parent:s.parent,item:E.deserialize(s.item)})})(p=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(r){r.serialize=s=>{let u;return s.item&&(u={},s.item.label!==void 0&&(u.label=s.item.label),s.item.tags!==void 0&&(u.tags=s.item.tags),s.item.busy!==void 0&&(u.busy=s.item.busy),s.item.uri!==void 0&&(u.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(u.range=s.item.range?.toJSON()),s.item.description!==void 0&&(u.description=s.item.description),s.item.error!==void 0&&(u.error=s.item.error),s.item.sortText!==void 0&&(u.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:u}},r.deserialize=s=>{let u;return s.item&&(u={},s.item.label!==void 0&&(u.label=s.item.label),s.item.tags!==void 0&&(u.tags=s.item.tags),s.item.busy!==void 0&&(u.busy=s.item.busy),s.item.range!==void 0&&(u.range=s.item.range?t.Range.lift(s.item.range):null),s.item.description!==void 0&&(u.description=s.item.description),s.item.error!==void 0&&(u.error=s.item.error),s.item.sortText!==void 0&&(u.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:u}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const d=(r,s)=>{s.expand!==void 0&&(r.expand=s.expand),s.item!==void 0&&(r.item=r.item?Object.assign(r.item,s.item):s.item)};e.applyTestItemUpdate=d;var l;(function(r){r.serialize=(s,u)=>({...p.serialize(s),children:u,ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(R.serialize)})})(l=e.TestResultItem||(e.TestResultItem={}));var c;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(c=e.DetailType||(e.DetailType={}));var n;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(n=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(r){r.deserialize=s=>s.op===0?{op:s.op,item:p.deserialize(s.item)}:s.op===1?{op:s.op,item:g.deserialize(s.item)}:s,r.serialize=s=>s.op===0?{op:s.op,item:p.serialize(s.item)}:s.op===1?{op:s.op,item:g.serialize(s.item)}:s})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class i{add(s){}update(s){}remove(s,u){}complete(){}}e.IncrementalChangeCollector=i;class a{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(s){const u=this.createChangeCollector();for(const h of s)switch(h.op){case 0:{const b=p.deserialize(h.item);if(b.parent){if(this.items.has(b.parent)){const A=this.items.get(b.parent);A.children.add(b.item.extId);const B=this.createItem(b,A);this.items.set(b.item.extId,B),u.add(B)}}else{const A=this.createItem(b);this.roots.add(A),this.items.set(b.item.extId,A),u.add(A)}b.expand===2&&this.busyControllerCount++;break}case 1:{const b=g.deserialize(h.item),A=this.items.get(b.extId);if(!A)break;b.expand!==void 0&&(A.expand===2&&this.busyControllerCount--,b.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(A,b),u.update(A);break}case 2:{const b=this.items.get(h.itemId);if(!b)break;b.parent?this.items.get(b.parent).children.delete(b.item.extId):this.roots.delete(b);const A=[[h.itemId]];for(;A.length;)for(const B of A.pop()){const G=this.items.get(B);G&&(A.push(G.children),this.items.delete(B),u.remove(G,G!==b),G.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h.itemId);break;case 3:this.updatePendingRoots(h.amount);break;case 5:this._tags.set(h.tag.id,h.tag);break;case 6:this._tags.delete(h.id);break}u.complete()}retireTest(s){}updatePendingRoots(s){this.pendingRootCount+=s}createChangeCollector(){return new i}}e.AbstractIncrementalTestCollection=a}),define(we[118],ye([0,1,14,6,2,12,80,79]),function(ie,e,I,t,y,P,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk"})(v=e.TestItemEventOp||(e.TestItemEventOp={}));const D=(p,g)=>p===g,T={range:(p,g)=>p===g?!0:!p||!g?!1:p.equalsRange(g),busy:D,label:D,description:D,error:D,tags:(p,g)=>!(p.length!==g.length||p.some(d=>!g.includes(d)))},R=(p,g)=>{let d;for(const[l,c]of Object.entries(T))c(p[l],g[l])||(d?d[l]=g[l]:d={[l]:g[l]});return d};class C extends y.Disposable{constructor(g){super();this.options=g,this.debounceSendDiff=this._register(new I.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(g){this._resolveHandler=g;for(const d of this.tree.values())this.updateExpandability(d)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const d=this.diff[this.diff.length-1];if(d&&g.op===1){if(d.op===1&&d.item.extId===g.item.extId){(0,k.applyTestItemUpdate)(d.item,g.item);return}if(d.op===0&&d.item.item.extId===g.item.extId){(0,k.applyTestItemUpdate)(d.item,g.item);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,d){const l=this.tree.get(g);if(!!l){if((l.expandLevels===void 0||d>l.expandLevels)&&(l.expandLevels=d),l.expand===1){const c=this.resolveChildren(l);return c.isOpen()?this.expandChildren(l,d-1):c.wait().then(()=>this.expandChildren(l,d-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,d-1)):this.expandChildren(l,d-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,d){switch(d.op){case 3:this.removeItem(S.TestId.joinToString(g.fullId,d.id));break;case 0:this.upsertItem(d.item,g);break;case 5:for(const l of d.ops)this.onTestItemEvent(g,l);break;case 1:this.diffTagRefs(d.new,d.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:d.update}});break;default:(0,P.assertNever)(d)}}upsertItem(g,d){const l=S.TestId.fromExtHostTestItem(g,this.root.id,d?.actual),c=this.options.getApiFor(g);c.parent&&c.parent!==d?.actual&&this.options.getChildren(c.parent).delete(g.id);let n=this.tree.get(l.toString());if(!n){n={fullId:l,actual:g,parent:d?l.parentId:null,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(n.fullId.toString(),n),this.setItemParent(g,d),this.pushDiff({op:0,item:{parent:n.parent&&n.parent.toString(),controllerId:this.options.controllerId,expand:n.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,n,d);return}if(n.actual===g){this.connectItem(g,n,d);return}const o=this.options.getChildren(n.actual),i=n.actual,a=R(this.options.toITestItem(i),this.options.toITestItem(g));this.options.getApiFor(i).listener=void 0,n.actual=g,n.expand=0,a&&(a.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,i.tags,l.toString()),delete a.tags),this.onTestItemEvent(n,{op:4,update:a})),this.connectItemAndChildren(g,n,d);for(const r of o)this.options.getChildren(g).get(r.id)||this.removeItem(S.TestId.joinToString(l,r.id))}diffTagRefs(g,d,l){const c=new Set(d.map(n=>n.id));for(const n of g)c.delete(n.id)||this.incrementTagRefs(n);this.pushDiff({op:1,item:{extId:l,item:{tags:g.map(n=>(0,k.namespaceTestTag)(this.options.controllerId,n.id))}}}),c.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const d=this.tags.get(g.id);d?d.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,k.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const d=this.tags.get(g);d&&!--d.refCount&&(this.tags.delete(g),this.pushDiff({op:6,id:(0,k.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,d){this.options.getApiFor(g).parent=d&&d.actual!==this.root?d.actual:void 0}connectItem(g,d,l){this.setItemParent(g,l);const c=this.options.getApiFor(g);c.parent=l?.actual,c.listener=n=>this.onTestItemEvent(d,n),this.updateExpandability(d)}connectItemAndChildren(g,d,l){this.connectItem(g,d,l);for(const c of this.options.getChildren(g))this.upsertItem(c,d)}updateExpandability(g){let d;this._resolveHandler?g.resolveBarrier?d=g.resolveBarrier.isOpen()?3:2:d=g.actual.canResolveChildren?1:0:d=0,d!==g.expand&&(g.expand=d,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:d}}),d===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,d){if(d<0)return;const l=[];for(const c of this.options.getChildren(g.actual)){const n=this.expand(S.TestId.joinToString(g.fullId,c.id),d);(0,I.isThenable)(n)&&l.push(n)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const n=new I.Barrier;return n.open(),n}g.expand=2,this.pushExpandStateUpdate(g);const d=g.resolveBarrier=new I.Barrier,l=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,n)};let c;try{c=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(n){l(n)}return(0,I.isThenable)(c)?c.catch(l).then(()=>{d.open(),this.updateExpandability(g)}):(d.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const d=this.tree.get(g);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:g});const l=[d];for(;l.length;){const c=l.pop();if(!!c){this.options.getApiFor(c.actual).listener=void 0;for(const n of c.actual.tags)this.decrementTagRefs(n.id);this.tree.delete(c.fullId.toString());for(const n of this.options.getChildren(c.actual))l.push(this.tree.get(S.TestId.joinToString(c.fullId,n.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=C;class w extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=w;class m extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class E extends Error{constructor(g,d,l){super(`TestItem with ID "${g}" is from controller "${d}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=E;const f=(p,g,d)=>{let l=new Map;return{get size(){return l.size},forEach(c,n){for(const o of l.values())c.call(n,o,this)},replace(c){const n=new Map,o=new Set(l.keys()),i={op:5,ops:[]};for(const a of c){if(!(a instanceof d))throw new m(a.id);const r=g(a).controllerId;if(r!==p.controllerId)throw new E(a.id,r,p.controllerId);if(n.has(a.id))throw new w(a.id);n.set(a.id,a),o.delete(a.id),i.ops.push({op:0,item:a})}for(const a of o.keys())i.ops.push({op:3,id:a});p.listener?.(i),l=n},add(c){if(!(c instanceof d))throw new m(c.id);l.set(c.id,c),p.listener?.({op:0,item:c})},delete(c){l.delete(c)&&p.listener?.({op:3,id:c})},get(c){return l.get(c)},toJSON(){return Array.from(l.values())},[Symbol.iterator](){return l.values()}}};e.createTestItemChildren=f}),define(we[119],ye([0,1,118]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,y=(k,S)=>{const v={controllerId:S};return t.set(k,v),v};e.createPrivateApiFor=y;const P=k=>{const S=t.get(k);if(!S)throw new I.InvalidTestItemError(k?.id||"<unknown>");return S};e.getPrivateApiFor=P}),define(we[244],ye([0,1,25,7]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(I.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(we[245],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,I.createDecorator)("configurationResolverService")}),define(we[246],ye([0,1,5,27,12,21,3,86,180,15]),function(ie,e,I,t,y,P,k,S,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(C,w,m,E){this._contributedVariables=new Map,this._context=C,this._labelService=w,this._userHomePromise=m,E&&(this._envVariablesPromise=E.then(f=>this.prepareEnv(f)))}prepareEnv(C){if(k.isWindows){const w=Object.create(null);return Object.keys(C).forEach(m=>{w[m.toLowerCase()]=C[m]}),w}return C}resolveWithEnvironment(C,w,m){return this.recursiveResolve({env:this.prepareEnv(C),userHome:void 0},w?w.uri:void 0,m)}async resolveAsync(C,w){const m={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(m,C?C.uri:void 0,w)}async resolveAnyBase(C,w,m,E){const f=P.deepClone(w);k.isWindows&&f.windows?Object.keys(f.windows).forEach(g=>f[g]=f.windows[g]):k.isMacintosh&&f.osx?Object.keys(f.osx).forEach(g=>f[g]=f.osx[g]):k.isLinux&&f.linux&&Object.keys(f.linux).forEach(g=>f[g]=f.linux[g]),delete f.windows,delete f.osx,delete f.linux;const p={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(p,C?C.uri:void 0,f,m,E)}async resolveAnyAsync(C,w,m){return this.resolveAnyBase(C,w,m)}async resolveAnyMap(C,w,m){const E=new Map;return{newConfig:await this.resolveAnyBase(C,w,m,E),resolvedVariables:E}}resolveWithInteractionReplace(C,w,m,E){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,w,m,E){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,w){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,w)}async recursiveResolve(C,w,m,E,f){if(y.isString(m))return this.resolveString(C,w,m,E,f);if(y.isArray(m))return Promise.all(m.map(p=>this.recursiveResolve(C,w,p,E,f)));if(y.isObject(m)){let p=Object.create(null);const g=await Promise.all(Object.keys(m).map(async d=>[await this.resolveString(C,w,d,E,f),await this.recursiveResolve(C,w,m[d],E,f)]));for(const[d,l]of g)p[d]=l;return p}return m}resolveString(C,w,m,E,f){return(0,D.replaceAsync)(m,T.VARIABLE_REGEXP,async(p,g)=>{if(g.includes(T.VARIABLE_LHS))return p;let d=await this.evaluateSingleVariable(C,p,g,w,E);return f&&f.set(g,d),d!==p&&y.isString(d)&&d.match(T.VARIABLE_REGEXP)&&(d=await this.resolveString(C,w,d,E,f)),d})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}async evaluateSingleVariable(C,w,m,E,f){let p;const g=m.split(":");g.length>1&&(m=g[0],p=g[1]);const d=()=>{const n=this._context.getFilePath();if(n)return n;throw new Error((0,v.localize)(0,null,w))},l=()=>{const n=d();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,v.localize)(1,null,w,I.basename(n)))},c=()=>{if(p){const n=this._context.getFolderUri(p);if(n)return n;throw new Error((0,v.localize)(2,null,w,p))}if(E)return E;throw this._context.getWorkspaceFolderCount()>1?new Error((0,v.localize)(3,null,w)):new Error((0,v.localize)(4,null,w))};switch(m){case"env":if(p){if(C.env){const n=C.env[k.isWindows?p.toLowerCase():p];if(y.isString(n))return n}return""}throw new Error((0,v.localize)(5,null,w));case"config":if(p){const n=this._context.getConfigurationValue(E,p);if(y.isUndefinedOrNull(n))throw new Error((0,v.localize)(6,null,w,p));if(y.isObject(n))throw new Error((0,v.localize)(7,null,w,p));return n}throw new Error((0,v.localize)(8,null,w));case"command":return this.resolveFromMap(w,p,f,"command");case"input":return this.resolveFromMap(w,p,f,"input");case"extensionInstallFolder":if(p){const n=await this._context.getExtension(p);if(!n)throw new Error((0,v.localize)(9,null,w,p));return this.fsPath(n.extensionLocation)}throw new Error((0,v.localize)(10,null,w));default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,S.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return E||p?(0,S.normalizeDriveLetter)(this.fsPath(c())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return I.basename(this.fsPath(c()));case"userHome":{if(C.userHome)return C.userHome;throw new Error((0,v.localize)(11,null,w))}case"lineNumber":{const n=this._context.getLineNumber();if(n)return n;throw new Error((0,v.localize)(12,null,w))}case"selectedText":{const n=this._context.getSelectedText();if(n)return n;throw new Error((0,v.localize)(13,null,w))}case"file":return d();case"fileWorkspaceFolder":return l();case"relativeFile":return E||p?I.relative(this.fsPath(c()),d()):d();case"relativeFileDirname":{const n=I.dirname(d());if(E||p){const o=I.relative(this.fsPath(c()),n);return o.length===0?".":o}return n}case"fileDirname":return I.dirname(d());case"fileExtname":return I.extname(d());case"fileBasename":return I.basename(d());case"fileBasenameNoExtension":{const n=I.basename(d());return n.slice(0,n.length-I.extname(n).length)}case"fileDirnameBasename":return I.basename(I.dirname(d()));case"execPath":{const n=this._context.getExecPath();return n||w}case"execInstallFolder":{const n=this._context.getAppRoot();return n||w}case"pathSeparator":return I.sep;default:try{const n=p?`${m}:${p}`:m;return this.resolveFromMap(w,n,f,void 0)}catch{return w}}}}resolveFromMap(C,w,m,E){if(w&&m){const f=E===void 0?m[w]:m[E+":"+w];if(typeof f=="string")return f;throw new Error((0,v.localize)(14,null,C))}return C}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[247],ye([0,1,7,115]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,I.createDecorator)("editorGroupsService");var y;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var P;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var S;(function(m){m[m.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var v;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(v=e.MergeGroupMode||(e.MergeGroupMode={}));function D(m){const E=m;return(0,t.isEditorInput)(E?.editor)&&(0,t.isEditorInput)(E?.replacement)}e.isEditorReplacement=D;var T;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var R;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function C(m){const E=m;return!!E&&typeof E.id=="number"&&Array.isArray(E.editors)}e.isEditorGroup=C;function w(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=w}),define(we[120],ye([0,1,7,247]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,I.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(P){const k=P;return typeof P=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=y}),define(we[121],ye([0,1,16,17,85,29,132,45,21,12,4,47,146,183,204,119,241,79,80,120,114,62]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f,p,g,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.SnippetTextEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Ee){function Ie(q){const{selectionStartLineNumber:Pe,selectionStartColumn:Ae,positionLineNumber:Qe,positionColumn:We}=q,it=new l.Position(Pe-1,Ae-1),rt=new l.Position(Qe-1,We-1);return new l.Selection(it,rt)}Ee.to=Ie;function he(q){const{anchor:Pe,active:Ae}=q;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Ae.line+1,positionColumn:Ae.character+1}}Ee.from=he})(n=e.Selection||(e.Selection={}));var o;(function(Ee){function Ie(q){if(!q)return;const{start:Pe,end:Ae}=q;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Ae.line+1,endColumn:Ae.character+1}}Ee.from=Ie;function he(q){if(!q)return;const{startLineNumber:Pe,startColumn:Ae,endLineNumber:Qe,endColumn:We}=q;return new l.Range(Pe-1,Ae-1,Qe-1,We-1)}Ee.to=he})(o=e.Range||(e.Range={}));var i;(function(Ee){function Ie(he){switch(he){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Ee.to=Ie})(i=e.TokenType||(e.TokenType={}));var a;(function(Ee){function Ie(q){return new l.Position(q.lineNumber-1,q.column-1)}Ee.to=Ie;function he(q){return{lineNumber:q.line+1,column:q.character+1}}Ee.from=he})(a=e.Position||(e.Position={}));var r;(function(Ee){function Ie(Pe,Ae){return(0,I.coalesce)((0,I.asArray)(Pe).map(Qe=>he(Qe,Ae)))}Ee.from=Ie;function he(Pe,Ae){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:q(Pe.scheme,Ae),pattern:ke.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function q(Pe,Ae){return Ae&&typeof Pe=="string"?Ae.transformOutgoingScheme(Pe):Pe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(Ee){function Ie(q){switch(q){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Ee.from=Ie;function he(q){switch(q){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Ee.to=he})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var u;(function(Ee){function Ie(q){let Pe;return q.code&&((0,D.isString)(q.code)||(0,D.isNumber)(q.code)?Pe=String(q.code):Pe={value:String(q.code.value),target:q.code.target}),{...o.from(q.range),message:q.message,source:q.source,code:Pe,severity:b.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(h.from),tags:Array.isArray(q.tags)?(0,I.coalesce)(q.tags.map(s.from)):void 0}}Ee.from=Ie;function he(q){const Pe=new l.Diagnostic(o.to(q),q.message,b.to(q.severity));return Pe.source=q.source,Pe.code=(0,D.isString)(q.code)?q.code:q.code?.value,Pe.relatedInformation=q.relatedInformation&&q.relatedInformation.map(h.to),Pe.tags=q.tags&&(0,I.coalesce)(q.tags.map(s.to)),Pe}Ee.to=he})(u=e.Diagnostic||(e.Diagnostic={}));var h;(function(Ee){function Ie(q){return{...o.from(q.location.range),message:q.message,resource:q.location.uri}}Ee.from=Ie;function he(q){return new l.DiagnosticRelatedInformation(new l.Location(q.resource,o.to(q)),q.message)}Ee.to=he})(h=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var b;(function(Ee){function Ie(q){switch(q){case l.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}Ee.from=Ie;function he(q){switch(q){case m.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Ee.to=he})(b=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var A;(function(Ee){function Ie(q){return typeof q=="number"&&q>=l.ViewColumn.One?q-1:q===l.ViewColumn.Beside?d.SIDE_GROUP:d.ACTIVE_GROUP}Ee.from=Ie;function he(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=he})(A=e.ViewColumn||(e.ViewColumn={}));function B(Ee){return typeof Ee.range!="undefined"}function G(Ee){return Ee.length===0?!0:!!B(Ee[0])}e.isDecorationOptionsArr=G;var Q;(function(Ee){function Ie(We){return We.map(Ee.from)}Ee.fromMany=Ie;function he(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function q(We){let it;if(he(We)){const{language:ft,value:mt}=We;it={value:"```"+ft+`
`+mt+"\n```\n"}}else l.MarkdownString.isMarkdownString(We)?it={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?it={value:We}:it={value:""};const rt=Object.create(null);it.uris=rt;const Pt=ft=>{try{let mt=T.URI.parse(ft,!0);mt=mt.with({query:Pe(mt.query,rt)}),rt[ft]=mt}catch{}return""},dt=new k.marked.Renderer;return dt.link=Pt,dt.image=ft=>typeof ft=="string"?Pt(y.parseHrefAndDimensions(ft).href):"",(0,k.marked)(it.value,{renderer:dt}),it}Ee.from=q;function Pe(We,it){if(!We)return We;let rt;try{rt=(0,S.parse)(We)}catch{}if(!rt)return We;let Pt=!1;return rt=(0,v.cloneAndChange)(rt,dt=>{if(T.URI.isUri(dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ft]=dt,Pt=!0,ft}else return}),Pt?JSON.stringify(rt):We}function Ae(We){const it=new l.MarkdownString(We.value,We.supportThemeIcons);return it.isTrusted=We.isTrusted,it.supportHtml=We.supportHtml,it.baseUri=We.baseUri?T.URI.from(We.baseUri):void 0,it}Ee.to=Ae;function Qe(We){if(!!We)return typeof We=="string"?We:Ee.from(We)}Ee.fromStrict=Qe})(Q=e.MarkdownString||(e.MarkdownString={}));function _(Ee){return G(Ee)?Ee.map(Ie=>({range:o.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?Q.fromMany(Ie.hoverMessage):Ie.hoverMessage?Q.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Ee.map(Ie=>({range:o.from(Ie)}))}e.fromRangeOrRangeWithMessage=_;function X(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?T.URI.file(Ee):Ee}e.pathOrURIToURI=X;var F;(function(Ee){function Ie(he){return typeof he=="undefined"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?X(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Ee.from=Ie})(F=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Ee){function Ie(he){return typeof he=="undefined"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?X(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?F.from(he.before):void 0,after:he.after?F.from(he.after):void 0}}Ee.from=Ie})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var le;(function(Ee){function Ie(he){if(typeof he=="undefined")return he;switch(he){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Ie})(le=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var j;(function(Ee){function Ie(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?le.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?U.from(he.light):void 0,dark:he.dark?U.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?X(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?F.from(he.before):void 0,after:he.after?F.from(he.after):void 0}}Ee.from=Ie})(j=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(Ee){function Ie(q){return{text:q.newText,eol:q.newEol&&He.from(q.newEol),range:o.from(q.range)}}Ee.from=Ie;function he(q){const Pe=new l.TextEdit(o.to(q.range),q.text);return Pe.newEol=typeof q.eol=="undefined"?void 0:He.to(q.eol),Pe}Ee.to=he})($=e.TextEdit||(e.TextEdit={}));var O;(function(Ee){function Ie(he){return{range:o.from(he.range),snippet:he.snippet.value}}Ee.from=Ie})(O=e.SnippetTextEdit||(e.SnippetTextEdit={}));var M;(function(Ee){function Ie(q,Pe){const Ae={edits:[]};if(q instanceof l.WorkspaceEdit){const Qe=new P.ResourceSet;for(const We of q._allEntries())We._type===1&&T.URI.isUri(We.to)&&We.from===void 0&&Qe.add(We.to);for(const We of q._allEntries())We._type===1?Ae.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata}):We._type===2?Ae.edits.push({_type:2,resource:We.uri,edit:$.from(We.edit),modelVersionId:Qe.has(We.uri)?void 0:Pe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Ae.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Ae.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(We.uri),edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(xe.from)}})}return Ae}Ee.from=Ie;function he(q){const Pe=new l.WorkspaceEdit;for(const Ae of q.edits)Ae.edit?Pe.replace(T.URI.revive(Ae.resource),o.to(Ae.edit.range),Ae.edit.text):Pe.renameFile(T.URI.revive(Ae.oldUri),T.URI.revive(Ae.newUri),Ae.options);return Pe}Ee.to=he})(M=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(Ee){const Ie=Object.create(null);Ie[l.SymbolKind.File]=0,Ie[l.SymbolKind.Module]=1,Ie[l.SymbolKind.Namespace]=2,Ie[l.SymbolKind.Package]=3,Ie[l.SymbolKind.Class]=4,Ie[l.SymbolKind.Method]=5,Ie[l.SymbolKind.Property]=6,Ie[l.SymbolKind.Field]=7,Ie[l.SymbolKind.Constructor]=8,Ie[l.SymbolKind.Enum]=9,Ie[l.SymbolKind.Interface]=10,Ie[l.SymbolKind.Function]=11,Ie[l.SymbolKind.Variable]=12,Ie[l.SymbolKind.Constant]=13,Ie[l.SymbolKind.String]=14,Ie[l.SymbolKind.Number]=15,Ie[l.SymbolKind.Boolean]=16,Ie[l.SymbolKind.Array]=17,Ie[l.SymbolKind.Object]=18,Ie[l.SymbolKind.Key]=19,Ie[l.SymbolKind.Null]=20,Ie[l.SymbolKind.EnumMember]=21,Ie[l.SymbolKind.Struct]=22,Ie[l.SymbolKind.Event]=23,Ie[l.SymbolKind.Operator]=24,Ie[l.SymbolKind.TypeParameter]=25;function he(Pe){return typeof Ie[Pe]=="number"?Ie[Pe]:6}Ee.from=he;function q(Pe){for(const Ae in Ie)if(Ie[Ae]===Pe)return Number(Ae);return l.SymbolKind.Property}Ee.to=q})(W=e.SymbolKind||(e.SymbolKind={}));var J;(function(Ee){function Ie(q){switch(q){case l.SymbolTag.Deprecated:return 1}}Ee.from=Ie;function he(q){switch(q){case 1:return l.SymbolTag.Deprecated}}Ee.to=he})(J=e.SymbolTag||(e.SymbolTag={}));var ae;(function(Ee){function Ie(q){return{name:q.name,kind:W.from(q.kind),tags:q.tags&&q.tags.map(J.from),containerName:q.containerName,location:x.from(q.location)}}Ee.from=Ie;function he(q){const Pe=new l.SymbolInformation(q.name,W.to(q.kind),q.containerName,x.to(q.location));return Pe.tags=q.tags&&q.tags.map(J.to),Pe}Ee.to=he})(ae=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var me;(function(Ee){function Ie(q){const Pe={name:q.name||"!!MISSING: name!!",detail:q.detail,range:o.from(q.range),selectionRange:o.from(q.selectionRange),kind:W.from(q.kind),tags:q.tags?.map(J.from)??[]};return q.children&&(Pe.children=q.children.map(Ie)),Pe}Ee.from=Ie;function he(q){const Pe=new l.DocumentSymbol(q.name,q.detail,W.to(q.kind),o.to(q.range),o.to(q.selectionRange));return(0,I.isNonEmptyArray)(q.tags)&&(Pe.tags=q.tags.map(J.to)),q.children&&(Pe.children=q.children.map(he)),Pe}Ee.to=he})(me=e.DocumentSymbol||(e.DocumentSymbol={}));var fe;(function(Ee){function Ie(q){const Pe=new l.CallHierarchyItem(W.to(q.kind),q.name,q.detail||"",T.URI.revive(q.uri),o.to(q.range),o.to(q.selectionRange));return Pe._sessionId=q._sessionId,Pe._itemId=q._itemId,Pe}Ee.to=Ie;function he(q,Pe,Ae){if(Pe=Pe??q._sessionId,Ae=Ae??q._itemId,Pe===void 0||Ae===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ae,name:q.name,detail:q.detail,kind:W.from(q.kind),uri:q.uri,range:o.from(q.range),selectionRange:o.from(q.selectionRange),tags:q.tags?.map(J.from)}}Ee.from=he})(fe=e.CallHierarchyItem||(e.CallHierarchyItem={}));var V;(function(Ee){function Ie(he){return new l.CallHierarchyIncomingCall(fe.to(he.from),he.fromRanges.map(q=>o.to(q)))}Ee.to=Ie})(V=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ee;(function(Ee){function Ie(he){return new l.CallHierarchyOutgoingCall(fe.to(he.to),he.fromRanges.map(q=>o.to(q)))}Ee.to=Ie})(ee=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var x;(function(Ee){function Ie(q){return{range:q.range&&o.from(q.range),uri:q.uri}}Ee.from=Ie;function he(q){return new l.Location(T.URI.revive(q.uri),o.to(q.range))}Ee.to=he})(x=e.location||(e.location={}));var z;(function(Ee){function Ie(q){const Pe=q,Ae=q;return{originSelectionRange:Pe.originSelectionRange?o.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Ae.uri,range:o.from(Pe.targetRange?Pe.targetRange:Ae.range),targetSelectionRange:Pe.targetSelectionRange?o.from(Pe.targetSelectionRange):void 0}}Ee.from=Ie;function he(q){return{targetUri:T.URI.revive(q.uri),targetRange:o.to(q.range),targetSelectionRange:q.targetSelectionRange?o.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?o.to(q.originSelectionRange):void 0}}Ee.to=he})(z=e.DefinitionLink||(e.DefinitionLink={}));var te;(function(Ee){function Ie(q){return{range:o.from(q.range),contents:Q.fromMany(q.contents)}}Ee.from=Ie;function he(q){return new l.Hover(q.contents.map(Q.to),o.to(q.range))}Ee.to=he})(te=e.Hover||(e.Hover={}));var ce;(function(Ee){function Ie(q){return{range:o.from(q.range),expression:q.expression}}Ee.from=Ie;function he(q){return new l.EvaluatableExpression(o.to(q.range),q.expression)}Ee.to=he})(ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Z;(function(Ee){function Ie(q){if(q instanceof l.InlineValueText)return{type:"text",range:o.from(q.range),text:q.text};if(q instanceof l.InlineValueVariableLookup)return{type:"variable",range:o.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ie;function he(q){switch(q.type){case"text":return{range:o.to(q.range),text:q.text};case"variable":return{range:o.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:o.to(q.range),expression:q.expression}}}Ee.to=he})(Z=e.InlineValue||(e.InlineValue={}));var se;(function(Ee){function Ie(q){return{frameId:q.frameId,stoppedLocation:o.from(q.stoppedLocation)}}Ee.from=Ie;function he(q){return new l.InlineValueContext(q.frameId,o.to(q.stoppedLocation))}Ee.to=he})(se=e.InlineValueContext||(e.InlineValueContext={}));var ge;(function(Ee){function Ie(q){return{range:o.from(q.range),kind:q.kind}}Ee.from=Ie;function he(q){return new l.DocumentHighlight(o.to(q.range),q.kind)}Ee.to=he})(ge=e.DocumentHighlight||(e.DocumentHighlight={}));var Y;(function(Ee){function Ie(he){switch(he){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Ee.to=Ie})(Y=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var re;(function(Ee){function Ie(he){return{triggerKind:Y.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Ee.to=Ie})(re=e.CompletionContext||(e.CompletionContext={}));var H;(function(Ee){function Ie(q){switch(q){case l.CompletionItemTag.Deprecated:return 1}}Ee.from=Ie;function he(q){switch(q){case 1:return l.CompletionItemTag.Deprecated}}Ee.to=he})(H=e.CompletionItemTag||(e.CompletionItemTag={}));var K;(function(Ee){const Ie=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function he(Ae){return Ie.get(Ae)??9}Ee.from=he;const q=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Pe(Ae){return q.get(Ae)??l.CompletionItemKind.Property}Ee.to=Pe})(K=e.CompletionItemKind||(e.CompletionItemKind={}));var ue;(function(Ee){function Ie(he,q){const Pe=new l.CompletionItem(he.label);return Pe.insertText=he.insertText,Pe.kind=K.to(he.kind),Pe.tags=he.tags?.map(H.to),Pe.detail=he.detail,Pe.documentation=y.isMarkdownString(he.documentation)?Q.to(he.documentation):he.documentation,Pe.sortText=he.sortText,Pe.filterText=he.filterText,Pe.preselect=he.preselect,Pe.commitCharacters=he.commitCharacters,R.Range.isIRange(he.range)?Pe.range=o.to(he.range):typeof he.range=="object"&&(Pe.range={inserting:o.to(he.range.insert),replacing:o.to(he.range.replace)}),Pe.keepWhitespace=typeof he.insertTextRules=="undefined"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules!="undefined"&&he.insertTextRules&4?Pe.insertText=new l.SnippetString(he.insertText):(Pe.insertText=he.insertText,Pe.textEdit=Pe.range instanceof l.Range?new l.TextEdit(Pe.range,Pe.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Pe.additionalTextEdits=he.additionalTextEdits.map(Ae=>$.to(Ae))),Pe.command=q&&he.command?q.fromInternal(he.command):void 0,Pe}Ee.to=Ie})(ue=e.CompletionItem||(e.CompletionItem={}));var pe;(function(Ee){function Ie(q){return{label:q.label,documentation:Q.fromStrict(q.documentation)}}Ee.from=Ie;function he(q){return{label:q.label,documentation:y.isMarkdownString(q.documentation)?Q.to(q.documentation):q.documentation}}Ee.to=he})(pe=e.ParameterInformation||(e.ParameterInformation={}));var De;(function(Ee){function Ie(q){return{label:q.label,documentation:Q.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(pe.from):[],activeParameter:q.activeParameter}}Ee.from=Ie;function he(q){return{label:q.label,documentation:y.isMarkdownString(q.documentation)?Q.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(pe.to):[],activeParameter:q.activeParameter}}Ee.to=he})(De=e.SignatureInformation||(e.SignatureInformation={}));var Te;(function(Ee){function Ie(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(De.from):[]}}Ee.from=Ie;function he(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(De.to):[]}}Ee.to=he})(Te=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(Ee){function Ie(he,q){const Pe=new l.InlayHint(a.to(q.position),typeof q.label=="string"?q.label:q.label.map(Ue.to.bind(void 0,he)),q.kind&&de.to(q.kind));return Pe.textEdits=q.textEdits&&q.textEdits.map($.to),Pe.tooltip=y.isMarkdownString(q.tooltip)?Q.to(q.tooltip):q.tooltip,Pe.paddingLeft=q.paddingLeft,Pe.paddingRight=q.paddingRight,Pe}Ee.to=Ie})(Me=e.InlayHint||(e.InlayHint={}));var Ue;(function(Ee){function Ie(he,q){const Pe=new l.InlayHintLabelPart(q.label);return Pe.tooltip=y.isMarkdownString(q.tooltip)?Q.to(q.tooltip):q.tooltip,C.Command.is(q.command)&&(Pe.command=he.fromInternal(q.command)),q.location&&(Pe.location=x.to(q.location)),Pe}Ee.to=Ie})(Ue=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var de;(function(Ee){function Ie(q){return q}Ee.from=Ie;function he(q){return q}Ee.to=he})(de=e.InlayHintKind||(e.InlayHintKind={}));var Se;(function(Ee){function Ie(q){return{range:o.from(q.range),url:q.target,tooltip:q.tooltip}}Ee.from=Ie;function he(q){let Pe;if(q.url)try{Pe=typeof q.url=="string"?T.URI.parse(q.url,!0):T.URI.revive(q.url)}catch{}return new l.DocumentLink(o.to(q.range),Pe)}Ee.to=he})(Se=e.DocumentLink||(e.DocumentLink={}));var ve;(function(Ee){function Ie(q){const Pe=new l.ColorPresentation(q.label);return q.textEdit&&(Pe.textEdit=$.to(q.textEdit)),q.additionalTextEdits&&(Pe.additionalTextEdits=q.additionalTextEdits.map(Ae=>$.to(Ae))),Pe}Ee.to=Ie;function he(q){return{label:q.label,textEdit:q.textEdit?$.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Pe=>$.from(Pe)):void 0}}Ee.from=he})(ve=e.ColorPresentation||(e.ColorPresentation={}));var Le;(function(Ee){function Ie(q){return new l.Color(q[0],q[1],q[2],q[3])}Ee.to=Ie;function he(q){return[q.red,q.green,q.blue,q.alpha]}Ee.from=he})(Le=e.Color||(e.Color={}));var Ne;(function(Ee){function Ie(q){return{range:o.from(q.range)}}Ee.from=Ie;function he(q){return new l.SelectionRange(o.to(q.range))}Ee.to=he})(Ne=e.SelectionRange||(e.SelectionRange={}));var Ze;(function(Ee){function Ie(he){switch(he){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Ee.to=Ie})(Ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var $e;(function(Ee){function Ie(q){switch(q){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Ie;function he(q){switch(q){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Ee.to=he})($e=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var He;(function(Ee){function Ie(q){if(q===l.EndOfLine.CRLF)return 1;if(q===l.EndOfLine.LF)return 0}Ee.from=Ie;function he(q){if(q===1)return l.EndOfLine.CRLF;if(q===0)return l.EndOfLine.LF}Ee.to=he})(He=e.EndOfLine||(e.EndOfLine={}));var je;(function(Ee){function Ie(he){if(typeof he=="object")return he.viewId;switch(he){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ie})(je=e.ProgressLocation||(e.ProgressLocation={}));var Ye;(function(Ee){function Ie(he){const q={start:he.start+1,end:he.end+1};return he.kind&&(q.kind=oe.from(he.kind)),q}Ee.from=Ie})(Ye=e.FoldingRange||(e.FoldingRange={}));var oe;(function(Ee){function Ie(he){if(he)switch(he){case l.FoldingRangeKind.Comment:return C.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return C.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return C.FoldingRangeKind.Region}}Ee.from=Ie})(oe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var be;(function(Ee){function Ie(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?o.from(he.selection):void 0,override:typeof he.override=="boolean"?w.EditorResolution.DISABLED:void 0}}Ee.from=Ie})(be=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ke;(function(Ee){function Ie(Ae){return Ae instanceof l.RelativePattern?Ae.toJSON():typeof Ae=="string"?Ae:he(Ae)||q(Ae)?new l.RelativePattern(Ae.baseUri??Ae.base,Ae.pattern).toJSON():Ae}Ee.from=Ie;function he(Ae){const Qe=Ae;return Qe?T.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function q(Ae){const Qe=Ae;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Pe(Ae){return typeof Ae=="string"?Ae:new l.RelativePattern(T.URI.revive(Ae.baseUri),Ae.pattern)}Ee.to=Pe})(ke=e.GlobPattern||(e.GlobPattern={}));var _e;(function(Ee){function Ie(he){if(he){if(Array.isArray(he))return he.map(Ie);if(typeof he=="string")return he;{const q=he;return{language:q.language,scheme:q.scheme,pattern:ke.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}Ee.from=Ie})(_e=e.LanguageSelector||(e.LanguageSelector={}));var Be;(function(Ee){function Ie(q){return{start:q.start,end:q.end}}Ee.from=Ie;function he(q){return new l.NotebookRange(q.start,q.end)}Ee.to=he})(Be=e.NotebookRange||(e.NotebookRange={}));var Fe;(function(Ee){function Ie(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}Ee.to=Ie;function he(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}Ee.from=he})(Fe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(Ee){function Ie(he){if(he===f.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;if(he===f.NotebookCellExecutionState.Pending)return l.NotebookCellExecutionState.Pending;if(he===f.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${he}`)}Ee.to=Ie})(qe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ge;(function(Ee){function Ie(q){switch(q){case l.NotebookCellKind.Markup:return f.CellKind.Markup;case l.NotebookCellKind.Code:default:return f.CellKind.Code}}Ee.from=Ie;function he(q){switch(q){case f.CellKind.Markup:return l.NotebookCellKind.Markup;case f.CellKind.Code:default:return l.NotebookCellKind.Code}}Ee.to=he})(Ge=e.NotebookCellKind||(e.NotebookCellKind={}));var Ke;(function(Ee){function Ie(q){const Pe={metadata:q.metadata??Object.create(null),cells:[]};for(let Ae of q.cells)l.NotebookCellData.validate(Ae),Pe.cells.push(xe.from(Ae));return Pe}Ee.from=Ie;function he(q){const Pe=new l.NotebookData(q.cells.map(xe.to));return(0,D.isEmptyObject)(q.metadata)||(Pe.metadata=q.metadata),Pe}Ee.to=he})(Ke=e.NotebookData||(e.NotebookData={}));var xe;(function(Ee){function Ie(q){return{cellKind:Ge.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:Fe.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(nt.from):[]}}Ee.from=Ie;function he(q){return new l.NotebookCellData(Ge.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(nt.to):void 0,q.metadata,q.internalMetadata?Fe.to(q.internalMetadata):void 0)}Ee.to=he})(xe=e.NotebookCellData||(e.NotebookCellData={}));var tt;(function(Ee){function Ie(q){return{mime:q.mime,valueBytes:t.VSBuffer.wrap(q.data)}}Ee.from=Ie;function he(q){return new l.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}Ee.to=he})(tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var nt;(function(Ee){function Ie(q){return{outputId:q.id,items:q.items.map(tt.from),metadata:q.metadata}}Ee.from=Ie;function he(q){const Pe=q.items.map(tt.to);return new l.NotebookCellOutput(Pe,q.outputId,q.metadata)}Ee.to=he})(nt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var at;(function(Ee){function Ie(Pe){return q(Pe)?{include:(0,D.withNullAsUndefined)(ke.from(Pe.include)),exclude:(0,D.withNullAsUndefined)(ke.from(Pe.exclude))}:(0,D.withNullAsUndefined)(ke.from(Pe))}Ee.from=Ie;function he(Pe){return q(Pe)?{include:ke.to(Pe.include),exclude:ke.to(Pe.exclude)}:ke.to(Pe)}Ee.to=he;function q(Pe){const Ae=Pe;return Ae?!(0,D.isUndefinedOrNull)(Ae.include)&&!(0,D.isUndefinedOrNull)(Ae.exclude):!1}})(at=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ht;(function(Ee){function Ie(he){return{backgroundColor:he.backgroundColor,borderColor:he.borderColor,top:he.top?F.from(he.top):void 0}}Ee.from=Ie})(ht=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Tt;(function(Ee){function Ie(he,q,Pe){const Ae=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Ae,Pe),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Ee.from=Ie})(Tt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ct;(function(Ee){function Ie(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{}}}Ee.from=Ie})(Ct=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var st;(function(Ee){function Ie(q){return{uri:q.uri,provides:q.provides}}Ee.from=Ie;function he(q){return new l.NotebookRendererScript(T.URI.revive(q.uri),q.provides)}Ee.to=he})(st=e.NotebookRendererScript||(e.NotebookRendererScript={}));var vt;(function(Ee){function Ie(q){return{message:Q.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location&&{range:o.from(q.location.range),uri:q.location.uri}}}Ee.from=Ie;function he(q){const Pe=new l.TestMessage(typeof q.message=="string"?q.message:Q.to(q.message));return Pe.actualOutput=q.actual,Pe.expectedOutput=q.expected,Pe.location=q.location?x.to(q.location):void 0,Pe}Ee.to=he})(vt=e.TestMessage||(e.TestMessage={}));var ct;(function(Ee){Ee.namespace=g.namespaceTestTag,Ee.denamespace=g.denamespaceTestTag})(ct=e.TestTag||(e.TestTag={}));var ut;(function(Ee){function Ie(q){const Pe=(0,E.getPrivateApiFor)(q).controllerId;return{extId:p.TestId.fromExtHostTestItem(q,Pe).toString(),label:q.label,uri:T.URI.revive(q.uri),busy:!1,tags:q.tags.map(Ae=>ct.namespace(Pe,Ae.id)),range:R.Range.lift(o.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&Q.fromStrict(q.error)||null}}Ee.from=Ie;function he(q){return{parent:void 0,error:void 0,id:p.TestId.fromString(q.extId).localId,label:q.label,uri:T.URI.revive(q.uri),tags:(q.tags||[]).map(Pe=>{const{tagId:Ae}=ct.denamespace(Pe);return new l.TestTag(Ae)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},get:()=>{},replace:()=>{},size:0},range:o.to(q.range||void 0),canResolveChildren:!1,busy:!1,description:q.description||void 0,sortText:q.sortText||void 0}}Ee.toPlain=he})(ut=e.TestItem||(e.TestItem={})),function(Ee){function Ie(q){return{id:q.id}}Ee.from=Ie;function he(q){return new l.TestTag(q.id)}Ee.to=he}(ct=e.TestTag||(e.TestTag={}));var It;(function(Ee){const Ie=(q,Pe)=>{const Ae={...ut.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(We=>We.type===0).map(vt.to)})),children:q.children.map(Qe=>Pe.get(Qe)).filter(D.isDefined).map(Qe=>Ie(Qe,Pe))};for(const Qe of Ae.children)Qe.parent=Ae;return Ae};function he(q){const Pe=[],Ae=new Map;for(const Qe of q.items)Ae.set(Qe.item.extId,Qe),q.request.targets.some(We=>We.controllerId===Qe.controllerId&&We.testIds.includes(Qe.item.extId))&&Pe.push(Qe);return{completedAt:q.completedAt,results:Pe.map(Qe=>Ie(Qe,Ae))}}Ee.to=he})(It=e.TestResults||(e.TestResults={}));var Dt;(function(Ee){function Ie(Ae){return{covered:Ae.covered,total:Ae.covered}}function he(Ae){return"line"in Ae?a.from(Ae):o.from(Ae)}function q(Ae){return"branches"in Ae?{count:Ae.executionCount,location:he(Ae.location),type:1,branches:Ae.branches.length?Ae.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&he(Qe.location)})):void 0}:{type:0,count:Ae.executionCount,location:he(Ae.location)}}Ee.fromDetailed=q;function Pe(Ae){return{uri:Ae.uri,statement:Ie(Ae.statementCoverage),branch:Ae.branchCoverage&&Ie(Ae.branchCoverage),function:Ae.functionCoverage&&Ie(Ae.functionCoverage),details:Ae.detailedCoverage?.map(q)}}Ee.fromFile=Pe})(Dt=e.TestCoverage||(e.TestCoverage={}));var Lt;(function(Ee){function Ie(he){switch(he){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Ee.to=Ie})(Lt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(Ee){function Ie(q){const Pe=new l.TypeHierarchyItem(W.to(q.kind),q.name,q.detail||"",T.URI.revive(q.uri),o.to(q.range),o.to(q.selectionRange));return Pe._sessionId=q._sessionId,Pe._itemId=q._itemId,Pe}Ee.to=Ie;function he(q,Pe,Ae){if(Pe=Pe??q._sessionId,Ae=Ae??q._itemId,Pe===void 0||Ae===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ae,kind:W.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:o.from(q.range),selectionRange:o.from(q.selectionRange),tags:q.tags?.map(J.from)}}Ee.from=he})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ot;(function(Ee){function Ie(he){if(!!he)return{value:he.value,tooltip:he.tooltip}}Ee.from=Ie})(Ot=e.ViewBadge||(e.ViewBadge={}));var Rt;(function(Ee){function Ie(he,q){const Pe=he.fileData;return Pe?new class extends l.DataTransferItem{asFile(){return{name:Pe.name,uri:T.URI.revive(Pe.uri),data:(0,c.once)(()=>q())}}}(""):new l.DataTransferItem(he.asString)}Ee.toDataTransferItem=Ie})(Rt=e.DataTransferItem||(e.DataTransferItem={}));var Nt;(function(Ee){function Ie(q,Pe){const Ae=q.items.map(([Qe,We],it)=>[Qe,Rt.toDataTransferItem(We,()=>Pe(it))]);return new l.DataTransfer(Ae)}Ee.toDataTransfer=Ie;async function he(q){const Pe={items:[]},Ae=[];return q.forEach((Qe,We)=>{Ae.push((async()=>{const it=await Qe.asString(),rt=Qe.asFile();Pe.items.push([We,{asString:it,fileData:rt?{name:rt.name,uri:rt.uri}:void 0}])})())}),await Promise.all(Ae),Pe}Ee.toDataTransferDTO=he})(Nt=e.DataTransfer||(e.DataTransfer={}))}),define(we[248],ye([0,1,47,119,79,118,80,121,4]),function(ie,e,I,t,y,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const D=(d,l,c,n)=>{let o=l;return{enumerable:!0,configurable:!1,get(){return o},set(i){if(!c(o,i)){const a=o;o=i,d.listener?.(n(i,a))}}}},T=(d,l)=>d===l,R={range:(d,l)=>d===l?!0:!d||!l?!1:d.isEqual(l),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(d,l)=>!(d.length!==l.length||d.some(c=>!l.find(n=>c.id===n.id)))},C=d=>l=>({op:4,update:d(l)}),w=(d,l)=>({range:D(d,void 0,R.range,C(c=>({range:I.Range.lift(S.Range.from(c))}))),label:D(d,l,R.label,C(c=>({label:c}))),description:D(d,void 0,R.description,C(c=>({description:c}))),sortText:D(d,void 0,R.sortText,C(c=>({sortText:c}))),canResolveChildren:D(d,!1,R.canResolveChildren,c=>({op:2,state:c})),busy:D(d,!1,R.busy,C(c=>({busy:c}))),error:D(d,void 0,R.error,C(c=>({error:S.MarkdownString.fromStrict(c)||null}))),tags:D(d,[],R.tags,(c,n)=>({op:1,new:c.map(S.TestTag.from),old:n.map(S.TestTag.from)}))}),m=d=>{const l=y.TestId.fromString(d.extId),c=new f(l.controllerId,l.localId,d.label,v.URI.revive(d.uri)||void 0);return c.range=S.Range.to(d.range||void 0),c.description=d.description||void 0,c.sortText=d.sortText||void 0,c.tags=d.tags.map(n=>S.TestTag.to({id:(0,k.denamespaceTestTag)(n).tagId})),c},E=d=>{let l;for(const c of d.tests){const n=m(c.item);(0,t.getPrivateApiFor)(n).parent=l,l=n}return l};e.toItemFromContext=E;class f{constructor(l,c,n,o){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const i=(0,t.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof p?void 0:i.parent}},children:{value:(0,P.createTestItemChildren)(i,t.getPrivateApiFor,f),enumerable:!0,writable:!1},...w(i,n)})}}e.TestItemImpl=f;class p extends f{constructor(l,c){super(l,l,c,void 0)}}e.TestItemRootImpl=p;class g extends P.TestItemCollection{constructor(l,c){super({controllerId:l,getApiFor:t.getPrivateApiFor,getChildren:n=>n.children,root:new p(l,c),toITestItem:S.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(we[249],ye([0,1,12,244,13,104,111,117,245,115,120,8,199,116]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let m=class{constructor(f,p,g,d,l,c,n,o,i,a){this._remoteAuthority=f,this._channel=p,this._configurationService=g,this._workspaceContextService=d,this._resolverService=l,this._environmentVariableService=c,this._remoteAuthorityResolverService=n,this._logService=o,this._editorService=i,this._labelService=a}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(f,p,g,d,l,c,n,o){await this._configurationService.whenRemoteConfigurationLoaded();const i=Object.create(null),a=g?(0,I.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(g)):void 0;let r;try{r=(await this._resolverService.resolveAnyMap(a,{shellLaunchConfig:f,configuration:p})).resolvedVariables}catch(_){this._logService.error(_)}if(r)for(const[_,X]of r.entries())(/^config:/.test(_)||_==="selectedText"||_==="lineNumber")&&(i[_]=X);const s=[];for(const[_,X]of this._environmentVariableService.collections.entries())s.push([_,(0,S.serializeEnvironmentVariableCollection)(X.map)]);const u=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),h=u.options&&u.options.extensionHostEnv,b=this._workspaceContextService.getWorkspace(),A=b.folders,B=g?this._workspaceContextService.getWorkspaceFolder(g):null,G=D.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:D.SideBySideEditor.PRIMARY,filterByScheme:[R.Schemas.file,R.Schemas.vscodeUserData,R.Schemas.vscodeRemote]}),Q={configuration:p,resolvedVariables:i,envVariableCollections:s,shellLaunchConfig:f,workspaceId:b.id,workspaceName:this._labelService.getWorkspaceLabel(b),workspaceFolders:A,activeWorkspaceFolder:B,activeFileResource:G,shouldPersistTerminal:l,options:d,cols:c,rows:n,unicodeVersion:o,resolverEnv:h};return await this._channel.call("$createProcess",Q)}requestDetachInstance(f,p){return this._channel.call("$requestDetachInstance",[f,p])}acceptDetachInstanceReply(f,p){return this._channel.call("$acceptDetachInstanceReply",[f,p])}attachToProcess(f){return this._channel.call("$attachToProcess",[f])}detachFromProcess(f){return this._channel.call("$detachFromProcess",[f])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(f,p){return this._channel.call("$processBinary",[f,p])}start(f){return this._channel.call("$start",[f])}input(f,p){return this._channel.call("$input",[f,p])}acknowledgeDataEvent(f,p){return this._channel.call("$acknowledgeDataEvent",[f,p])}setUnicodeVersion(f,p){return this._channel.call("$setUnicodeVersion",[f,p])}shutdown(f,p){return this._channel.call("$shutdown",[f,p])}resize(f,p,g){return this._channel.call("$resize",[f,p,g])}getInitialCwd(f){return this._channel.call("$getInitialCwd",[f])}getCwd(f){return this._channel.call("$getCwd",[f])}orphanQuestionReply(f){return this._channel.call("$orphanQuestionReply",[f])}sendCommandResult(f,p,g){return this._channel.call("$sendCommandResult",[f,p,g])}installAutoReply(f,p){return this._channel.call("$installAutoReply",[f,p])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(f){return this._channel.call("$getDefaultSystemShell",[f])}getProfiles(f,p,g){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,f,p,g])}acceptPtyHostResolvedVariables(f,p){return this._channel.call("$acceptPtyHostResolvedVariables",[f,p])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(f){return this._channel.call("$getWslPath",[f])}setTerminalLayoutInfo(f){const g={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:f?f.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",g)}updateTitle(f,p,g){return this._channel.call("$updateTitle",[f,p,g])}updateIcon(f,p,g){return this._channel.call("$updateIcon",[f,p,g])}refreshProperty(f,p){return this._channel.call("$refreshProperty",[f,p])}updateProperty(f,p,g){return this._channel.call("$updateProperty",[f,p,g])}getTerminalLayoutInfo(){const p={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",p)}reviveTerminalProcesses(f,p){return this._channel.call("$reviveTerminalProcesses",[f,p])}serializeTerminalState(f){return this._channel.call("$serializeTerminalState",[f])}};m=Re([Oe(2,t.IWorkbenchConfigurationService),Oe(3,k.IWorkspaceContextService),Oe(4,v.IConfigurationResolverService),Oe(5,w.IEnvironmentVariableService),Oe(6,P.IRemoteAuthorityResolverService),Oe(7,y.ILogService),Oe(8,T.IEditorService),Oe(9,C.ILabelService)],m),e.RemoteTerminalChannelClient=m}),define(we[122],ye([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class I{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++I.count}}e.ProxyIdentifier=I,I.count=0;const t=[];function y(S){const v=new I(S);return t[v.nid]=v,v}e.createProxyIdentifier=y;function P(S){return t[S].sid}e.getStringIdentifierForProxy=P;class k{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=k}),define(we[250],ye([0,1,45,4,122]),function(ie,e,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.NotebookInput=3]="NotebookInput",d[d.NotebookDiffInput=4]="NotebookDiffInput",d[d.CustomEditorInput=5]="CustomEditorInput",d[d.WebviewEditorInput=6]="WebviewEditorInput",d[d.TerminalEditorInput=7]="TerminalEditorInput"})(k=e.TabInputKind||(e.TabInputKind={}));var S;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(S=e.TabModelOperationKind||(e.TabModelOperationKind={}));var v;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(v=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var C;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(C=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(l){return l._id=w._n++,l}}e.IdObject=w,w._n=0;var m;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(f=e.WorkspaceEditType||(e.WorkspaceEditType={}));function p(d){if(d&&d.edits)for(const l of d.edits)typeof l.resource=="object"?l.resource=t.URI.revive(l.resource):(l.newUri=t.URI.revive(l.newUri),l.oldUri=t.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,I.revive)(l.metadata));return d}e.reviveWorkspaceEditDto=p;var g;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(g=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createProxyIdentifier)("ExtHostTelemetry")}});var St=this&&this.__classPrivateFieldSet||function(ie,e,I,t,y){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?y.call(ie,I):y?y.value=I:e.set(ie,I),I},et=this&&this.__classPrivateFieldGet||function(ie,e,I,t){if(I==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!t:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return I==="m"?t:I==="a"?t.call(ie):t?t.value:e.get(ie)};define(we[251],ye([0,1,12,114,121,21,250,16,13,45,47,92,4,2,7,238,248,17,122,36]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f,p,g,d){"use strict";var l,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{constructor(u,h){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,c.set(this,void 0),St(this,l,u.getProxy(k.MainContext.MainThreadCommands),"f"),this._logService=h,St(this,c,u.getProxy(k.MainContext.MainThreadTelemetry),"f"),this.converter=new o(this,b=>{const A=this._apiCommands.get(b);return A?.result===a.Void?A:void 0},h),this._argumentProcessors=[{processArgument(b){return(0,D.revive)(b)}},{processArgument(b){return(0,P.cloneAndChange)(b,function(A){if(T.Range.isIRange(A))return y.Range.to(A);if(R.Position.isIPosition(A))return y.Position.to(A);if(T.Range.isIRange(A.range)&&C.URI.isUri(A.uri))return y.location.to(A);if(A instanceof p.VSBuffer)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(u){this._argumentProcessors.push(u)}registerApiCommand(u){const h=this.registerCommand(!1,u.id,async(...b)=>{const A=u.args.map((G,Q)=>{if(!G.validate(b[Q]))throw new Error(`Invalid argument '${G.name}' when running '${u.id}', received: ${b[Q]}`);return G.convert(b[Q])}),B=await this.executeCommand(u.internalId,...A);return u.result.convert(B,b,this.converter)},void 0,{description:u.description,args:u.args,returns:u.result.description});return this._apiCommands.set(u.id,u),new t.Disposable(()=>{h.dispose(),this._apiCommands.delete(u.id)})}registerCommand(u,h,b,A,B,G){if(this._logService.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this._commands.has(h))throw new Error(`command '${h}' already exists`);return this._commands.set(h,{callback:b,thisArg:A,description:B,extension:G}),u&&et(this,l,"f").$registerCommand(h),new t.Disposable(()=>{this._commands.delete(h)&&u&&et(this,l,"f").$unregisterCommand(h)})}executeCommand(u,...h){return this._logService.trace("ExtHostCommands#executeCommand",u),this._doExecuteCommand(u,h,!0)}async _doExecuteCommand(u,h,b){if(this._commands.has(u))return this._executeContributedCommand(u,h,!1);{let A=!1;const B=(0,P.cloneAndChange)(h,function(G){if(G instanceof t.Position)return y.Position.from(G);if(G instanceof t.Range)return y.Range.from(G);if(G instanceof t.Location)return y.location.from(G);if(t.NotebookRange.isNotebookRange(G))return y.NotebookRange.from(G);if(G instanceof ArrayBuffer)return A=!0,p.VSBuffer.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return A=!0,p.VSBuffer.wrap(G);if(G instanceof p.VSBuffer)return A=!0,G;if(!Array.isArray(G))return G});try{const G=await et(this,l,"f").$executeCommand(u,A?new g.SerializableObjectWithBuffers(B):B,b);return(0,D.revive)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this._doExecuteCommand(u,h,!1);throw G}}}async _executeContributedCommand(u,h,b){const A=this._commands.get(u);if(!A)throw new Error("Unknown command");this._reportTelemetry(A,u);let{callback:B,thisArg:G,description:Q}=A;if(Q)for(let _=0;_<Q.args.length;_++)try{(0,I.validateConstraint)(h[_],Q.args[_].constraint)}catch{throw new Error(`Running the contributed command: '${u}' failed. Illegal argument '${Q.args[_].name}' - ${Q.args[_].description}`)}try{return await B.apply(G,h)}catch(_){if(u===this.converter.delegatingCommandId){const X=this.converter.getActualCommand(...h);X&&(u=X.command)}throw this._logService.error(_,u,A.extension?.identifier),b?new class extends Error{constructor(){super((0,d.toErrorMessage)(_));this.id=u,this.source=A.extension?.displayName??A.extension?.name}}:_}}_reportTelemetry(u,h){!u.extension||u.extension.isBuiltin||et(this,c,"f").$publicLog2("Extension:ActionExecuted",{extensionId:u.extension.identifier.value,id:h})}$executeContributedCommand(u,...h){return this._logService.trace("ExtHostCommands#$executeContributedCommand",u),this._commands.has(u)?(h=h.map(b=>this._argumentProcessors.reduce((A,B)=>B.processArgument(A),b)),this._executeContributedCommand(u,h,!0)):Promise.reject(new Error(`Contributed command '${u}' does not exist.`))}getCommands(u=!1){return this._logService.trace("ExtHostCommands#getCommands",u),et(this,l,"f").$getCommands().then(h=>(u&&(h=h.filter(b=>b[0]!=="_")),h))}$getContributedCommandHandlerDescriptions(){const u=Object.create(null);for(let[h,b]of this._commands){let{description:A}=b;A&&(u[h]=A)}return Promise.resolve(u)}};l=new WeakMap,c=new WeakMap,n=Re([Oe(0,E.IExtHostRpcService),Oe(1,v.ILogService)],n),e.ExtHostCommands=n,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class o{constructor(u,h,b){this._commands=u,this._lookupApiCommand=h,this._logService=b,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(u,h){if(!u)return;const b={$ident:void 0,id:u.command,title:u.title,tooltip:u.tooltip};if(!u.command)return b;const A=this._lookupApiCommand(u.command);if(A)b.id=A.internalId,b.arguments=A.args.map((B,G)=>B.convert(u.arguments&&u.arguments[G]));else if((0,S.isNonEmptyArray)(u.arguments)){const B=++this._cachIdPool;this._cache.set(B,u),h.add((0,w.toDisposable)(()=>{this._cache.delete(B),this._logService.trace("CommandsConverter#DISPOSE",B)})),b.$ident=B,b.id=this.delegatingCommandId,b.arguments=[B],this._logService.trace("CommandsConverter#CREATE",u.command,B)}return b}fromInternal(u){return typeof u.$ident=="number"?this._cache.get(u.$ident):{command:u.id,title:u.title,arguments:u.arguments}}getActualCommand(...u){return this._cache.get(u[0])}_executeConvertedCommand(...u){const h=this.getActualCommand(...u);return this._logService.trace("CommandsConverter#EXECUTE",u[0],h?h.command:"MISSING"),h?this._commands.executeCommand(h.command,...h.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class i{constructor(u,h,b,A){this.name=u,this.description=h,this.validate=b,this.convert=A}optional(){return new i(this.name,`(optional) ${this.description}`,u=>u==null||this.validate(u),u=>u===void 0?void 0:u===null?null:this.convert(u))}with(u,h){return new i(u??this.name,h??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",s=>C.URI.isUri(s),s=>s),i.Position=new i("position","A position in a text document",s=>t.Position.isPosition(s),y.Position.from),i.Range=new i("range","A range in a text document",s=>t.Range.isRange(s),y.Range.from),i.Selection=new i("selection","A selection in a text document",s=>t.Selection.isSelection(s),y.Selection.from),i.Number=new i("number","",s=>typeof s=="number",s=>s),i.String=new i("string","",s=>typeof s=="string",s=>s),i.CallHierarchyItem=new i("item","A call hierarchy item",s=>s instanceof t.CallHierarchyItem,y.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",s=>s instanceof t.TypeHierarchyItem,y.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",s=>s instanceof f.TestItemImpl,y.TestItem.from);class a{constructor(u,h){this.description=u,this.convert=h}}e.ApiCommandResult=a,a.Void=new a("no result",s=>s);class r{constructor(u,h,b,A,B){this.id=u,this.internalId=h,this.description=b,this.args=A,this.result=B}}e.ApiCommand=r}),define(we[252],ye([0,1,84]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logRemoteEntryIfError=e.logRemoteEntry=void 0;function t(P,k,S=null){const v=(0,I.parse)(k).args;let D=v.shift();if(typeof D=="string")switch(k.severity||(k.severity="info"),S&&(/^\[/.test(S)||(S=`[${S}]`),/ $/.test(S)||(S=`${S} `),D=S+D),k.severity){case"log":case"info":P.info(D,...v);break;case"warn":P.warn(D,...v);break;case"error":P.error(D,...v);break}}e.logRemoteEntry=t;function y(P,k,S){const v=(0,I.parse)(k).args,D=v.shift();typeof D!="string"||k.severity!=="error"||(/^\[/.test(S)||(S=`[${S}]`),/ $/.test(S)||(S=`${S} `),P.error(S+D,...v))}e.logRemoteEntryIfError=y}),define(we[123],ye([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,I.createDecorator)("remoteAgentService")}),define(we[253],ye([0,1,9,2,8,194]),function(ie,e,I,t,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class k extends P.DiskFileSystemProviderClient{static register(v,D,T){const R=v.getConnection();if(!R)return t.Disposable.None;const C=new t.DisposableStore,w=(async()=>{try{const m=await v.getRawEnvironment();m?D.registerProvider(y.Schemas.vscodeRemote,C.add(new k(m,R))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(m){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,I.getErrorMessage)(m))}})();return C.add(D.onWillActivateFileSystemProvider(m=>{m.scheme===y.Schemas.vscodeRemote&&m.join(w)})),C}constructor(v,D){super(D.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:v.os===3})}}e.RemoteFileSystemProviderClient=k}),define(we[124],ye([0,1,30,14,5,12,22,154,268,269]),function(ie,e,I,t,y,P,k,S,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class T extends Error{constructor(n,o){let i=o.message;switch(n){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=n,this.cause=o}}e.ExtractError=T;function R(c){const n=c.externalFileAttributes>>16||33188;return[448,56,7].map(o=>n&o).reduce((o,i)=>o+i,n&61440)}function C(c){if(c instanceof T)return c;let n;return/end of central directory record signature not found/.test(c.message)&&(n="CorruptZip"),new T(n,c)}function w(c,n,o,i,a,r){const s=y.dirname(n),u=y.join(i,s);if(!u.startsWith(i))return Promise.reject(new Error(S.localize(0,null,n)));const h=y.join(i,n);let b;return r.onCancellationRequested(()=>{b&&b.destroy()}),Promise.resolve(k.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((A,B)=>{if(!r.isCancellationRequested)try{b=(0,I.createWriteStream)(h,{mode:o}),b.once("close",()=>A()),b.once("error",B),c.once("error",B),c.pipe(b)}catch(G){B(G)}}))}function m(c,n,o,i){let a=(0,t.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{a.cancel(),c.close()}),new Promise((s,u)=>{const h=new t.Sequencer,b=A=>{A.isCancellationRequested||(r++,c.readEntry())};c.once("error",u),c.once("close",()=>a.then(()=>{i.isCancellationRequested||c.entryCount===r?s():u(new T("Incomplete",new Error(S.localize(1,null,r,c.entryCount))))},u)),c.readEntry(),c.on("entry",A=>{if(i.isCancellationRequested)return;if(!o.sourcePathRegex.test(A.fileName)){b(i);return}const B=A.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(B)){const _=y.join(n,B);a=(0,t.createCancelablePromise)(X=>k.Promises.mkdir(_,{recursive:!0}).then(()=>b(X)).then(void 0,u));return}const G=f(c,A),Q=R(A);a=(0,t.createCancelablePromise)(_=>h.queue(()=>G.then(X=>w(X,B,Q,n,o,_).then(()=>b(_)))).then(null,u))})})}function E(c,n=!1){return new Promise((o,i)=>{(0,v.open)(c,n?{lazyEntries:!0}:void 0,(a,r)=>{a?i(C(a)):o((0,P.assertIsDefined)(r))})})}function f(c,n){return new Promise((o,i)=>{c.openReadStream(n,(a,r)=>{a?i(C(a)):o((0,P.assertIsDefined)(r))})})}function p(c,n){return new Promise((o,i)=>{const a=new D.ZipFile;n.forEach(s=>{s.contents?a.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&a.addFile(s.localPath,s.path)}),a.end();const r=(0,I.createWriteStream)(c);a.outputStream.pipe(r),a.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>o(c))})}e.zip=p;function g(c,n,o={},i){const a=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let r=E(c,!0);return o.overwrite&&(r=r.then(s=>k.Promises.rm(n).then(()=>s))),r.then(s=>m(s,n,{sourcePathRegex:a},i))}e.extract=g;function d(c,n){return E(c).then(o=>new Promise((i,a)=>{o.on("entry",r=>{r.fileName===n&&f(o,r).then(s=>i(s),s=>a(s))}),o.once("close",()=>a(new Error(S.localize(2,null,n))))}))}function l(c,n){return d(c,n).then(o=>new Promise((i,a)=>{const r=[];o.once("error",a),o.on("data",s=>r.push(s)),o.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=l}),define(we[254],ye([0,1,124,163]),function(ie,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function y(P){return(0,I.buffer)(P,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=y}),define(we[125],ye([0,1,14,36,9,2,8,5,3,19,55,12,4,23,22,124,162,71,28,217,31,35,50,207,201,254,208,230,69,18,7,13,26,32,52]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f,p,g,d,l,c,n,o,i,a,r,s,u,h,b,A,B,G,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let _=class extends d.AbstractExtensionManagementService{constructor(O,M,W,J,ae,me,fe,V,ee){super(O,M,W,V);this.environmentService=J,this.downloadService=ae,this.fileService=fe;const x=this._register(me.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(me.createInstance(X,te=>x.postUninstall(te))),this.manifestCache=this._register(new r.ExtensionsManifestCache(J,this)),this.extensionsDownloader=this._register(me.createInstance(o.ExtensionsDownloader));const z=this._register(new s.ExtensionsWatcher(this,fe,J,W,ee));this._register(z.onDidChangeExtensionsByAnotherSource(({added:te,removed:ce})=>{te.length&&this._onDidInstallExtensions.fire(te.map(Z=>({identifier:Z.identifier,operation:1,local:Z}))),ce.forEach(Z=>this._onDidUninstallExtension.fire({identifier:Z}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(O){this.logService.trace("ExtensionManagementService#zip",O.identifier.id);const M=await this.collectFiles(O),W=await(0,E.zip)((0,D.joinPath)(this.environmentService.tmpDir,(0,w.generateUuid)()).fsPath,M);return C.URI.file(W)}async unzip(O){return this.logService.trace("ExtensionManagementService#unzip",O.toString()),(await this.install(O)).identifier}async getManifest(O){const M=await this.downloadVsix(O),W=S.resolve(M.fsPath);return(0,a.getManifest)(W)}getInstalled(O=null){return this.extensionsScanner.scanExtensions(O)}async install(O,M={}){this.logService.trace("ExtensionManagementService#install",O.toString());const W=await this.downloadVsix(O),J=await(0,a.getManifest)(S.resolve(W.fsPath));if(J.engines&&J.engines.vscode&&!(0,u.isEngineValid)(J.engines.vscode,this.productService.version,this.productService.date))throw new Error(f.localize(0,null,(0,c.getGalleryExtensionId)(J.publisher,J.name),this.productService.version));return this.installExtension(J,W,M)}async updateMetadata(O,M){this.logService.trace("ExtensionManagementService#updateMetadata",O.identifier.id);const W={...M};return M.isPreReleaseVersion&&(W.preRelease=!0),O=await this.extensionsScanner.updateMetadata(O,W),this.manifestCache.invalidate(),O}async updateExtensionScope(O,M){return this.logService.trace("ExtensionManagementService#updateExtensionScope",O.identifier.id),O=await this.extensionsScanner.updateMetadata(O,{isMachineScoped:M}),this.manifestCache.invalidate(),O}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(O){if(O.scheme===k.Schemas.file)return O;const M=(0,D.joinPath)(this.environmentService.tmpDir,(0,w.generateUuid)());return await this.downloadService.download(O,M),M}createInstallExtensionTask(O,M,W){return C.URI.isUri(M)?new le(O,M,W,this.galleryService,this.extensionsScanner,this.logService):new U(M,W,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(O,M){return new j(O,M,this.extensionsScanner)}async collectFiles(O){const M=async J=>{let ae=await m.Promises.readdir(J);ae=ae.map(V=>S.join(J,V));const me=await Promise.all(ae.map(V=>m.Promises.stat(V)));let fe=Promise.resolve([]);return me.forEach((V,ee)=>{const x=ae[ee];V.isFile()&&(fe=fe.then(z=>[...z,x])),V.isDirectory()&&(fe=fe.then(z=>M(x).then(te=>[...z,...te])))}),fe};return(await M(O.location.fsPath)).map(J=>({path:`extension/${S.relative(O.location.fsPath,J)}`,localPath:J}))}};_=Re([Oe(0,l.IExtensionGalleryService),Oe(1,G.ITelemetryService),Oe(2,A.ILogService),Oe(3,g.INativeEnvironmentService),Oe(4,p.IDownloadService),Oe(5,b.IInstantiationService),Oe(6,h.IFileService),Oe(7,B.IProductService),Oe(8,Q.IUriIdentityService)],_),e.ExtensionManagementService=_;let X=class extends P.Disposable{constructor(O,M,W,J){super();this.beforeRemovingExtension=O,this.fileService=M,this.extensionsScannerService=W,this.logService=J,this.uninstalledPath=(0,D.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new I.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(O){const M={includeInvalid:!0};let W=[];return O===null||O===0?W.push(...await this.extensionsScannerService.scanAllExtensions(M)):O===1&&W.push(...await this.extensionsScannerService.scanUserExtensions(M)),W=O!==null?W.filter(J=>J.type===O):W,Promise.all(W.map(J=>this.toLocalExtension(J)))}async scanUserExtensions(O){const M=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!O,includeInvalid:!0});return Promise.all(M.map(W=>this.toLocalExtension(W)))}async extractUserExtension(O,M,W,J){const ae=O.toString(),me=S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,w.generateUuid)()}`),fe=S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,ae);try{await m.Promises.rm(fe)}catch{throw new l.ExtensionManagementError(f.localize(1,null,fe,O.id),l.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(O,M,me,J),await this.extensionsScannerService.updateMetadata(C.URI.file(me),{...W,installedTimestamp:Date.now()});try{await this.rename(O,me,fe,Date.now()+2*60*1e3),this.logService.info("Renamed to",fe)}catch(V){try{await m.Promises.rm(me)}catch{}if(V.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",O.id);else throw this.logService.info(`Rename failed because of ${(0,y.getErrorMessage)(V)}. Deleted from extracted location`,me),V}return this.scanLocalExtension(C.URI.file(fe),1)}async updateMetadata(O,M){return await this.extensionsScannerService.updateMetadata(O.location,M),this.scanLocalExtension(O.location,O.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...O){const M=O.map(W=>c.ExtensionKey.create(W));await this.withUninstalledExtensions(W=>{M.forEach(J=>W[J.toString()]=!0)})}async setInstalled(O){await this.withUninstalledExtensions(J=>delete J[O.toString()]);const W=(await this.scanUserExtensions(!0)).find(J=>c.ExtensionKey.create(J).equals(O))||null;return W?this.updateMetadata(W,{installedTimestamp:Date.now()}):null}async removeExtension(O,M){this.logService.trace(`Deleting ${M} extension from disk`,O.identifier.id,O.location.fsPath),await m.Promises.rm(O.location.fsPath),this.logService.info("Deleted from disk",O.identifier.id,O.location.fsPath)}async removeUninstalledExtension(O){await this.removeExtension(O,"uninstalled"),await this.withUninstalledExtensions(M=>delete M[c.ExtensionKey.create(O).toString()])}async withUninstalledExtensions(O){return this.uninstalledFileLimiter.queue(async()=>{let M;try{M=await m.Promises.readFile(this.uninstalledPath,"utf8")}catch(J){if(J.code!=="ENOENT")throw J}let W={};if(M)try{W=JSON.parse(M)}catch{}return O&&(O(W),Object.keys(W).length?await m.Promises.writeFile(this.uninstalledPath,JSON.stringify(W)):await m.Promises.rm(this.uninstalledPath)),W})}async extractAtLocation(O,M,W,J){this.logService.trace(`Started extracting the extension from ${M} to ${W}`);try{await m.Promises.rm(W)}catch(ae){throw new l.ExtensionManagementError(this.joinErrors(ae).message,l.ExtensionManagementErrorCode.Delete)}try{await(0,E.extract)(M,W,{sourcePath:"extension",overwrite:!0},J),this.logService.info(`Extracted extension to ${W}:`,O.id)}catch(ae){try{await m.Promises.rm(W)}catch{}let me=l.ExtensionManagementErrorCode.Extract;throw ae instanceof E.ExtractError&&(ae.type==="CorruptZip"?me=l.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(me=l.ExtensionManagementErrorCode.IncompleteZip)),new l.ExtensionManagementError(ae.message,me)}}async rename(O,M,W,J){try{await m.Promises.rename(M,W)}catch(ae){if(v.isWindows&&ae&&ae.code==="EPERM"&&Date.now()<J)return this.logService.info(`Failed renaming ${M} to ${W} with 'EPERM' error. Trying again...`,O.id),this.rename(O,M,W,J);throw new l.ExtensionManagementError(ae.message||f.localize(2,null,M,W),ae.code||l.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(O,M){const W=await this.extensionsScannerService.scanExistingExtension(O,M,{includeInvalid:!0});if(W)return this.toLocalExtension(W);throw new Error(f.localize(3,null,O.path))}async toLocalExtension(O){const M=await this.fileService.resolve(O.location);let W,J;return M.children&&(W=M.children.find(({name:ae})=>/^readme(\.txt|\.md|)$/i.test(ae))?.resource,J=M.children.find(({name:ae})=>/^changelog(\.txt|\.md|)$/i.test(ae))?.resource),{identifier:O.identifier,type:O.type,isBuiltin:O.isBuiltin||!!O.metadata?.isBuiltin,location:O.location,manifest:O.manifest,targetPlatform:O.targetPlatform,validations:O.validations,isValid:O.isValid,readmeUrl:W,changelogUrl:J,publisherDisplayName:O.metadata?.publisherDisplayName||null,publisherId:O.metadata?.publisherId||null,isMachineScoped:!!O.metadata?.isMachineScoped,isPreReleaseVersion:!!O.metadata?.isPreReleaseVersion,preRelease:!!O.metadata?.preRelease,installedTimestamp:O.metadata?.installedTimestamp,updated:!!O.metadata?.updated}}async removeUninstalledExtensions(){const O=await this.getUninstalledExtensions(),M=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),W=new Set;for(const me of M)O[c.ExtensionKey.create(me).toString()]||W.add(me.identifier.id.toLowerCase());const J=(0,c.groupByExtension)(M,me=>me.identifier);await I.Promises.settled(J.map(async me=>{const fe=me.sort((V,ee)=>T.rcompare(V.manifest.version,ee.manifest.version))[0];W.has(fe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(fe))}));const ae=M.filter(me=>O[c.ExtensionKey.create(me).toString()]);await I.Promises.settled(ae.map(me=>this.removeUninstalledExtension(me)))}async removeOutdatedExtensions(){const O=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=[],W=await this.extensionsScannerService.getTargetPlatform(),J=(0,c.groupByExtension)(O,ae=>ae.identifier);M.push(...J.map(ae=>ae.sort((me,fe)=>{const V=T.rcompare(me.manifest.version,fe.manifest.version);return V!==0?V:me.targetPlatform===W?-1:1}).slice(1)).flat()),await I.Promises.settled(M.map(ae=>this.removeExtension(ae,"outdated")))}joinErrors(O){const M=Array.isArray(O)?O:[O];return M.length===1?M[0]instanceof Error?M[0]:new Error(M[0]):M.reduce((W,J)=>new Error(`${W.message}${W.message?",":""}${J instanceof Error?J.message:J}`),new Error(""))}};X=Re([Oe(1,h.IFileService),Oe(2,n.IExtensionsScannerService),Oe(3,A.ILogService)],X);class F extends d.AbstractExtensionTask{constructor(O,M,W,J,ae){super();this.identifier=O,this.source=M,this.options=W,this.extensionsScanner=J,this.logService=ae,this._operation=2}get operation(){return(0,R.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(O,M){try{const W=await this.unsetUninstalledAndGetLocal(O.key);if(W)return O.metadata?this.extensionsScanner.updateMetadata(W,O.metadata):W}catch{throw v.isMacintosh?new l.ExtensionManagementError(f.localize(4,null),l.ExtensionManagementErrorCode.Internal):new l.ExtensionManagementError(f.localize(5,null),l.ExtensionManagementErrorCode.Internal)}return this.extract(O,M)}async unsetUninstalledAndGetLocal(O){if(!await this.isUninstalled(O))return null;this.logService.trace("Removing the extension from uninstalled list:",O.id);const W=await this.extensionsScanner.setInstalled(O);return this.logService.info("Removed the extension from uninstalled list:",O.id),W}async isUninstalled(O){return!!(await this.extensionsScanner.getUninstalledExtensions())[O.toString()]}async extract({zipPath:O,key:M,metadata:W},J){let ae=await this.extensionsScanner.extractUserExtension(M,O,W,J);return this.logService.info("Extracting completed.",M.id),ae}}class U extends F{constructor(O,M,W,J,ae){super(O.identifier,O,M,J,ae);this.gallery=O,this.extensionsDownloader=W}async doRun(O){const W=(await this.extensionsScanner.scanExtensions(null)).find(ae=>(0,c.areSameExtensions)(ae.identifier,this.gallery.identifier));W&&(this._operation=3);const J=await this.downloadInstallableExtension(this.gallery,this._operation);J.metadata.isMachineScoped=this.options.isMachineScoped||W?.isMachineScoped,J.metadata.isBuiltin=this.options.isBuiltin||W?.isBuiltin,J.metadata.isSystem=W?.type===0?!0:void 0,J.metadata.updated=!!W,J.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,J.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,R.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:W?.preRelease);try{const ae=await this.installExtension(J,O);return W&&(W.targetPlatform!==ae.targetPlatform||T.neq(W.manifest.version,ae.manifest.version))&&await this.extensionsScanner.setUninstalled(W),ae}catch(ae){throw await this.deleteDownloadedVSIX(J.zipPath),ae}}async deleteDownloadedVSIX(O){try{await this.extensionsDownloader.delete(C.URI.file(O))}catch(M){this.logService.warn("Error while deleting the downloaded vsix",O.toString(),(0,y.getErrorMessage)(M))}}async downloadInstallableExtension(O,M){const W={id:O.identifier.uuid,publisherId:O.publisherId,publisherDisplayName:O.publisherDisplayName,targetPlatform:O.properties.targetPlatform};let J;try{this.logService.trace("Started downloading extension:",O.identifier.id),J=(await this.extensionsDownloader.downloadExtension(O,M)).fsPath,this.logService.info("Downloaded extension:",O.identifier.id,J)}catch(ae){throw new l.ExtensionManagementError((0,d.joinErrors)(ae).message,l.ExtensionManagementErrorCode.Download)}try{return await(0,a.getManifest)(J),{zipPath:J,key:c.ExtensionKey.create(O),metadata:W}}catch(ae){throw await this.deleteDownloadedVSIX(J),new l.ExtensionManagementError((0,d.joinErrors)(ae).message,l.ExtensionManagementErrorCode.Invalid)}}}class le extends F{constructor(O,M,W,J,ae,me){super({id:(0,c.getGalleryExtensionId)(O.publisher,O.name)},M,W,ae,me);this.manifest=O,this.location=M,this.galleryService=J}async doRun(O){const M=new c.ExtensionKey(this.identifier,this.manifest.version),J=(await this.extensionsScanner.scanExtensions(1)).find(me=>(0,c.areSameExtensions)(this.identifier,me.identifier)),ae=await this.getMetadata(this.identifier.id,this.manifest.version,O);if(ae.isMachineScoped=this.options.isMachineScoped||J?.isMachineScoped,ae.isBuiltin=this.options.isBuiltin||J?.isBuiltin,J)if(this._operation=3,M.equals(new c.ExtensionKey(J.identifier,J.manifest.version)))try{await this.extensionsScanner.removeExtension(J,"existing")}catch{throw new Error(f.localize(6,null,this.manifest.displayName||this.manifest.name))}else T.gt(J.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(J);else{const me=await this.unsetUninstalledAndGetLocal(M);if(me)try{await this.extensionsScanner.removeExtension(me,"existing")}catch{throw new Error(f.localize(7,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:S.resolve(this.location.fsPath),key:M,metadata:ae},O)}async getMetadata(O,M,W){try{let[J]=await this.galleryService.getExtensions([{id:O,version:M}],W);if(J||([J]=await this.galleryService.getExtensions([{id:O}],W)),J)return{id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId,isPreReleaseVersion:J.properties.isPreReleaseVersion,preRelease:J.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class j extends d.AbstractExtensionTask{constructor(O,M,W){super();this.extension=O,this.options=M,this.extensionsScanner=W}async doRun(O){const M=[],W=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const J=c.ExtensionKey.create(this.extension);M.push(...W.filter(ae=>J.equals(c.ExtensionKey.create(ae))))}else M.push(...W.filter(J=>(0,c.areSameExtensions)(J.identifier,this.extension.identifier)));if(!M.length)throw new Error(f.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...M),this.options.remove)for(const J of M)try{O.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(J)}catch(ae){throw new Error(f.localize(9,null,(0,t.toErrorMessage)(ae)))}}}}),define(we[61],ye([0,1,75,68,24,17,9,6,2,5,3,23,40,91,255]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class E{constructor(A,B=""){this.debugLabel=B,this.socket=A,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=G=>{if(this.traceSocketEvent("error",{code:G?.code,message:G?.message}),G){if(G.code==="EPIPE")return;(0,k.onUnexpectedError)(G)}},this.socket.on("error",this._errorListener)}traceSocketEvent(A,B){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,A,B)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(A){const B=G=>{this.traceSocketEvent("read",G),A(P.VSBuffer.wrap(G))};return this.socket.on("data",B),{dispose:()=>this.socket.off("data",B)}}onClose(A){const B=G=>{this.traceSocketEvent("close",{hadError:G}),A({type:0,hadError:G,error:void 0})};return this.socket.on("close",B),{dispose:()=>this.socket.off("close",B)}}onEnd(A){const B=()=>{this.traceSocketEvent("nodeEndReceived"),A()};return this.socket.on("end",B),{dispose:()=>this.socket.off("end",B)}}write(A){if(!this.socket.destroyed)try{this.traceSocketEvent("write",A),this.socket.write(A.buffer,B=>{if(B){if(B.code==="EPIPE")return;(0,k.onUnexpectedError)(B)}})}catch(B){if(B.code==="EPIPE")return;(0,k.onUnexpectedError)(B)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((A,B)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),A();return}const G=()=>{this.socket.off("close",G),this.socket.off("end",G),this.socket.off("error",G),this.socket.off("timeout",G),this.socket.off("drain",G),this.traceSocketEvent("nodeDrainEnd"),A()};this.socket.on("close",G),this.socket.on("end",G),this.socket.on("error",G),this.socket.on("timeout",G),this.socket.on("drain",G)})}}e.NodeSocket=E;var f;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var p;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(p||(p={}));class g extends v.Disposable{constructor(A,B,G,Q){super();this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=A,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:B,inflateBytesLength:G?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new d(this,B,G,Q,this._onData,(_,X)=>this._write(_,X))),this._register(this._flowManager.onError(_=>{console.error(_),(0,k.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})})),this._incomingData=new w.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(A,B){this.socket.traceSocketEvent(A,B)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(A){return this._onData.event(A)}onClose(A){return this._onClose.event(A)}onEnd(A){return this.socket.onEnd(A)}write(A){this._flowManager.writeMessage(A)}_write(A,B){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",A);let G=2;A.byteLength<126?G+=0:A.byteLength<2**16?G+=2:G+=8;const Q=P.VSBuffer.alloc(G);if(B?Q.writeUInt8(194,0):Q.writeUInt8(130,0),A.byteLength<126)Q.writeUInt8(A.byteLength,1);else if(A.byteLength<2**16){Q.writeUInt8(126,1);let _=1;Q.writeUInt8(A.byteLength>>>8&255,++_),Q.writeUInt8(A.byteLength>>>0&255,++_)}else{Q.writeUInt8(127,1);let _=1;Q.writeUInt8(0,++_),Q.writeUInt8(0,++_),Q.writeUInt8(0,++_),Q.writeUInt8(0,++_),Q.writeUInt8(A.byteLength>>>24&255,++_),Q.writeUInt8(A.byteLength>>>16&255,++_),Q.writeUInt8(A.byteLength>>>8&255,++_),Q.writeUInt8(A.byteLength>>>0&255,++_)}this.socket.write(P.VSBuffer.concat([Q,A]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(A){if(A.byteLength!==0){for(this._incomingData.acceptChunk(A);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const B=this._incomingData.peek(this._state.readLen),G=B.readUInt8(0),Q=(G&128)>>>7,_=(G&64)>>>6,X=B.readUInt8(1),F=(X&128)>>>7,U=X&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(U===126?2:0)+(U===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const B=this._incomingData.read(this._state.readLen),G=B.readUInt8(1),Q=(G&128)>>>7;let _=G&127,X=1;_===126?_=B.readUInt8(++X)*2**8+B.readUInt8(++X):_===127&&(_=B.readUInt8(++X)*0+B.readUInt8(++X)*0+B.readUInt8(++X)*0+B.readUInt8(++X)*0+B.readUInt8(++X)*2**24+B.readUInt8(++X)*2**16+B.readUInt8(++X)*2**8+B.readUInt8(++X));let F=0;Q&&(F=B.readUInt8(++X)*2**24+B.readUInt8(++X)*2**16+B.readUInt8(++X)*2**8+B.readUInt8(++X)),this._state.state=3,this._state.readLen=_,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const B=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",B),n(B,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",B),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(B,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await S.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class d extends v.Disposable{constructor(A,B,G,Q,_,X){super();this._tracer=A,this._onData=_,this._writeFn=X,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new S.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,B?(this._zlibInflateStream=this._register(new l(this._tracer,Q,G,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:P.VSBuffer.alloc(0)}writeMessage(A){this._writeQueue.push(A),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const A=this._writeQueue.shift();if(this._zlibDeflateStream){const B=await this._deflateMessage(this._zlibDeflateStream,A);this._writeFn(B,!0)}else this._writeFn(A,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(A,B){return new Promise((G,Q)=>{A.write(B),A.flush(_=>G(_))})}acceptFrame(A,B,G){this._readQueue.push({data:A,isCompressed:B,isLastFrameOfMessage:G}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const A=this._readQueue.shift();if(this._zlibInflateStream&&A.isCompressed){const B=await this._inflateFrame(this._zlibInflateStream,A.data,A.isLastFrameOfMessage);this._onData.fire(B)}else this._onData.fire(A.data)}this._isProcessingReadQueue=!1}}_inflateFrame(A,B,G){return new Promise((Q,_)=>{A.write(B),G&&A.write(P.VSBuffer.fromByteArray([0,0,255,255])),A.flush(X=>Q(X))})}}class l extends v.Disposable{constructor(A,B,G,Q){super();this._tracer=A,this._recordInflateBytes=B,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=m.createInflateRaw(Q),this._zlibInflate.on("error",_=>{this._tracer.traceSocketEvent("zlibInflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibInflate.on("data",_=>{this._tracer.traceSocketEvent("zlibInflateData",_),this._pendingInflateData.push(P.VSBuffer.wrap(_))}),G&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",G.buffer),this._zlibInflate.write(G.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.concat(this._recordedInflateBytes):P.VSBuffer.alloc(0)}write(A){this._recordInflateBytes&&this._recordedInflateBytes.push(A.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",A),this._zlibInflate.write(A.buffer)}flush(A){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const B=P.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,A(B)})}}class c extends v.Disposable{constructor(A,B){super();this._tracer=A,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=m.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",G=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:G?.message,code:G?.code}),this._onError.fire(G)}),this._zlibDeflate.on("data",G=>{this._tracer.traceSocketEvent("zlibDeflateData",G),this._pendingDeflateData.push(P.VSBuffer.wrap(G))})}write(A){this._tracer.traceSocketEvent("zlibDeflateWrite",A.buffer),this._zlibDeflate.write(A.buffer)}flush(A){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let B=P.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,B=B.slice(0,B.byteLength-4),A(B)})}}function n(b,A){if(A===0)return;let B=b.byteLength>>>2;for(let U=0;U<B;U++){const le=b.readUInt32BE(U*4);b.writeUInt32BE(le^A,U*4)}let G=B*4,Q=b.byteLength-G;const _=A>>>24&255,X=A>>>16&255,F=A>>>8&255;Q>=1&&b.writeUInt8(b.readUInt8(G)^_,G),Q>=2&&b.writeUInt8(b.readUInt8(G+1)^X,G+1),Q>=3&&b.writeUInt8(b.readUInt8(G+2)^F,G+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function i(){const b=(0,R.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;let A;return e.XDG_RUNTIME_DIR?A=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${b}.sock`):A=(0,D.join)((0,y.tmpdir)(),`vscode-ipc-${b}.sock`),r(A),A}e.createRandomIPCHandle=i;function a(b,A,B){const G=(0,I.createHash)("md5").update(b).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${G}-${B}-${A}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${G.substr(0,8)}-${B}-${A}.sock`):Q=(0,D.join)(b,`${B}-${A}.sock`),r(Q),Q}e.createStaticIPCHandle=a;function r(b){const A=o[T.platform];typeof A=="number"&&b.length>=A&&console.warn(`WARNING: IPC handle "${b}" is longer than ${A} chars, try a shorter --user-data-dir`)}class s extends C.IPCServer{constructor(A){super(s.toClientConnectionEvent(A));this.server=A}static toClientConnectionEvent(A){const B=S.Event.fromNodeEventEmitter(A,"connection");return S.Event.map(B,G=>({protocol:new w.Protocol(new E(G,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(G,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function u(b){return new Promise((A,B)=>{const G=(0,t.createServer)();G.on("error",B),G.listen(b,()=>{G.removeListener("error",B),A(new s(G))})})}e.serve=u;function h(b,A){return new Promise((B,G)=>{const Q=(0,t.createConnection)(b,()=>{Q.removeListener("error",G),B(w.Client.fromSocket(new E(Q,`ipc-client${A}`),A))});Q.once("error",G)})}e.connect=h}),define(we[126],ye([0,1,76,14,17,9,2,12,25,28,77,13,211,255]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends k.Disposable{constructor(f,p,g){super();this.environmentService=p,this.logService=g,this.configure(f.getValue()),this._register(f.onDidChangeConfiguration(()=>this.configure(f.getValue()),this))}configure(f){this.proxyUrl=f.http&&f.http.proxy,this.strictSSL=!!(f.http&&f.http.proxyStrictSSL),this.authorization=f.http&&f.http.proxyAuthorization}async request(f,p){this.logService.trace("RequestService#request (node) - begin",f.url);const{proxyUrl:g,strictSSL:d}=this;let l;try{l=await(0,T.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const c={...process.env,...l},n=f.agent?f.agent:await(0,C.getProxyAgent)(f.url||"",c,{proxyUrl:g,strictSSL:d});f.agent=n,f.strictSSL=d,this.authorization&&(f.headers={...f.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(f,p);return this.logService.trace("RequestService#request (node) - success",f.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",f.url,o),o}}async getNodeRequest(f){return((0,I.parse)(f.url).protocol==="https:"?await new Promise((d,l)=>{ie(["https"],d,l)}):await new Promise((d,l)=>{ie(["http"],d,l)})).request}_request(f,p){return t.Promises.withAsyncBody(async(g,d)=>{let l;const c=(0,I.parse)(f.url),n=f.getRawRequest?f.getRawRequest(f):await this.getNodeRequest(f),o={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,S.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(o.auth=f.user+":"+f.password),l=n(o,i=>{const a=(0,S.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&a>0&&i.headers.location)this._request({...f,url:i.headers.location,followRedirects:a-1},p).then(g,d);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,w.createGunzip)())),g({res:i,stream:(0,y.streamToBufferReadableStream)(r)})}}),l.on("error",d),f.timeout&&l.setTimeout(f.timeout),f.data&&typeof f.data=="string"&&l.write(f.data),l.end(),p.onCancellationRequested(()=>{l.abort(),d((0,P.canceled)())})})}async resolveProxy(f){}};m=Re([Oe(0,v.IConfigurationService),Oe(1,D.INativeEnvironmentService),Oe(2,R.ILogService)],m),e.RequestService=m}),define(we[127],ye([0,1,39,68,78,8,5,17,6,61,77,13,37,3,252,53,112,2]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function g(i={},a,r,s,u,h){const b=await(0,y.getNLSConfiguration)(r,u.userDataPath);let A={};if(a)try{A=await(0,T.getResolvedShellEnv)(h,u.args,process.env)}catch(F){h.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",F)}const G={...process.env,...A,VSCODE_LOG_NATIVE:String(s),VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(b,void 0,0),...i},Q=u.isBuilt?(0,k.join)(u.appRoot,"bin"):(0,k.join)(u.appRoot,"resources","server","bin-dev"),_=(0,k.join)(Q,"remote-cli");let X=c(G,"PATH");return X?X=_+k.delimiter+X:X=_,n(G,"PATH",X),u.args["without-browser-env-var"]||(G.BROWSER=(0,k.join)(Q,"helpers",w.isWindows?"browser.cmd":"browser.sh")),o(G),G}e.buildUserEnvironment=g;class d{constructor(a,r){this.socket=a,this.initialDataChunk=r}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let a,r,s;return this.socket instanceof D.NodeSocket?(a=!0,r=!1,s=S.VSBuffer.alloc(0)):(a=!1,r=this.socket.permessageDeflate,s=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:a,permessageDeflate:r,inflateBytes:s.buffer.toString("base64")}}}let l=class{constructor(a,r,s,u,h,b,A){this._reconnectionToken=a,this._environmentService=h,this._logService=b,this._extensionHostStatusService=A,this._onClose=new v.Emitter,this.onClose=this._onClose.event,this._canSendSocket=!w.isWindows||!this._environmentService.args["socket-path"],this._disposed=!1,this._remoteAddress=r,this._extensionHostProcess=null,this._connectionData=new d(s,u),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(a){this._logService.info(`${this._logPrefix}${a}`)}_logError(a){this._logService.error(`${this._logPrefix}${a}`)}async _pipeSockets(a,r){const s=new p.DisposableStore;s.add(r.socket),s.add((0,p.toDisposable)(()=>{a.destroy()}));const u=()=>{s.dispose()};s.add(r.socket.onEnd(u)),s.add(r.socket.onClose(u)),s.add(v.Event.fromNodeEventEmitter(a,"end")(u)),s.add(v.Event.fromNodeEventEmitter(a,"close")(u)),s.add(v.Event.fromNodeEventEmitter(a,"error")(u)),s.add(r.socket.onData(h=>a.write(h.buffer))),s.add(v.Event.fromNodeEventEmitter(a,"data")(h=>{r.socket.write(S.VSBuffer.wrap(h))})),r.initialDataChunk.byteLength>0&&a.write(r.initialDataChunk.buffer)}async _sendSocketToExtensionHost(a,r){await r.socketDrain();const s=r.toIExtHostSocketMessage();let u;r.socket instanceof D.NodeSocket?u=r.socket.socket:u=r.socket.socket.socket,a.send(s,u)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const a={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(a)}acceptReconnection(a,r,s){this._remoteAddress=a,this._log("The client has reconnected.");const u=new d(r,s);if(!this._extensionHostProcess){this._connectionData=u;return}this._sendSocketToExtensionHost(this._extensionHostProcess,u)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(a){try{let r=[];a.port&&!process.pkg&&(r=[`--inspect${a.break?"-brk":""}=${a.port}`]);const s=await g(a.env,!0,a.language,!!a.debugId,this._environmentService,this._logService);(0,E.removeDangerousEnvVariables)(s);let u;if(this._canSendSocket)s.VSCODE_EXTHOST_WILL_SEND_SOCKET="true",u=null;else{const{namedPipeServer:_,pipeName:X}=await this._listenOnPipe();s.VSCODE_IPC_HOOK_EXTHOST=X,u=_}const h={env:s,execArgv:r,silent:!0},b=["--type=extensionHost","--transformURIs"],A=this._environmentService.args["use-host-proxy"];b.push(`--useHostProxy=${A?"true":"false"}`),this._extensionHostProcess=I.fork(P.FileAccess.asFileUri("bootstrap-fork",ie).fsPath,b,h);const B=this._extensionHostProcess.pid;this._log(`<${B}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const G=v.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),Q=v.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");if(G(_=>this._log(`<${B}> ${_}`)),Q(_=>this._log(`<${B}><stderr> ${_}`)),this._extensionHostProcess.on("message",_=>{_&&_.type==="__$console"&&(0,m.logRemoteEntry)(this._logService,_,`${this._logPrefix}<${B}>`)}),this._extensionHostProcess.on("error",_=>{this._logError(`<${B}> Extension Host Process had an error`),this._logService.error(_),this._cleanResources()}),this._extensionHostProcess.on("exit",(_,X)=>{this._extensionHostStatusService.setExitInfo(this._reconnectionToken,{code:_,signal:X}),this._log(`<${B}> Extension Host Process exited with code: ${_}, signal: ${X}.`),this._cleanResources()}),u)u.on("connection",_=>{u.close(),this._pipeSockets(_,this._connectionData)});else{const _=X=>{X.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",_),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",_)}}catch(r){console.error("ExtensionHostConnection errored"),r&&console.error(r)}}_listenOnPipe(){return new Promise((a,r)=>{const s=(0,D.createRandomIPCHandle)(),u=t.createServer();u.on("error",r),u.listen(s,()=>{u&&u.removeListener("error",r),a({pipeName:s,namedPipeServer:u})})})}};l=Re([Oe(4,C.IServerEnvironmentService),Oe(5,R.ILogService),Oe(6,f.IExtensionHostStatusService)],l),e.ExtensionHostConnection=l;function c(i,a){const r=Object.keys(i).filter(u=>u.toLowerCase()===a.toLowerCase()),s=r.length>0?r[0]:a;return i[s]}function n(i,a,r){const s=Object.keys(i).filter(h=>h.toLowerCase()===a.toLowerCase()),u=s.length>0?s[0]:a;i[u]=r}function o(i){for(let a of Object.keys(i))i[a]===null&&delete i[a]}}),define(we[256],ye([0,1,72,13,56,103,25,51,126,42,32,31,107,125,98,48,2,99,58,8,18,26,101,123,37,105,73,106,9,4,5,27,209,71,52,110,54,3,50,113,59]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f,p,g,d,l,c,n,o,i,a,r,s,u,h,b,A,B,G,Q,_,X,F,U,le,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class $ extends f.Disposable{constructor(J,ae){super();this.args=J,this.remoteDataFolder=ae,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async ae=>{const me=ae.get(t.ILogService),fe=ae.get(R.IExtensionManagementCLIService);try{await this.doRun(fe)}catch(V){throw me.error(V),console.error((0,u.getErrorMessage)(V)),V}})}async initServices(){const J=new I.ServiceCollection,ae={_serviceBrand:void 0,...E.default};J.set(c.IProductService,ae);const me=new i.ServerEnvironmentService(this.args,ae);J.set(i.IServerEnvironmentService,me);const fe=new t.LogService(new n.SpdLogLogger(o.RemoteExtensionLogFileName,(0,b.join)(me.logsPath,`${o.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(me)));J.set(t.ILogService,fe),fe.trace(`Remote configuration data at ${this.remoteDataFolder}`),fe.trace("process arguments:",this.args);const V=this._register(new p.FileService(fe));J.set(l.IFileService,V),V.registerProvider(d.Schemas.file,this._register(new g.DiskFileSystemProvider(fe)));const ee=this._register(new P.ConfigurationService(me.settingsResource,V,new j.NullPolicyService,fe));return await ee.initialize(),J.set(k.IConfigurationService,ee),J.set(Q.IUriIdentityService,new _.UriIdentityService(V)),J.set(S.IRequestService,new y.SyncDescriptor(v.RequestService)),J.set(G.IDownloadService,new y.SyncDescriptor(B.DownloadService)),J.set(T.ITelemetryService,D.NullTelemetryService),J.set(R.IExtensionGalleryService,new y.SyncDescriptor(C.ExtensionGalleryServiceWithNoStorageService)),J.set(U.IExtensionsScannerService,new y.SyncDescriptor(le.ExtensionsScannerService)),J.set(R.IExtensionManagementService,new y.SyncDescriptor(w.ExtensionManagementService)),J.set(R.IExtensionManagementCLIService,new y.SyncDescriptor(a.ExtensionManagementCLIService)),J.set(r.ILanguagePackService,new y.SyncDescriptor(s.NativeLanguagePackService)),new m.InstantiationService(J)}async doRun(J){if(this.args["list-extensions"])return J.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const ae={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return J.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],ae,!!this.args.force)}else{if(this.args["uninstall-extension"])return J.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return J.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(J){return J.map(ae=>/\.vsix$/i.test(ae)?h.URI.file((0,b.isAbsolute)(ae)?ae:(0,b.join)((0,A.cwd)(),ae)):ae)}}function O(W){setTimeout(()=>process.exit(W),0)}async function M(W,J,ae){if(W.help){const fe=E.default.serverApplicationName+(F.isWindows?".cmd":"");console.log((0,X.buildHelpMessage)(E.default.nameLong,fe,E.default.version,ae,{noInputFiles:!0,noPipe:!0}));return}if(W.version){console.log((0,X.buildVersionMessage)(E.default.version,E.default.commit));return}const me=new $(W,J);try{await me.run(),O(0)}catch{O(1)}finally{me.dispose()}}e.run=M}),define(we[257],ye([0,1,61,236,30,251,4,13,111]),function(ie,e,I,t,y,P,k,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(C,w,m){this._commands=C,this.logService=w,this._ipcHandlePath=m,this._server=t.createServer((E,f)=>this.onRequest(E,f)),this.setup().catch(E=>(w.error(E),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",C=>this.logService.error(C))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(C,w){const m=(f,p)=>{w.writeHead(f,{"content-type":"application/json"}),w.end(JSON.stringify(p||null),g=>g&&this.logService.error(g))},E=[];C.setEncoding("utf8"),C.on("data",f=>E.push(f)),C.on("end",async()=>{try{const f=JSON.parse(E.join(""));let p;switch(f.type){case"open":p=await this.open(f);break;case"openExternal":p=await this.openExternal(f);break;case"status":p=await this.getStatus(f);break;case"extensionManagement":p=await this.manageExtensions(f);break;default:m(404,`Unknown message type: ${f.type}`);break}m(200,p)}catch(f){const p=f instanceof Error?f.message:JSON.stringify(f);m(500,p),this.logService.error("Error while processing pipe request",f)}})}async open(C){const{fileURIs:w,folderURIs:m,forceNewWindow:E,diffMode:f,addMode:p,forceReuseWindow:g,gotoLineMode:d,waitMarkerFilePath:l,remoteAuthority:c}=C,n=[];if(Array.isArray(m))for(const r of m)try{n.push({folderUri:k.URI.parse(r)})}catch{}if(Array.isArray(w))for(const r of w)try{(0,v.hasWorkspaceFileExtension)(r)?n.push({workspaceUri:k.URI.parse(r)}):n.push({fileUri:k.URI.parse(r)})}catch{}const o=l?k.URI.file(l):void 0,a={forceNewWindow:E,diffMode:f,addMode:p,gotoLineMode:d,forceReuseWindow:g,preferNewWindow:!g&&!o&&!p,waitMarkerFileURI:o,remoteAuthority:c};return this._commands.executeCommand("_remoteCLI.windowOpen",n,a),""}async openExternal(C){for(const w of C.uris){const m=k.URI.parse(w),E=m.scheme==="file"?m:w;await this._commands.executeCommand("_remoteCLI.openExternal",E)}}async manageExtensions(C){const w=E=>E?.map(f=>/\.vsix$/i.test(f)?k.URI.parse(f):f),m={list:C.list,install:w(C.install),uninstall:w(C.uninstall),force:C.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",m)}async getStatus(C){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&y.existsSync(this._ipcHandlePath)&&y.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let T=class extends D{constructor(C,w){super(C,w,(0,I.createRandomIPCHandle)())}};T=Re([Oe(0,P.IExtHostCommands),Oe(1,S.ILogService)],T),e.CLIServer=T}),define(we[258],ye([0,1,24,6,21,2,5,3,4,61,60,257,242,117,243,246,127]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class p extends E.AbstractVariableResolverService{constructor(l,c,n,o,i){super({getFolderUri:a=>{const r=c.filter(s=>s.name===a);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(a,r)=>o[`config:${r}`],getExecPath:()=>l.VSCODE_EXEC_PATH,getAppRoot:()=>l.VSCODE_CWD,getFilePath:()=>{if(n)return k.normalize(n.fsPath)},getSelectedText:()=>o.selectedText,getLineNumber:()=>o.lineNumber,getExtension:async a=>{const s=(await i.getInstalled()).find(u=>u.identifier.id===a);return s&&{extensionLocation:s.location}}},void 0,Promise.resolve(I.homedir()),Promise.resolve(l))}}class g extends P.Disposable{constructor(l,c,n,o,i){super();this._environmentService=l,this._logService=c,this._ptyService=n,this._productService=o,this._extensionManagementService=i,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new t.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(l,c,n){switch(c){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,n);case"$createProcess":{const o=(0,T.createURITransformer)(l.remoteAuthority);return this._createProcess(o,n)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,n);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,n);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,n);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,n);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,n);case"$start":return this._ptyService.start.apply(this._ptyService,n);case"$input":return this._ptyService.input.apply(this._ptyService,n);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,n);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,n);case"$resize":return this._ptyService.resize.apply(this._ptyService,n);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,n);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,n);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,n);case"$sendCommandResult":return this._sendCommandResult(n[0],n[1],n[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,n);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,n);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,n);case"$getProfiles":return this._getProfiles.apply(this,n);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(n[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(n);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(n);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,n);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,n);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,n);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,n);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,n);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,n);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,n);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(n[0],n[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(n[0],n[1])}throw new Error(`IPC Command ${c} not found`)}listen(l,c,n){switch(c){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(l,c){const n={name:c.shellLaunchConfig.name,executable:c.shellLaunchConfig.executable,args:c.shellLaunchConfig.args,cwd:typeof c.shellLaunchConfig.cwd=="string"||typeof c.shellLaunchConfig.cwd=="undefined"?c.shellLaunchConfig.cwd:v.URI.revive(l.transformIncoming(c.shellLaunchConfig.cwd)),env:c.shellLaunchConfig.env,useShellEnvironment:c.shellLaunchConfig.useShellEnvironment},o=await(0,f.buildUserEnvironment)(c.resolverEnv,!!c.shellLaunchConfig.useShellEnvironment,S.language,!1,this._environmentService,this._logService);this._logService.trace("baseEnv",o);const i=U=>({uri:v.URI.revive(l.transformIncoming(U.uri)),name:U.name,index:U.index,toResource:()=>{throw new Error("Not implemented")}}),a=c.workspaceFolders.map(i),r=c.activeWorkspaceFolder?i(c.activeWorkspaceFolder):void 0,s=c.activeFileResource?v.URI.revive(l.transformIncoming(c.activeFileResource)):void 0,u=new p(o,a,s,c.resolvedVariables,this._extensionManagementService),h=m.createVariableResolver(r,process.env,u),b=await m.getCwd(n,I.homedir(),h,r?.uri,c.configuration["terminal.integrated.cwd"],this._logService);n.cwd=b;const A=S.isWindows?"terminal.integrated.env.windows":S.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",B=c.configuration[A],G=await m.createTerminalEnvironment(n,B,h,this._productService.version,c.configuration["terminal.integrated.detectLocale"],o);if(!n.strictEnv){const U=[];for(const[$,O]of c.envVariableCollections)U.push([$,{map:(0,w.deserializeEnvironmentVariableCollection)(O)}]);const le=new Map(U);await new C.MergedEnvironmentVariableCollection(le).applyToProcessEnvironment(G,h)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:n,initialCwd:b,cols:c.cols,rows:c.rows,env:G});const Q=(0,D.createRandomIPCHandle)();G.VSCODE_IPC_HOOK_CLI=Q;const _={executeCommand:(U,...le)=>this._executeCommand(F,U,le,l)},X=new R.CLIServerBase(_,this._logService,Q),F=await this._ptyService.createProcess(n,b,c.cols,c.rows,c.unicodeVersion,G,o,c.options,c.shouldPersistTerminal,c.workspaceId,c.workspaceName);return this._ptyService.onProcessExit(U=>U.id===F&&X.dispose()),{persistentTerminalId:F,resolvedShellLaunchConfig:n}}_executeCommand(l,c,n,o){let i,a;const r=new Promise((h,b)=>{i=h,a=b}),s=++this._lastReqId;this._pendingCommands.set(s,{resolve:i,reject:a,uriTransformer:o});const u=(0,y.cloneAndChange)(n,h=>{if(h&&h.$mid===1)return o.transformOutgoing(h);if(h&&h instanceof v.URI)return o.transformOutgoingURI(h)});return this._onExecuteCommand.fire({reqId:s,terminalId:l,commandId:c,commandArgs:u}),r}_sendCommandResult(l,c,n){const o=this._pendingCommands.get(l);if(!o)return;this._pendingCommands.delete(l);const i=(0,y.cloneAndChange)(n,a=>{if(a&&a.$mid===1)return o.uriTransformer.transformIncoming(a)});c?o.reject(i):o.resolve(i)}_getDefaultSystemShell(l){return this._ptyService.getDefaultSystemShell(l)}async _getProfiles(l,c,n,o){return this._ptyService.getProfiles?.(l,c,n,o)||[]}_getEnvironment(){return{...process.env}}_getWslPath(l){return this._ptyService.getWslPath(l)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=g}),define(we[259],ye([0,1,24,6,2,8,5,88,22,40,25,103,70,234,181,71,182,192,184,28,107,31,105,193,125,18,99,58,56,98,72,73,106,13,100,101,48,26,51,210,126,213,32,42,221,222,108,229,52,110,239,240,215,220,258,60,37,249,123,253,112,50,113,235,59]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f,p,g,d,l,c,n,o,i,a,r,s,u,h,b,A,B,G,Q,_,X,F,U,le,j,$,O,M,W,J,ae,me,fe,V,ee,x,z,te,ce,Z,se,ge,Y,re,H,K,ue,pe,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Te="monacoworkbench";async function Me($e,He,je,Ye){const oe=new b.ServiceCollection,be=new Se,ke={_serviceBrand:void 0,...X.default};oe.set(F.IProductService,ke);const _e=new se.ServerEnvironmentService(He,ke);oe.set(d.IEnvironmentService,_e),oe.set(d.INativeEnvironmentService,_e);const Be=new G.LogService(new _.SpdLogLogger(Y.RemoteExtensionLogFileName,k.join(_e.logsPath,`${Y.RemoteExtensionLogFileName}.log`),!0,!1,(0,G.getLogLevel)(_e))),Fe=new G.MultiplexLogService([new ve((0,G.getLogLevel)(_e)),Be]);oe.set(G.ILogService,Fe),setTimeout(()=>Ze(_e.logsPath).then(null,st=>Fe.error(st)),1e4),Fe.trace(`Remote configuration data at ${je}`),Fe.trace("process arguments:",_e.args),Array.isArray(ke.serverGreeting)&&Be.info(`

${ke.serverGreeting.join(`
`)}

`),be.registerChannel(m.ExtensionHostDebugBroadcastChannel.ChannelName,new m.ExtensionHostDebugBroadcastChannel);const qe=new D.StaticRouter(st=>st.clientId==="renderer");be.registerChannel("logger",new Q.LogLevelChannel(Fe));const Ge=Ye.add(new r.FileService(Fe));oe.set(a.IFileService,Ge),Ge.registerProvider(P.Schemas.file,Ye.add(new s.DiskFileSystemProvider(Fe)));const Ke=new R.ConfigurationService(_e.machineSettingsResource,Ge,new De.NullPolicyService,Fe);oe.set(T.IConfigurationService,Ke);const xe=new H.ExtensionHostStatusService;oe.set(H.IExtensionHostStatusService,xe),oe.set(fe.IUriIdentityService,new V.UriIdentityService(Ge)),oe.set(U.IRequestService,new u.SyncDescriptor(j.RequestService));let tt=M.NullAppender;const nt=await(0,S.getMachineId)();if((0,M.supportsTelemetry)(ke,_e)){const st=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";st?(tt=new W.AppInsightsAppender(Te,null,()=>new pe.TelemetryClient(st)),Ye.add((0,y.toDisposable)(()=>tt.flush()))):ke.aiConfig&&ke.aiConfig.asimovKey&&(tt=new W.AppInsightsAppender(Te,null,ke.aiConfig.asimovKey),Ye.add((0,y.toDisposable)(()=>tt.flush())));const vt={appenders:[tt],commonProperties:(0,$.resolveCommonProperties)(Ge,(0,I.release)(),(0,I.hostname)(),process.arch,ke.commit,ke.version+"-remote",nt,ke.msftInternalDomains,_e.installSourcePath,"remoteAgent"),piiPaths:(0,M.getPiiPathsFromEnvironment)(_e)},ct=_e.args["telemetry-level"];let ut=3;ct==="all"?ut=3:ct==="error"?ut=2:ct==="crash"?ut=1:ct!==void 0&&(ut=0),oe.set(te.IServerTelemetryService,new u.SyncDescriptor(te.ServerTelemetryService,[vt,ut]))}else oe.set(te.IServerTelemetryService,te.ServerNullTelemetryService);oe.set(c.IExtensionGalleryService,new u.SyncDescriptor(l.ExtensionGalleryServiceWithNoStorageService));const at=be.getChannel("download",qe);oe.set(E.IDownloadService,new f.DownloadServiceChannelClient(at,()=>de("renderer"))),oe.set(K.IExtensionsScannerService,new u.SyncDescriptor(ue.ExtensionsScannerService)),oe.set(c.IExtensionManagementService,new u.SyncDescriptor(i.ExtensionManagementService));const ht=new h.InstantiationService(oe);oe.set(A.ILanguagePackService,ht.createInstance(B.NativeLanguagePackService));const Tt=ht.createInstance(n.ExtensionManagementCLIService);oe.set(c.IExtensionManagementCLIService,Tt);const Ct=ht.createInstance(me.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100});return oe.set(ae.IPtyService,Ct),oe.set(p.IEncryptionMainService,new u.SyncDescriptor(g.EncryptionMainService,[nt])),oe.set(C.ICredentialsMainService,new u.SyncDescriptor(w.CredentialsWebMainService)),ht.invokeFunction(st=>{const vt=st.get(c.IExtensionManagementService),ct=st.get(K.IExtensionsScannerService),ut=new ee.RemoteAgentEnvironmentChannel($e,_e,Tt,Fe,xe,ct);be.registerChannel("remoteextensionsenvironment",ut);const It=new z.ServerTelemetryChannel(st.get(te.IServerTelemetryService),tt);be.registerChannel("telemetry",It),be.registerChannel(ge.REMOTE_TERMINAL_CHANNEL_NAME,new ce.RemoteTerminalChannel(_e,Fe,Ct,ke,vt));const Dt=new x.RemoteAgentFileSystemProviderChannel(Fe,_e);be.registerChannel(re.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Dt),be.registerChannel("request",new le.RequestChannel(st.get(U.IRequestService)));const Lt=new o.ExtensionManagementChannel(vt,Nt=>de(Nt.remoteAuthority));be.registerChannel("extensions",Lt);const Ft=D.ProxyChannel.fromService(st.get(A.ILanguagePackService));be.registerChannel("languagePacks",Ft);const Ot=D.ProxyChannel.fromService(st.get(p.IEncryptionMainService));be.registerChannel("encryption",Ot);const Rt=D.ProxyChannel.fromService(st.get(C.ICredentialsMainService));return be.registerChannel("credentials",Rt),vt.removeDeprecatedExtensions(),Ye.add(new J.default(st.get(O.ITelemetryService))),{telemetryService:st.get(O.ITelemetryService)}}),{socketServer:be,instantiationService:ht}}e.setupServerServices=Me;const Ue=Object.create(null);function de($e){return Ue[$e]||(Ue[$e]=(0,Z.createURITransformer)($e)),Ue[$e]}class Se extends D.IPCServer{constructor(){const He=new t.Emitter;super(He.event);this._onDidConnectEmitter=He}acceptConnection(He,je){this._onDidConnectEmitter.fire({protocol:He,onDidClientDisconnect:je})}}e.SocketServer=Se;class ve extends G.AbstractLogger{constructor(He=G.DEFAULT_LOG_LEVEL){super();this.setLevel(He),this.useColors=Boolean(process.stdout.isTTY)}trace(He,...je){this.getLevel()<=G.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Le()}][0m`,He,...je):console.log(`[${Le()}]`,He,...je))}debug(He,...je){this.getLevel()<=G.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Le()}][0m`,He,...je):console.log(`[${Le()}]`,He,...je))}info(He,...je){this.getLevel()<=G.LogLevel.Info&&(this.useColors?console.log(`[90m[${Le()}][0m`,He,...je):console.log(`[${Le()}]`,He,...je))}warn(He,...je){this.getLevel()<=G.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Le()}][0m`,He,...je):console.warn(`[${Le()}]`,He,...je))}error(He,...je){this.getLevel()<=G.LogLevel.Error&&(this.useColors?console.error(`[91m[${Le()}][0m`,He,...je):console.error(`[${Le()}]`,He,...je))}critical(He,...je){this.getLevel()<=G.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Le()}][0m`,He,...je):console.error(`[${Le()}]`,He,...je))}dispose(){}flush(){}}function Le(){const $e=new Date;return`${Ne($e.getHours())}:${Ne($e.getMinutes())}:${Ne($e.getSeconds())}`}function Ne($e){return $e<10?`0${$e}`:String($e)}async function Ze($e){const He=k.basename($e),je=k.dirname($e),be=(await v.Promises.readdir(je)).filter(_e=>/^\d{8}T\d{6}$/.test(_e)).sort().filter(_e=>_e!==He),ke=be.slice(0,Math.max(0,be.length-9));await Promise.all(ke.map(_e=>v.Promises.rm(k.join(je,_e))))}}),define(we[260],ye([0,1,75,30,68,261,76,128,17,9,33,2,8,5,46,3,15,4,23,143,91,61,7,13,26,74,32,127,231,232,37,259,237]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C,w,m,E,f,p,g,d,l,c,n,o,i,a,r,s,u,h,b,A,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const G=5*60*1e3;let Q=class extends R.Disposable{constructor(U,le,j,$,O,M,W,J){super();this._socketServer=U,this._connectionToken=le,this._vsdaMod=j,this._environmentService=O,this._productService=M,this._logService=W,this._instantiationService=J,this._webEndpointOriginChecker=X.create(this._productService),this._serverRootPath=(0,a.getRemoteServerRootPath)(M),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=$?this._instantiationService.createInstance(B.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(U,le){if(U.method!=="GET")return(0,B.serveError)(U,le,405,`Unsupported method ${U.method}`);if(!U.url)return(0,B.serveError)(U,le,400,"Bad request.");const j=k.parse(U.url,!0);let $=j.pathname;if(!$)return(0,B.serveError)(U,le,400,"Bad request.");if($.startsWith(this._serverRootPath)&&$.charCodeAt(this._serverRootPath.length)===47&&($=$.substring(this._serverRootPath.length)),$==="/version")return le.writeHead(200,{"Content-Type":"text/plain"}),le.end(this._productService.commit||"");if($==="/delay-shutdown")return this._delayShutdown(),le.writeHead(200),le.end("OK");if(!(0,h.requestHasValidConnectionToken)(this._connectionToken,U,j))return(0,B.serveError)(U,le,403,"Forbidden.");if($==="/vscode-remote-resource"){const O=j.query.path;if(typeof O!="string")return(0,B.serveError)(U,le,400,"Bad request.");let M;try{M=p.URI.from({scheme:C.Schemas.file,path:O}).fsPath}catch{return(0,B.serveError)(U,le,400,"Bad request.")}const W=Object.create(null);this._environmentService.isBuilt&&((0,T.isEqualOrParent)(M,this._environmentService.builtinExtensionsPath,!E.isLinux)||(0,T.isEqualOrParent)(M,this._environmentService.extensionsPath,!E.isLinux))&&(W["Cache-Control"]="public, max-age=31536000"),W.Vary="Origin";const J=U.headers.origin;return J&&this._webEndpointOriginChecker.matches(J)&&(W["Access-Control-Allow-Origin"]=J),(0,B.serveFile)(M,1,this._logService,U,le,W)}if(this._webClientServer){this._webClientServer.handle(U,le,j);return}return le.writeHead(404,{"Content-Type":"text/plain"}),le.end("Not found")}handleUpgrade(U,le){let j=(0,g.generateUuid)(),$=!1,O=!1;if(U.url){const fe=k.parse(U.url,!0).query;typeof fe.reconnectionToken=="string"&&(j=fe.reconnectionToken),fe.reconnection==="true"&&($=!0),fe.skipWebSocketFrames==="true"&&(O=!0)}if(U.headers.upgrade===void 0||U.headers.upgrade.toLowerCase()!=="websocket"){le.end("HTTP/1.1 400 Bad Request");return}const M=U.headers["sec-websocket-key"],W=I.createHash("sha1");W.update(M+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const J=W.digest("base64"),ae=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${J}`];let me=!1;if(!O&&!this._environmentService.args["disable-websocket-compression"]&&U.headers["sec-websocket-extensions"]){const fe=Array.isArray(U.headers["sec-websocket-extensions"])?U.headers["sec-websocket-extensions"]:[U.headers["sec-websocket-extensions"]];for(const V of fe)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(V)){if(/\b(permessage-deflate)\b/.test(V)){me=!0,ae.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(V)){me=!0,ae.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}le.write(ae.join(`\r
`)+`\r
\r
`),le.setTimeout(0),le.setNoDelay(!0),O?this._handleWebSocketConnection(new c.NodeSocket(le,`server-connection-${j}`),$,j):this._handleWebSocketConnection(new c.WebSocketNodeSocket(new c.NodeSocket(le,`server-connection-${j}`),me,null,!0),$,j)}handleServerError(U){this._logService.error("Error occurred in server"),this._logService.error(U)}_getRemoteAddress(U){let le;return U instanceof c.NodeSocket?le=U.socket:le=U.socket.socket,le.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(U,le,j){const $=le.getSocket();this._logService.error(`${U} ${j}.`);const O={type:"error",reason:j};le.sendControl(v.VSBuffer.fromString(JSON.stringify(O))),le.dispose(),await $.drain(),$.dispose()}_handleWebSocketConnection(U,le,j){const $=this._getRemoteAddress(U),O=`[${$}][${j.substr(0,8)}]`,M=new l.PersistentProtocol(U),W=this._vsdaMod?new this._vsdaMod.validator:null,J=this._vsdaMod?new this._vsdaMod.signer:null;let ae;(function(ee){ee[ee.WaitingForAuth=0]="WaitingForAuth",ee[ee.WaitingForConnectionType=1]="WaitingForConnectionType",ee[ee.Done=2]="Done",ee[ee.Error=3]="Error"})(ae||(ae={}));let me=0;const fe=ee=>{me=3,V.dispose(),this._rejectWebSocketConnection(O,M,ee)},V=M.onControlMessage(ee=>{if(me===0){let x;try{x=JSON.parse(ee.toString())}catch{return fe("Malformed first message")}if(x.type!=="auth")return fe("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(x.auth))return fe("Unauthorized client refused: auth mismatch");let z=(0,g.generateUuid)();if(J)try{z=J.sign(x.data)}catch{}let te=(0,g.generateUuid)();if(W)try{te=W.createNewMessage(te)}catch{}const ce={type:"sign",data:te,signedData:z};M.sendControl(v.VSBuffer.fromString(JSON.stringify(ce))),me=1}else if(me===1){let x;try{x=JSON.parse(ee.toString())}catch{return fe("Malformed second message")}if(x.type!=="connectionType")return fe("Invalid second message");if(typeof x.signedData!="string")return fe("Invalid second message field type");const z=x.commit,te=this._productService.commit;if(z&&te&&z!==te)return fe("Client refused: version mismatch");let ce=!1;if(!W)ce=!0;else if(this._connectionToken.validate(x.signedData))ce=!0;else try{ce=W.validate(x.signedData)==="ok"}catch{}if(!ce){if(this._environmentService.isBuilt)return fe("Unauthorized client refused");this._logService.error(`${O} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let Z in this._managementConnections)this._managementConnections[Z].shortenReconnectionGraceTimeIfNecessary();for(let Z in this._extHostConnections)this._extHostConnections[Z].shortenReconnectionGraceTimeIfNecessary();me=2,V.dispose(),this._handleConnectionType($,O,M,U,le,j,x)}})}async _handleConnectionType(U,le,j,$,O,M,W){const J=W.desiredConnectionType===1?`${le}[ManagementConnection]`:W.desiredConnectionType===2?`${le}[ExtensionHostConnection]`:le;if(W.desiredConnectionType===1)if(O){if(!this._managementConnections[M])return this._allReconnectionTokens.has(M)?this._rejectWebSocketConnection(J,j,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(J,j,"Unknown reconnection token (never seen)");j.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const ae=j.readEntireBuffer();j.dispose(),this._managementConnections[M].acceptReconnection(U,$,ae)}else{if(this._managementConnections[M])return this._rejectWebSocketConnection(J,j,"Duplicate reconnection token");j.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const ae=new u.ManagementConnection(this._logService,M,U,j);this._socketServer.acceptConnection(ae.protocol,ae.onClose),this._managementConnections[M]=ae,this._allReconnectionTokens.add(M),ae.onClose(()=>{delete this._managementConnections[M]})}else if(W.desiredConnectionType===2){const ae=W.args||{language:"en"},me=await this._updateWithFreeDebugPort(ae);if(me.port&&this._logService.trace(`${J} - startParams debug port ${me.port}`),this._logService.trace(`${J} - startParams language: ${me.language}`),this._logService.trace(`${J} - startParams env: ${JSON.stringify(me.env)}`),O){if(!this._extHostConnections[M])return this._allReconnectionTokens.has(M)?this._rejectWebSocketConnection(J,j,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(J,j,"Unknown reconnection token (never seen)");j.sendPause(),j.sendControl(v.VSBuffer.fromString(JSON.stringify(me.port?{debugPort:me.port}:{})));const fe=j.readEntireBuffer();j.dispose(),this._extHostConnections[M].acceptReconnection(U,$,fe)}else{if(this._extHostConnections[M])return this._rejectWebSocketConnection(J,j,"Duplicate reconnection token");j.sendPause(),j.sendControl(v.VSBuffer.fromString(JSON.stringify(me.port?{debugPort:me.port}:{})));const fe=j.readEntireBuffer();j.dispose();const V=this._instantiationService.createInstance(s.ExtensionHostConnection,M,U,$,fe);this._extHostConnections[M]=V,this._allReconnectionTokens.add(M),V.onClose(()=>{delete this._extHostConnections[M],this._onDidCloseExtHostConnection()}),V.start(me)}}else if(W.desiredConnectionType===3){const ae=W.args;this._createTunnel(j,ae)}else return this._rejectWebSocketConnection(J,j,"Unknown initial data received")}async _createTunnel(U,le){const j=U.getSocket().socket,$=U.readEntireBuffer();U.dispose(),j.pause();const O=await this._connectTunnelSocket(le.host,le.port);$.byteLength>0&&O.write($.buffer),O.on("end",()=>j.end()),O.on("close",()=>j.end()),O.on("error",()=>j.destroy()),j.on("end",()=>O.end()),j.on("close",()=>O.end()),j.on("error",()=>O.destroy()),O.pipe(j),j.pipe(O)}_connectTunnelSocket(U,le){return new Promise((j,$)=>{const O=y.createConnection({host:U,port:le},()=>{O.removeListener("error",$),O.pause(),j(O)});O.once("error",$)})}_updateWithFreeDebugPort(U){return typeof U.port=="number"?(0,d.findFreePort)(U.port,10,5e3).then(le=>(U.port=le,U)):(U.debugId=void 0,U.port=void 0,U.break=void 0,Promise.resolve(U))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},G))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};Q=Re([Oe(4,b.IServerEnvironmentService),Oe(5,i.IProductService),Oe(6,o.ILogService),Oe(7,n.IInstantiationService)],Q),e.RemoteExtensionHostAgentServer=Q;async function _(F,U,le){const j=await(0,h.determineServerConnectionToken)(U);j instanceof h.ServerConnectionTokenParseError&&(console.warn(j.message),process.exit(1));const $=new R.DisposableStore,{socketServer:O,instantiationService:M}=await(0,A.setupServerServices)(j,U,le,$);M.invokeFunction(x=>{const z=x.get(o.ILogService);(0,D.setUnexpectedErrorHandler)(te=>{te&&te.code==="EPIPE"&&te.syscall==="write"&&te.stack&&/unexpectedErrorHandler/.test(te.stack)||z.error(te)}),process.on("SIGPIPE",()=>{(0,D.onUnexpectedError)(new Error("Unexpected SIGPIPE"))})}),M.invokeFunction(x=>{const z=x.get(o.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const te=(0,w.join)(process.env.HOMEDRIVE,"node_modules"),ce=(0,w.dirname)((0,w.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),Z=(0,w.join)(ce,"node_modules");if(t.existsSync(te)||t.existsSync(Z)){const se=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${te}
* ${Z}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;z.warn(se),console.warn(se),process.exit(0)}}});const W=M.invokeFunction(x=>{const z=x.get(o.ILogService);if(t.existsSync((0,w.join)(C.FileAccess.asFileUri("",ie).fsPath,"../node_modules/vsda")))try{return ie.__$__nodeRequire("vsda")}catch(ce){z.error(ce)}return null}),J=t.existsSync(C.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",ie).fsPath);if(J&&F&&typeof F!="string"){const x=j.type!==0?`?${C.connectionTokenQueryName}=${j.value}`:"";console.log(`Web UI available at http://localhost${F.port===80?"":`:${F.port}`}/${x}`)}const ae=M.createInstance(Q,O,j,W,J);m.mark("code/server/ready");const me=P.performance.now(),fe=global.vscodeServerStartTime,V=global.vscodeServerListenTime,ee=global.vscodeServerCodeLoadedTime;if(M.invokeFunction(x=>{x.get(r.ITelemetryService).publicLog2("serverStart",{startTime:fe,startedTime:V,codeLoadedTime:ee,readyTime:me})}),U["print-startup-performance"]){const x=S.LoaderStats.get();let z="";z+=`

### Load AMD-module
`,z+=S.LoaderStats.toMarkdownTable(["Module","Duration"],x.amdLoad),z+=`

### Load commonjs-module
`,z+=S.LoaderStats.toMarkdownTable(["Module","Duration"],x.nodeRequire),z+=`

### Invoke AMD-module factory
`,z+=S.LoaderStats.toMarkdownTable(["Module","Duration"],x.amdInvoke),z+=`

### Invoke commonjs-module
`,z+=S.LoaderStats.toMarkdownTable(["Module","Duration"],x.nodeEval),z+=`Start-up time: ${V-fe}
`,z+=`Code loading time: ${ee-fe}
`,z+=`Initialized time: ${me-fe}
`,z+=`
`,console.log(z)}return ae}e.createServer=_;class X{constructor(U){this._originRegExp=U}static create(U){const le=U.webEndpointUrlTemplate,j=U.commit,$=U.quality;if(!le||!j||!$)return new X(null);const O=(0,g.generateUuid)(),W=new URL(le.replace("{{uuid}}",O).replace("{{commit}}",j).replace("{{quality}}",$)).origin,J=(0,f.escapeRegExpCharacters)(W).replace(O,"[a-zA-Z0-9\\-]+");try{const ae=(0,f.createRegExp)(`^${J}$`,!0,{matchCase:!1});return new X(ae)}catch{return new X(null)}}matches(U){return this._originRegExp?this._originRegExp.test(U):!1}}}),define(we[270],ye([0,1,24,30,8,256,260,54,5,261,37,48,46]),function(ie,e,I,t,y,P,k,S,v,D,T,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,C.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=D.performance.now();const w={onMultipleValues:(g,d)=>{console.error(`Option '${g}' can only be defined once. Using value ${d}.`)},onEmptyValue:g=>{console.error(`Ignoring option '${g}': Value must not be empty.`)},onUnknownOption:g=>{console.error(`Ignoring option '${g}': not supported for server.`)},onDeprecatedOption:(g,d)=>{console.warn(`Option '${g}' is deprecated: ${d}`)}};function m(){return(0,S.parseArgs)(process.argv.slice(2),T.serverOptions,w)}function E(g){const d=g["server-data-dir"]||g["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.join)(I.homedir(),R.default.serverDataFolderName||".vscode-remote"),l=g["user-data-dir"]||(0,v.join)(d,"data"),c=(0,v.join)(l,"User"),n=(0,v.join)(c,"globalStorage"),o=(0,v.join)(c,"History"),i=(0,v.join)(l,"Machine");g["user-data-dir"]=l;const a=(0,v.dirname)(y.FileAccess.asFileUri("",ie).fsPath),r=g["builtin-extensions-dir"]||(0,v.join)(a,"extensions");return g["builtin-extensions-dir"]=r,g["extensions-dir"]=g["extensions-dir"]||(0,v.join)(d,"extensions"),[d,g["extensions-dir"],l,c,i,n,o].forEach(s=>{try{t.existsSync(s)||t.mkdirSync(s,{mode:448})}catch(u){console.error(u)}}),d}function f(g=m()){return(0,P.run)(g,E(g),T.serverOptions)}e.spawnCli=f;function p(g,d=m()){return(0,k.createServer)(g,d,E(d))}e.createServer=p})}).call(this);

//# sourceMappingURL=server.main.js.map
